/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.03.2
*
* Fabio Bertoldi - 20141001
*
*/

----------------
-- Ticket #21405
----------------

INSERT
  INTO administracao.funcionalidade
     ( cod_funcionalidade
     , cod_modulo
     , nom_funcionalidade
     , nom_diretorio
     , ordem
     , ativo
     )
     VALUES
     ( 487
     , 63
     , 'Configuração'
     , 'instancias/configuracao/'
     , 1
     , TRUE
     );

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2992
     , 487
     , 'FMManterOrcamento.php'
     , 'configurar'
     , 1
     , ''
     , 'Configurar Orçamento'
     , TRUE
     );

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2994
     , 487
     , 'FMManterConfiguracaoUnidadeGestora.php'
     , 'configurar'
     , 2
     , ''
     , 'Configurar Unidade Gestora'
     , TRUE
     );

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3004
     , 487
     , 'FLManterConfiguracaoOrdenador.php'
     , 'manter'
     , 9
     , ''
     , 'Configurar Ordenador'
     , TRUE
     );

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 3005
     , 487
     , 'FLManterConfiguracaoGestor.php'
     , 'manter'
     , 10
     , ''
     , 'Configurar Gestor'
     , TRUE
     );


CREATE TABLE tcepe.configuracao_ordenador(
    exercicio           CHAR(4)     NOT NULL,
    cod_entidade        INTEGER     NOT NULL,
    cgm_ordenador       INTEGER     NOT NULL,
    num_unidade         INTEGER     NOT NULL,
    num_orgao           INTEGER     NOT NULL,
    dt_inicio_vigencia  DATE        NOT NULL,
    dt_fim_vigencia     DATE        NOT NULL,
    CONSTRAINT pk_configuracao_ordenador    PRIMARY KEY (exercicio, cod_entidade, cgm_ordenador, num_unidade, num_orgao),
    CONSTRAINT fk_configuracao_ordenador_1  FOREIGN KEY                     (exercicio, cod_entidade)
                                            REFERENCES orcamento.entidade   (exercicio, cod_entidade),
    CONSTRAINT fk_configuracao_ordenador_2  FOREIGN KEY                     (cgm_ordenador)
                                            REFERENCES sw_cgm_pessoa_fisica (numcgm),
    CONSTRAINT fk_configuracao_ordenador_3  FOREIGN KEY                     (exercicio, num_unidade, num_orgao)
                                            REFERENCES orcamento.unidade    (exercicio, num_unidade, num_orgao)
);
GRANT ALL ON tcepe.configuracao_ordenador TO urbem;


CREATE TABLE tcepe.configuracao_gestor(
    exercicio           CHAR(4)     NOT NULL,
    cod_entidade        INTEGER     NOT NULL,
    cgm_gestor          INTEGER     NOT NULL,
    num_unidade         INTEGER     NOT NULL,
    num_orgao           INTEGER     NOT NULL,
    dt_inicio_vigencia  DATE        NOT NULL,
    dt_fim_vigencia     DATE        NOT NULL,
    CONSTRAINT pk_configuracao_gestor       PRIMARY KEY (exercicio, cod_entidade, cgm_gestor, num_unidade, num_orgao),
    CONSTRAINT fk_configuracao_gestor_1     FOREIGN KEY                     (exercicio, cod_entidade)
                                            REFERENCES orcamento.entidade   (exercicio, cod_entidade),
    CONSTRAINT fk_configuracao_gestor_2     FOREIGN KEY                     (cgm_gestor)
                                            REFERENCES sw_cgm_pessoa_fisica (numcgm),
    CONSTRAINT fk_configuracao_gestor_3     FOREIGN KEY                     (exercicio, num_unidade, num_orgao)
                                            REFERENCES orcamento.unidade    (exercicio, num_unidade, num_orgao)
);
GRANT ALL ON tcepe.configuracao_gestor TO urbem;


INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_ano_vigencia'          , '');
INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_data_aprovacao_LOA'    , '');
INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_lei_orcamentaria_LOA'  , '');
INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_data_aprovacao_LDO'    , '');
INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_lei_orcamentaria_LDO'  , '');
INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_data_aprovacao_PPA'    , '');
INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'tcepe_lei_orcamentaria_PPA'  , '');

CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE
    stSQL       VARCHAR;
    reRecord    RECORD;
BEGIN
    stSQL := '
                 SELECT cod_entidade
                   FROM orcamento.entidade
               GROUP BY cod_entidade
                      ;
             ';
    FOR reRecord IN EXECUTE stSQL LOOP
        INSERT
          INTO administracao.configuracao_entidade
             ( exercicio
             , cod_entidade
             , cod_modulo
             , parametro
             , valor
             )
        SELECT '2014'
             , reRecord.cod_entidade
             , 63
             , 'tcepe_codigo_unidade_gestora'
             , ''
         WHERE 0 = (
                     SELECT COUNT(1)
                       FROM administracao.configuracao_entidade
                      WHERE exercicio    = '2014'
                        AND cod_entidade = reRecord.cod_entidade
                        AND cod_modulo   = 63
                        AND parametro    = 'tcepe_codigo_unidade_gestora'
                   )
             ;
    END LOOP;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #22215
----------------

INSERT
  INTO administracao.funcionalidade
     ( cod_funcionalidade
     , cod_modulo
     , nom_funcionalidade
     , nom_diretorio
     , ordem
     , ativo
     )
     VALUES
     ( 488
     , 63
     , 'SAGRES'
     , 'instancias/SAGRES/'
     , 2
     , TRUE
     );

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2993
     , 488
     , 'FLExportarArquivosEOF.php'
     , 'gerar'
     , 1
     , 'Execução Orçamentária e Financeira'
     , 'EOF'
     , TRUE
     );



----------------
-- Ticket #22213
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2995
     , 480
     , 'FLManterMargemConsignada.php'
     , 'configurar'
     , 12
     , ''
     , 'Relacionar Margem Consignada'
     , TRUE
     );


----------------
-- Ticket #21459
----------------

CREATE TABLE tcepe.tipo_regime_trabalho(
    cod_tipo_regime     INTEGER         NOT NULL,
    descricao           VARCHAR(20)     NOT NULL,
    CONSTRAINT pk_tipo_regime_trabalho  PRIMARY KEY (cod_tipo_regime)
);
GRANT ALL ON tcepe.tipo_regime_trabalho TO urbem;

INSERT INTO tcepe.tipo_regime_trabalho VALUES (0, 'Estatutário');
INSERT INTO tcepe.tipo_regime_trabalho VALUES (1, 'Celetista'  );
INSERT INTO tcepe.tipo_regime_trabalho VALUES (2, 'Contratual' );
INSERT INTO tcepe.tipo_regime_trabalho VALUES (3, 'Eletivo'    );
INSERT INTO tcepe.tipo_regime_trabalho VALUES (4, 'Sem Vinculo');


CREATE TABLE tcepe.tipo_vinculo(
    cod_tipo_vinculo    INTEGER     NOT NULL,
    descricao           VARCHAR(80) NOT NULL,
    CONSTRAINT pk_tipo_vinculo      PRIMARY KEY (cod_tipo_vinculo)
);
GRANT ALL ON tcepe.tipo_vinculo TO urbem;

INSERT INTO tcepe.tipo_vinculo VALUES ( 2, 'Efetivo / Vitalício / Militar'                                );
INSERT INTO tcepe.tipo_vinculo VALUES ( 3, 'Eletivo'                                                      );
INSERT INTO tcepe.tipo_vinculo VALUES ( 4, 'Cargo comissionado'                                           );
INSERT INTO tcepe.tipo_vinculo VALUES ( 5, 'Função de confiança (Função gratificada)'                     );
INSERT INTO tcepe.tipo_vinculo VALUES ( 6, 'Contratação por excepcional interesse público'                );
INSERT INTO tcepe.tipo_vinculo VALUES ( 7, 'Emprego público'                                              );
INSERT INTO tcepe.tipo_vinculo VALUES ( 8, 'Benefício previdenciário temporário'                          );
INSERT INTO tcepe.tipo_vinculo VALUES ( 9, 'À disposição'                                                 );
INSERT INTO tcepe.tipo_vinculo VALUES (11, 'Função pública relevante (membros de conselho administrativo)');

SELECT atualizarbanco('
CREATE TABLE pessoal.vinculo_regime_subdivisao(
    exercicio               CHAR(4)         NOT NULL,
    cod_sub_divisao         INTEGER         NOT NULL,
    cod_tipo_regime         INTEGER         NOT NULL,
    cod_tipo_vinculo        INTEGER         NOT NULL,
    CONSTRAINT pk_vinculo_regime_subdivisao     PRIMARY KEY                             (exercicio, cod_sub_divisao),
    CONSTRAINT fk_vinculo_regime_subdivisao_1   FOREIGN KEY                             (cod_sub_divisao)
                                                REFERENCES pessoal.sub_divisao          (cod_sub_divisao),
    CONSTRAINT fk_vinculo_regime_subdivisao_2   FOREIGN KEY                             (cod_tipo_regime)
                                                REFERENCES tcepe.tipo_regime_trabalho   (cod_tipo_regime),
    CONSTRAINT fk_vinculo_regime_subdivisao_3   FOREIGN KEY                             (cod_tipo_vinculo)
                                                REFERENCES tcepe.tipo_vinculo           (cod_tipo_vinculo)
);
');
SELECT atualizarbanco('
GRANT ALL ON pessoal.vinculo_regime_subdivisao TO urbem;
');


INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2996
     , 487
     , 'FLManterVinculoRegimeTrabalho.php'
     , 'configurar'
     , 3
     , ''
     , 'Configurar Vinculo e Regime de Trabalho'
     , TRUE
     );


----------------
-- Ticket #21460
----------------

CREATE TABLE tcepe.agente_politico(
    cod_agente_politico INTEGER     NOT NULL,
    descricao           VARCHAR(30) NOT NULL,
    CONSTRAINT pk_tipo_agente       PRIMARY KEY (cod_agente_politico)
);
GRANT ALL ON tcepe.agente_politico TO urbem;

INSERT INTO tcepe.agente_politico VALUES(1, 'Prefeito'            );
INSERT INTO tcepe.agente_politico VALUES(2, 'Vice-Prefeito'       );
INSERT INTO tcepe.agente_politico VALUES(3, 'Vereador'            );
INSERT INTO tcepe.agente_politico VALUES(4, 'Vereador-Presidente' );
INSERT INTO tcepe.agente_politico VALUES(5, 'Secretário Municipal');
INSERT INTO tcepe.agente_politico VALUES(6, 'Outros'              );


CREATE TABLE tcepe.cgm_agente_politico(
    numcgm                  INTEGER     NOT NULL,
    exercicio               CHAR(4)     NOT NULL,
    cod_entidade            INTEGER     NOT NULL,
    cod_agente_politico     INTEGER     NOT NULL,
    CONSTRAINT pk_cgm_agente_politico   PRIMARY KEY                     (numcgm),
    CONSTRAINT fk_cgm_agente_politico_1 FOREIGN KEY                     (numcgm)
                                        REFERENCES sw_cgm_pessoa_fisica (numcgm),
    CONSTRAINT fk_cgm_agente_politico_2 FOREIGN KEY                     (exercicio, cod_entidade)
                                        REFERENCES orcamento.entidade   (exercicio, cod_entidade),
    CONSTRAINT fk_cgm_agente_politico_3 FOREIGN KEY                     (cod_agente_politico)
                                        REFERENCES tcepe.agente_politico(cod_agente_politico)
);
GRANT ALL ON tcepe.cgm_agente_politico TO urbem;

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2998
     , 487
     , 'FMManterAgentePolitico.php'
     , 'configurar'
     , 4
     , ''
     , 'Configurar Agente Político'
     , TRUE
     );


----------------
-- Ticket #22227
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 2999
     , 487
     , 'FLManterRelacionamentoHistoricoFuncional.php'
     , 'configurar'
     , 5
     , ''
     , 'Relacionar Histórico Funcional'
     , TRUE
     );

CREATE TABLE tcepe.tipo_movimentacao (
    cod_tipo_movimentacao   INTEGER         NOT NULL,
    descricao               VARCHAR(80)     NOT NULL,
    CONSTRAINT pk_tipo_movimentacao         PRIMARY KEY (cod_tipo_movimentacao)
);
GRANT ALL ON tcepe.tipo_movimentacao TO urbem;

INSERT INTO tcepe.tipo_movimentacao VALUES (13,'Dispensa de função gratificada'                                             );
INSERT INTO tcepe.tipo_movimentacao VALUES (16,'À disposição com ônus'                                                      );
INSERT INTO tcepe.tipo_movimentacao VALUES (17,'À disposição sem ônus'                                                      );
INSERT INTO tcepe.tipo_movimentacao VALUES (18,'Disponibilidade'                                                            );
INSERT INTO tcepe.tipo_movimentacao VALUES (22,'Alteração da unidade orçamentária de trabalho'                              );
INSERT INTO tcepe.tipo_movimentacao VALUES (28,'Reestruturação de cargos'                                                   );
INSERT INTO tcepe.tipo_movimentacao VALUES (29,'Alteração de regime previdenciário'                                         );
INSERT INTO tcepe.tipo_movimentacao VALUES (30,'Alteração de regime de Trabalho'                                            );
INSERT INTO tcepe.tipo_movimentacao VALUES (31,'Readaptação'                                                                );
INSERT INTO tcepe.tipo_movimentacao VALUES (34,'Reenquadramento'                                                            );
INSERT INTO tcepe.tipo_movimentacao VALUES (35,'Designação para exercício de função gratificada'                            );
INSERT INTO tcepe.tipo_movimentacao VALUES (40,'Afastamento contando o tempo de serviço, contando tempo de contribuição'    );
INSERT INTO tcepe.tipo_movimentacao VALUES (41,'Afastamento contando o tempo de serviço, sem contar tempo de contribuição'  );
INSERT INTO tcepe.tipo_movimentacao VALUES (42,'Afastamento sem contar o tempo de serviço, contando tempo de contribuição'  );
INSERT INTO tcepe.tipo_movimentacao VALUES (43,'Afastamento sem contar o tempo de serviço, sem contar tempo de contribuição');
INSERT INTO tcepe.tipo_movimentacao VALUES (47,'Promoção'                                                                   );


SELECT atualizarbanco('
CREATE TABLE pessoal.tcepe_configuracao_relaciona_historico (
    cod_assentamento        INTEGER     NOT NULL,
    timestamp               TIMESTAMP   NOT NULL,
    cod_tipo_movimentacao   INTEGER     NOT NULL,
    exercicio               CHAR(4)     NOT NULL,
    CONSTRAINT pk_tcepe_configuracao_relaciona_historico   PRIMARY KEY (cod_assentamento, timestamp, cod_tipo_movimentacao, exercicio),
    CONSTRAINT fk_tcepe_configuracao_relaciona_historico_1 FOREIGN KEY                        (cod_assentamento, timestamp)
                                                           REFERENCES pessoal.assentamento    (cod_assentamento, timestamp),
    CONSTRAINT fk_tcepe_configuracao_relaciona_historico_2 FOREIGN KEY                        (cod_tipo_movimentacao)
                                                           REFERENCES tcepe.tipo_movimentacao (cod_tipo_movimentacao)
);
');

SELECT atualizarbanco('
GRANT ALL ON pessoal.tcepe_configuracao_relaciona_historico TO urbem;
');


----------------
-- Ticket #22120
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3000
     , 487
     , 'FLManterAgentesEletivos.php'
     , 'incluir'
     , 6
     , ''
     , 'Relacionar Agentes Eletivos'
     , TRUE
     );


CREATE TABLE tcepe.agente_eletivo(
    exercicio               char(4)      NOT NULL,
    cod_entidade            integer      NOT NULL,
    cod_tipo_remuneracao    integer      NOT NULL,
    cod_tipo_norma          integer      NOT NULL,
    cod_norma               integer      NOT NULL,
    cod_cargo               integer      NOT NULL,
    CONSTRAINT pk_tcepe_agente_eletivo   PRIMARY KEY                   (exercicio, cod_entidade, cod_cargo),
    CONSTRAINT fk_tcepe_agente_eletivo_1 FOREIGN KEY                   (cod_norma)
                                         REFERENCES normas.norma       (cod_norma),
    CONSTRAINT fk_tcepe_agente_eletivo_2 FOREIGN KEY                   (exercicio, cod_entidade)
                                         REFERENCES orcamento.entidade (exercicio, cod_entidade)
);
GRANT ALL ON tcepe.agente_eletivo TO urbem;


----------------
-- Ticket #21505
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3001
     , 487
     , 'FLConfigurarFonteRecursoFolha.php'
     , 'configurar'
     , 7
     , ''
     , 'Configurar Fonte de Recurso da Folha'
     , TRUE
     );

CREATE TABLE tcepe.fonte_recurso(
    cod_fonte       INTEGER         NOT NULL,
    descricao       VARCHAR(50)     NOT NULL,
    CONSTRAINT pk_fonte_recurso     PRIMARY KEY (cod_fonte)
);
GRANT ALL ON tcepe.fonte_recurso TO urbem;

INSERT INTO tcepe.fonte_recurso VALUES(1, 'Recursos do FUNDEB – Magistério (60%)'     );
INSERT INTO tcepe.fonte_recurso VALUES(2, 'Recursos do FUNDEB - Outras Despesas (40%)');
INSERT INTO tcepe.fonte_recurso VALUES(9, 'Outros'                                    );


CREATE TABLE tcepe.fonte_recurso_lotacao(
    cod_fonte       INTEGER     NOT NULL,
    exercicio       CHAR(4)     NOT NULL,
    cod_entidade    INTEGER     NOT NULL,
    cod_orgao       INTEGER     NOT NULL,
    CONSTRAINT pk_fonte_recurso_lotacao   PRIMARY KEY (cod_fonte, exercicio, cod_entidade, cod_orgao),
    CONSTRAINT fk_fonte_recurso_lotacao_1 FOREIGN KEY                    (cod_fonte)
                                          REFERENCES tcepe.fonte_recurso (cod_fonte),
    CONSTRAINT fk_fonte_recurso_lotacao_2 FOREIGN KEY                    (exercicio, cod_entidade)
                                          REFERENCES orcamento.entidade  (exercicio, cod_entidade),
    CONSTRAINT fk_fonte_recurso_lotacao_3 FOREIGN KEY                    (cod_orgao)
                                          REFERENCES organograma.orgao   (cod_orgao)
);
GRANT ALL ON tcepe.fonte_recurso_lotacao TO urbem;

CREATE TABLE tcepe.fonte_recurso_local(
    cod_fonte       INTEGER     NOT NULL,
    exercicio       CHAR(4)     NOT NULL,
    cod_entidade    INTEGER     NOT NULL,
    cod_local       INTEGER     NOT NULL,
    CONSTRAINT pk_fonte_recurso_local   PRIMARY KEY (cod_fonte, exercicio, cod_entidade, cod_local),
    CONSTRAINT fk_fonte_recurso_local_1 FOREIGN KEY                    (cod_fonte)
                                        REFERENCES tcepe.fonte_recurso (cod_fonte),
    CONSTRAINT fk_fonte_recurso_local_2 FOREIGN KEY                    (exercicio, cod_entidade)
                                        REFERENCES orcamento.entidade  (exercicio, cod_entidade),
    CONSTRAINT fk_fonte_recurso_local_3 FOREIGN KEY                    (cod_local)
                                        REFERENCES organograma.local   (cod_local)
);
GRANT ALL ON tcepe.fonte_recurso_local TO urbem;


----------------
-- Ticket #22134
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 3002
     , 487
     , 'FMManterRecDespExtra.php'
     , 'rec_desp'
     , 8
     , ''
     , 'Configurar Rec/Desp Extra'
     , TRUE
     );


CREATE TABLE tcepe.tipo_retencao(
    cod_tipo        INTEGER         NOT NULL,
    descricao       VARCHAR(40)     NOT NULL,
    CONSTRAINT pk_tipo_retencao     PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcepe.tipo_retencao TO urbem;

INSERT INTO tcepe.tipo_retencao VALUES ( 1, 'ISS'                                      );
INSERT INTO tcepe.tipo_retencao VALUES ( 2, 'IRRF'                                     );
INSERT INTO tcepe.tipo_retencao VALUES ( 5, 'Outras Consignações'                      );
INSERT INTO tcepe.tipo_retencao VALUES ( 6, 'INSS (Saúde)'                             );
INSERT INTO tcepe.tipo_retencao VALUES ( 7, 'INSS (FUNDEB 60%)'                        );
INSERT INTO tcepe.tipo_retencao VALUES ( 8, 'INSS (Educação - demais)'                 );
INSERT INTO tcepe.tipo_retencao VALUES ( 9, 'INSS (Câmara)'                            );
INSERT INTO tcepe.tipo_retencao VALUES ( 10, 'INSS (Demais)'                           );
INSERT INTO tcepe.tipo_retencao VALUES ( 11, 'Previdência Própria (Saúde)'             );
INSERT INTO tcepe.tipo_retencao VALUES ( 12, 'Previdência Própria (FUNDEB 60%)'        );
INSERT INTO tcepe.tipo_retencao VALUES ( 13, 'Previdência Própria (Educação - demais)' );
INSERT INTO tcepe.tipo_retencao VALUES ( 14, 'Previdência Própria (Câmara)'            );
INSERT INTO tcepe.tipo_retencao VALUES ( 15, 'Previdência Própria (Demais)'            );


CREATE TABLE tcepe.plano_analitica_tipo_retencao(
    cod_plano       INTEGER         NOT NULL,
    exercicio       CHAR(4)         NOT NULL,
    cod_tipo        INTEGER         NOT NULL,
    CONSTRAINT pk_plano_analitica_tipo_retencao     PRIMARY KEY                             (cod_plano, exercicio),
    CONSTRAINT fk_plano_analitica_tipo_retencao_1   FOREIGN KEY                             (cod_plano, exercicio)
                                                    REFERENCES contabilidade.plano_analitica(cod_plano, exercicio),
    CONSTRAINT fk_plano_analitica_tipo_retencao_2   FOREIGN KEY                             (cod_tipo)
                                                    REFERENCES tcepe.tipo_retencao          (cod_tipo)
);
GRANT ALL ON tcepe.plano_analitica_tipo_retencao TO urbem;

CREATE TABLE tcepe.plano_analitica_relacionamento(
    exercicio                       CHAR(4)         NOT NULL,
    cod_plano                       INTEGER         NOT NULL,
    tipo                            CHAR(1)         NOT NULL,
    cod_relacionamento              INTEGER         NOT NULL,
    CONSTRAINT pk_plano_analitica_relacionamento    PRIMARY KEY                             (exercicio, cod_plano, tipo),
    CONSTRAINT fk_plano_analitica_relacionamento    FOREIGN KEY                             (exercicio, cod_plano)
                                                    REFERENCES contabilidade.plano_analitica(exercicio, cod_plano),
    CONSTRAINT ck_plano_analitica_relacionamento    CHECK (tipo IN ('D', 'R'))
);
GRANT ALL ON tcepe.plano_analitica_relacionamento TO urbem;


----------------
-- Ticket #22215
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 3003
     , 488
     , 'FLExportarArquivosPessoal.php'
     , 'gerar'
     , 2
     , ''
     , 'Módulo de Pessoal'
     , TRUE
     );


----------------
-- Ticket #22244
----------------

CREATE TABLE tcepe.tipo_norma(
    cod_tipo    INTEGER         NOT NULL,
    descricao   VARCHAR(20)     NOT NULL,
    CONSTRAINT pk_tipo_norma    PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcepe.tipo_norma TO urbem;

INSERT INTO tcepe.tipo_norma VALUES (1, 'Decreto' );
INSERT INTO tcepe.tipo_norma VALUES (2, 'Portaria');
INSERT INTO tcepe.tipo_norma VALUES (3, 'Outro'   );

CREATE TABLE tcepe.vinculo_tipo_norma(
    cod_tipo_norma      INTEGER         NOT NULL,
    cod_tipo            INTEGER         NOT NULL,
    CONSTRAINT pk_vinculo_tipo_norma    PRIMARY KEY                  (cod_tipo_norma),
    CONSTRAINT fk_vinculo_tipo_norma_1  FOREIGN KEY                  (cod_tipo_norma)
                                        REFERENCES normas.tipo_norma (cod_tipo_norma),
    CONSTRAINT fk_vinculo_tipo_norma_2  FOREIGN KEY                  (cod_tipo)
                                        REFERENCES tcepe.tipo_norma  (cod_tipo)
);
GRANT ALL ON tcepe.vinculo_tipo_norma TO urbem;

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 3006
     , 487
     , 'FMManterTipoNorma.php'
     , 'configurar'
     , 11
     , ''
     , 'Configurar Tipo Norma'
     , TRUE
     );


----------------
-- Ticket #21371
----------------

CREATE SEQUENCE tcepe.seqLiquidacao;


----------------
-- Ticket #22235
----------------

CREATE TABLE tcepe.tipo_conta_corrente(
    cod_tipo        INTEGER     NOT NULL,
    descricao       VARCHAR(20) NOT NULL,
    CONSTRAINT pk_tipo_conta_corrente   PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcepe.tipo_conta_corrente TO urbem;

INSERT INTO tcepe.tipo_conta_corrente VALUES ( 1, 'Atributo Financeiro');
INSERT INTO tcepe.tipo_conta_corrente VALUES ( 2, 'Célula de Despesa' );
INSERT INTO tcepe.tipo_conta_corrente VALUES ( 3, 'Célula da Receita'  );
INSERT INTO tcepe.tipo_conta_corrente VALUES ( 4, 'Consórcios Públicos');
INSERT INTO tcepe.tipo_conta_corrente VALUES ( 5, 'Restos a Pagar'     );
INSERT INTO tcepe.tipo_conta_corrente VALUES ( 6, 'Domicílio Bancário' );
INSERT INTO tcepe.tipo_conta_corrente VALUES ( 7, 'Fonte de Recursos'  );
INSERT INTO tcepe.tipo_conta_corrente VALUES (99, 'Sem Conta Corrente' );


ALTER TABLE contabilidade.plano_conta_estrutura ADD COLUMN atributo_tcepe INTEGER;
ALTER TABLE contabilidade.plano_conta_estrutura  ADD CONSTRAINT fk_plano_conta_estrutura_2 FOREIGN KEY (atributo_tcepe)
                                                    REFERENCES tcepe.tipo_conta_corrente(cod_tipo);
ALTER TABLE contabilidade.plano_conta           ADD COLUMN atributo_tcepe INTEGER;
ALTER TABLE contabilidade.plano_conta           ADD CONSTRAINT fk_plano_conta_3 FOREIGN KEY (atributo_tcepe)
                                                    REFERENCES tcepe.tipo_conta_corrente(cod_tipo);


INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16)+1, 1),'1.0','2014-10-01');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.0.0.0.0.00.00','ATIVO','Compreende os recursos controlados por uma entidade como consequência de eventos passados e dos quais se espera que fluam benefícios econômicos ou potencial de serviços futuros a unidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.0.0.0.00.00','ATIVO CIRCULANTE','Compreende os ativos que atendam a qualquer um dos seguintes critérios: sejam caixa ou equivalente de caixa; sejam realizáveis ou mantidos para venda ou consumo dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; sejam realizáveis no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.0.0.00.00','CAIXA E EQUIVALENTES DE CAIXA','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.01.00','CAIXA','Registra o somatório de numerários em espécie e outros valores em tesouraria.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.02.00','CONTA ÚNICA','Registra os valores da Conta Única, exceto RPPS.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.06.00','CONTA ÚNICA RPPS','Compreende os valores disponíveis na Conta Única do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.06.01','BANCOS CONTA MOVIMENTO – RPPS','Registra o somatório das disponibilidades bancarias agregadas nos itens conta única da previdência social e outras contas, agregadas nos agentes financeiros autorizados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.06.02','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','Registra a movimentação financeira dos recursos nas contas movimento do plano financeiro do RPPS através dos agentes financeiros credenciados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.06.03','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','Registra a movimentação financeira dos recursos nas contas movimento do plano previdenciário do RPPS através dos agentes financeiros credenciados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.06.04','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','Registra a movimentação financeira dos recursos nas contas movimento da taxa de administração do RPPS através dos agentes financeiros credenciados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.19.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','Compreende o somatório das disponibilidades existentes em outras contas bancárias, que não sejam a Conta Única, agregadas pelos subitens identificativos dos bancos correspondentes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.30.00','REDE BANCÁRIA - ARRECADAÇÃO','Registra o somatório dos recursos referentes a receitas arrecadadas e não recolhidas.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.50.00','APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Compreende as aplicações financeiras de alta liquidez em moeda nacional, que são prontamente conversíveis em valores conhecidos de caixa e que estão sujeitas a um insignificante risco de mudança de valor.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.50.01','TÍTULOS PÚBLICOS','Registra os valores das disponibildiades das instituições, entidades e unidades aplicadas em títulos públicos.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.50.02','POUPANÇA','Registra o valor das aplicações financeiras em poupanças e seus rendimentos (juros e atualização moentária) posteriores.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.50.03','FUNDOS DE INVESTIMENTO','Registra o valor das aplicações financeiras em fundo de investimento e seus rendimentos (juros e atualização) posteriores, conforme instrução CVM 409/2004.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.50.04','CDB','Registra os valores das disponibilidades das instituições, entidades ou unidades aplicadas em certificados de depósitos bancários (CDB).','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.1.50.99','OUTRAS APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Registra outras aplicações financeiras, não classificadas em itens anteriores, das disponibilidades financeiras das entidades, instituições ou unidades.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.2.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.2.06.00','CONTA ÚNICA RPPS','Compreende os valores disponíveis na Conta Única do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.2.06.01','BANCOS CONTA MOVIMENTO – RPPS','Registra o somatório das disponibilidades bancarias agregadas nos itens conta única da previdência social e outras contas, agregadas nos agentes financeiros autorizados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.2.06.02','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','Registra a movimentação financeira dos recursos nas contas movimento do plano financeiro do RPPS através dos agentes financeiros credenciados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.2.06.03','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','Registra a movimentação financeira dos recursos nas contas movimento do plano previdenciário do RPPS através dos agentes financeiros credenciados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.1.2.06.04','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','Registra a movimentação financeira dos recursos nas contas movimento da taxa de administração do RPPS através dos agentes financeiros credenciados.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.2.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.2.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.2.1.01.00','CAIXA','Registra o somatório de numerários em espécie e outros valores em tesouraria no exterior.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.2.1.02.00','BANCOS','Registra a livre movimentação de recursos financeiros em moeda extrangeira mantidos em contas bancárias no exterior.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.1.2.1.03.00','APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Registra as aplicações financeiras de alta liquidez em moeda estrangeira, que são prontamente conversíveis em valores conhecidos de caixa e que estão sujeitas a um insignificante risco de mudança de valor, inclusive as aplicações referentes ao fechamento de câmbio para aquisição de moeda estrangeira e as aplicações de depósitos com juros em moeda estrangeira realizadas no curtíssimo prazo.','D','S','','F',6);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.0.0.00.00','CRÉDITOS A CURTO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos realizáveis no curso do exercício social subsequente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.0.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos aos créditos a receber não classificadas em itens anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.1.70.00','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTRA OFSS','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos aos créditos a receber não classificadas em itens anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.2.70.00','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. .','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos aos créditos a receber não classificadas em itens anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto à sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.3.70.00','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS – ESTADO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos aos créditos a receber não classificadas em itens anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.4.70.00','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos aos créditos a receber não classificadas em itens anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.1.5.70.00','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.2.0.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorram no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.2.1.00.00','CLIENTES - CONSOLIDAÇÃO','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.2.1.01.00','FATURAS/DUPLICATAS A RECEBER','Registra os valores das faturas/duplicatas a receber não vencidas decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.2.1.02.00','(-) FATURAS/DUPLICATAS A RECEBER - DESCONTADAS','Registra a apropriação e movimentação das duplicatas descontadas provenientes do faturamento de vendas de mercadorias ou serviços.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.2.1.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','Registra os valores duplicatas a receber decorrentes de Faturas Vencidas que ocorrem no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.2.1.04.00','(-) FATURAS/DUPLICATAS A RECEBER VENCIDAS - DESCONTADAS','Registra a apropriação e movimentação das duplicatas descontadas vencidas provenientes do faturamento de vendas de mercadorias ou serviços.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.0.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.1.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.1.01.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE INSTITUIÇÕES PRIVADAS','Registra os recursos a receber pelo Ente decorrentes de transferência de instituições privadas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.1.02.00','CRÉDITOS DE CONSÓRCIOS PÚBLICOS DECORRENTES DE CONTRATO DE RATEIO','Registra os recursos a receber pelo consórcio decorrente do contrato de rateio.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS – UNIÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, Estados, Distrito Federal e Municípios, consórcios públicos e outras instituições. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DA UNIÃO','Compreende os recursos a receber pelo Estado por sua participação constitucional e legal em receitas arrecadadas pela União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.01.02','COTA-PARTE DO FPM','Registra a participação dos Municípios no produto da arrecadação dos Impostos sobre a Renda e sobre Produtos Industrializados, conforme coeficientes fixados pelo Tribunal de contas da União, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.01.03','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL','Registra a participação dos Municípios no produto da arrecadação do Imposto sobre a Propriedade Territorial Rural, transferido pela União aos Municípios onde estejam localizados os imóveis sobre os quais incida o imposto, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.01.04','COTA-PARTE DO IPI - ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS','Registra a parcela do Imposto sobre Produtos Industrializados destinada aos Estados exportadores de produtos industrializados, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.01.06','COTA-PARTE DO IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CÂMBIO E SEGURO, OU RELATIVAS A TÍTULOS OU VALORES MOBILIÁRIOS – COMERCIALIZAÇÃO DO OURO','Registra o valor total das receitas recebidas por meio de cota-parte do imposto sobre operações de crédito, câmbio e seguros, a receber','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.02.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Compreende os recursos a receber pelo estado ou município decorrentes da exploração de recursos naturais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.02.01','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECUROS HÍDRICOS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos hídricos, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.02.02','COTA-PARTE CA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos minerais, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.02.03','COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL','Registra a parcela da cota-parte do valor do petróleo bruto de produção nacional, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.03.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO SUS','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Sistema Único de Saúde, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.04.00','CRÉDITOS DECORRENTES DO FNAS','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo Nacional de Assistência Social, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.05.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO FNDE','Compreende os recursos a receber pelo estado ou município decorrentes das transferências do Fundo Nacional de Desenvolvimento da Educação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.05.01','COTA-PARTE DO SALÁRIO-EDUCAÇÃO','Registra a parcela do produto arrecadado da contribuição do salário-educação, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.05.02','PROGRAMA DINHEIRO DIRETO NA ESCOLA – PDDE','Registra o valor dos recursos de transferências da União referentes ao Programa Dinheiro Direto na Escola – PDDE, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.05.03','PROGRAMA NACIONAL DE ALIMENTAÇÃO ESCOLAR – PNAE','Registra o valor dos recursos de transferências da União referentes ao Programa Nacional de Alimentação Escolar – PNAE. Lei nº 10.880, de 09/06/04, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.05.04','PROGRAMA NACIONAL DE APOIO AO TRANSPORTE DO ESCOLAR – PNATE','Registra o valor dos recursos de transferências da União referentes ao Programa Nacional de Apoio ao Transporte Escolar – PNATE . Lei nº 10.880, de 09/06/04, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.05.99','OUTRAS TRANSFERÊNCIAS DO FNDE','Registra o valor total de outros recursos de transferências da União referentes ao Fundo Nacional do Desenvolvimento da Educação – FNDE, não classificados nos itens anteriores e que não sejam repassados por meio de convênios, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.06.00','CRÉDITOS DECORRENTES DAS TRANSFERÊNCIAS DO ICMS - DESONERAÇÃO - LC 87/96','Compreende os recursos a receber pelo estado ou município decorrentes das transferências financeiras pela desoneração de ICMS, prevista na Lei complementar 87/96.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.06.01','TRANSFERÊNCIA FINANCEIRA DO ICMS - DESONERAÇÃO - LC 87/96','Registra as transferências financeiras do ICMS - Desoneração - Lei Complementar 87/96, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.07.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','Compreende os recursos a receber pelo estado ou município decorrentes de transferência multigovernamentais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.07.01','FUNDEB','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação (FUNDEB), a receber','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.08.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE CONVÊNIOS','Registra os recursos a receber pelo estado ou município decorrentes de convênios firmados com outro ente, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.3.09.00','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','Registra os recursos a receber pelo estado ou município decorrentes de transferências não especificadas nos itens acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DOS ESTADOS','Compreende os recursos a receber pelos Municípios por sua participação constitucional e legal em receitas arrecadadas pelos Estados.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.01.01','COTA-PARTE DO ICMS','Registra a parcela pertencente aos Municípios, do Imposto sobre Operações Relativas à Circulação de Mercadorias e sobre Prestações de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.01.02','COTA-PARTE DO IPVA','Registra a parcela pertencente aos Municípios, do Imposto sobre a Propriedade de Veículos Automotores, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.01.03','COTA-PARTE DO IPI-EXPORTAÇÃO','Registra o valor da arrecadação de receita de transferência da participação de municípios na arrecadação do Imposto sobre Produtos Industrializados – IPI, para exportação, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.01.04','COTA-PARTE DA CIDE','Registra a parcela da Cota-Parte da Contribuição de Intervenção no Domínio Econômico, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.02.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Compreende os recursos a receber pelo município decorrentes da exploração de recursos naturais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.02.01','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS HÍDRICOS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos hídricos, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.02.02','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos minerais, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.02.03','COTA-PARTE ROYALTIES – COMPENSAÇÃO FINANCEIRA PELA PRODUÇÃO DO PETRÓLEO','Registra o valor da arrecadação com a cota-parte royalties – compensação financeira pela produção do petróleo, a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.03.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIAS DO ESTADO PARA PROGRAMA DE SAÚDE','Registra os recursos a receber pelo município decorrentes das transferências de recursos do Sistema Único de Saúde oriundo do Fundo Estadual de Saúde para o Fundo Municipal de Saúde (Ações Básicas de Vigilância Sanitária, Atenção à Saúde dos Povos Indígenas, Programa de Assistência Farmacêutica Básica, Programa de Combate às Carências Nutricionais, Programa de Saúde da Família, Programa de Agentes Comunitários, Programa Nacional de Vigilância Epidemiológica e Controle de Doenças e outros), a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.4.04.00','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','Registra os recursos a receber pelo município decorrentes de transferências não especificadas nos itens acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.3.5.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.1.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.3.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.4.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.4.5.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.0.00.00','DÍVIDA ATIVA TRIBUTÁRIA','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.00.00','DÍVIDA ATIVA TRIBUTÁRIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.1.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTRA OFSS','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.2.99.00','DEMAIS DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - UNIÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.3.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - ESTADO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.4.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - MUNICÍPIO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.5.5.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.6.0.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Compreende os valores dos créditos de divida ativa não tributaria inscritos, derivados de clientes, realizáveis no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.6.1.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa não tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.6.1.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os valores dos créditos de divida ativa não tributaria tais como os provenientes de empréstimos compulsórios, contribuições estabelecidas em lei, multas de qualquer origem ou natureza (exceto as tributárias), foros, laudêmios, aluguéis, taxas de ocupação, custas processuais, preços de serviços prestados por estabelecimentos públicos e outros, exigíveis por transcurso de prazo para pagamento, inscritos na forma de legislação própria, após apurada sua liquidez e certeza.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.0.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.1.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.2.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.3.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.4.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.2.9.5.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.0.0.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende os valores a receber por demais transações realizáveis no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.0.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','Compreende os valores das antecipações concedidas a servidores e a dirigentes da unidade, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de férias e de gratificações natalinas,entre outras.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.01','SALÁRIOS E ORDENADOS - ADIANTAMENTOS','Registra o adiantamento a pessoal referente a salários e ordenados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.02','13 SALÁRIO - ADIANTAMENTO','Registra o adiantamento a pessoal referente ao 13º salário.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.03','FÉRIAS - ADIANTAMENTO','Registra o adiantamento a pessoal referente às férias, exceto o 1/3 de férias.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.04','1/3 DE FÉRIAS - ADIANTAMENTO','Registra o adiantamento a pessoal referente a 1/3 de férias.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.05','VIAGENS - ADIANTAMENTO','Registra o adiantamento a pessoal referente a viagens.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.01.99','OUTROS ADIANTAMENTOS A PESSOAL','Registra outros adiantamentos concedidos a pessoal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.02.00','SUPRIMENTO DE FUNDOS','Registra o adiantamento a servidor para despesas sujeitas a prestação de contas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.03.00','ADIANTAMENTOS DE TRANSFERÊNCIAS VOLUNTÁRIAS','Registra os valores relativos a adiantamentos de recursos financeiros formalizados por transferências voluntárias.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.1.1.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','Registra os outros valores entregues antecipadamente, não classificados em contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.0.00.00','TRIBUTOS A RECUPERAR/COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/compensar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.00.00','TRIBUTOS A RECUPERAR/COMPENSAR - CONSOLIDAÇÃO','Compreende o somatório dos valores dos tributos a recuperar/compensar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.01.00','IPI A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IPI a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.02.00','ICMS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de ICMS a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.03.00','ICMS DIFERIDO','Registra os valores do ICMS diferido dos estoques.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.04.00','IRRF A COMPENSAR','Registra o somatório dos valores do IR retido na fonte a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.05.00','IR E CSLL A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IR e da CSLL a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.06.00','IR E CSLL DIFERIDOS','Registra a parcela do IR e CSLL que representa a diferença entre os valores de lucro apurados seguindo as normas fiscais e seguindo o regime de competência, quando estes forem menores e as diferenças temporárias.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.07.00','ISS A COMPENSAR','Registra o somatório dos valores do ISS a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.08.00','IPVA A COMPENSAR','Registra o somatório dos valores do IPVA a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.09.00','IPTU A COMPENSAR','Registra o somatório dos valores do IPTU a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.10.00','ITR A COMPENSAR','Registra o somatório dos valores do ITR a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.11.00','INSS A COMPENSAR','Registra o somatório dos valores do INSS a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.12.00','COFINS A RECUPERAR/COMPENSAR','Registra o somatório dos valores da COFINS a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.13.00','PIS/PASEP A RECUPERAR/COMPENSAR','Registra o somatório dos valores do PIS/PASEP a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.14.00','CIP A RECUPERAR/COMPENSAR','Registra o somatório dos valores da Contribuição de Iluminação Pública a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.2.1.99.00','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de outros tributos a recuperar/compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.3.0.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.3.1.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.3.1.01.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.4.0.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.4.1.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO- CONSOLIDAÇÃO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.4.1.01.00','CRÉDITOS POR DANOS AO PATRIMÔNIO DECORRENTES DE CRÉDITOS ADMINISTRATIVOS','Registra os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos .','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.4.1.02.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em Tomada de Contas Especial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.4.1.03.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM PROCESSOS JUDICIAIS','Registra os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos judiciais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.0.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS - CONSOLIDAÇÃO','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no curto prazo.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.02.00','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no curto prazo.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados, decorrentes de interposição de recursos na esfera judicial ou administrativa.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.04.00','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.06.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do tribunal de justiça relacionado ao pagamento de precatórios.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.5.1.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados, realizáveis no curto prazo.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.0.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.01.00','ALUGUÉIS A RECEBER','Registra os valores a receber decorrentes de contratos de aluguel.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.02.00','CRÉDITOS A RECEBER DECORRENTES DE PERMISSÃO DE USO DE BENS PÚBLICOS','Registra os valores a receber decorrentes de permissão de uso de bens públicos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZAÇÕES POR SINISTROS PAGOS','Registra os valores a recuperar referentes a indefinições pelo pagamento de sinistros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.04.00','VALES, TICKETS E BILHETES','Registra o valor dos vales, tickets e bilhetes adquiridos para futura distribuição aos servidores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.06.00','VALORES EM TRÂNSITO REALIZÁVEIS A CURTO PRAZO','Registra o somatório dos valores contabilizados indevidamente em conta bancária, guia de recebimento e ordens bancárias emitidas a compensar.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.07.00','CRÉDITOS A RECEBER DECORRENTES DE INFRAÇÕES LEGAIS E CONTRATUAIS','Registra os recursos a receber provenientes da aplicação de autos de infração ou decorrentes de quebra de cláusulas contratuais. Os créditos decorrentes da quebra de cláusulas contratuais podem ser pagos em espécie, glosa ou através de fornecimentos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.08.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO FAMÍLIA PAGO','Registra os valores relativos ao salário-família, incluídos em folhas de pagamento, pagos aos empregados (CLT), com filhos menores, a compensar com as contribuições devidas pelo empregador a Previdência Social.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.09.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO MATERNIDADE PAGO','Registra os salários pagos as servidoras gestantes, regidas pela CLT no período que perdurar a licença maternidade, prevista em lei, a deduzir das obrigações sociais devidas pelos órgãos e entidades.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.10.00','AUXÍLIO NATALIDADE PAGO A RECUPERAR','Registra os valores relativos à auxilio natalidade, pagos aos empregados regidos pela CLY, quando do nascimento de filhos destes, a recuperar, por se tratar de obrigações da Previdência Social.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.11.00','CRÉDITOS A RECEBER POR REEMBOLSO DE AUXÍLIO DOENÇA E ACIDENTES PAGOS','Registra os salários pagos aos servidores, regidos pela CLT, a título de auxilio doença/acidentes, previsto em lei, a serem reembolsados pelo INSS.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.12.00','CRÉDITOS A RECEBER POR CESSÃO DE PESSOAL','Registra os valores de créditos a receber tais como: folha de pagamento, despesa de transporte, alimentação e outras relativas à cessão de pessoal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.13.00','CRÉDITOS A RECEBER DECORRENTES DE CESSÃO DE ÁREAS PÚBLICAS','Registra os valores dos créditos a receber decorrentes da cessão de áreas públicas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.14.00','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','Registra os valores dos créditos a receber decorrentes da alienação de bens móveis ou imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.15.00','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESA DE TERCEIROS','Registra os recursos a receber provenientes de pagamentos de despesas de terceiros decorrentes de cláusulas contratuais, tais como: água, luz, telefone, instalações, transporte e aluguéis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.16.00','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDORES E EX-SERVIDORES','Registra os valores dos créditos a receber decorrentes de acertos financeiros com servidores e ex-servidores do órgão, conforme disposto na lei 8.112/90.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.17.00','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','Registra os valores dos créditos a receber decorrentes de folha de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.18.00','DIVIDENDOS PROPOSTOS A RECEBER','Registra os valores dos dividendos a que a empresa tenha direito, em função de participações em outras empresas, quando tais empresas já tenham registrado na demonstração de lucros ou prejuízos acumulados a parcela de dividendos propostos a distribuir.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.20.00','REMUNERAÇÃO DE DEBÊNTURES A RECEBER','Registra os valores das remunerações de debêntures a receber.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.27.00','TÍTULOS A RECEBER','Registra os valores a receber a curto prazo representados por notas promissórias, letras de câmbio e outros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.28.00','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','Registra os valores a receber a curto prazo, decorrentes de direitos junto a entidades federais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.29.00','CRÉDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','Registra os valores a receber a curto prazo, decorrentes de direitos junto a estados, DF e municípios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.31.00','CRÉDITOS A RECEBER DE PARCELAMENTOS','Registra o crédito de origem fiscal ou não, se autorizado o parcelamento, excluídos os créditos tributários e previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.8.1.99.00','OUTROS CRÉDITOS A RECEBER E VALORES DE CURTO PRAZO','Registra os valores de outros créditos a receber, para os quais não tenham contas especificas neste subgrupo de contas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.0.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.03.00','(-) AJUSTE PARA PERDAS EM CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os valores dos ajustes para perdas em créditos a receber por descentralizações da prestação de serviços públicos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.04.00','(-) AJUSTE PARA PERDAS EM CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores das provisões para perdas de créditos por danos ao patrimônio, verificados em processos administrativos ou apurados em Tomada de Contas Especial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.04.01','(-) AJUSTE PARA PERDAS EM CRÉDITOS ADMINISTRATIVOS','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, verificados em processos administrativos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.04.02','(-) AJUSTE PARA PERDAS EM CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, apurados em Tomada de Contas Especial.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.04.03','(-) AJUSTE PARA PERDAS EM CRÉDITOS APURADOS EM PROCESSOS JUDICIAIS','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, apurados em processos judiciais.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.06.00','(-) AJUSTE PARA PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIAS - DEMAIS CRÉDITOS','Registra os valores referentes à constituição de provisão para perdas de dívida ativa não tributária, exceto as derivadas de clientes de acordo com os critérios definidos no Manual de Procedimentos da Dívida Ativa.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.3.9.1.99.00','(-) AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Registra os valores das provisões para perdas de demais créditos a curto prazo, não classificadas anteriormente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.0.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo, alem das aplicações temporárias em metais preciosos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.0.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.00.00','TÍTULOS E VALORES MOBILIÁRIOS- CONSOLIDAÇÃO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis até o final do exercício seguinte. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.01.00','TÍTULOS PÚBLICOS','Registra os valores relativos aos titulos públicos, emitidos e em circulacao, de posse da entidade pública.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.02.00','AÇÕES','Registra os valores das acoes representativas das participacoes dos orgaos e entidades no capital das sociedades por acoes havidas por aquisicoes, subscricoes, bonificacoes e doações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.03.00','DERIVATIVOS','Registra os créditos relativos a operações com derivativos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.00','APLICAÇÕES EM SEGMENTO DE RENDA FIXA - RPPS','Compreende o somatório dos investimentos realizados pelo RPPS com recursos previdenciários, efetuados em conformidade com a legislação específica.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.01','TÍTULOS DE RESPONSABILIDADE DO TESOURO','Registra os investimentos realizados pelo RPPS, em títulos de emissao do tesouro nacional, efetuados em conformidade com o art. 7º, inciso I, alinea a(inclui operações compromissadas) da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.02','TÍTULOS DE RESPONSABILIDADE DO BANCO CENTRAL','Registra os investimentos realizados pelo RPPS, em títulos de emissao do banco central do brasil; saldos remanescentes para resgates, considerando que o BC não emite mais títulos da divida publica- art 34 LC 101/2000.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.03','POUPANÇA','Registra os investimentos realizados pelo RPPS, em poupança e seus rendimentos (juros e atualização monetária) posteriores.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.04','FUNDOS DE INVESTIMENTO EM RENDA FIXA','Registra os investimentos realizados pelos RPPS, em fundos de investimentos em renda fixa, efetuados em conformidade com o art. 7º, inciso IV, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.05','FUNDOS DE INVESTIMENTO EM RENDA FIXA - CRÉDITO PRIVADO','Registra os investimentos realizados pelos RPPS, em fundos de investimentos em renda fixa - crédito privado.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.06','FUNDOS DE INVESTIMENTOS REFERENCIADOS','Registra os investimentos realizados pelo RPPS, em fundos de investimentos referenciados, efetuados em conformidade com o art. 7º, inciso III, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.07','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITÓRIOS','Registra os investimentos realizados pelo RPPS, em fundos de investimentos em direito creditorio, efetuados em conformidade com o art. 7º, inciso VI e VII, alineas a e b da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.08','FUNDOS DE INVESTIMENTOS EM TÍTULOS DO TESOURO','Registra os investimentos realizados pelo RPPS, em fundos de investimentos em titulos do tesouro, efetuados em conformidade com o art. 7º, inciso I, alinea b da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.09.09','OPERAÇÕES COMPROMISSADAS','Registra os investimentos realizados pelo RPPS, em operacoes compromissadas, efetuados em conformidade com o art.7º , inciso II, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.00','APLICAÇÕES EM SEGMENTO DE RENDA VARIÁVEL - RPPS','Compreende o somatorio dos investimentos realizados pelo RPPS com recursos previdenciarios, efetuados em conformidade com o art. 8º, da resolucao CMN n° 3.922/2010.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.01','FUNDO DE AÇÕES REFERENCIADOS','Registra os investimentos realizados pelo RPPS, em operacoes compromissadas, efetuados em conformidade com o art.7º , inciso II, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.02','FUNDOS DE AÇÕES','Registra os investimentos realizados pelo RPPS, em fundo de acoes, efetuados em conformidade com o art. 8º, inciso III, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.03','FUNDO MULTIMERCADO','Registra os investimentos realizados pelo RPPS, em fundo de multimercado, efetuados em conformidade com o art. 8º, inciso IV, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.04','FUNDOS DE ÍNDICES REFERENCIADOS EM AÇÕES','Registra os investimentos realizados pelo RPPS, em fundos de indices referenciados em acoes, efetuados em conformidade com o art. 8º, inciso II, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.05','FUNDOS DE INVESTIMENTOS EM PARTICIPAÇÕES','Registra os investimentos realizados pelo RPPS, em fundos de investimentos em participacoes, efetuados em conformidade com o art. 7º, inciso v, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.10.06','FUNDOS DE INVESTIMENTOS IMOBILIÁRIOS','Registra os investimentos realizados pelo RPPS, em fundo de investimentos imobiliarios, efetuados em conformidade com o art. 8º, inciso VI, da resolucao CMN n° 3.922/2010.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.11.00','APLICAÇÕES EM SEGMENTO IMOBILIÁRIO - RPPS','Compreende o somatório dos investimentos realizados pelo RPPS com recursos previdenciários em segmento imobiliário.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.11.01','FUNDOS DE INVESTIMENTO IMOBILIÁRIOS','Registra o somatório dos investimentos realizados pelo RPPS com recursos previdenciários em fundos de investimento imobiliários.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.12.00','APLICAÇÕES EM ENQUADRAMENTO - RPPS','Compreende os investimentos realizados pelo RPPS, em desacordo com as regras estabelecidas pela resolucao CMN nº 3.922/2009, artigo 21.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.12.01','TÍTULOS E VALORES EM ENQUADRAMENTO','Registra os investimentos realizados pelo RPPS, em desacordo com as regras estabelecidas pela resolução CMN nº 3.922/2009, artigo 21.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.13.00','TÍTULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS','Compreende os investimentos realizados pelo RPPS, em ativos nao sujeitos as regras da resolucao CMN nº 3.922/2009.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.13.01','TÍTULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','Registra os investimentos realizados pelo RPPS, em ativos não sujeitos as regras da resolução CMN nº 3.922/2009.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.14.00','APLICAÇÕES COM A TAXA DE ADMINISTRAÇÃO DO RPPS','Compreende os investimentos realizados pelo RPPS, com recursos da taxa de administracao, sujeitos as regras da resolucao CMN nº 3.922/2009.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.1.1.14.01','APLICAÇÕES COM A TAXA DE ADMINISTRAÇÃO DO RPPS','Registra os investimentos realizados pelo RPPS, com recursos da taxa de administração, sujeitos as regras da resolução CMN nº 3.922/2009.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.2.0.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.2.1.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.9.0.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.9.1.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS TEMPORÁRIOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.9.1.01.00','(-) AJUSTE DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','Registra a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor, referente a títulos e valores mobiliários.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.4.9.1.02.00','(-) AJUSTE DE PERDAS COM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','Registra a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor, referente a aplicações temporárias em metais preciosos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.0.0.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.1.0.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.1.1.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.1.1.01.00','MERCADORIAS PARA VENDA OU REVENDA','Registra o valor das mercadorias para venda ou revenda e doações relativas a estoques da entidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.1.1.02.00','MERCADORIAS ESTOQUES REGULATÓRIOS','Registra o valor das mercadorias adquiridas para revenda relativas a estoques públicos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.1.1.99.00','OUTRAS MERCADORIAS PARA REVENDA','Registra o valor das demais mercadorias adquiridas para revenda.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.2.0.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.2.1.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','Compreende os produtos já terminados oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.2.1.01.00','PRODUTOS ACABADOS','Registra o valor de produtos manufaturados já terminados, oriundos da própria produção da entidade e disponíveis para venda, estocados na fábrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.2.1.02.00','SERVIÇOS ACABADOS','Registra os valores pertinentes a serviços acabados que estão pendentes de faturamento ou de transferência para outras contas do ativo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.3.0.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.3.1.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.3.1.01.00','PRODUTOS EM ELABORACAO','Registra a totalidade das matérias-primas já requisitadas que estão em processo de transformação e o montante de custos diretos e indiretos relativos aos produtos em elaboração não concluídos na data do balanço patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.3.1.02.00','SERVIÇOS EM ELABORACAO','Registra os custos diretos e indiretos relativos aos serviços em elaboração não concluídos na data do balanço patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.4.0.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.4.1.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.4.1.01.00','MATERIAS-PRIMAS - ARMAZÉNS PRÓPRIOS','Registra o estoque de matérias-primas que serão utilizados no processo produtivo, guardadas em armazéns próprios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.4.1.02.00','MATERIAS-PRIMAS - ARMAZÉNS DE TERCEIROS','Registra o estoque de matérias-primas que serão utilizados no processo produtivo, guardadas em armazéns de terceiros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.5.0.00.00','MATERIAIS EM TRÂNSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.5.1.00.00','MATERIAIS EM TRÂNSITO - CONSOLIDAÇÃO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.5.1.01.00','MATERIAL EM TRÂNSITO','Registra os valores dos materiais em trânsito relativos a transferências efetuadas entre unidades.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.0.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','Compreende o valor dos materiais destinados ao consumo interno da unidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.01.00','MATERIAL DE CONSUMO','Registra os valores dos materiais de consumo adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.02.00','GÊNEROS ALIMENTÍCIOS','Registra os valores dos gêneros alimentícios adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.03.00','MATERIAIS DE CONSTRUÇÃO','Registra os valores dos materiais de construção adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.04.00','AUTOPEÇAS','Registra os valores de autopeças adquiridas e estocadas em almoxarifados, destinadas a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.05.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','Registra os valores dos medicamentos e materias hospitalares adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.06.00','MATERIAIS GRÁFICOS','Registra os valores dos materiais gráficos adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.08.00','MATERIAL DE EXPEDIENTE','Registra os valores dos materiais de expediente adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.09.00','MATERIAIS A CLASSIFICAR','Registra os valores dos materiais estocados pendentes de classificação e identificação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.6.1.10.00','ESTOQUE SOBRESSALENTES A ALIENAR','Registra os valores de bens sobressalentes que estejam disponíveis para alienação sob diversas formas (venda, leilão, etc)','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.7.0.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.7.1.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.8.0.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.8.1.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.9.0.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.9.1.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.9.1.01.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Registra as perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.5.9.1.02.00','(-) AJUSTE DE PERDAS PARA REDUÇÃO AO VALOR DE MERCADO','Registra o ajuste de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no curto prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.1.0.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.1.1.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de prêmios de seguro a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.2.0.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos, a título de VPD financeiras a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.2.1.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos, a título de VPD financeiras a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.3.0.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.3.1.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.4.0.00.00','ALUGUÉIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.4.1.00.00','ALUGUÉIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de aluguel a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.5.0.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.5.1.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de tributos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.6.0.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.6.1.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de contribuições confederativas a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.7.0.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.7.1.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.8.0.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.1.9.8.1.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','Compreende os demais valores pagos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.0.0.0.00.00','ATIVO NÃO CIRCULANTE','Compreende o ativo não circulante: o ativo realizável a longo prazo, os investimentos, o imobilizado e o intangível.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.0.0.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','Compreende os bens, direitos e despesas antecipadas realizáveis no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.0.00.00','CRÉDITOS A LONGO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos e com vencimento no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento após o término do exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.01.01','IMPOSTOS','Registra os créditos tributários a receber provenientes de impostos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.01.02','TAXAS','Registra os créditos tributários a receber provenientes de taxas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.01.03','CONTRIBUIÇÕES DE MELHORIA','Registra os créditos tributários a receber provenientes de contribuições de melhoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.01.04','DEMAIS CONTRIBUIÇÕES','Registra os créditos tributários a receber provenientes de contribuições especiais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.01.70','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.02.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.02.01','FATURAS/DUPLICATAS A RECEBER','Registra os valores provenientes dos faturamentos da venda de mercadorias/produtos e serviços do estoque da entidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.03.01','EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra os valores dos créditos por empréstimos concedidos pelo Ente, por autorização legal ou vinculação a contrato ou acordo, com vencimento a longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.03.02','FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra os valores dos créditos por financiamentos concedidos pelo Ente, por autorizaão legal ou vinculação a contrato ou acordo, com vencimento a longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.03.03','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.04.00','DÍVIDA ATIVA TRIBUTÁRIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.04.01','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','Registra os valores relativos a créditos inscritos de Dívida Ativa tributária não previdenciária.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.04.02','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','Registra os valores relativos a créditos inscritos de Dívida Ativa tributária previdenciária.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.99.01','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','Registra o ajuste para cobertura de perdas estimadas na cobrança de créditos tributários.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.99.02','(-) AJUSTE DE PERDAS DE CLIENTES','Registra o ajuste para cobertura de perdas estimadas na cobrança das contas a receber de clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.99.03','(-) AJUSTE DE PERDAS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para cobertura de perdas estimadas na cobrança de empréstimos e financiamentos concedidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.99.04','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra o ajuste para cobertura de perdas estimadas na cobrança de dívida ativa tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.1.99.05','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para cobertura de perdas estimadas na cobrança de dívida ativa não tributária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos daw variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.02.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.04.00','DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.2.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos da variação patrimonial aumentativa tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsório.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.02.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.04.00','DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.3.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após o término do exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.02.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.04.00','DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.4.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após o término do exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.02.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.04.00','DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.1.5.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.0.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende os valores a receber por demais transações, com vencimento no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por demais transações, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.01.01','ADIANTAMENTOS CONCEDIDOS A PESSOAL','Registra os valores das antecipações concedidas a servidores e a dirigentes da unidade, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de férias e de gratificações natalinas, entre outras.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','Registra os outros valores entregues antecipadamente, não classificados em contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.00','TRIBUTOS A RECUPERAR/COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/compensar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.01','IPI A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IPI a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.02','ICMS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de ICMS a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.03','ICMS DIFERIDO','Registra os valores do ICMS diferido dos estoques.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.04','IRRF A COMPENSAR','Registra o somatório dos valores do IR retido na fonte a compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.05','IR E CSLL A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IR e da CSLL a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.06','IR E CSLL DIFERIDOS','Registra a parcela do IR e CSLL que representa a diferença entre os valores de lucro apurados seguindo as normas fiscais e seguindo o regime de competência, quando estes forem menores e as diferenças temporárias.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.07','ISS A COMPENSAR','Registra o somatório dos valores do ISS a compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.08','IPVA A COMPENSAR','Registra o somatório dos valores do IPVA a compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.09','IPTU A COMPENSAR','Registra o somatório dos valores do IPTU a compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.10','ITR A COMPENSAR','Registra o somatório dos valores do ITR a compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.11','INSS A COMPENSAR','Registra o somatório dos valores do INSS a compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.12','COFINS A RECUPERAR/COMPENSAR','Registra o somatório dos valores da COFINS a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.13','PIS/PASEP A RECUPERAR/COMPENSAR','Registra o somatório dos valores do PIS/PASEP a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.14','CIP A RECUPERAR/COMPENSAR','Registra o somatório dos valores da Contribuição de Iluminação Pública a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.02.99','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de outros tributos a recuperar/compensar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.03.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os créditos a receber com realização após os doze meses seguintes a data de publicação das demonstrações contábeis, decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','Compreende os valores realizáveis após os doze meses seguintes a data de publicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.01','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','Registra o crédito do ente correspondente a débitos administrativos decorrentes de folha de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.02','CRÉDITOS A RECEBER DECORRENTES DE DANO AO PATRIMÔNIO','Registra o crédito do ente correspondente a débito administrativo decorrentes de danos ao patrimônio público.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.03','CRÉDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','Registra o crédito do ente correspondente a débito administrativo decorrentes de erro da administração.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.04','CRÉDITOS A RECEBER DECORRENTES DE DOLO, MÁ-FÉ OU FRAUDE','Registra o crédito do ente correspondente a débito administrativo decorrentes de dolo, má-fé ou fraude.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.05','CRÉDITOS A RECEBER DE SERVIDORES NÃO RECOLHIDOS NO PRAZO LEGAL','Registra os saldos dos valores entregues a funcionários ou servidores, não devolvidos dentro dos prazos estabelecidos em normas legais ou determinação administrativa ou seja, quando o produto a arrecadar não tenha sido recolhido no prazo legal.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.06','CRÉDITOS A RECEBER POR DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos as responsabilidades por irregularidades em prestação de serviços por terceiros, cujos processos foram apurados, com imputação da responsabilidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.07','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','Registra os valores referentes a multas e juros pagos pelo órgão, porém de responsabilidade de servidores, que foram apurados, com imputação da responsabilidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.08','CRÉDITOS A RECEBER POR USO INDEVIDO DE COTA','Registra os débitos (apurados e em apuração) de parlamentares em razão de recebimento indevido de valor relacionado a cota destina a custear gastos vinculados ao exercício de atividade parlamentar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.09','CRÉDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL','Registra os débitos (apurados e em apuração) referentes a débitos de parlamentares conhecidos após seu afastamento do mandado e que não puderam ser descontados em folha de pagamento. exemplos: remanescente de conta de energia elétrica, gás, taxa de limpeza pública e aluguéis de outros bens imóveis pertencente ao órgão.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.10','CRÉDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Registra as responsabilidades imputadas a órgãos pagadores por pagamentos indevidos de benefícios previdenciários, pós-morte do segurado (créditos reconhecidos sem necessidade de instauração de tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.04.99','OUTROS CRÉDITOS ADMINISTRATIVOS','Registra o crédito do ente correspondente a outros créditos administrativos que não se enquadram em rubricas específicas existentes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','Compreende os valores realizáveis após os doze meses seguintes a data de publicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em tomada de contas especial.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.01','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades imputadas a gestores e outros responsáveis e co-responsáveis por pagamentos efetuados indevidamente, inclusive em casos de super faturamento. (quando for instaurada tomada de conta especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.02','CRÉDITOS A RECEBER DE SERVIDORES NÃO RECOLHIDOS NO PRAZO LEGAL - TOMADA DE CONTAS ESPECIAL','Registra os saldos dos valores entregues a funcionários ou servidores, não devolvidos dentro dos prazos estabelecidos em normas legais ou determimanação administrativa, ou seja, quando o produto a arrecadar não tenha sido recolhido no prazo legal.(quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.03','CRÉDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','Registra os desfalques, desvios de bens e valores da ente público ou de entidades publicas, apuradas em processos por ações administrativas e policial ou julgamento judicial. (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.04','CRÉDITOS A RECEBER POR DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS - TOMADA DE CONTAS ESPECIAL','Registra os valores relativos às responsabilidades por irregularidades em prestação de serviços por terceiros, cujos processos foram apurados, com imputação da responsabilidade. (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.05','CRÉDITOS A RECEBER DE RESPONSÁVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades apuradas em inquéritos administrativo ou policial contra servidores ou terceiros, por danos e perdas causados afazenda nacional sendo apurados com imputação da responsabilidade. (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.06','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORÇAMENTÁRIO - TOMADA DE CONTAS ESPECIAL','Registra as despesas realizadas sem existência de crédito que as comporte, resultando em pagamento sem prévio empenho ou ainda com classificação imprópria (diferente daquela prevista no orçamento), apuradas, com imputação da responsabilidade (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.07','CRÉDITOS A RECEBER DECORRENTES DE CRÉDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','Registra os valores pagos sobre dotações decorrentes de créditos antecipados não realizados até o fechamento do exercicio, apurados, com imputacao da responsabilidade (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.08','CRÉDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVAÇÃO - TOMADA DE CONTAS ESPECIAL','Registra os valores correspondentes à falta de documentação comprobatória da execução da despesa, inclusive as apresentações fora do prazo legal, bem como a inadimplência na comprovação de instrumentos de transferência ou ainda irregularidade na documentação apurados, com imputação da responsabilidade (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.09','CRÉDITOS A RECEBER DECORRENTES DE FALTA DE LICITAÇÃO - TOMADA DE CONTAS ESPECIAL','Registra os valores relativos a bens e serviços adquiridos sem a necessária licitação específica, em processos motivados, por determinações administrativas e ou inquéritos, apurados, com imputação da responsabilidade. (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.10','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL','Registra os valores referentes a multas e juros pagos pelo órgão, porém de responsabilidade de servidores, que foram apurados, com imputação da responsabilidade .(quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.11','CRÉDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIÁRIAS - TOMADA DE CONTAS ESPECIAL','Registra os valores correspondentes à falta de recolhimento ou pagamento de obrigações pecuniárias, tais como: parte de obrigações patronais do empregador , valores descontados de terceiros e não recolhidos, não pagamento de obrigações para com o ente. (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.12','CRÉDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFÍCIOS - TOMADA DE CONTAS ESPECIAL','Registra os débitos relativos a fraudes em benefícios da previdência social, com a responsabilidade devidamente apurada e imputada a servidores ou terceiros (quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.13','CRÉDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades imputadas a gestores e outros responsáveis e co-responsáveis por adiantamentos concedidos em desacordo com a legislação pertinente, tais como a fornecedores e empregados.(quando for instaurada tomada de contas especial).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.14','CRÉDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL','Registra os debitos (apurados e em apuração) de parlamentares em razão de recebimento indevido de valor relacionado a cota destinada a custear gastos vinculados ao exercício de atividade parlamentar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.15','CRÉDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL','Registra os débitos (apurados e em apuração) referentes a débitos de parlamentares conhecidos após seu afastamento do mandado e que não puderam ser descontados em folha de pagamento. exemplos: remanescente de conta de energia elétrica, gás, taxa de limpeza pública e aluguéis de outros bens imóveis pertencente ao órgão.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.05.99','OUTRAS CRÉDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades diversas cujas classificações não estejam definidas em contas próprias ou para as quais não hajam contas específicas. (quando for instaurada tomada de contas especial)','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis após os doze meses seguintes a data de publicação das demonstrações contábeis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.01','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.02','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.03','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados decorrentes da interposição de recursos na esfera judicial ou administrativa.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.04','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.05','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.06','DEPÓSITOS TRANSFERIDOS','Registra os valores relativos a depósitos transferidos, para garantia de operações específicas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.07','DEPÓSITOS COMPULSÓRIOS','Registra os valores relativos a depósitos compulsórios, de acordo com a legislação em vigor.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.06.99','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.00','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','Compreende os outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.01','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','Registra os valores realizáveis após o término do exercício seguinte decorrentes de débito de entidades federais com o estado/município.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.02','CRÉDITOS A RECEBER POR CESSÃO DE CRÉDITOS','Registra os valores dos créditos a receber cedidos pelo estado/município realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.03','CRÉDITOS ORIUNDOS DE CONCESSÕES DE DIREITOS DE USO E DE EXPLORAÇÃO DE BENS','Registra o valor dos créditos oriundos das concessões de direitos de uso e de exploração de bens do estado/município, para terceiros ou para outras entidades governamentais realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.04','CRÉDITOS A RECEBER DE DEVEDORES DE CONVÊNIOS','Registra os valores, realizáveis após o término do exercício seguinte, oriundos de créditos de convênios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.05','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','Registra os valores, realizáveis após o término do exercício seguinte, dos créditos a receber decorrentes da alienação de bens móveis e imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.06','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX-SERVIDOR','Registra os valores, realizáveis após o término do exercício seguinte, dos créditos a receber decorrentes de acertos financeiros com servidores e ex-servidores do órgão.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.07','CRÉDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRAÇÃO','Registra o valor dos créditos administrativos oriundos de autos de infração e outros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.08','INDENIZAÇÕES A RECEBER','Registra o valor de indenizações a receber realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.98.99','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','Registra o valor de outros créditos a receber e valores realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.99.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.99.01','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','Registra o ajuste para perdas estimadas com o não recebimento de valores referentes a dívida ativa não tributária de longo prazo, exceto as derivadas de clientes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.99.02','(-) AJUSTE DE PERDAS DE CRÉDITOS ADMINISTRATIVOS','Registra os valores, realizáveis após o término do exercício seguinte, dos ajustes para perdas estimadas de créditos por danos ao patrimônio, verificados em processos administrativos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.99.03','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra os valores dos ajustes para perdas estimadas de créditos por danos ao patrimônio, apurados em tomada de contas especial, e realizáveis no longo prazo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.99.07','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','Registra os valores dos ajustes para perdas estimadas de créditos de divida ativa não tributaria, exceto as derivadas de clientes, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.2.1.99.98','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','Registra os valores dos ajustes para perdas estimadas de outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.01.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.01.01','TÍTULOS PÚBLICOS - MERCADO ABERTO','Registra os valores, realizáveis após o término do exercício seguinte, de títulos públicos - mercado aberto.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.01.02','AÇÕES','Registra os valores, realizáveis após o término do exercício seguinte, de ações representativas das participações dos órgãos e entidades no capital das sociedades por ações havidas por aquisições, subscrições, bonificações e doações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.01.03','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','Registra os valores, realizáveis após o término do exercício seguinte, aplicados em fundos de aplicações em cotas - renda variável.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.01.99','OUTROS TÍTULOS E VALORES MOBILIÁRIOS','Registra os valores, realizáveis após o término do exercício seguinte, de outros títulos e valores mobiliários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.02.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreendem as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.02.01','APLICAÇÃO TEMPORÁRIA EM OURO','Registra as aplicações temporárias em ouro, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.02.02','APLICAÇÃO TEMPORÁRIA EM OUTROS METAIS PRECIOSOS','Registra as aplicações temporárias em outros metais preciosos, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.03.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Registra os investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.99.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.99.01','(-) AJUSTE DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','Registra os valores de ajustes para perdas em títulos e valores mobiliários a longo prazo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.99.02','(-) AJUSTE DE PERDAS COM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','Registra os valores de ajustes para perdas em aplicações em ouro e outros metais preciosos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.3.1.99.03','(-) AJUSTE DE PERDAS COM APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Registra os valores de ajustes para perdas em investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.0.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade para utilização própria ou para venda, previstos para período posterior ao término do exercício seguinte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.00.00','ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.01.00','MERCADORIAS PARA REVENDA','Registra todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.02.00','PRODUTOS E SERVIÇOS ACABADOS','Registra os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.03.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Registra os produtos e serviços em andamento que não serão concluídos até o término do exercício subsequente a data do balanço patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.04.00','MATÉRIAS-PRIMAS','Registra o estoque de matérias-primas que será utilizado no processo produtivo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.05.00','MATERIAIS EM TRÂNSITO','Registra o valor dos materiais em processo de transferência para outras unidades da entidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.06.00','ALMOXARIFADO','Registra o valor dos materiais destinados ao consumo interno da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.07.00','ADIANTAMENTOS A FORNECEDORES','Registra os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.98.00','OUTROS ESTOQUES','Registra o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.4.1.99.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Registra o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro de perdas estimadas para os estoque que tiverem o valor de mercado inferior ao seu custo. Conta a ser utilizada apenas para os estoques classificados no ativo realizável a longo prazo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço à entidade ocorrerão no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.01.00','PRÊMIOS DE SEGUROS A APROPRIAR','Registra os valores pagos a titulo de prêmios de seguro a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.02.00','VPD FINANCEIRAS A APROPRIAR','Registra os valores pagos a título de VPD financeiras a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','Registra os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.04.00','ALUGUÉIS PAGOS A APROPRIAR','Registra os valores pagos a titulo de aluguel a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.05.00','TRIBUTOS PAGOS A APROPRIAR','Registra os valores pagos a titulo de tributos a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.06.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Registra os valores pagos a titulo de contribuições confederativas a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.07.00','BENEFÍCIOS A APROPRIAR','Registra os valores pagos a titulo de beneficio a pessoal a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.1.9.1.99.00','DEMAIS VPD A APROPRIAR','Registra os demais valores pagos a apropriar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.0.0.00.00','INVESTIMENTOS','Compreende as participações permanentes em outras sociedades, bem como os bens e direitos não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção da atividade da entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.0.00.00','PARTICIPAÇÕES PERMANENTES','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.98','(-) DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.01.99','(-) AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na Aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.1.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.98','(-) DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.01.99','(-) AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.2.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.98','(-) DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.01.99','(-) AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.3.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.98','(-) DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.01.99','(-) AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.4.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.98','(-) DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.01.99','(-) AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.1.5.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.0.00.00','PROPRIEDADES PARA INVESTIMENTO','Compreende a propriedade (terreno ou edifício – ou parte de edifício – ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','Compreende a propriedade (terreno ou edifício – ou parte de edifício – ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.01.00','BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','Compreende os valores de imóveis da unidade mantidos para futura utilização.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.01.01','TERRENOS','Registra os terrenos de propriedade do ente não destinados ao uso do mesmo nas suas atividades fins, avaliados pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.01.02','EDIFÍCIOS','Registra os edifícios ou parte deles, ou casas, de propriedade do ente não destinados ao uso do mesmo nas suas atividades fins, avaliados pelo custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.02.00','BENS IMÓVEIS NÃO DESTINADOS A USO','Compreende os valores de imóveis da unidade mantidos para geração de renda.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.02.01','TERRENOS','Registra os valores de terrenos da unidade mantidos para geração de renda.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.02.02','EDIFÍCIOS','Registra os valores de edifícios da unidade mantidos para geração de renda.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.2.1.99.00','OUTRAS PROPRIEDADES PARA INVESTIMENTOS','Registra as outras propriedades para investimentos não abrangidas nas contas anteriores, avaliadas pelo método do custo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.0.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.1.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.1.01.00','TÍTULOS E VALORES MOBILIÁRIOS - RPPS','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social em títulos e valores mobiliários .','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.1.01.01','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TÍTULOS E VALORES','Registra os investimentos realizados pelo Regime Próprio da Previdência Social em títulos e valores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.1.01.02','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN - TÍTULOS E VALORES','Registra os investimentos realizados pelo Regime Próprio da Previdência Social em aplicações em ativos não sujeitos à Resolução do CMN-Títulos e Valores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.1.02.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - RPPS','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social em aplicações em segmentos de imóveis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.3.1.02.01','IMÓVEIS – RPPS','Registra os investimentos realizados pelo Regime Próprio da Previdência Social em imóveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.0.00.00','DEMAIS INVESTIMENTOS PERMANENTES','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.1.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.1.01.00','OBRAS DE ARTE E OUTROS BENS SINGULARES','Registra os valores provenientes de Obras de Arte e outros bens singulares, tais como jóias, antiguidades, moedas sem valor liberatório e etc.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.1.02.00','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTE','Registra o valor dos Títulos e Valores Mobiliários não classificáveis no Ativo Circulante nem no Ativo Realizável a Longo Prazo, com por exemplo as Debêntures (Perpétuas).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.1.03.00','BENS MÓVEIS NÃO DESTINADOS A USO','Registra os valores de Bens Moveis da Unidade mantidos para geração de renda.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.1.04.00','BENS INTANGÍVEIS NÃO DESTINADOS A USO','Registra o valor de Bens Intangíveis não destinados ao Uso e que a Unidade não explore comercialmente.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.7.1.99.00','DEMAIS INVESTIMENTOS PERMANENTES','Registra o valor de Investimentos Permanentes, não classificáveis nas demais contas deste Plano.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.8.0.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.8.1.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS – CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das propriedades mantidas para investimento.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.8.1.01.01','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','Registra a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, dos valores de imóveis da unidade mantidos para futura utilização.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.8.1.01.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS NÃO DESTINADOS A USO','Registra a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, dos valores de imóveis da unidade mantidos para geração de renda.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.8.1.01.99','(-) DEPRECIAÇÃO ACUMULADA OUTRAS PROPRIEDADES PARA INVESTIMENTOS','Registra a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das outras propriedades mantidas para investimento.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Compreende os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.01.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra o valor da redução ao valor recuperável das participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.01.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra o valor da redução ao valor recuperável das participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Compreende os valores de ajuste ao valor recuperável de propriedades para investimento, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.02.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','Registra o valor da redução ao valor recuperável de imóveis da unidade mantidos para futura utilização.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.02.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMÓVEIS NÃO DESTINADOS A USO','Registra o valor da redução ao valor recuperável de imóveis da unidade mantidos para geração de renda.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','Registra os valores de ajuste ao valor recuperável de investimentos do RPPS, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.1.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.2.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.2.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.2.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.3.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.3.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.3.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.4.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.4.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.4.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.5.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.5.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.2.9.5.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.0.0.00.00','IMOBILIZADO','Compreende os direitos que tenham por objeto bens corpóreos destinados a manutenção das atividades da entidade ou exercidos com essa finalidade, inclusive os decorrentes de operações que transfiram a ela os benefícios, os riscos e o controle desses bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.0.00.00','BENS MÓVEIS','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.00.00','BENS MÓVEIS- CONSOLIDAÇÃO','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.00','MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Compreende o valor da aquisição ou incorporação de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.01','APARELHOS DE MEDIÇÃO E ORIENTAÇÃO','Registra os aparelhos utilizados para medição e orientação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.02','APARELHOS E EQUIPAMENTOS DE COMUNICAÇÃO','Registra os aparelhos e equipamentos utilizados para comunicação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.03','APARELHOS, EQUIPAMENTOS E UTENSÍLIOS MÉDICOS, ODONTOLÓGICOS, LABORATORIAIS E HOSPITALARES','Registra os aparelhos, equipamentos e utensílios para uso médico, odontológico, laboratorial e hospitalar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.04','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSÕES','Registra os aparelhos e equipamentos utilizados para modalidades de esportes e diversões.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.05','EQUIPAMENTO DE PROTEÇÃO, SEGURANÇA E SOCORRO','Registra os equipamentos utilizados para proteção, segurança e socorro.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.06','MÁQUINAS E EQUIPAMENTOS INDUSTRIAIS','Registra as máquinas e equipamentos de natureza industrial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.07','MÁQUINAS E EQUIPAMENTOS ENERGÉTICOS','Registra as máquinas e equipamentos energéticos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.08','MÁQUINAS E EQUIPAMENTOS GRÁFICOS','Registra as máquinas e equipamentos empregados na indústria gráfica ou necessários para sua industrialização.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.09','MÁQUINAS, FERRAMENTAS E UTENSÍLIOS DE OFICINA','Registra as máquinas, ferramentas ou utensílios utilizados em oficinas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.10','EQUIPAMENTOS DE MONTARIA','Registra os equipamentos utilizados em montarias, bem como os serviços correlacionados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.11','EQUIPAMENTOS E MATERIAL SIGILOSO E RESERVADO','Registra os equipamentos e materiais utilizados em atividades de caráter sigiloso ou reservado.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.12','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS PARA AUTOMÓVEIS','Registra os equipamentos, peças e acessórios para automóveis que podem ser desincorporados, sem prejuízo dos mesmos, para aplicação em outros veículos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.13','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS MARÍTIMOS','Registra os equipamentos, peças e acessórios marítimos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.14','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS AERONÁUTICOS','Registra os equipamentos, peças e acessórios aeronáuticos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.15','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS DE PROTEÇÃO AO VOO','Registra os equipamentos, peças e acessórios de proteção de voo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.16','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','Registra os equipamentos de mergulho e salvamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.17','EQUIPAMENTOS DE MANOBRAS E PATRULHAMENTO','Registra os equipamentos destinados ao exercício militar, serviço de bordo, guarnições, rondas ou vigilância utilizados pela unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.18','EQUIPAMENTOS DE PROTEÇÃO E VIGILÂNCIA AMBIENTAL','Registra os equipamentos utilizados em sistemas de proteção e vigilância aérea e ambiental.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.19','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS AGROPECUÁRIOS','Registra os valores relativos a máquinas, equipamentos, ferramentas e utensílios agropecuários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.20','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS RODOVIÁRIOS','Registra os valores relativos a máquinas, equipamentos, ferramentas e utensílios rodoviários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.21','EQUIPAMENTOS HIDRÁULICOS E ELÉTRICOS','Registra os equipamentos hidráulicos e elétricos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.01.99','OUTRAS MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra os valores referentes a máquinas, aparelhos, equipamentos e ferramentas não classificados em contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.02.00','BENS DE INFORMÁTICA','Compreende o valor da aquisição ou incorporação de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.02.01','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','Registra os equipamentos de centro de processamento de dados/data center, como servidores e equipamentos de armazenamento e rede.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.02.02','EQUIPAMENTOS DE TECNOLOGIA DA INFORMAÇÃO','Registra os equipamentos relacionados com tecnologia da informação, como estações de trabalho, impressoras e periféricos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.02.03','SISTEMAS APLICATIVOS - SOFTWARES','Registra o valor dos softwares adquiridos ou desenvolvidos pela empresa que seja inerente e essencial para o funcionamento do computador e que não sejam classificados juntos a esse.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.03.00','MÓVEIS E UTENSÍLIOS','Compreende o valor da aquisição ou incorporação de mobiliário em geral e utensílios, entre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.03.01','APARELHOS E UTENSÍLIOS DOMÉSTICOS','Registra os objetos ou peças de uso caseiro ou necessários a vida familiar.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.03.02','MÁQUINAS E UTENSÍLIOS DE ESCRITÓRIO','Registra as máquinas e utensílios de escritório.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.03.03','MOBILIÁRIO EM GERAL','Registra os valores relativos aos bens móveis, de caráter geral, em uso na unidade, não classificados em contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.03.04','UTENSÍLIOS EM GERAL','Registra os valores relativos a utensílios, de caráter geral, em uso na unidade, não classificados em contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Compreende o valor da aquisição ou incorporação de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.01','BANDEIRAS, FLÂMULAS E INSÍGNIAS','Registra os valores relativos a bandeiras, flâmulas e insígnias, geralmente utilizadas como distintivo da nação e de corporações, pequenas chamas, adornos, sinal distintivo, emblemas, estandartes e outros símbolos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.02','COLEÇÕES E MATERIAIS BIBLIOGRÁFICOS','Registra os valores relativos aos objetos e materiais bibliográficos destinados a reunir, geralmente, para formação de bibliotecas de uso da unidade ou cumprir objetivos dessa.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.03','DISCOTECAS E FILMOTECAS','Registra os valores relativos a discos, CDs e coleções de fitas gravadas com músicas e fitas cinematográficas de caráter educativo, científico e informativo.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.04','INSTRUMENTOS MUSICAIS E ARTÍSTICOS','Registra os valores relativos aos instrumentos musicais e artísticos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.05','EQUIPAMENTOS PARA ÁUDIO, VÍDEO E FOTO','Registra os valores de equipamentos de áudio, vídeo e foto.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.06','OBRAS DE ARTE E PEÇAS PARA EXPOSIÇÃO','Registra os valores relativos a obras e objetos de arte e de peças para decoração ou exposição em geral em museus, galerias, halls, prédios públicos e outros, desde que se destinem a manutenção de sua atividade, caso contrário, deve ser classificado como investimentos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.04.99','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra os valores referentes a materiais culturais, educacionais e de comunicação não classificados em contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.00','VEÍCULOS','Compreende o valor da aquisição ou incorporação de meios de transportes aéreos, aquáticos e terrestres, entre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.01','VEÍCULOS EM GERAL','Registra os veículos de diversos tipos, não motorizados, para os quais não tenham sido criadas contas específicas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.02','VEÍCULOS FERROVIÁRIOS','Registra os veículos destinados ao tráfego por via férrea e para usos diversos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.03','VEÍCULOS DE TRAÇÃO MECÂNICA','Registra os veículos de tração mecânica.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.04','CARROS DE COMBATE','Registra os carros de combate, tais como carro-tanque, auto-choque e assemelhados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.05','AERONAVES','Registra os veículos destinados ao tráfego aéreo, geralmente de uso comercial, no transporte de passageiros e cargas ou para treinamento, defesa e ataque militar, bem como outras atividades.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.05.06','EMBARCAÇÕES','Registra as embarcações adquiridas ou construídas e destinadas a navegação por vias marítimas, fluviais e outras vias navegáveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.06.00','PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra o valor da aquisição ou incorporação de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.07.00','BENS MÓVEIS EM ANDAMENTO','Compreende os valores de bens móveis em andamento.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.07.01','BENS MÓVEIS EM ELABORACÃO','Registra os valores relativos a todos os gastos ocorridos com bens móveis em fase de elaboração e acabamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.07.02','IMPORTAÇÕES EM ANDAMENTO','Registra os valores relativos a todos os gastos com importações em andamento de equipamentos, máquinas, aparelhos e outros bens móveis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.07.04','ALMOXARIFADO DE MATERIAIS A SEREM APLICADOS EM BENS EM ANDAMENTO','Registra todos os materiais e bens da empresa destinados a aplicação na elaboração de bens móveis em andamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.08.00','BENS MÓVEIS EM ALMOXARIFADO','Compreende os valores de bens permanentes a serem estocados em almoxarifado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.08.01','ESTOQUE INTERNO','Registra os valores dos bens móveis adquiridos e estocados em almoxarifado, destinados a atender as necessidades dos órgãos adquirentes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.08.03','BENS MÓVEIS A REPARAR','Registra os valores dos bens móveis que necessitam de reparos ou reformas, estocados em almoxarifado.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.08.05','BENS MÓVEIS INSERVÍVEIS','Registra os valores dos bens móveis inservíveis em almoxarifado, que dependem de parecer da comissão e homologação da autoridade competente para serem descarregados.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.09.00','ARMAMENTOS','Registra os valores de armas que constituem objetos de defesa ou preparativos de guerra.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.10.00','SEMOVENTES','Registra os valores relativos aos animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.99.00','DEMAIS BENS MÓVEIS','Compreende o valor da aquisição ou incorporação dos demais bens móveis não classificados em grupos específicos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.99.01','BENS MÓVEIS A ALIENAR','Registra os valores relativos aos bens móveis que, por algum motivo, foram destinados a alienação, mediante venda, permuta ou doação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.99.02','BENS EM PODER DE OUTRA UNIDADE OU TERCEIROS','Registra os valores de bens móveis de propriedade da unidade cedente, entregues a outra unidade ou terceiros por meio de convênio, comodato ou outras formas de empréstimo, distribuição ou transferência.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.99.08','BENS MÓVEIS A CLASSIFICAR','Registra os bens móveis pendentes de classificação e de identificação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.1.1.99.99','OUTROS BENS MÓVEIS','Registra o valor da aquisição ou incorporação dos outros bens móveis não podem classificados nas contas anteriores.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.0.00.00','BENS IMÓVEIS','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.00.00','BENS IMÓVEIS- CONSOLIDAÇÃO','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.00','BENS DE USO ESPECIAL','Compreende os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.01','IMÓVEIS RESIDENCIAIS','Registra os valores relativos aos imóveis residenciais dos estados ou municípios, como apartamentos; casas; residenciais; conjuntos. Os imóveis funcionais, os próprios residenciais e as vilas militares devem ser registrados nessa conta.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.02','IMÓVEIS COMERCIAIS','Registra os valores relativos aos imóveis comerciais dos estados ou municípios, como conjuntos, salas, e lojas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.03','EDIFÍCIOS','Registra os valores relativos aos seguintes imóveis dos estados ou municípios nas seguintes categorias: edifícios, prédios, conventos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.04','TERRENOS/GLEBAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: terrenos e glebas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.05','ARMAZÉNS/GALPÕES','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: armazéns e galpões.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.06','AQUARTELAMENTOS','Registra os valores relativos aos seguintes imóveis da união, estados e municípios nas seguintes categorias: bases; quartéis; fortes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.07','AEROPORTOS/ESTAÇÕES/AERÓDROMOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: aeródromo; aeroporto; estação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.08','IMÓVEIS DE USO EDUCACIONAL','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: escolas; faculdades; universidades; bibliotecas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.09','REPRESAS/AÇUDES','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: açudes; represas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.10','FAZENDAS, PARQUES E RESERVAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: fazendas; parques; reservas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.11','IMÓVEIS DE USO RECREATIVO','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem nas seguintes categorias: clubes; estádios; teatros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.12','FARÓIS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: faróis (faroletes). Os instrumentos de auxílio a navegação aérea também devem ser registrados nesta conta.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.13','MUSEUS/PALÁCIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: museus; palácios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.14','LABORATÓRIOS/OBSERVATÓRIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem nas seguintes categorias: laboratórios; observatórios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.15','HOSPITAIS E UNIDADES DE SAÚDE','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: hospitais e unidades de saúde.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.16','HOTÉIS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: hotéis.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.17','PRESÍDIOS/DELEGACIAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: presídios; delegacias.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.18','PORTOS/ESTALEIROS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: estaleiros; portos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.19','COMPLEXOS/FÁBRICAS/USINAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: fábricas; usinas; complexos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.20','CEMITÉRIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: cemitérios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.21','ESTACIONAMENTOS E GARAGENS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: estacionamentos. Também devem ser registrados nesta conta as garagens.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.22','POSTOS DE FISCALIZAÇÃO','Registra os valores relativos aos seguintes imóveis dos estados e municípios: postos policiais. Também devem ser registrados nessa conta os demais postos de fiscalização.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.01.98','OUTROS BENS IMÓVEIS DE USO ESPECIAL','Registra os valores relativos aos seguintes imóveis dos estados e municípios que não se enquadrem em nenhuma outra categoria.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.00','BENS DOMINICAIS','Compreende os bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.01','EDIFÍCIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem nas seguintes categorias: edifícios; prédios; conventos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.02','APARTAMENTOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: apartamentos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.03','ARMAZÉNS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: armazéns.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.04','CASAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: casas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.05','CEMITÉRIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: cemitérios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.06','EDIFÍCIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: edifícios.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.07','GARAGENS E ESTACIONAMENTOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: garagens e estacionamentos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.08','FAZENDAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: fazendas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.09','GALPÕES','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: galpões.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.10','GLEBAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.11','LOJAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lojas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.12','SALAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: salas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.13','TERRENOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: terrenos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.14','LOTES','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lotes.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.15','LOTES INDUSTRIAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lotes industriais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.16','GLEBAS URBANAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas urbanas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.17','GLEBAS URBANIZADAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas urbanizadas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.18','GLEBAS RURAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas rurais.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.04.99','OUTROS BENS DOMINICAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que não se enquadrem em outras categorias.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.00','BENS DE USO COMUM DO POVO','Compreende os bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.01','RUAS','Registra os valores de ruas que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.02','PRAÇAS','Registra os valores de praças que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.03','ESTRADAS','Registra os valores de estradas que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.04','PONTES','Registra os valores de pontes que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.05','VIADUTOS','Registra os valores de viadutos que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.06','SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA','Registra os valores de sistemas de esgoto e/ou de abastecimento de água que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.07','SISTEMAS DE ABASTECIMETNO DE ENERGIA','Registra os valores de sistemas de abastecimento de energia que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.08','REDES DE TELECOMUNICAÇÕES','Registra os valores de redes de telecomunicações que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.09','BENS DO PATRIMÔNIO CULTURAL','Registra osbens com significancia histórica, cultural ou ambiental tais como monumentos e prédios históricos, sítios arqueológicos, área de conservação e reservas naturais e obras de arte, quando passíveis de mensuração e avaliação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.05.99','OUTROS BENS DE USO COMUM DO POVO','Registra os valores bens de uso comum, não classificados anteriormente neste plano de contas, que foram adquiridos, produzidos ou construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.06.00','BENS IMÓVEIS EM ANDAMENTO','Compreende os valores de bens imóveis em andamento.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.06.01','OBRAS EM ANDAMENTO','Registra os valores pertinentes a obras, desde sua construção até o término da mesma.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.06.05','ESTUDOS E PROJETOS','Registra os valores relativos a estudos e projetos, englobando limpeza do terreno, serviços topográficos, sondagens de reconhecimento, terraplenagem, drenagens, instalações provisórias como galpões, instalações elétricas e hidráulicas, utilizadas durante as obras.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.07.00','INSTALAÇÕES','Registra equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.08.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.00','DEMAIS BENS IMÓVEIS','Compreende os demais bens imóveis não classificados anteriormente nesse plano de contas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.01','BENS IMÓVEIS LOCADOS PARA TERCEIROS','Registra os bens imóveis locados para terceiros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.02','IMÓVEIS EM PODER DE TERCEIROS','Registra os imóveis concedidos a terceiros a título de empréstimo gratuito com prazo de devolução convencionado.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.03','MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMÓVEIS','Registra os materiais provisoriamente separados de um imóvel, para nele se reempregarem.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.05','BENS IMÓVEIS A CLASSIFICAR','Registra os bens imóveis, cuja classificação esteja pendente por algum motivo, geralmente por falta de identificação ou pendência de legalização ou registro.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.06','BENS IMÓVEIS A ALIENAR','Registra os valores relativos aos bens imóveis separados para alienação, quando considerados desnecessários, inservíveis ou por decisão administrativa da unidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.2.1.99.99','OUTROS BENS IMÓVEIS','Registra os valores relativos a outros bens imóveis, para os quais não tenham sido criadas contas próprias ou específicas neste plano de contas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.0.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA – BENS MÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.01','(-) DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a depreciação acumulada de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE INFORMÁTICA','Registra a depreciação acumulada de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.03','(-) DEPRECIAÇÃO ACUMULADA DE MÓVEIS E UTENSÍLIOS','Registra a depreciação acumulada de mobiliário em geral e utensílios, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.04','(-) DEPRECIAÇÃO ACUMULADA DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a depreciação acumulada de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.05','(-) DEPRECIAÇÃO ACUMULADA DE VEÍCULOS','Registra a depreciação acumulada de transportes aéreos, aquáticos e terrestres, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.06','(-) DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a depreciação acumulada de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.07','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO','Registra a depreciação acumulada de bens móveis em andamento.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.08','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ALMOXARIFADO','Registra a depreciação acumulada de bens permanentes a serem estocados em almoxarifado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.09','(-) DEPRECIAÇÃO ACUMULADA DE ARMAMENTOS','Registra a depreciação acumulada de armas que constituem objetos de defesa ou preparativos de guerra.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.10','(-) DEPRECIAÇÃO ACUMULADA DE SEMOVENTES','Registra a depreciação acumulada de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.01.99','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS','Registra a depreciação acumulada de demais bens móveis não classificados em grupos específicos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.00','(-) DEPRECIAÇÃO ACUMULADA – BENS IMÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.01','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO ESPECIAL','Registra a depreciação acumulada de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS DOMINICAIS','Registra a depreciação acumulada de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.03','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO','Registra a depreciação acumulada de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.04','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS EM ANDAMENTO','Registra a depreciação acumulada de valores de bens imóveis em andamento.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.05','(-) DEPRECIAÇÃO ACUMULADA DE INSTALAÇÕES','Registra a depreciação acumulada de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.06','(-) DEPRECIAÇÃO ACUMULADA DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a depreciação acumulada de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.02.99','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS IMÓVEIS','Registra a depreciação acumulada de os demais bens imóveis não classificados anteriormente nesse plano de contas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.03.00','(-) EXAUSTÃO ACUMULADA – BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.04.00','(-) EXAUSTÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.05.00','(-) AMORTIZAÇÃO ACUMULADA – BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.8.1.06.00','(-) AMORTIZAÇÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens Imóveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MÓVEIS','Compreende os valores de ajuste ao valor recuperável de bens moveis, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.01','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra os valores de ajuste ao valor recuperável de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.02','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','Registra os valores de ajuste ao valor recuperável de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.03','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','Registra os valores de ajuste ao valor recuperável de mobiliário em geral e utensílios, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.04','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra os valores de ajuste ao valor recuperável de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.05','(-) REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','Registra os valores de ajuste ao valor recuperável de transportes aéreos, aquáticos e terrestres, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.06','(-) REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra os valores de ajuste ao valor recuperável de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.07','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','Registra os valores de ajuste ao valor recuperável de bens móveis em andamento.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.08','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','Registra os valores de ajuste ao valor recuperável de bens permanentes a serem estocados em almoxarifado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.09','(-) REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','Registra os valores de ajuste ao valor recuperável de armas que constituem objetos de defesa ou preparativos de guerra.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.10','(-) REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','Registra os valores de ajuste ao valor recuperável de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.01.99','(-) REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','Registra os valores de ajuste ao valor recuperável de demais bens móveis não classificados em grupos específicos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','Compreende os valores de ajuste ao valor recuperável de bens imóveis, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.01','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','Registra os valores de ajuste ao valor recuperável de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.02','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','Registra os valores de ajuste ao valor recuperável de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.03','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','Registra os valores de ajuste ao valor recuperável de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.04','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','Registra os valores de ajuste ao valor recuperável de valores de bens imóveis em andamento.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.05','(-) REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','Registra os valores de ajuste ao valor recuperável de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.06','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra os valores de ajuste ao valor recuperável de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.3.9.1.02.99','(-) REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','Registra os valores de ajuste ao valor recuperável de os demais bens imóveis não classificados anteriormente nesse plano de contas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.0.0.00.00','INTANGÍVEL','Compreende os direitos que tenham por objeto bens incorpóreos destinados a manutenção da entidade ou exercidos com essa finalidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.1.0.00.00','SOFTWARES','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.1.1.00.00','SOFTWARES- CONSOLIDAÇÃO','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.1.1.01.00','SOFTWARES','Registra os valores dos softwares pertencentes ao órgão, englobando os valores referentes à construção, implementação e instalação do programa.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.1.1.02.00','SOFTWARES EM DESENVOLVIMENTO','Registra os valores apropriados na fase de desenvolvimento do software, de acordo com a nota técnica específica para o tema.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.0.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação e direitos autorais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS- CONSOLIDAÇÃO','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação, direitos autorais e direitos sobre recursos naturais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.01.00','MARCAS E PATENTES INDUSTRIAIS','Registra os valores relativos a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, além de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fábricação (tecnologia).','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.02.00','CONCESSÃO DE DIREITO DE USO DE COMUNICAÇÃO','Registra os valores relativos a bens intangíveis representados pela concessão de direito de uso de comunicação e divulgação.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.03.00','DIREITOS AUTORAIS','Registra os valores relativos aos direitos autorais adquiridos pela entidade.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.04.00','DIREITOS SOBRE RECURSOS NATURAIS','Registra os valores relativos aos direitos obtidos por legislação e/ou por compras de direitos de reservas ou de exploração de recursos naturais, tais como jazidas e outros.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.05.00','ADIANTAMENTO PARA TRANFERÊNCIA DE TECNOLOGIA','Registra todos os adiantamentos a fornecedores vinculados a um contrato de transferencia de tecnologia. Representam pagamentos por conta de um valor previamente contratado.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.2.1.99.00','OUTROS DIREITOS - BENS INTANGÍVEIS','Registra os valores relativos a outros direitos, classificados como bens intangíveis, cuja classificação não esteja definida em contas específicas.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.3.0.00.00','DIREITO DE USO DE IMÓVEIS','Compreende os valores pertinentes a bens intangíveis representados pela aquisição do direito de uso de imóveis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.3.1.00.00','DIREITO DE USO DE IMÓVEIS- CONSOLIDAÇÃO','Compreende os valores pertinentes a bens intangíveis representados pela aquisição de direito de uso de imóveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.8.0.00.00','(-) AMORTIZAÇÃO ACUMULADA','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.8.1.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.8.1.01.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','Registra a diminuição do valor do capital aplicado em softwares, pertencentes ao ativo intangível.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.8.1.02.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATENTES','Registra a diminuição do valor do capital aplicado em marcas, direitos e patentes, pertencentes ao ativo intangível.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.8.1.03.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','Registra a diminuição do valor do capital aplicado em direito de uso de imóveis, pertencentes ao ativo intangível.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','Registra os valores de ajuste ao valor recuperável do software pertencente ao ativo intangível, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATENTES','Registra os valores de ajuste ao valor recuperável das marcas, direitos e patentes, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'1.2.4.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','Registra os valores de ajuste ao valor recuperável de direito de uso, quando esse for inferior ao valor liquido contábil.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.0.0.0.0.00.00','PASSIVO E PATRIMÔNIO LÍQUIDO','Passivo compreende as obrigações existentes da entidade oriundas de eventos passados de cuja liquidação se espera que resulte em fluxo de saída de recursos que incorporem benefícios econômicos ou serviços em potencial. Patrimônio liquido compreende a diferença entre o ativo e o passivo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.0.0.0.00.00','PASSIVO CIRCULANTE','Compreende as obrigações conhecidas e estimadas que atendam a qualquer um dos seguintes critérios: tenham prazos estabelecidos ou esperados dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; tenham prazos estabelecidos ou esperados no curto prazo; sejam valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar, benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações , com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.0.00.00','PESSOAL A PAGAR','Compreende as obrigações a curto prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.01.00','PESSOAL A PAGAR DO EXERCÍCIO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas ao exercício atual.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.01.01','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DO EXERCÍCIO','Registra as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas ao exercício atual.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.01.02','DÉCIMO TERCEIRO SALÁRIO','Registra as obrigações referentes ao décimo terceiro salário, geralmente apropriadas na base de 1/12 do valor bruto da folha de pagamento da unidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.01.03','FÉRIAS','Registra as obrigações referentes a férias, geralmente apropriadas como percentuais da folha de pagamento da unidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.01.04','LICENÇA- PRÊMIO','Registra os valores das obrigações constituídas com base em percentuais de salários, destinados ao pagamento de licença-prêmio.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.01.05','PARTICIPAÇÕES A EMPREGADOS','Registra os valores das obrigações do exercício constituídas para pagamento de participações a empregados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.02.00','PESSOAL A PAGAR DE EXERCÍCIOS ANTERIORES','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas a exercícios anteriores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.02.01','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERC. ANTERIORES','Registra as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas a exercicios anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.02.02','PARTICIPAÇÕES A EMPREGADOS - EXERC. ANTERIORES','Registra os valores das obrigações de exercícios anteriores constituídas para pagamento de participações a empregados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.03.00','PRECATÓRIOS DE PESSOAL','Compreende os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.03.01','PRECATÓRIOS DE PESSOAL DO EXERCÍCIO','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.03.02','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - ANTES DE 05/05/2000','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.03.03','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - A PARTIR DE 05/05/2000','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, de exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.1.1.03.04','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de pessoal do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a curto prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.01.00','BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas no exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.02.00','BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas em exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.03.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Compreende as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.03.01','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.03.02','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.1.03.03','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões e exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTRA OFSS','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.01.00','BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas no exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.02.00','BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas em exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.03.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Compreende as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.03.01','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.03.02','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.2.03.03','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões e exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.01.00','BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas no exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.02.00','BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas em exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.03.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Compreende as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.03.01','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.03.02','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.3.03.03','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões e exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - ESTADO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.01.00','BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas no exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.02.00','BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas em exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.03.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Compreende as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.03.01','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.03.02','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.4.03.03','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões e exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - MUNICÍPIO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.01.00','BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas no exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.02.00','BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas em exercícios anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.03.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Compreende as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.03.01','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.03.02','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.2.5.03.03','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões e exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a curto prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.3.1.01.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR DO EXERCÍCIO','Registra as obrigações relativas aos benefícios assistênciais administrados pela previdência social liquidados no exercício e ainda não pagos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.3.1.02.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR DE EXERCÍCIOS ANTERIORES','Registra os valores relativos aos benefícios assistênciais administrados pela previdência social, de exercícios anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a curto prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.1.07.00','CONTRIBUIÇÃO A ENTIDADES DE PREVIDÊNCIA PRIVADA E COMPLEMENTAR','Registra as obrigações relativas à entidades de previdência privada e complementar, inclusive à entidades de previdência privada e assitência médico-odontológica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.1.08.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.1.98.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','Registra os valores relativos às contribuições patronais para custeio do plano de seguridade social do servidor, conforme arts. 3 e 4 da Lei nº. 8.688 de 21/07/93.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.04.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','Compreende os valores relativos às obrigações com regimes próprios de previdência, não identificados como previdência privada ou complementar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.04.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA DO ENTE','Registra os valores relativos às obrigações com regimes próprios de previdência de pessoal do ente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.05.00','PREVIDÊNCIA SOCIAL RURAL','Registra os valores relativos às obrigações das empresas ou instituições, resultantes do cálculo da previdência social rural.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.07.00','SALÁRIO EDUCAÇÃO','Registra os valores relativos às obrigações das empresas ou instituições, resultantes do cálculo do salário educação, com base no montante da folha de pagamento de salários.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.2.08.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.01.00','INSS A PAGAR','Compreende os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos e sobre serviços de terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','Registra os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.01.02','INSS - DÉBITO PARCELADO','Registra os valores de débito parcelado que se referem ao não recolhimento de obrigações da folha de pagamento junto ao INSS.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','Registra os valores relativos às contribuições incidentes sobre serviços prestados por terceiros ou contribuintes avulsos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','Registra os compromissos perante o fundo da previdência e assistência social (FPAS).','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','Registra os valores relativos às contribuições patronais para custeio do plano de seguridade social do servidor, conforme arts. 3 e 4 da Lei nº. 8.688 de 21/07/93.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.04.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','Compreende os valores relativos às obrigações com regimes próprios de previdência, não identificados como previdência privada ou complementar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.04.02','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','Registra os valores relativos às obrigações com regimes próprios de previdência, de pessoal requisitado de outros entes da federação.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.05.00','PREVIDÊNCIA SOCIAL RURAL','Registra os valores relativos às obrigações das empresas ou instituições, resultantes do cálculo da previdência social rural.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.06.00','FGTS','Registra os valores dos encargos sociais a recolher ao FGTS, gerados por pagamentos de salários.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.08.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.3.98.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.01.00','INSS A PAGAR','Compreende os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos e sobre serviços de terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','Registra os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.01.02','INSS - DÉBITO PARCELADO','Registra os valores de débito parcelado que se referem ao não recolhimento de obrigações da folha de pagamento junto ao INSS.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','Registra os valores relativos às contribuições incidentes sobre serviços prestados por terceiros ou contribuintes avulsos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','Registra os compromissos perante o fundo da previdência e assistência social (FPAS).','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','Registra os valores relativos às contribuições patronais para custeio do plano de seguridade social do servidor, conforme arts. 3 e 4 da Lei nº. 8.688 de 21/07/93.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.04.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','Compreende os valores relativos às obrigações com regimes próprios de previdência, não identificados como previdência privada ou complementar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.04.02','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','Registra os valores relativos às obrigações com regimes próprios de previdência, de pessoal requisitado de outros entes da federação.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.05.00','PREVIDÊNCIA SOCIAL RURAL','Registra os valores relativos às obrigações das empresas ou instituições, resultantes do cálculo da previdência social rural.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.06.00','FGTS','Registra os valores dos encargos sociais a recolher ao FGTS, gerados por pagamentos de salários.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.08.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.4.98.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.01.00','INSS A PAGAR','Compreende os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos e sobre serviços de terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','Registra os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.01.02','INSS - DÉBITO PARCELADO','Registra os valores de débito parcelado que se referem ao não recolhimento de obrigações da folha de pagamento junto ao INSS.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','Registra os valores relativos às contribuições incidentes sobre serviços prestados por terceiros ou contribuintes avulsos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','Registra os compromissos perante o fundo da previdência e assistência social (FPAS).','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','Registra os valores relativos às contribuições patronais para custeio do plano de seguridade social do servidor, conforme arts. 3 e 4 da Lei nº. 8.688 de 21/07/93.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.04.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','Compreende os valores relativos às obrigações com regimes próprios de previdência, não identificados como previdência privada ou complementar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.04.02','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','Registra os valores relativos às obrigações com regimes próprios de previdência, de pessoal requisitado de outros entes da federação.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.05.00','PREVIDÊNCIA SOCIAL RURAL','Registra os valores relativos às obrigações das empresas ou instituições, resultantes do cálculo da previdência social rural.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.06.00','FGTS','Registra os valores dos encargos sociais a recolher ao FGTS, gerados por pagamentos de salários.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.08.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.1.4.5.98.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','Compreende as obrigações financeiras externas e internas da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Registra os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.3.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Registra os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.4.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Registra os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.1.5.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Registra os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.2.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.2.1.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS - EM TÍTULOS','Registra os valores das operações de crédito externas decorrentes da emissão de títulos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','Registra os valores das operações de crédito externas decorrentes da emissão em contratos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Registra os empréstimos a curto prazo - externo - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.0.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.3.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.4.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.3.5.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.4.0.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.4.1.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes de financiamentos externos a curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos externos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos externos a curto prazo contraídos para o capital de giro.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos externos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.3.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.3.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.3.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.3.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.4.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.4.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.4.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.4.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos externos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos externos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.3.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.3.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.4.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.4.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS – MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos externos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos externos.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.0.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.01.00','FORNECEDORES NACIONAIS','Compreende os valores a pagar aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','Compreende as obrigações referentes a precatórios de fornecedores nacionais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de fornecedores nacionais do exercicio.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – ANTERIORES A 05/5/2000','Registra os valores relativos a precatórios de contas a pagar a fornecedores nacionais de exercícios anteriores, anteriores a 05/05/2000 (lei de responsabilidde fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.02.03','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – A PARTIR DE 05/5/2000','Registra os valores relativos a precatórios de contas a pagar a fornecedores nacionais de exercícios anteriores, a partir de 05/05/2000 (lei de responsabilidde fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de fornecedores a pagar do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.03.00','CONTAS A PAGAR CREDORES NACIONAIS','Compreende os valores a pagar aos credores nacionais decorrentes do fornecimento de bens/materiais e da prestação de contas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.03.01','CONTAS NÃO FINANCIADAS A PAGAR','Registra os valores não financiados, ou seja, em uma única parcela, de contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.03.02','CONTAS FINANCIADAS A PAGAR','Registra os valores financiados de contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.03.03','PARCELAMENTO DE CONTAS A PAGAR','Registra o parcelamento de dívidas com contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.03.99','DEMAIS CONTAS A PAGAR','Registra os valores de demais contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.04.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','Compreende as obrigações referentes a precatórios de contas a pagar - credores nacionais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.04.01','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de contas a pagar a credores nacionais do exercício.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.04.02','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','Registra os valores relativos a precatórios de contas a pagar a credores nacionais de exercícios anteriores, anteriores a 05/05/2000 (lei de responsabilidde fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.04.03','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra os valores relativos a precatórios de contas a pagar a credores nacionais de exercícios anteriores, a partir de 05/05/2000 (lei de responsabilidde fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.1.1.04.04','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de contas a pagar do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.0.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos fornecedores estrangeiros de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.02.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos credores estrangeiros decorrentes do fornecimento de bens/materiais e da prestação de contas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.02.01','CONTAS NÃO FINANCIADAS A PAGAR','Registra os valores não financiados, ou seja, em uma única parcela, de contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.02.02','CONTAS FINANCIADS A PAGAR','Registra os valores financiados de contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.02.03','PARCELAMENTO DE CONTAS A PAGAR','Registra o parcelamento de dívidas com contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.3.2.1.02.99','DEMAIS CONTAS A PAGAR','Registra os valores de demais contas a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.0.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.01.00','IPI A RECOLHER','Registra o valor das Obrigações Tributárias a Recolher referentes ao Imposto sobre Produtos Industrializados das Unidades Industriais ou com características dessas, geradas pelas vendas de produtos industriais e sujeiras a compensação com os créditos adquiridos por compras de matérias primas, em conformidade com a sistemática de apuração deste imposto.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.02.00','IRPJ A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Renda pessoa Jurídica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.03.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de curto prazo relativos a diferenças intertemporais (Deliberação da CVM nº 273, de 20/08/98), correspondentes ao Imposto de Renda Pessoa Jurídica (IRPJ) e Contribuição Social sobre o Lucro Líquido (CSSL), bem como PIS/PASEP e Confins (Lei nº 9718 de 27/11/1998).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Importação a Recolher.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.05.00','IOF A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre Operações Financeiras a Recolher.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.06.00','ITR A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre a Propriedade Territorial Rural (ITR).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.08.00','CIDE A RECOLHER','Registra os valores das obrigações exigíveis a curto prazo relativas a contribuição de intervenção no domínio econômico (CIDE) (LEI Nº 10.168/2000).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.09.00','CSSL A RECOLHER','Registra o valor das Obrigações exigíveis a Curto Prazo relativas a Contribuição Social sobre o Lucro das Pessoas Jurídicas (CSSL).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.10.00','COFINS A RECOLHER','Registra o valor das obrigações exigíveis a curto prazo a recolher relativas à Contribuição para Financiamento da Seguridade Social (COFINS).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.11.00','PIS/PASEP A RECOLHER','Registra o valor das obrigações a recolher relativas ao Programa de Integração Social (PIS) e ao Programa de Formação do Servidor Público (PASEP).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores exigíveis a curto prazo devidos pela entidade relativos a tributos federais que tenham sido renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.13.00','RECURSOS FISCAIS - DARF A EMITIR','Registra o valor das Obrigações exigíveis a Curto Prazo a recolher relativas a Recursos Fiscais - DARF a Emitir.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os valores exigíveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao Tesouro Nacional, para os quais não haja conta específica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - INTRA OFSS','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.01.00','IPI A RECOLHER','Registra o valor das Obrigações Tributárias a Recolher referentes ao Imposto sobre Produtos Industrializados das Unidades Industriais ou com características dessas, geradas pelas vendas de produtos industriais e sujeiras a compensação com os créditos adquiridos por compras de matérias primas, em conformidade com a sistemática de apuração deste imposto.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.02.00','IRPJ A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Renda pessoa Jurídica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.03.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de curto prazo relativos a diferenças intertemporais (Deliberação da CVM nº 273, de 20/08/98), correspondentes ao Imposto de Renda Pessoa Jurídica (IRPJ) e Contribuição Social sobre o Lucro Líquido (CSSL), bem como PIS/PASEP e Confins (Lei nº 9718 de 27/11/1998).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Importação a Recolher.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.05.00','IOF A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre Operações Financeiras a Recolher.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.06.00','ITR A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre a Propriedade Territorial Rural (ITR).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.08.00','CIDE A RECOLHER','Registra os valores das obrigações exigíveis a curto prazo relativas a contribuição de intervenção no domínio econômico (CIDE) (LEI Nº 10.168/2000).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.09.00','CSSL A RECOLHER','Registra o valor das Obrigações exigíveis a Curto Prazo relativas a Contribuição Social sobre o Lucro das Pessoas Jurídicas (CSSL).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.10.00','COFINS A RECOLHER','Registra o valor das obrigações exigíveis a curto prazo a recolher relativas à Contribuição para Financiamento da Seguridade Social (COFINS).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.11.00','PIS/PASEP A RECOLHER','Registra o valor das obrigações a recolher relativas ao Programa de Integração Social (PIS) e ao Programa de Formação do Servidor Público (PASEP).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores exigíveis a curto prazo devidos pela entidade relativos a tributos federais que tenham sido renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.13.00','RECURSOS FISCAIS - DARF A EMITIR','Registra o valor das Obrigações exigíveis a Curto Prazo a recolher relativas a Recursos Fiscais - DARF a Emitir.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os valores exigíveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao Tesouro Nacional, para os quais não haja conta específica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.01.00','IPI A RECOLHER','Registra o valor das Obrigações Tributárias a Recolher referentes ao Imposto sobre Produtos Industrializados das Unidades Industriais ou com características dessas, geradas pelas vendas de produtos industriais e sujeiras a compensação com os créditos adquiridos por compras de matérias primas, em conformidade com a sistemática de apuração deste imposto.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.02.00','IRPJ A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Renda pessoa Jurídica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.03.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de curto prazo relativos a diferenças intertemporais (Deliberação da CVM nº 273, de 20/08/98), correspondentes ao Imposto de Renda Pessoa Jurídica (IRPJ) e Contribuição Social sobre o Lucro Líquido (CSSL), bem como PIS/PASEP e Confins (Lei nº 9718 de 27/11/1998).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Importação a Recolher.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.05.00','IOF A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre Operações Financeiras a Recolher.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.06.00','ITR A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre a Propriedade Territorial Rural (ITR).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.08.00','CIDE A RECOLHER','Registra os valores das obrigações exigíveis a curto prazo relativas a contribuição de intervenção no domínio econômico (CIDE) (Lei Nº 10.168/2000).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.09.00','CSSL A RECOLHER','Registra o valor das Obrigações exigíveis a Curto Prazo relativas a Contribuição Social sobre o Lucro das Pessoas Jurídicas (CSSL).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.10.00','COFINS A RECOLHER','Registra o valor das obrigações exigíveis a curto prazo a recolher relativas à Contribuição para Financiamento da Seguridade Social (COFINS).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.11.00','PIS/PASEP A RECOLHER','Registra o valor das obrigações a recolher relativas ao Programa de Integração Social (PIS) e ao Programa de Formação do Servidor Público (PASEP).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores exigíveis a curto prazo devidos pela entidade relativos a tributos federais que tenham sido renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.13.00','RECURSOS FISCAIS - DARF A EMITIR','Registra o valor das Obrigações exigíveis a Curto Prazo a recolher relativas a Recursos Fiscais - DARF a Emitir.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os valores exigíveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao Tesouro Nacional, para os quais não haja conta específica.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.01.00','ICMS A RECOLHER','Compreende o valor das Obrigações exigíveis em Função das vendas de Mercadorias e Serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e prestação de Serviços (ICMS), Sujeitos a Compensações com os Créditos obtidos em Compras de Mercadorias e Serviços, Conforme sistemática de apuração deste Imposto ou sobre Mercadorias de Terceiros entregues para Depósito.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','Registra o valor das obrigações exigíveis em função das vendas de mercadorias e serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e Prestação de Serviços (ICMS), Sujeitas a Compensações com os créditos obtidos em compras de mercadorias e Serviços, conforme sistemática de apuração deste imposto.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','Registra o valor das Obrigações exigíveis em função da entrada de Mercadorias de Terceiros entregues a Unidade para deposito em Armazém.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.02.00','IPVA A RECOLHER','Registra o valor das obrigações exigíveis relativas ao Imposto sobre a Propriedade de Veículos Automotores (IPVA).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos relativos a Tributos que foram renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','Registra o valor das obrigações junto ao Governo Estadual, referentes a taxa de cooperação e defesa da orizicultura - CDO.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Atendimento Contra Incêndio.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Licenciamento Anual de Veículos, decorrente do serviço de licenciamento de veículos automotores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.07.00','RECURSOS FISCAIS ESTADUAIS','Registra o valor das Obrigações junto ao Governo Estadual, referente a Recursos Fiscais Estaduais.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra o valor das Obrigações junto ao Governo Estadual, referente a Taxa de Licenciamento Ambiental.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a Curto prazo, decorrentes da incidência de tributos para os quais não haja contas especificas. Registra os valores exigíveis a Curto Prazo provenientes da Retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Estadual, para os quais não haja contas especificas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTRA OFSS','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.01.00','ICMS A RECOLHER','Compreende o valor das Obrigações exigíveis em Função das vendas de Mercadorias e Serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e prestação de Serviços (ICMS), Sujeitos a Compensações com os Créditos obtidos em Compras de Mercadorias e Serviços, Conforme sistemática de apuração deste Imposto ou sobre Mercadorias de Terceiros entregues para Depósito.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','Registra o valor das obrigações exigíveis em função das vendas de mercadorias e serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e Prestação de Serviços (ICMS), Sujeitas a Compensações com os créditos obtidos em compras de mercadorias e Serviços, conforme sistemática de apuração deste imposto.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','Registra o valor das Obrigações exigíveis em função da entrada de Mercadorias de Terceiros entregues a Unidade para deposito em Armazém.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.02.00','IPVA A RECOLHER','Registra o valor das obrigações exigíveis relativas ao Imposto sobre a Propriedade de Veículos Automotores (IPVA).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos relativos a Tributos que foram renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','Registra o valor das obrigações junto ao Governo Estadual, referentes a taxa de cooperação e defesa da orizicultura - CDO.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Atendimento Contra Incêndio.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Licenciamento Anual de Veículos, decorrente do serviço de licenciamento de veículos automotores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.07.00','RECURSOS FISCAIS ESTADUAIS','Registra o valor das Obrigações junto ao Governo Estadual, referente a Recursos Fiscais Estaduais.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra o valor das Obrigações junto ao Governo Estadual, referente a Taxa de Licenciamento Ambiental.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a Curto prazo, decorrentes da incidência de tributos para os quais não haja contas especificas. Registra os valores exigíveis a Curto Prazo provenientes da Retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Estadual, para os quais não haja contas especificas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.01.00','ICMS A RECOLHER','Compreende o valor das Obrigações exigíveis em Função das vendas de Mercadorias e Serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e prestação de Serviços (ICMS), Sujeitos a Compensações com os Créditos obtidos em Compras de Mercadorias e Serviços, Conforme sistemática de apuração deste Imposto ou sobre Mercadorias de Terceiros entregues para Depósito.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','Registra o valor das obrigações exigíveis em função das vendas de mercadorias e serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e Prestação de Serviços (ICMS), Sujeitas a Compensações com os créditos obtidos em compras de mercadorias e Serviços, conforme sistemática de apuração deste imposto.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','Registra o valor das Obrigações exigíveis em função da entrada de Mercadorias de Terceiros entregues a Unidade para deposito em Armazém.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.02.00','IPVA A RECOLHER','Registra o valor das obrigações exigíveis relativas ao Imposto sobre a Propriedade de Veículos Automotores (IPVA).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos relativos a Tributos que foram renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','Registra o valor das obrigações junto ao Governo Estadual, referentes a taxa de cooperação e defesa da orizicultura - CDO.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Atendimento Contra Incêndio.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Licenciamento Anual de Veículos, decorrente do serviço de licenciamento de veículos automotores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.07.00','RECURSOS FISCAIS ESTADUAIS','Registra o valor das Obrigações junto ao Governo Estadual, referente a Recursos Fiscais Estaduais.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra o valor das Obrigações junto ao Governo Estadual, referente a Taxa de Licenciamento Ambiental.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a Curto prazo, decorrentes da incidência de tributos para os quais não haja contas especificas. Registra os valores exigíveis a Curto Prazo provenientes da Retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Estadual, para os quais não haja contas especificas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.01.00','ISS A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre Serviços de Qualquer Natureza (ISS) em que a própria Unidade seja a prestadora de serviço.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.02.00','IPTU/TLP A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre a Propriedade Predial e Territorial Urbana (IPTU) e Taxa de Limpeza Pública (TLP).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela unidade relativos a Tributos que foram renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal referentes a Contribuição para Custeio de Iluminação Pública.(ART.149-A da Constituição Federal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.06.00','RECURSOS FISCAIS MUNICIPAIS','Registra os valores exigíveis a Curto Prazo provenientes de retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Municipal, por meio de documento de arrecadação (DAR).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Licenciamento Ambiental.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.08.00','TAXA DE INSPEÇÃO VEICULAR','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Inspeção Veicular.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a Curto Prazo, decorrentes da incidência de tributos para os quais não haja contas especificas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - INTRA OFSS','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.01.00','ISS A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre Serviços de Qualquer Natureza (ISS) em que a própria Unidade seja a prestadora de serviço.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.02.00','IPTU/TLP A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre a Propriedade Predial e Territorial Urbana (IPTU) e Taxa de Limpeza Pública (TLP).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela unidade relativos a Tributos que foram renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PÚBLICA A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal referentes a Contribuição para Custeio de Iluminação Pública.(ART.149-A da Constituição Federal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.06.00','RECURSOS FISCAIS MUNICIPAIS','Registra os valores exigíveis a Curto Prazo provenientes de retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Municipal, por meio de documento de arrecadação (DAR).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Licenciamento Ambiental.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.08.00','TAXA DE INSPEÇÃO VEICULAR','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Inspeção Veicular.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a Curto Prazo, decorrentes da incidência de tributos para os quais não haja contas especificas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - INTER OFSS - MUNICÍPIO','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.01.00','ISS A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre Serviços de Qualquer Natureza (ISS) em que a própria Unidade seja a prestadora de serviço.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.02.00','IPTU/TLP A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre a Propriedade Predial e Territorial Urbana (IPTU) e Taxa de Limpeza Pública (TLP).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela unidade relativos a Tributos que foram renegociados.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PÚBLICA A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal referentes a Contribuição para Custeio de Iluminação Pública.(ART.149-A da Constituição Federal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.06.00','RECURSOS FISCAIS MUNICIPAIS','Registra os valores exigíveis a Curto Prazo provenientes de retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Municipal, por meio de documento de arrecadação (DAR).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Licenciamento Ambiental.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.08.00','TAXA DE INSPEÇÃO VEICULAR','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Inspeção Veicular.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a Curto Prazo, decorrentes da incidência de tributos para os quais não haja contas especificas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.5.0.0.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.5.0.3.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.5.0.4.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.5.0.5.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.0.0.00.00','PROVISÕES A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','Registra os valores das provisões constituídas visando o pagamento de indenizações trabalhistas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','Registra os valores das provisões constituídas visando o pagamento de dissídios coletivos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.0.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','Compreende os valores das provisões para pagamento de autos de infração já lavrados e que se encontram na esfera administrativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade ainda não apresentou recurso administrativo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade apresentou recurso administrativo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','Compreende os valores das provisões para pagamento de autuações fiscais que já se encontram na esfera judicial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera juducial e que não estão em fase recursal.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera juducial em fase recursal.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','Registra os valores das provisões constituídas para o pagamento de indenizações cíveis.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','Registra os valores das provisões para pagamento de seguros referentes a sinistros a liquidar.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTÍFICADOS','Registra os valores das provisões para pagamento de seguros referentes a sinistros já cientificados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTÍFICADOS','Registra os valores das provisões para pagamento de seguros referentes a sinistros não cientificados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreente os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os valores de operações efetuadas entre uma unidade pertencente ao Orçamento Fiscal e da Seguridade Social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.9.0.00.00','OUTRAS PROVISÕES A CURTO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo, não classificadas anteriormente neste plano de contas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.9.1.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.9.1.01.00','PROVISÃO PARA GARANTIAS','Registra os valores das provisões destinadas a cobrir despesas com a prestação de garantia relativas a produtos vendidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','Registra os valores das provisões destinadas a cobrir obrigações oriundas da venda ou extinção de uma linha de negócios, fechamento de fábricas ou locais de negócios, mudanças na estrututa da administração e reorganizações com efeito relevante na natureza e foco das operações da entidade.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.7.9.1.99.00','OUTRAS PROVISÕES A CURTO PRAZO','Registra os valores das provisões não classificáveis nas demais contas deste plano de contas.','C','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.0.0.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, com vencimento no curto prazo, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.3.0.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.3.1.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.3.1.01.00','ARRENDAMENTO OPERACIONAL A PAGAR','Registra as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A CURTO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.01.00','DEBÊNTURES CONVERSÍVEIS EM AÇÕES NO CURTO PRAZO','Registra os títulos emitidos pela entidade que conferirão aos seus titulares direito de crédito contra ela, nas condições constantes da escritura de emissão do título e que são conversíveis em ações, com vencimento até o término do exercício seguinte.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.02.00','DEBÊNTURES NÃO-CONVERSÍVEIS EM AÇÕES NO CURTO PRAZO','Registra os títulos emitidos pela entidade que conferirão aos seus titulares direito de crédito contra ela, nas condições constantes da escritura de emissão do título e que não são conversíveis em ações, com vencimento até o término do exercício seguinte.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.96.00','ÁGIO NA EMISSÃO DE DEBÊNTURES','Registra os valores de ágio na emissão de debêntures, que são os valores recebidos que superam o de resgate desses títulos na data do próprio recebimento ou do valor formalmente atribuído às debêntures.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.97.00','(-) DESÁGIO NA EMISSÃO DE DEBÊNTURES','Registra os valores de deságio na emissão de debêntures, que são os valores recebidos inferiores ao valor de resgate desses títulos na data do próprio recebimento ou do valor formalmente atribuído às debêntures.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.98.00','(-) CUSTO DA TRANSAÇÃO A AMORTIZAR','Registra os custos da transação a amortizar, que são apenas os custos incorridos e diretamente atribuíveis às atividades necessárias exclusivamente à consecução da transação. por exemplo: taxas e comissões. Entretanto, não incluem despesas financeiras, custos internos administrativos ou custo de carregamento.','D','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.4.1.99.00','OUTROS TÍTULOS','Registra outros títulos de dívida com vencimento até o término do exercício seguinte.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.5.0.00.00','DIVIDENDOS A PAGAR','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.5.1.00.00','DIVIDENDOS A PAGAR- CONSOLIDAÇÃO','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.5.1.01.00','DIVIDENDOS A PAGAR - TESOURO ESTADUAL/MUNICIPAL','Registra os valores a serem pagos ao tesouro estadual/municipal a título de dividendos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.5.1.02.00','DIVIDENDOS A PAGAR - TERCEIROS','Registra os valores a serem pagos a terceiros a título de dividendos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.0.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositária, exigíveis no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositária, exigíveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.00','CONSIGNAÇÕES','Compreende os valores entregues em confiança ou em consignações, geralmente retidos em folha de pagamento de empregados ou servidores ou nos pagamentos referentes a compras de bens e serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','Registra o valor das retenções procedidas em pagamentos de servidores a ser recolhido ao RPPS do servidor.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.02','INSS','Registra o valor das retenções procedidas em pagamentos de empregados regidos pela consolidação das leis do trabalho (CLT) ou de serviços de terceiros, a ser recolhido ao instituto nacional do seguro social/previdência social.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','Registra o valor a ser recolhido a outras entidades, em função de dispositivos legais com as quais a entidade mantenha convênio de arrecadação direta. exemplo: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','Registra os valores referentes às retenções na fonte, pela entidade, do imposto sobre a renda, relativas às importâncias pagas a terceiros ou creditadas a servidores ou empregados, sobre as quais incida o referido imposto.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.05','INDENIZAÇÕES E RESTITUIÇÕES','Registra os valores relativos às indenizações e restituições de tributos com autorizações concedidas, porém não devolvidas aos legítimos credores pela entidade.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','Registra os valores referentes às retenções na fonte, pela entidade, de impostos e contribuições diversos, relativas às importâncias pagas a terceiros, sobre os quais incidam os referidos tributos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.07','ICMS','Registra os valores relativos ao imposto sobre a circulação de mercadorias e serviços retidos por força de legislação ou por acordo entre as partes envolvidas na transação em consignações.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.08','ISS','Registra os valores do imposto sobre serviços retidos em consignações por força de legislação, circunstâncias ou acordo entre as partes envolvidos na transação, em situações que a entidade como parte contratante, atue como substituta tributária.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','Registra os valores em consignação relativos a outros tributos a serem repassados aos estados e municípios.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.10','PENSÃO ALIMENTÍCIA','Registra os valores das retenções em folha procedidas em pagamentos a empregados ou a servidores, autorizados por esses ou por determinação judicial, a título de pensão alimentícia.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.11','PLANOS DE PREVIDÊNCIA E ASSISTÊNCIA MÉDICA','Registra os descontos efetuados em folhas de pagamento do pessoal para posterior recolhimento a favor de instituições de previdência e assistência médica.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.12','ASSISTÊNCIA A SAÚDE - ADMINISTRAÇÃO PRÓPRIA','Registra os valores das consignações retidos pela entidade, ou entregues a essa, que serão administrados pelo próprio órgão/entidade para assistência a saúde de seus servidores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.13','RETENÇÕES - ENTIDADES REPRESENTATIVAS DE CLASSES','Registra os descontos efetuados em folhas de pagamento de pessoal para posterior recolhimento a favor de instituições representativas de classe.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.14','RETENÇÕES - PLANOS DE SEGUROS','Registra os valores das retenções efetuadas em folha de pagamento dos servidores referentes às contribuições a planos de seguro de vida em grupo.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.15','RETENÇÕES - EMPRÉSTIMOS E FINANCIAMENTOS','Registra os valores das retenções efetuadas em folha de pagamento dos servidores referentes a empréstimos e financiamentos concedidos por terceiros, bem como retenções de parcelas de consórcios e segurados do INSS.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','Registra os valores das consignações retidas pela entidade a serem repassados para as empresas prestadoras dos serviços de fornecimento de vale-transporte. Trata-se dos valores referentes aos 6% instituídos pelo artigo 9º do Decreto nº 95.247/1987 e suas alterações.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','Registra os valores das consignações retidas pela entidade a serem repassados para as empresas prestadoras dos serviços de fornecimento de cartão-alimentação/refeição.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.01.99','OUTROS CONSIGNATÁRIOS','Registra os valores das consignações retidos pela entidade, ou entregues a essa, em confiança, por diversos contribuintes sujeitos a recolhimentos e ou pagamentos aos favorecidos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.02.00','GARANTIAS','Registra a garantia do cumprimento de uma obrigação, que se efetiva com o oferecimento de bens ou recursos financeiros ou ainda retenções de um percentual do valor do contrato como garantia de cumprimento do mesmo.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.03.00','DEPÓSITOS JUDICIAIS','Compreende os valores de obrigações, decorrentes de depósitos recebidos por determinação judicial e depósitos para recursos judiciais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.03.01','DEPÓSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL','Registra os valores de obrigações, decorrentes de depósitos recebidos por determinação judicial.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.03.02','DEPÓSITOS PARA RECURSOS JUDICIAIS','Registra os valores relativos às obrigações contraídas por depósitos efetuados a favor da entidade destinados ao exercício de direito de recurso junto a justica e encontrados vinculados em contas bancárias.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.00','DEPÓSITOS NÃO JUDICIAIS','Compreende os valores de obrigações, decorrentes de depósitos recebidos, exceto depósitos judiciais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.01','DEPÓSITOS E CAUÇÕES','Registra os valores das obrigações exigíveis contraídas com o recebimento de depósitos e/ou cauções vinculados a contratos ou outros instrumentos, para garantias de operações específicas.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.02','DEPÓSITOS ESPECIAIS','Registra o valor relativo a retenções de depósitos vinculados a restituir no curso do exercício seguinte a entidade transferidora, decorrente de contratos ou instrumentos congêneres, convenção, acordo ou ajuste.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.03','DEPÓSITOS DE TERCEIROS','Registra os valores relativos aos depósitos de terceiros de diversas origens, inclusive desconhecidas, não reclamados pelos credores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.04','DEPÓSITOS DE VEÍCULOS ALIENÁVEIS','Registra o valor dos recebimentos provenientes da alienação de veículos removidos, recolhidos ou apreendidos de acordo com a resolução do CONTRAN nº 178/2005, pendentes de transferências diversas.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.05','DEPÓSITOS A TRANSFERIR','Registra os valores das retenções de depósitos de diversas origens recebidos por UG central cuja devolução deve ser realizada no curso do exercício seguinte.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.06','DEPÓSITOS DE TERCEIROS','Registra os valores relativos aos depósitos de terceiros de diversas origens, inclusive desconhecidas, não reclamados pelos credores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.04.99','OUTROS DEPÓSITOS','Registra compromissos exigíveis até o término do exercício seguinte, decorrentes de recebimentos a título de depósitos, para os quais não haja contas específicas.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.8.1.99.00','OUTROS VALORES RESTITUÍVEIS','Registra outros valores restituíveis em posse da entidade, no papel de fiel depositária.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.0.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.01.00','INDENIZAÇÕES E RESTITUIÇÕES','Compreende as obrigações relativas a indenizações e restituições.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.01.01','INDENIZAÇÕES A SERVIDORES','Registra o valor das despesas a serem indenizadas decorrentes de liquidação de pagamentos efetuados com auxílio - alimentação bem como reembolsos de gastos realizados pelos servidores custeados pelo programa de assistência a saúde e benefícios sociais do órgão responsável.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.01.02','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','Registra os valores relativos às diversas indenizações e restituições no exercício.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.01.03','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DE EXERCÍCIOS ANTERIORES','Registra os valores relativos às diversas indenizações e restituições de exercícios anteriores.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.02.00','DIÁRIAS A PAGAR','Registra os valores relativos às diárias a pagar.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','Registra os valores relativos aos suprimentos de fundos a pagar.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.05.00','CONVÊNIOS A PAGAR','Compreende os valores a pagar retidos a título de convênio.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.05.01','CONVÊNIOS A PAGAR DO EXERCÍCIO','Registra os valores a pagar referentes a convênios firmados no exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.05.02','CONVÊNIOS A PAGAR DE EXERCÍCIOS ANTERIORES','Registra os valores a pagar referentes a convênios firmados em exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.09.00','TERMOS DE PARCERIA A PAGAR','Compreende os valores a pagar retidos a título de termo de parceria, que é um instrumento jurídico de fomento e gestão das relações de parceria entre organizações do terceiro setor - qualificadas como organização da sociedade civil de interesse público - OSCIP, e o poder público, com objetivo de imprimir maior agilidade gerencial aos projetos, reduzir as excessivas exigências burocráticas e realizar controle dos resultados. O termo de parceria foi instituído e disciplinado pela Lei 9.790/99, de 23 de março de 1999 e Decreto nº 3 100/99.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCÍCIO','Registra os valores a pagar referentes a termos de parceria firmados no exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCÍCIOS ANTERIORES','Registra os valores a pagar referentes a termos de parceria firmados em exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.10.00','TERMO DE COMPROMISSO A PAGAR','Registra os valores a pagar retidos a título de termo de compromisso.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.11.00','CONTRATOS DE GESTÃO A PAGAR','Registra as obrigações relativas aos contratos entre a administração pública e a iniciativa privada para gestão de atividades típicas de governo','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.12.00','SUBVENÇÕES A PAGAR','Registra o somatório das subvenções a pagar de exercícios anteriores.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.13.00','TRANSFERÊNCIAS ORÇAMENTÁRIAS A LIBERAR','Registra os compromissos exigíveis provenientes da apropriação da despesa de transferência.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.1.14.00','CONSÓRCIOS A PAGAR','Registra a apropriação e movimentação dos valores a repassar a consórcios, em atendimento ao disposto na portaria STN 72/2012.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.1.8.9.2.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.0.0.0.00.00','PASSIVO NÃO-CIRCULANTE','Compreende as obrigações conhecidas e estimadas que não atendam a nenhum dos critérios para serem classificadas no passivo circulante.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar, benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.0.00.00','PESSOAL A PAGAR','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.01.00','PESSOAL A PAGAR DE EXERCÍCIOS ANTERIORES','Registra os valores relativos a vencimentos e vantagens fixas e variáveis devidas ao servidores civis e militares, bem como as aposentadorias, reformas e pensões, relativas a exercícios anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.02.00','PRECATÓRIOS DE PESSOAL','Compreende os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.02.01','PRECATÓRIOS DE PESSOAL - REGIME ORDINÁRIO','Registra os valores dos precatórios judiciais relativos ao regime ordinário de natureza alimentar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.02.02','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - ANTERIORES 05/05/2000','Registra a apropriação e movimentação de precatórios de pessoal a pagar - anteriores a 05/05/2000, exigíveis a longo prazo.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.02.03','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, de exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.02.04','PRECATÓRIOS DE PESSOAL - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao regime especial de natureza alimentar , instituído pela Emenda Constitucional 62/ 2009.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.1.1.02.05','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de pessoal do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.01.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Compreende as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.01.01','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','Registra os valores dos precatórios judiciais relativos ao regime ordinário de natureza alimentar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.01.02','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','Registra a apropriação e movimentação de precatórios de benefícios a pagar - anteriores a 05/05/2000, exigíveis a longo prazo.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.01.03','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões e exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.01.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao regime especial de natureza alimentar , instituído pela Emenda Constitucional 62/ 2009.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.2.1.01.05','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de benefícios previdenciários do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.3.1.01.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR DE EXERCÍCIOS ANTERIORES','Registra os valores relativos aos benefícios assistênciais administrados pela previdência social, de exercícios anteriores.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.1.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.1.02.00','CONTRIBUICÕES SOCIAIS - DÉBITOS PARCELADOS','Registra a apropriação e movimentação do valor dos débitos parcelados, referente ao não recolhimento de contribuições sociais.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.1.03.00','FGTS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor dos débitos parcelados, referente ao não recolhimento de FGTS.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.1.99.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.2.01.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','Registra os valores relativos às obrigações com regimes próprios de previdência, não identificados como previdência privada ou complementar.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.2.99.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.3.01.00','INSS A PAGAR','Compreende os valores relativos às contribuições a previdência social, incidentes sobre salários e remunerações pagos e sobre serviços de terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.3.01.01','INSS - DÉBITO PARCELADO','Registra os valores de débito parcelado que se referem ao não recolhimento de obrigações da folha de pagamento junto ao INSS.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.3.99.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','Compreende as obrigações financeiras da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.1.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Registra os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.3.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Registra os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.4.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Registra os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.1.5.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Registra os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.2.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.2.1.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS - EM TÍTULOS','Registra os valores das operações de crédito externas decorrentes da emissão de títulos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','Registra os valores das operações de crédito externas decorrentes da emissão em contratos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Registra os empréstimos a curto prazo - externo - não enquadrados nas classificações anteriores.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.0.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a longo prazo, contraídos para aquisição de bens do ativo permanente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a longo prazo contraídos para construção de imóveis.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a longo prazo contraídos para o capital de giro.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a longo prazo para os quais não haja contas específicas.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','Registra as obrigações a longo prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.3.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.4.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.3.5.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.4.0.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.4.1.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes de financiamentos externos a longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos externos a longo prazo, contraídos para aquisição de bens do ativo permanente.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos externos a longo prazo contraídos para o capital de giro.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','Registra as obrigações a longo prazo referentes a financiamentos externos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos do exercício anterior.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos do exercício anterior.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos do exercício anterior.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos do exercício anterior.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos externos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos externos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos externos de exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos de exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos externos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos externos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos externos de exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos do exercício.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.6.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos de exercícios anteriores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS – MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – EXTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos externos.','D','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos externos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.0.0.00.00','FORNECEDORES A LONGO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.0.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.01.00','FORNECEDORES NACIONAIS','Compreende os valores a pagar aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','Compreende as Obrigações referentes a Precatórios de Fornecedores Nacionais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','Registra os valores dos Precatórios Judiciais relativos ao Regime Ordinário de Natureza não Alimentar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACONAIS DO EXERCÍCIO - A PARTIR DE 05/05/2000','Registra a apropriação e movimentação de Precatórios de fornecedores a Pagar - anteriores a 05/05/2000, exigíveis a Longo Prazo.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.02.03','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO - ANTES DE 05/05/2000','Registra a apropriação e movimentação de Precatórios de Fornecedores a Pagar - a partir de 05/05/2000, exigíveis a Longo Prazo.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao Regime Especial mensal de Natureza não alimentar, instituído pela emenda Constitucional 62/2009','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.1.1.02.05','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de fornecedores nacionais do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.0.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.1.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos fornecedores estrangeiros de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','','X',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.0.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.1.01.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de longo prazo relativos a diferenças intertemporais (deliberação da CVM nº 273, de 20/08/98),correspondentes ao IRPJ e CSSL, bem como PIS/PASEP E COFINS (lei nº 9.718 de 27/11/1998).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.1.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (IPI, IRPJ CSSL, PIS, PASEP e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.2.01.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de longo prazo relativos a diferenças intertemporais (deliberação da CVM nº 273, de 20/08/98),correspondentes ao IRPJ e CSSL, bem como PIS/PASEP E COFINS (lei nº 9.718 de 27/11/1998).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.2.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (IPI, IRPJ CSSL, PIS, PASEP e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.3.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.3.01.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de longo prazo relativos a diferenças intertemporais (deliberação da CVM nº 273, de 20/08/98),correspondentes ao IRPJ e CSSL, bem como PIS/PASEP E COFINS (lei nº 9.718 de 27/11/1998).','C','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.3.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (IPI, IRPJ CSSL, PIS, PASEP e Outros).','C','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','p',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.1.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.2.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.4.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.4.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.1.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ISS, IPTU e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.2.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ISS, IPTU e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.5.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTER OFSS - MUNICÍPIO','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.5.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ISS, IPTU e Outros).','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.0.0.00.00','PROVISÕES A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','Registra os valores das provisões constituídas visando o pagamento de indenizações trabalhistas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','Registra os valores das provisões constituídas visando o pagamento de dissídios coletivos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.0.00.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.00.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, comprobabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.00','PLANO FINANCEIRO - PROVISÕES DE BENEFÍCIOS CONCEDIDOS','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de benefício de prestação continuada.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.03','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos inativos, por prazo de vigência indeterminado, para financiar os benefíciosjá em fase de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos pensionistas, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11, da Portaria MPS nº 403/2008.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao fundo sob o regime de parcelamento de débitos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.01.07','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das insuficiências financeiras futuras do plano financeiro considerando o §1º do artigo 2º da Lei nº 9.717/98.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.00','PLANO FINANCEIRO - PROVISÕES DE BENEFÍCIOS A CONCEDER','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente dos benefícios a serem concedidos aos integrantes da geração atual que ainda não estejam em gozo de benefícios de prestação continuada.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, incidentes sobre as remunerações da geração atual.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o somatório do valor presente das contribuições futuras dos servidores ativos, incidentes sobre as remunerações da geração atual.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11, da Portaria MPS nº 403/2008.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, considerando o parcelamento dos valores não recolhidos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.02.06','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das insuficiências financeiras futuras do plano financeiro, considerando o §1º do artigo 2º da Lei nº 9.717/98.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.00','PLANO PREVIDENCIÁRIO - PROVISÕES DE BENEFÍCIOS CONCEDIDOS','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuaria, o valor presente das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de benefício de prestação continuada.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.03','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos inativos, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos pensionistas, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11 da Portaria MPS nº 403/2008.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.03.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS DO PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, considerando o parcelamento de valores não recolhidos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.04.00','PLANO PREVIDENCIÁRIO - PROVISÕES DE BENEFÍCIOS A CONCEDER','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.04.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente dos benefícios a serem concedidos aos integrantes da geração atual que ainda não estejam em gozo de benefícios de prestação continuada.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.04.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, incidentes sobre as remunerações da geração atual.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.04.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o somatório do valor presente das contribuições futuras dos servidores ativos, incidentes sobre as remunerações da geração atual.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.04.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11 da Portaria MPS nº 403/2008.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.04.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, sob o regime de parcelamento de débitos.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.05.00','PLANO PREVIDENCIÁRIO - PLANO DE AMORTIZAÇÃO','Compreende, de acordo com resultado da avaliação atuarial, o valor presente liquido dos direitos incorporados ao patrimônio do RPPS com base em legislação especifica, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrera na apresentação de uma nova reavaliação atuarial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.05.98','(-) OUTROS CRÉDITOS DO PLANO DE AMORTIZAÇÃO','Registra, de acordo com o resultado da avaliação atuarial, o valor presente líquido dos direitos incorporados ao patrimônio do RPPS com base em legislação específica, como exemplo: direitos sobre royalties, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrerá na apresentação de uma nova reavaliação atuarial.','D','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.06.00','PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO','Compreende o somatório das provisões atuariais constituídas para ajustes do plano financeiro, conforme o resultado da avaliação atuarial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.06.01','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','Registra, de acordo com a nota técnica atuarial, a provisão atuarial correspondente a eventuais desvios dos compromissos esperados ou pela adoção de bases técnicas que não se adaptam ao plano.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.07.00','PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIÁRIO','Compreende o somatório das provisões atuariais constituídas para ajustes do plano previdenciário, conforme o resultado da avaliação atuarial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.07.01','AJUSTE DE RESULTADO ATUARIAL SUPERAVITÁRIO','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar resultado superavitário, considerando o artigo 25 da Portaria MPS nº 403/2008.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.07.02','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar oscilação de riscos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.07.03','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar benefícios a regularizar.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.07.04','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar contingências.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.2.1.07.98','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano necessitar de outros ajustes.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.0.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','Compreende os valores das provisões para pagamento de autos de infração já lavrados e que se encontram na esfera administrativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade ainda não apresentou recurso administrativo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade apresentou recurso administrativo.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','Compreende os valores das provisões para pagamento de autuações fiscais que já se encontram na esfera judicial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera judicial e que não estão em fase recursal.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera judicial em fase recursal.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','Registra os valores das provisões constituídas para o pagamento de indenizações cíveis.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','Registra os valores das provisões para pagamento de seguros referentes a sinistros a liquidar.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTÍFICADOS','Registra os valores das provisões para pagamento de seguros referentes a sinistros já cientificados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTÍFICADOS','Registra os valores das provisões para pagamento de seguros, referentes a sinistros não cientificados.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO OFSS','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.0.00.00','OUTRAS PROVISÕES A LONGO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem após o término do exercício seguinte, não classificadas anteriormente neste plano de contas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem após o término do exercício seguinte, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.01.00','PROVISÃO PARA GARANTIAS','Registra os valores das provisões destinadas a cobrir despesas com a prestação de garantia relativas a produtos vendidos.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','Registra os valores das provisões destinadas a cobrir obrigações oriundas da venda ou extinção de uma linha de negócios, fechamento de fábricas ou locais de negócios, mudanças na estrutura da administração e reorganizações com efeito relevante na natureza e foco das operações da entidade.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.03.00','PROVISÕES DO FCVS','Compreende, de acordo com a nota técnica atuarial, os valores atuariais dos passivos do fundo de compensação e variações salariais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.03.01','PROVISÕES DO FCVS - RISCOS EXPIRADOS','Registra os resíduos de contratos liquidados pelo mutuário com cobertura do FCVS, de acordo com a avaliação atuarial.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.03.02','PROVISÕES DO FCVS - RISCOS NÃO EXPIRADOS','Registra o montante de contratos com cobertura do FCVS em fase de pagamento pelos mutuários, de acordo com a avaliação atuarial.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.7.9.1.99.00','OUTRAS PROVISÕES A LONGO PRAZO','Registra os valores das provisões não classificáveis nas demais contas deste plano de contas.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.0.0.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','Compreende os valores exigíveis após o término do exercício seguinte, provenientes de danos a terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores exigíveis após o término do exercício seguinte, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.3.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A LONGO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.3.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A LONGO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.4.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.4.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.0.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.00','CONSIGNAÇÕES','Compreende os valores entregues em confiança ou em consignações, geralmente retidos em folha de pagamento de empregados ou servidores ou nos pagamentos referentes a compras de bens e serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','Registra o valor das retenções procedidas em pagamentos de servidores a ser recolhido ao RPPS do servidor.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.02','INSS','Registra o valor das retenções procedidas em pagamentos de empregados regidos pela consolidação das leis do trabalho (CLT) ou de serviços de terceiros, a ser recolhido ao instituto nacional do seguro social/previdência social.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','Registra o valor a ser recolhido a outras entidades, em função de dispositivos legais com as quais a entidade mantenha convênio de arrecadação direta. exemplo: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','Registra os valores referentes às retenções na fonte, pela entidade, do imposto sobre a renda, relativas às importâncias pagas a terceiros ou creditadas a servidores ou empregados, sobre as quais incida o referido imposto.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.05','INDENIZAÇÕES E RESTITUIÇÕES','Registra os valores relativos às indenizações e restituições de tributos com autorizações concedidas, porém não devolvidas aos legítimos credores pela entidade.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','Registra os valores referentes às retenções na fonte, pela entidade, de impostos e contribuições diversos, relativas às importâncias pagas a terceiros, sobre os quais incidam os referidos tributos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.07','ICMS','Registra os valores relativos ao imposto sobre a circulação de mercadorias e serviços retidos por força de legislação ou por acordo entre as partes envolvidas na transação em consignações.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.08','ISS','Registra os valores do imposto sobre serviços retidos em consignações por força de legislação, circunstâncias ou acordo entre as partes envolvidos na transação, em situações que a entidade como parte contratante, atue como substituta tributária.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','Registra os valores em consignação relativos a outros tributos a serem repassados aos estados e municípios.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.10','PENSÃO ALIMENTÍCIA','Registra os valores das retenções em folha procedidas em pagamentos a empregados ou a servidores, autorizados por esses ou por determinação judicial, a título de pensão alimentícia.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.11','PLANOS DE PREVIDÊNCIA E ASSISTÊNCIA MÉDICA','Registra os descontos efetuados em folhas de pagamento do pessoal para posterior recolhimento a favor de instituições de previdência e assistência médica.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.12','ASSISTÊNCIA A SAÚDE - ADMINISTRAÇÃO PRÓPRIA','Registra os valores das consignações retidos pela entidade, ou entregues a essa, que serão administrados pelo próprio órgão/entidade para assistência a saúde de seus servidores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.13','RETENÇÕES - ENTIDADES REPRESENTATIVAS DE CLASSES','Registra os descontos efetuados em folhas de pagamento de pessoal para posterior recolhimento a favor de instituições representativas de classe.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.14','RETENÇÕES - PLANOS DE SEGUROS','Registra os valores das retenções efetuadas em folha de pagamento dos servidores referentes às contribuições a planos de seguro de vida em grupo.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.15','RETENÇÕES - EMPRÉSTIMOS E FINANCIAMENTOS','Registra os valores das retenções efetuadas em folha de pagamento dos servidores referentes a empréstimos e financiamentos concedidos por terceiros, bem como retenções de parcelas de consórcios e segurados do INSS.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','Registra os valores das consignações retidas pela entidade a serem repassados para as empresas prestadoras dos serviços de fornecimento de vale-transporte. Trata-se dos valores referentes aos 6% instituídos pelo artigo 9º do Decreto nº 95.247/1987 e suas alterações.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','Registra os valores das consignações retidas pela entidade a serem repassados para as empresas prestadoras dos serviços de fornecimento de cartão-alimentação/refeição.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.01.99','OUTROS CONSIGNATÁRIOS','Registra os valores das consignações retidos pela entidade, ou entregues a essa, em confiança, por diversos contribuintes sujeitos a recolhimentos e ou pagamentos aos favorecidos.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.02.00','GARANTIAS','Registra a garantia do cumprimento de uma obrigação, que se efetiva com o oferecimento de bens ou recursos financeiros ou ainda retenções de um percentual do valor do contrato como garantia de cumprimento do mesmo.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.03.00','DEPÓSITOS JUDICIAIS','Compreende os valores de obrigações, decorrentes de depósitos recebidos por determinação judicial e depósitos para recursos judiciais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.03.01','DEPÓSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL','Registra os valores de obrigações, decorrentes de depósitos recebidos por determinação judicial.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.03.02','DEPÓSITOS PARA RECURSOS JUDICIAIS','Registra os valores relativos às obrigações contraídas por depósitos efetuados a favor da entidade destinados ao exercício de direito de recurso junto a justica e encontrados vinculados em contas bancárias.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.00','DEPÓSITOS NÃO JUDICIAIS','Compreende os valores de obrigações, decorrentes de depósitos recebidos, exceto depósitos judiciais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.01','DEPÓSITOS E CAUÇÕES','Registra os valores das obrigações exigíveis contraídas com o recebimento de depósitos e/ou cauções vinculados a contratos ou outros instrumentos, para garantias de operações específicas.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.02','DEPÓSITOS ESPECIAIS','Registra o valor relativo a retenções de depósitos vinculados a restituir no curso do exercício seguinte a entidade transferidora, decorrente de contratos ou instrumentos congêneres, convenção, acordo ou ajuste.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.03','DEPÓSITOS DE TERCEIROS','Registra os valores relativos aos depósitos de terceiros de diversas origens, inclusive desconhecidas, não reclamados pelos credores.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.04','DEPÓSITOS DE VEÍCULOS ALIENÁVEIS','Registra o valor dos recebimentos provenientes da alienação de veículos removidos, recolhidos ou apreendidos de acordo com a resolução do CONTRAN nº 178/2005, pendentes de transferências diversas.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.05','DEPÓSITOS A TRANSFERIR','Registra os valores das retenções de depósitos de diversas origens recebidos por UG central cuja devolução deve ser realizada no curso do exercício seguinte.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.04.99','OUTROS DEPÓSITOS','Registra compromissos exigíveis até o término do exercício seguinte, decorrentes de recebimentos a título de depósitos, para os quais não haja contas específicas.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.8.1.99.00','OUTROS VALORES RESTITUÍVEIS','Registra outros valores restituíveis em posse da entidade, no papel de fiel depositária.','C','S','','F',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.9.0.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.8.9.1.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.9.0.0.00.00','RESULTADO DIFERIDO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.  Compreende também o saldo existente na antiga conta resultado de exercícios futuros em 31 de dezembro de 2008.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.9.1.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.9.1.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.9.2.0.00.00','(-) CUSTO DIFERIDO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.2.9.2.1.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.0.0.0.00.00','PATRIMÔNIO LÍQUIDO','Compreende o valor residual dos ativos depois de deduzidos todos os passivos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.0.0.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','Compreende o patrimônio social das autarquias, fundações e fundos e o capital social das demais entidades da administração indireta.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.1.0.00.00','PATRIMÔNIO SOCIAL','Compreende o patrimônio das autarquias, fundações e fundos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.1.1.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','Compreende o patrimônio das autarquias, fundações e fundos, pertencentes ao Orçamento Fiscal e da Seguridade Social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.2.0.00.00','CAPITAL SOCIAL REALIZADO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.2.1.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.2.2.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.2.3.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.2.4.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.1.2.5.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.2.0.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.2.0.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.2.0.2.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.2.0.3.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.2.0.4.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.2.0.5.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS – MUNICÍPIO.','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.0.0.00.00','RESERVAS DE CAPITAL','Compreende os valores acrescidos ao patrimônio que não transitaram pelo resultado como variações patrimoniais aumentativas (VPA).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.1.0.00.00','ÁGIO NA EMISSÃO DE AÇÕES','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiárias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.1.1.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.1.2.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.1.3.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.1.4.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.1.5.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.2.0.00.00','ALIENAÇÃO DE PARTES BENEFICIÁRIAS','Compreende o produto da alienação de partes beneficiárias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.2.1.00.00','ALIENAÇÃO DE PARTES BENEFICIÁRIAS - CONSOLIDAÇÃO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.2.2.00.00','ALIENAÇÃO DE PARTES BENEFICIÁRIAS - INTRA OFSS','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.2.3.00.00','ALIENAÇÃO DE PARTES BENEFICIÁRIAS - INTER OFSS - UNIÃO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.2.4.00.00','ALIENAÇÃO DE PARTES BENEFICIÁRIAS - INTER OFSS - ESTADO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.2.5.00.00','ALIENAÇÃO DE PARTES BENEFICIÁRIAS - INTER OFSS - MUNICÍPIO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.3.0.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','Compreende o produto da alienação de bônus de subscrição.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.3.1.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.3.2.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.3.3.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.3.4.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.3.5.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.4.0.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.4.1.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.4.2.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.4.3.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.4.4.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.4.5.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.0.00.00','OUTRAS RESERVAS DE CAPITAL','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.1.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.1.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','Registra os valores de prêmio na emissão de debêntures, que ocorrem quando o preço da emissão de debêntures for superior a seu valor nominal. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.1.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','Registra os valores de doações e subvenções para investimentos. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.1.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','Registra os valores do resultado da correção monetária especial, conforme o Decreto-lei nº 1.598/77.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.1.99.00','DEMAIS RESERVAS DE CAPITAL','Registra os valores das demais reservas de capital, não contabilizáveis em outras contas deste plano.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.2.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.2.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','Registra os valores de prêmio na emissão de debêntures, que ocorrem quando o preço da emissão de debêntures for superior a seu valor nominal. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.2.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','Registra os valores de doações e subvenções para investimentos. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.2.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','Registra os valores do resultado da correção monetária especial, conforme o Decreto-lei nº 1.598/77.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.2.99.00','DEMAIS RESERVAS DE CAPITAL','Registra os valores das demais reservas de capital, não contabilizáveis em outras contas deste plano.','C','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.3.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.4.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.3.9.5.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.4.0.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo e do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício em obediência ao regime de competência.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.4.1.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.4.1.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.4.2.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.4.2.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.0.0.00.00','RESERVAS DE LUCROS','Compreende as reservas constituídas com parcelas do lucro liquido das entidades para finalidades especificas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.1.0.00.00','RESERVA LEGAL','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.1.1.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.1.2.00.00','RESERVA LEGAL- INTRA OFSS','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.1.3.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.1.4.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.1.5.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.2.0.00.00','RESERVAS ESTATUTÁRIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.2.1.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.2.2.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.2.3.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.2.4.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.2.5.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.3.0.00.00','RESERVA PARA CONTINGÊNCIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.3.1.00.00','RESERVA PARA CONTINGÊNCIAS - CONSOLIDAÇÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.3.2.00.00','RESERVA PARA CONTINGÊNCIAS - INTRA OFSS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.3.3.00.00','RESERVA PARA CONTINGÊNCIAS - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.3.4.00.00','RESERVA PARA CONTINGÊNCIAS - INTER OFSS - ESTADO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.3.5.00.00','RESERVA PARA CONTINGÊNCIAS - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.4.0.00.00','RESERVA DE INCENTIVOS FISCAIS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.4.1.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.4.2.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.4.3.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.4.4.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.4.5.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.5.0.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.5.1.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.5.2.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.5.3.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.5.4.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS –ESTADO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.5.5.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.6.0.00.00','RESERVA DE LUCROS A REALIZAR','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.6.1.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.6.2.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.6.3.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.6.4.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.6.5.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.7.0.00.00','RESERVA DE RETENÇÃO DE PRÊMIO NA EMISSÃO DE DEBÊNTURES','Compreende a parcela do lucro líquido do exercício decorrente do prêmio na emissão de debêntures.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.7.1.00.00','RESERVA DE RETENÇÃO DE PRÊMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.7.2.00.00','RESERVA DE RETENÇÃO DE PRÊMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.7.3.00.00','RESERVA DE RETENÇÃO DE PRÊMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.7.4.00.00','RESERVA DE RETENÇÃO DE PRÊMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.7.5.00.00','RESERVA DE RETENÇÃO DE PRÊMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.9.0.00.00','OUTRAS RESERVAS DE LUCRO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.9.1.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.9.2.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.9.3.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.9.4.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.5.9.5.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.0.0.00.00','DEMAIS RESERVAS','Compreende as demais reservas, não classificadas como reservas de capital ou de lucro, inclusive aquelas que terão seus saldos realizados por terem sido extintas pela legislação.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.1.0.00.00','RESERVA DE REAVALIAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.1.1.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.1.2.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.1.3.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.1.4.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.1.5.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.9.0.00.00','OUTRAS RESERVAS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.9.1.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.9.2.00.00','OUTRAS RESERVAS - INTRA OFSS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.9.3.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.9.4.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.6.9.5.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.0.0.00.00','RESULTADOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas e os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.0.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.1.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.1.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.1.02.00','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.1.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.1.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.2.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.2.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.2.02.00','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.2.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.2.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.3.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.3.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.3.02.00','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.3.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.3.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.4.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.4.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.4.02.00','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.4.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.4.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.5.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.5.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.5.02.00','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.5.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.1.5.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.0.00.00','LUCROS E PREJUÍZOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.1.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.2.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.3.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.4.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.7.2.5.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','','P',1);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.0.0.00.00','(-) AÇÕES/COTAS EM TESOURARIA','Compreende o valor das ações ou cotas da entidade que foram adquiridas pela própria entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.1.0.00.00','(-) AÇÕES EM TESOURARIA','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.1.1.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.1.2.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.1.3.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.1.4.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.1.5.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS – MUNICÍPIO','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.2.0.00.00','(-) COTAS EM TESOURARIA','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.2.1.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.2.2.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.2.3.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.2.4.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'2.3.9.2.5.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','Compreende o decréscimo no beneficio econômico durante o período contábil sob a forma de saída de recurso ou redução de ativo ou incremento em passivo, que resulte em decréscimo do patrimônio liquido e que não seja proveniente de distribuição aos proprietários da entidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.0.0.0.00.00','PESSOAL E ENCARGOS','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas ou variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público. Compreende ainda, obrigações trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos órgãos e demais entidades do setor público, contribuições a entidades fechadas de previdência e benefícios eventuais a pessoal civil e militar, destacados os custos de pessoal e encargos inerentes as mercadorias e produtos vendidos e serviços prestados.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.0.0.00.00','REMUNERAÇÃO A PESSOAL','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público, bem como as com contratos de terceirização de mão de obra que se refiram à substituição de servidores e empregados públicos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','Compreende o somatorio dos valores com vencimentos e vantagens fixas do pessoal civil do tipo: gratificação, representação, adicional insalubridade, férias, 13 salário, licenca-premio, abono pecuniario, adicional noturno, etc.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.01','VENCIMENTOS E SALÁRIOS','Registra o valor da despesa com vencimentos e salários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.02','ADICIONAL NOTURNO','Registra o valor da despesa com adicional noturno.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.03','INCORPORAÇÕES','Registra o valor da despesa com incorporações.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.04','ABONO DE PERMANÊNCIA','Registra o valor da despesa com abono de permanência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.05','ADICIONAL DE PERICULOSIDADE','Registra o valor da despesa com adicional de periculosidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.06','ADICIONAL DE INSALUBRIDADE','Registra o valor da despesa comadicional de insalubridade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.07','ADICIONAL DE ATIVIDADES PENOSAS','Registra o valor da despesa com adicional de atividades penosas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.08','INCENTIVO À QUALIFICAÇÃO','Registra o valor da despesa com incentivo á qualificação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.09','REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE','Registra o valor da despesa com vremuneração de pessoal em disponibilidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.10','RETRIBUIÇÃO ADICIONAL VARIÁVEL E PRÓ-LABORE (LEI 7711/88)','Registra o valor da despesa com retribuição adicional variável e pró-labore (lei 7711/88).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.12','VANTAGEM PECUNIÁRIA INDIVIDUAL','Registra o valor da despesa com vantagem pecuniária individual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.13','ABONO PROVISÓRIO – PESSOAL CIVIL','Registra o valor da despesa com abono provisório – pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.14','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','Registra o valor da despesa com gratificação por exercício de cargos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.16','GRATIFICAÇÃO POR EXERCÍCIO DE FUNÇÕES','Registra o valor da despesa comgratificação por exercício de funções.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.17','INDENIZAÇÃO E LOCAÇÃO','Registra o valor da despesa com indenização e locação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.18','GRATIFICAÇÃO DE TEMPO DE SERVIÇO','Registra o valor da despesa com gratificação de tempo de serviço.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.19','GRATIFICAÇÕES ESPECIAIS','Registra o valor da despesa comgratificações especiais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.20','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','Registra o valor da despesa com gratificação por atividades expostas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.21','FÉRIAS VENCIDAS E PROPORCIONAIS','Registra o valor da despesa com veférias vencidas e proporcionais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.22','13. SALÁRIO','Registra o valor da despesa com 13º salário.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.23','FÉRIAS – ABONO PECUNIÁRIO','Registra o valor da despesa com férias – abono pecuniário.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.24','FÉRIAS – ABONO CONSTITUCIONAL','Registra o valor da despesa com férias – abono constitucional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.25','LICENÇA-PRÊMIO','Registra o valor da despesa com licença-prêmio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.26','LICENÇA CAPACITAÇÃO','Registra o valor da despesa com licença capacitação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.27','ADIANTAMENTO PECUNIÁRIO','Registra o valor da despesa com adiantamento pecuniário.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.28','REPRESENTAÇÃO MENSAL','Registra o valor da despesa com representação mensal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.29','COMPLEMENTAÇÃO SALARIAL','Registra o valor da despesa com complementação salarial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.30','ADICIONAL – TETO PARLAMENTAR','Registra o valor da despesa com adicional – teto parlamentar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.31','SUBSÍDIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a subsídios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','Registra o valor da despesa com gratificação por exercício de cargo em comissão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor da despesa com vencimentos e salários prorrogação salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a férias - pagamento antecipado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.36','REMUN. PARTICIP. ÓRGÃOS DELIBERAÇÃO COLETIVA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a remun. particip. órgãos deliberação coletiva.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS – PESSOAL CIVIL RPPS','Registra o valor da despesa com voutros vencimentos e vantagens fixas – pessoal civil RPPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.00','OUTRAS DESPESAS VARIÁVEIS - PESSOAL CIVIL - RPPS','Compreende o valor de outras despesas variáveis - Pessoal Civil - RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.01','SUBSTITUIÇÕES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a substituições.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.02','ADICIONAL VARIÁVEL','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional variavel sujeitos a incidencia de tributos e contribuicoes de acordo com a lei 10.973/04 - distribuição de royalties.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.03','SERVIÇOS EXTRAORDINÁRIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a servicos extraordinários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.04','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificação por embarque fluvial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.05','GRATIFICAÇÃO ELEITORAL','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificação eleitoral.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.06','LICENÇA SEM REMUNERAÇÃO INCENTIVADA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a licença sem remuneração incentivada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.07','ADICIONAL POR PLANTÃO HOSPITALAR','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional por plantao hospitalar - aph devido aos servidores em efetivo exercicio de atividades hospitalares, desempenhadas em regime de plantao, nas areas indispensaveis ao funcionamento ininterrupto dos hospitais constantes no artigo 298 da lei 12.155, de 2009, que altera a lei 11.907, de 02 de fevereiro de 2009.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.08','CONVOCAÇÃO EXTRAORDINÁRIA LEGISLATIVA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a convocacao extraordinaria legislativa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.09','PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a participacao a empregados e administradores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.10','AUXÍLIO MORADIA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a auxilio moradia.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.11','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com com indenizações trabalhistas, referente a indenizações e restituições trabalhistas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.12','INDENIZ. E RESTIT. DECORR. DE PLANOS DE DEMISSÃO VOLUNTÁRIA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com com indenizações trabalhistas, referente a indeniz. e restit. decorr. de planos de demissão voluntária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.13','RESSARCIMENTO DE DESP. DE PESSOAL REQUISITADO','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com resarcimento de despesas de pessoal requisitado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.02.99','OUTROS VENCIMENTOS E VANTAGENS VARIÁVEIS – PESSOAL CIVIL RPPS','Registra o valor da despesa com voutros vencimentos e vantagens variáveis – pessoal civil RPPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.1.1.03.00','SENTENCAS JUDICIAIS','Registra as variacoes patrimoniais diminutivas provenientes de sentencas judiciais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RGPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RGPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','Compreende o somatório dos valores com vencimentos e vantagens fixas do pessoal civil do tipo: gratificação, representação, adicional insalubridade, férias, 13º salário, licença-prêmio, abono pecuniário, adicional noturno, etc.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.01','VENCIMENTOS E SALÁRIOS','Registra as variações patrimoniais diminutivas realizadas com vencimentos e salários do pessoal civil regidos pelo regime geral da previdência social.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.02','ADICIONAL NOTURNO','Registra as variações patrimoniais diminutivas com remunerações a empregados em atividade noturna.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.03','INCORPORAÇÕES','Registra as variações patrimoniais diminutivas realizadas a título de vencimentos e vantagens por incorporações.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.04','ABONO DE PERMANÊNCIA','Registra as variações patrimoniais diminutivas provenientes de despesas com pagamento do abono de permanência, devido aos empregados que tendo completado as exigências para aposentadoria voluntária, opte por permanecer em atividade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.05','ADICIONAL DE PERICULOSIDADE','Registra as variações patrimoniais diminutivas com remuneração de empregados que exercem atividades perigosas, conforme o § 1º , do artigo 193, do DecretoLei n.º 5.452, de 1º de maio de 1943 (CLT).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.06','ADICIONAL DE INSALUBRIDADE','Registra as variações patrimoniais diminutivas com remuneração de empregados em atividade em locais insalubres, conforme artigo 192, do Decreto-Lei n.º 5.452, de 1º de maio de 1943 (CLT).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.07','REMUNERAÇÃO PARTICIPANTES DE ÓRGÃO DE DELIBERAÇÃO COLETIVA','Registra as variações patrimoniais diminutivas realizadas a título de remuneração de membros de órgãos de deliberação coletiva (conselho consultivo, conselho de administração, conselho fiscal ou outros órgãos colegiados), observado o disposto na Lei nº 7733, de 14/02/89.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.08','INCENTIVO À QUALIFICAÇÃO','Registra as variações patrimoniais diminutivas provenientes de despesas com incentivo a qualificação de empregados que possuírem educação formal superior ao exigido pelo emprego/cargo que ocupam, em àreas de interesse do órgão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.09','ADICIONAL DE TRANSFERÊNCIA - ART. 469/CLT','Registra as variações patrimoniais diminutivas com remuneração de servidores que exercem foram transferidos conforme art. 469 da CLT.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.10','RETR.ADIC.VARIÁVEL E PRO-LABORE(LEI 7711/88)','Registra as variações patrimoniais diminutivas realizadas a título de retribuição adicional variável e pró-labore de êxito conforme Lei 7.711/88, artigos terceiro e quinto.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.11','REMUNERAÇÃO DE DIRETORES','Registra as variações patrimoniais diminutivas realizadas a título de remuneração de diretores de empresas públicas e de economia mista.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.12','VANTAGEM PECUNIÁRIA INDIVIDUAL','Registra as variações patrimoniais diminutivas realizadas com a vantagem pecuniária individual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.13','ABONO PROVISÓRIO - PESSOAL CIVIL','Registra as variações patrimoniais diminutivas realizadas com abono provisório a pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.14','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','Registra as variações patrimoniais diminutivas realizadas com gratificação por exercício de cargos, como GAJ, etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.15','INDENIZAÇÃO A ANISTIADO POLÍTICO','Registra as variações patrimoniais diminutivas realizadas a título de indenização de anistiados políticos conforme a Lei 10.559/2002.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.16','GRATIFICAÇÃO POR EXERCÍCIO DE FUNCÕES','Registra as variações patrimoniais diminutivas realizadas com gratificação por exercício de funções, de coordenação, assessoramento, chefia e encargo de atividades específicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.17','INDENIZAÇÃO DE LOCALIZAÇÃO','Registra as variações patrimoniais diminutivas realizadas a título de indenização de localização específica determinada por lei.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.18','GRATIFICAÇÃO DE TEMPO DE SERVIÇO','Registra as variações patrimoniais diminutivas com gratificações adquiridas em função de contagem de tempo de serviço, pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.19','GRATIFICAÇÕES ESPECIAIS','Registra as variações patrimoniais diminutivas com gratificações de natureza especial concedidas em virtude de lei a pessoal civil, tais como: gratificação especial de localização, etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.20','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','Registra as variações patrimoniais diminutivas com gratificações, quando pelo exercício, expõe o servidor a riscos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.21','FÉRIAS VENCIDAS E PROPORCIONAIS','Registra as variações patrimoniais diminutivas com pagamento de férias vencidas e proporcionais na rescisão de contrato de trabalho ou demissão do empregado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.22','13. SALÁRIO','Registra as variações patrimoniais diminutivas realizadas com gratificação de natal (13 salário) do pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.23','FÉRIAS - ABONO PECUNIÁRIO','Registra as variações patrimoniais diminutivas provenientes de despesas com a conversão em abono pecuniário de um terço do valor da remuneração devida ao empregado no período de férias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.24','FÉRIAS - ABONO CONSTITUCIONAL','Registra as variações patrimoniais diminutivas provenientes do valor do abono concedido a todos empregados como remuneração do período de férias anuais - um terço a mais do que o salário normal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.25','LICENÇA-PRÊMIO','Registra as variações patrimoniais diminutivas realizadas com licença-prêmio por assiduidade no trabalho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.26','LICENÇA CAPACITACAO','Registra as variações patrimoniais diminutivas realizadas com licença para capacitação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.27','ADIANTAMENTO PECUNIÁRIO','Registra as variações patrimoniais diminutivas com adiantamento pecuniário devidos aos servidores em decorrência de determinação legal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.28','REPRESENTAÇÃO MENSAL','Registra as variações patrimoniais diminutivas realizadas com representação mensal, por exemplo do "DAS" e etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.29','COMPLEMENTAÇÃO SALARIAL','Registra as variações patrimoniais diminutivas com complementação de remuneração paga a pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.30','ADICIONAL – TETO PARLAMENTAR','Registra as variações patrimoniais diminutivas com adicional – teto parlamentar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.31','SUBSÍDIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a subsídios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','Registra as variações patrimoniais diminutivas com gratificação por exercício de cargo em comissão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra as variações patrimoniais diminutivas com vencimentos e salários prorrogação salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a férias - pagamento antecipado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','Registra as variações patrimoniais diminutivas com outros vencimentos e vantagens fixas – pessoal civil RGPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.00','OUTRAS VPD VARIÁVEIS - PESSOAL CIVIL - RGPS','Compreende o valor de outras VPD variáveis – pessoal civil RGPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.01','SUBSTITUIÇÕES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a substituições.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.02','ADICIONAL VARIÁVEL','Registra as variações patrimoniais diminutivas realizadas a título de adicional variável sujeitos a incidência de tributos e contribuições de acordo com a lei 10.973/04 - distribuição de royalties.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.03','SERVIÇOS EXTRAORDINÁRIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a serviços extraordinários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.04','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificação por embarque fluvial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.05','AVISO PREVIO','Registra as variações patrimoniais diminutivas com aviso prévio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.06','PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a participação a empregados e administradores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.07','GRATIFICAÇÃO ELEITORAL (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificação eleitoral.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.08','LICENÇA SEM REMUNERAÇÃO INCENTIVADA (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a licenca sem remuneracao incentivada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.09','CONVOCAÇÃO EXTRAORDINÁRIA LEGISLATIVA (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a convocacao extraordinaria legislativa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.10','AUXÍLIO MORADIA (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a auxilio moradia..','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.02.99','OUTRAS DESPESAS VARIÁVEIS - PESSOAL CIVIL','Registra o valor de outras VPD variáveis – pessoal civil RGPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.03.00','SENTENCAS JUDICIAIS','Registra as variações patrimoniais diminutivas com sentenças judiciais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.00','CONTRATACÃO POR TEMPO DETERMINADO','Compreende as variações patrimoniais diminutivas com contratação por tempo determinado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.01','SALÁRIO CONTRATO TEMPORARIO - LEI 8.745/93','Registra as variações patrimoniais diminutivas com salário por contrato temporário, de acordo com a Lei 8.745/93.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.02','ADICIONAL NOTURNO DE CONTRATO TEMPORARIO','Registra as variações patrimoniais diminutivas com adiconal noturno por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.03','ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO','Registra as variações patrimoniais diminutivas com adicional de periculosidade por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.04','ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO','Registra as variações patrimoniais diminutivas com adicional de insalubridade por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.05','ADICIONAL DE ATIVIDADES PENOSAS - CONTR. TEMPORARIO','Registra as variações patrimoniais diminutivas com adiconal de atividades penosas contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.06','SERVIÇOS EVENTUAIS DE MEDICOS RESIDENTES','Registra as variações patrimoniais diminutivas com serviços eventuais de médicos residentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.07','RESIDÊNCIA MULTIPROFISSIONAL','Registra as variações patrimoniais diminutivas com residência multiprofissional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.08','ADICIONAL DE IRRADIAÇÃO IONIZANTE CONT. TEMP.','Registra as variações patrimoniais diminutivas com adicional de irradiação ionizante por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.09','GRATIFICAÇÃO DE RAIO-X CONTRATO TEMPORARIO','Registra as variações patrimoniais diminutivas com gratificação de raio-X por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.10','SERVIÇOS EXTRAORDINÁRIOS CONTRATO TEMPORÁRIO','Registra as variações patrimoniais diminutivas com serviços extraordinários por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.11','SERVIÇOS EXTRAORDINÁRIOS NOTURNO CONT. TEMP.','Registra as variações patrimoniais diminutivas com serviços extraordinários noturnos porcontratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.12','FÉRIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO','Registra as variações patrimoniais diminutivas com férias vencidas ou proporcionais por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.13','13º SALÁRIO CONTRATO TEMPORÁRIO','Registra as variações patrimoniais diminutivas com 13º salário por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.14','FÉRIAS - ABONO CONSTITUCIONAL','Registra as variações patrimoniais diminutivas com adicional de férias por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.15','FÉRIAS - PAGAMENTO ANTECIPADO','Registra as variações patrimoniais diminutivas com pagamento antecipado de férias por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.16','SERVIÇOS EVENTUAIS DE AUXILIARES CIVIS NO EXT','Registra as variações patrimoniais diminutivas com serviços eventuais de auxiliares civis no exterior por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.17','SERVIÇOS EVENTUAIS DE PROFESSORES','Registra as variações patrimoniais diminutivas com serviços eventuais de professores por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.18','SERVIÇOS EVENTUAIS DE ASSISTENCIA SOCIAL','Registra as variações patrimoniais diminutivas com serviços eventuais de assistência social por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.19','SERV EVENT ENFERMAG FISIOT TERAPIA OCUPAC','Registra as variações patrimoniais diminutivas com serviços eventuais de enfermagem e fisioterapia ocupacional por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.20','SERVIÇOS EVENTUAIS DE NATUREZA INDUSTRIAL','Registra as variações patrimoniais diminutivas com serviços eventuais de natureza industrial por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.21','SERVIÇOS EVENTUAIS DE AGENTES DE SAÚDE','Registra as variações patrimoniais diminutivas com serviços eventuais de agentes de saúde por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.22','SERVIÇOS EVENTUAIS DE DENTISTAS E PSICOLOGOS','Registra as variações patrimoniais diminutivas com serviços eventuais de dentistas e psicólogos por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.23','SERVIÇOS EVENTUAIS DE MAO-DE-OBRA','Registra as variações patrimoniais diminutivas com serviços eventuais de mão de obra por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.24','SERVIÇOS TEMPORÁRIOS DE AGENTES PRISIONAIS','Registra as variações patrimoniais diminutivas com salários de agentes prisionais por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.25','OBRIGAÇÕES PATRONAIS','Registra as variações patrimoniais diminutivas com obrigações patronais por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.26','INSS PATRONAL','Registra as variações patrimoniais diminutivas com INSS patronal por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.27','FGTS','Registra as variações patrimoniais diminutivas com FGTS por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.2.1.04.99','OUTRAS CONTRATAÇÕES POR TEMPO DETERMINADO','Registra as demais variações patrimoniais diminutivas por contratação por tempo determinado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR – ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo militar, abrangidos por regime próprio dos militares ou não, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR – ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo militar, abrangidos por regime próprio dos militares ou não, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR','Compreende a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.01','SOLDO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com soldo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.02','ADICIONAL DE PERMANÊNCIA','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de permanência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.03','ADICIONAL DE TEMPO DE SERVIÇO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional por tempo de serviço.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.04','ADICIONAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.05','ADICIONAL DE COMPENSACAO ORGANICA','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de compensação orgânica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.06','ADICIONAL DE HABITACAO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de habitação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.07','GRATIFICAÇÃO DE LOCALIDADE ESPECIAL','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com localidade especial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.08','GRATIFICAÇÃO DE REPRESENTAÇÃO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de representação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.09','GRATIFICAÇÃO DE FUNCAO DE NATUREZA ESPECIAL','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de função de natureza especial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.10','GRATIFICAÇÃO DE SERVIÇO VOLUNTARIO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de serviço voluntário.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.11','VANTAGEM PECUNIÁRIA ESPECIAL - VPE','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com vantagem pecuniária especial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.12','INDENIZAÇÃO DE REPRESENTAÇÃO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com indenização de representação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.13','GRATIFICAÇÃO DE EXERCÍCIOS DE CARGOS','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de exercícios de cargos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.14','FÉRIAS VENCIDAS E PROPORCIONAIS','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com férias vencidas e proporcionais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.15','ADICIONAL NATALINO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional natalino.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.16','FÉRIAS - ABONO CONSTITUCIONAL','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de férias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.17','COMPLEMENTAÇÃO SALARIAL - PESSOAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com complementação salarial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.01.99','OUTRAS VPD FIXAS - PESSOAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório de outras variações patrimoniais diminutivas fixas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.02.00','OUTRAS DESPESAS VARIÁVEIS - PESSOAL MILITAR','Compreende a remuneração do pessoal ativo militar, correspondente ao somatório de outras variações patrimoniais diminutivas variáveis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.02.01','INDENIZAÇÕES/MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com indenizações não especificadas em outros itens.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.02.02','ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional por tarefa por tempo certo (art. 23 da MP 2131).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.02.03','ADICIONAL NOTURNO - MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional noturno.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.02.04','HORA-EXTRA, HORAS DE SOBREAVISO E PLANTÃO - MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com hora extra, horas de sobreaviso e plantões.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.1.3.1.03.00','SENTENCAS JUDICIAIS','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com sentenças judiciais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.0.0.00.00','ENCARGOS PATRONAIS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores e empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como contribuições a entidades fechadas de previdência e ainda outras contribuições patronais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.1.0.00.00','ENCARGOS PATRONAIS - RPPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.1.2.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.1.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS','Registra as variações patrimoniais diminutivas provenientes de contribuições patronais para custeio do plano de seguridade social do servidor.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.1.2.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas realizadas com encargos de pessoal requisitado de outros entes da federação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.1.2.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','Registra as variações patrimoniais diminutivas realizadas com outras obrigações patronais ao RPPS, não classificáveis nos subitens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.0.00.00','ENCARGOS PATRONAIS - RGPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos, em cargo efetivo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','Registra as variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.03.00','SEGURO DE ACIDENTE NO TRABALHO','Registra as variações patrimoniais diminutivas realizadas relativas a contribuições previdenciárias de seguro de acidentes do trabalho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas realizadas com encargos de pessoal requisitado de outros entes da Federação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS referente a prorrogação do salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','Registra as variações patrimoniais diminutivas realizadas a título de contribuição para o PIS, determinada com base na folha de pagamento, a alíquota de 1%, pelas fundações públicas instituídas ou mantidas pelo Poder Público (MP 2.158-35/2001).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.1.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','Registra as variações patrimoniais diminutivas realizadas com outras obrigações patronais ao RGPS, não classificáveis nos subitens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.2.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','Registra as variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.03.00','SEGURO DE ACIDENTE NO TRABALHO','Registra as variações patrimoniais diminutivas realizadas relativas a contribuições previdenciárias de seguro de acidentes do trabalho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas realizadas com encargos de pessoal requisitado de outros entes da Federação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS referente a prorrogação do salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','Registra as variações patrimoniais diminutivas realizadas a titulo de contribuição para o PIS, determinada com base na folha de pagamento, a alíquota de 1%, pelas fundações públicas instituídas ou mantidas pelo Poder Público (MP 2.158-35/2001).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.3.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','Registra as variações patrimoniais diminutivas realizadas com outras obrigações patronais ao RGPS, não classificáveis nos subitens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.4.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.2.5.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.3.0.00.00','ENCARGOS PATRONAIS - FGTS','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.3.1.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.3.1.01.00','FGTS','Registra as variações patrimoniais diminutivas realizadas com obrigações relativas ao recolhimento do FGTS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.3.1.02.00','FGTS - PDV','Registra as variações patrimoniais diminutivas com FGTS de servidores que optaram pelo Plano de Demissão Voluntária - PDV.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.3.1.03.00','FGTS - PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra os valores das variações patrimoniais diminutivas realizadas com obrigações relativas ao recolhimento do FGTS referente a prorrogação do salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.4.0.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.4.1.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.4.1.01.00','SISTEMAS SOCIAIS AUTÔNOMOS - ATIVO CIVIL','Registra as variações patrimoniais diminutivas realizadas com contribuições patronais para os Sistemas Sociais Autônomos, como SESI/SENAI, referente a pessoal ativo civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.4.1.02.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO','Registra as variações patrimoniais diminutivas realizadas a titulo de contribuição de salário-educação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.4.1.03.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO REFERENTE A PRORROGAÇÃO DE SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas a titulo de contribuição de salário-educação referente a prorrogação do salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.4.1.99.00','OUTRAS CONSTRIBUIÇÕES SOCIAIS GERAIS','Registra as outras contribuições sociais gerais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.0.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.1.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.1.01.00','COMPLEMENTAÇÃO DE PREVIDÊNCIA','Registra as variações patrimoniais diminutivas com contribuições de responsabilidade das entidades patrocinadoras para atender plano de previdência complementar, administrado por suas instituições de seguridade social.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.1.02.00','SEGUROS','Registra as variações patrimoniais diminutivas com contribuições a entidades de previdência fechada, sob a modalidade de seguros, tais como: seguro de vida-pac.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.1.03.00','CONTRIBUIÇÃO PATRONAL PREVIDÊNCIA PRIVADA','Registra as variações patrimoniais diminutivas com contribuição patronal, devida a entidades de previdência privada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.1.04.00','COMPLEMENTAÇÃO PREVIDENCIÁRIA REFERENTE A PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra as variações patrimoniais diminutivas com contribuições de responsabilidade das entidades patrocinadoras p/ atender plano de previdência complementar, administrado por suas instituições de seguridade social referente a prorrogação do salário maternidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.5.1.99.00','OUTRAS CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Registra as variações patrimoniais diminutivas com contribuições a entidades privadas não enquadradas nos subitens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.0.00.00','OUTROS ENCARGOS PATRONAIS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.1.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.2.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.3.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.4.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.2.9.5.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.0.0.00.00','BENEFÍCIOS A PESSOAL','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal civil e militar , tais como para o pessoal civil: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxilia-alimentação, auxilia-transporte bem como outros decorrentes de acordo ou convenção coletiva no que se refere aos empregados públicos. Para os militares: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo as despesas com vencimentos, soldos e quaisquer outras vantagens pecuniárias, bem como as despesas relacionadas aos benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.1.0.00.00','BENEFÍCIOS A PESSOAL - RPPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.1.1.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.2.0.00.00','BENEFÍCIOS A PESSOAL - RGPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídos deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.2.1.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídos ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.3.0.00.00','BENEFÍCIOS A PESSOAL - MILITAR','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.3.3.1.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.0.0.00.00','CUSTO DE PESSOAL E ENCARGOS','Compreende a variação patrimonial diminutiva relativa à pessoal e encargos utilizados na produção de bens ou serviços, sendo registrada apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS','Compreende as variações patrimoniais diminutivas relativas à pessoal e encargos apropriadas às mercadorias, sendo registradas apenas no momento da venda destas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a pessoal e encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.1.1.01.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL','Registra as variações patrimoniais diminutivas relativas a pessoal apropriadas as mercadorias, sendo registradas apenas no momento da venda destas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.1.1.02.00','CUSTO DE MERCADORIAS VENDIDAS – ENCARGOS','Registra as variações patrimoniais diminutivas relativas a encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.2.1.01.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL','Registra outras variações patrimoniais diminutivas relativas a pessoal , utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.2.1.02.00','CUSTO DE PRODUTOS VENDIDOS – ENCARGOS','Registra outras variações patrimoniais diminutivas relativas a encargos , utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registradas apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.3.1.01.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL','Registra outras variações patrimoniais diminutivas relativas a pessoal, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.8.3.1.02.00','CUSTO DE SERVIÇOS PRESTADOS – ENCARGOS','Registra outras variações patrimoniais diminutivas relativas a encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.1.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntário.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.1.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntário. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.2.0.00.00','PESSOAL REQUISITADO DE OUTROS ÓRGÃOS','Compreende as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.2.1.00.00','PESSOAL REQUISITADO DE OUTROS ÓRGÃOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.9.0.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.9.1.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.9.1.01.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL','Registra outras variações patrimoniais diminutivas, relacionadas com pessoal, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.1.9.9.1.02.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - ENCARGOS','Registra outras variações patrimoniais diminutivas, relacionadas com encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.0.0.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreendem as variações patrimoniais diminutivas relativas às aposentadorias, pensões, reformas, reserva remunerada e outros benefícios previdenciários de caráter contributivo, do regime próprio da previdência social - RPPS e do regime geral da previdência social – RGPS, bem como as ações de assistência social, que são políticas de seguridade social não contributiva, visando ao enfrentamento da pobreza, a garantia dos mínimos sociais, ao provimento de condições para atender contingencias sociais e a universalização dos direitos sociais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.0.0.00.00','APOSENTADORIAS E REFORMAS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.0.00.00','APOSENTADORIAS - RPPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.01.00','PROVENTOS - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas com Aposentadoria de Pessoal Civil concedidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.02.00','ABONO PROVISÓRIO','Registra as Variações Patrimoniais Diminutivas realizadas com Abono Provisório.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.03.00','APOSENTADORIAS PENDENTES DE APROVAÇÃO - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas com Aposentadorias de Pessoal Civil Concedidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.06.00','13º. SALÁRIO – PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de 13º Salário - Pessoal Civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.07.00','GRATIFICAÇÃO TEMPO DE SERVIÇO - ANUÊNIO CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Gratificação tempo de Serviço - Anuênio Civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.10.00','VANTAGENS INCORPORADAS - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Vantagens Incorporadas - Pessoal Civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.11.00','PROVENTOS ORIGINÁRIAS DE GRATIFICAÇÕES POR EXERCÍCIO DE FUNÇÕES','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Proventos Originárias de Gratificações por Exercício de Funções.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.12.00','PROVENTOS ORIGINÁRIAS DE GRATIFICAÇÕES POR EXERCÍCIO DE CARGO','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Proventos Originárias de Gratificações por Exercício de Cargo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.15.00','GRATIFICAÇÕES ESPECIAIS A APOSENTADOS','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Gratificações Especiais a Aposentados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.16.00','COMPLEMENTAÇÃO DE APOSENTADORIAS','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Complementação de Aposentadorias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.70.00','SENTENÇAS JUDICIAIS DE BENEFÍCIOS PREVIDENCIÁRIOS PESSOAL CIVIL - RPPS','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Sentenças Judiciais de Benefícios Previdenciários Pessoal Civil - RPPS','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.1.1.99.00','OUTRAS APOSENTADORIAS','Registra as Variações Patrimoniais Diminutivas Realizadas com outras Aposentadorias não Classificáveis nos subitens anteriores, e/ou valores relativos a integração de Balancetes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.2.0.00.00','APOSENTADORIAS - RGPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RGPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.2.1.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidos pelo RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.0.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.01.00','PROVENTOS - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente proventos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.02.00','GRATIFICAÇÃO TEMPO DE SERVIÇO-ANUÊNIO MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Gratificação Tempo de Serviço - Anuênio Militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.04.00','AJUDA DE CUSTO (TRANSF. P/RESERVA REM.)','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Ajuda de Custo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.05.00','ADICIONAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Adicional Militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.06.00','COMPLEMENTAÇÃO APOSENTADORIA - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Complementação Aposentadoria - Pessoal Militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.07.00','VANTAGENS INCORPORADAS - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Vantagens Incorporadas - Pessoal Militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.08.00','AUXÍLIO-INVALIDEZ - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Auxílio invalidez Pessoal Militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.09.00','13º. SALÁRIO PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente 13º Salário Pessoal Militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.70.00','SENTENÇAS JUDICIAIS DE BENEFÍCIOS PREVIDENCIÁRIOS PESSOAL MILITAR - RPPS','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Sentenças Judiciais Benefícios Previdenciários Pessoal Militar - RPPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.3.1.99.00','OUTRAS REFORMAS','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Outras Reformas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.9.0.00.00','OUTRAS APOSENTADORIAS','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.1.9.1.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.0.0.00.00','PENSÕES','Compreendem os benefícios da previdência social que garantem uma renda aos dependentes do segurado falecido.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.1.0.00.00','PENSÕES - RPPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.1.1.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.2.0.00.00','PENSÕES - RGPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social – RGPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.2.1.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social - RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.3.0.00.00','PENSÕES - MILITAR','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.3.1.00.00','PENSÕES - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.9.0.00.00','OUTRAS PENSÕES','Compreende as variações patrimoniais diminutivas provenientes de outras pensões.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.2.9.1.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de outras pensões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.0.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem os benefícios de prestação continuada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.1.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Compreendem os benefícios de prestação continuada ao idoso e renda mensal vitalícia por idade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.1.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada e renda mensal vitalícia por idade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.1.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Registra o benefício de prestação continuada que garante 1 (um) salário mínimo mensal ao idoso , que comprove não possuir meios de prover a própria manutenção e nem de tê-la provida por sua família.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.2.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia – invalidez.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.2.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia – invalidez. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.2.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Registra o beneficio de prestação continuada que garante 1 (um) salário mínimo mensal a pessoa portadora de deficiência, que comprove não possuir meios de prover a própria manutenção e nem de tê-la provida por sua família.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.9.0.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem outros benefícios de prestação continuada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.3.9.1.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','Compreende outros benefícios de prestação continuada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.0.0.00.00','BENEFÍCIOS EVENTUAIS','Compreendem as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de nascimento, morte, situações de vulnerabilidade temporária e de calamidade pública. As provisões relativas a programas, projetos, serviços e benefícios diretamente vinculados ao campo da saúde, educação, integração nacional e das demais políticas setoriais não se incluem na modalidade de benefícios eventuais da assistência social.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.1.0.00.00','AUXÍLIO POR NATALIDADE','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.1.1.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.2.0.00.00','AUXÍLIO POR MORTE','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.2.1.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.3.0.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.3.1.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.4.0.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.4.1.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - CONSOLIDAÇÃO','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar - lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.9.0.00.00','OUTROS BENEFÍCIOS EVENTUAIS','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.4.9.1.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.5.0.0.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.5.0.1.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.0.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários ou assistenciais, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.01.00','AUXÍLIO FUNERAL ATIVO CIVIL','Registra o valor das variações patrimoniais diminutivas com auxílio devido a família do servidor ativo civil falecido, em valor equivalente a um mês de remuneração ou proventos. Devido também a terceiro que custear comprovadamente as despesas com funeral do servidor. Também será devido auxílio funeral, em caso de falecimento de servidor em serviço fora do local de trabalho, inclusive no exterior e as despesas de transporte do corpo (traslado) correrão a conta dos recursos da união, autarquia ou fundação pública (art. 228, Lei 8112/90).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.02.00','AUXÍLIO FUNERAL INATIVO CIVIL','Registra o valor das variações patrimoniais diminutivas com o auxílio devido a família do servidor inativo civil, em valor equivalente a um mês de remuneração ou proventos. Devido também a terceiro que custear comprovadamente as variações patrimoniais diminutivas com funeral do inativo civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.03.00','AUXÍLIO NATALIDADE ATIVO CIVIL','Registra o valor das variações patrimoniais diminutivas com auxílio natalidade-ativo civil, devido a servidora, cônjuge ou companheiro servidor público, por motivo de nascimento de filho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.04.00','AUXÍLIO NATALIDADE INATIVO CIVIL','Registra o valor das variações patrimoniais diminutivas com auxílio natalidade inativo civil,devido, a servidora, cônjuge ou companheiro servidor público, por motivo e nascimento de filho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.05.00','AUXÍLIO RECLUSÃO ATIVO CIVIL','Registra o valor das variações patrimoniais diminutivas com auxílio reclusão devido a família do servidor ativo civil, afastado por motivo de prisão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.06.00','AUXÍLIO RECLUSÃO INATIVO CIVIL','Registra o valor das variações patrimoniais diminutivas com auxílio reclusão devido a família do servidor inativo civil, afastado por motivo de prisão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.07.00','AUXÍLIO FUNERAL PENSIONISTA CIVIL','Registra o valor das variações patrimoniais diminutivas com o auxílio devido a família do servidor pensionista, em valor equivalente a um mês de remuneração ou proventos. Devido também a terceiro que custear comprovadamente as variações patrimoniais diminutivas com funeral do pensionista.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.08.00','AUXÍLIO RECLUSÃO PENSIONISTA CIVIL','Registra o valor das variações patrimoniais diminutivas com o auxílio devido a família do servidor pensionista, em valor equivalente a um mês de remuneração ou proventos. Devido também a terceiro que custear comprovadamente as variações patrimoniais diminutivas com funeral do pensionista.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.09.00','AUXÍLIO NATALIDADE PENSIONISTA CIVIL','Registra o valor das variações patrimoniais diminutivas com auxílio natalidade a pensionista civil, devido a servidora, cônjuge ou companheiro servidor público, por motivo de nascimento de filho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.10.00','AUXÍLIO-DOENCA','Registra as variações patrimoniais diminutivas com auxílio-doenca, devido ao segurado que ficar incapacitado para o trabalho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.11.00','SALÁRIO MATERNIDADE','Registra as variações patrimoniais diminutivas com salário-maternidade, devido a segurada gestante, na forma da Lei 6.136/74, durante o período de licença gestante previsto em lei.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.12.00','SALÁRIO-FAMÍLIA','Compreende as variações patrimoniais diminutivas com salário-família.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.12.01','SALÁRIO FAMÍLIA - ATIVO PESSOAL CIVIL','Registra o valor das variações patrimoniais diminutivas com salário família - ativo pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.12.02','SALÁRIO FAMÍLIA-INATIVO PESSOAL CIVIL','Registra o valor das variações patrimoniais diminutivas com salário-família devidos a inativos pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.1.1.12.03','SALÁRIO FAMÍLIA-PENSIONISTA PESSOAL CIVIL','Registra o valor das variações patrimoniais diminutivas com salário-família devido a pensionista pessoal civil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.2.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.2.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.01.00','AUXÍLIO FUNERAL ATIVO MILITAR','Registra o valor das variações patrimoniais diminutivas com o auxílio devido a família do servidor ativo militar, em valor equivalente a um mês de remuneração ou proventos. Devido também a terceiro que custear comprovadamente as despesas com funeral do ex-servidor.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.02.00','AUXÍLIO FUNERAL INATIVO MILITAR','Registra o valor das variações patrimoniais diminuitivas com o auxílio devido a família do servidor inativo militar, em valor equivalente a um mês de remuneração ou proventos. Devido também a terceiro que custear comprovadamente as despesas com funeral do inativo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.03.00','AUXÍLIO NATALIDADE ATIVO MILITAR','Registra o valor das variações patrimoniais diminutivas com auxílio natalidade-ativo militar devido a servidora, cônjuge ou companheiro servidor público, por motivo de nascimento de filho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.04.00','AUXÍLIO NATALIDADE INATIVO MILITAR','Registra o valor das variações patrimoniais diminutivas com auxílio natalidade inativo militar devido a servidora,cônjuge ou companheiro servidor público, por motivo de nascimento de filho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.05.00','AUXÍLIO RECLUSÃO ATIVO MILITAR','Registra o valor das variações patrimoniais diminutivas com auxílio reclusão devido a família do servidor ativo militar, afastado por motivo de prisão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.06.00','AUXÍLIO RECLUSÃO INATIVO MILITAR','Registra o valor das variações patrimoniais diminutivas com auxílio reclusão devido a família do servidor ativo militar, afastado por motivo de prisão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.07.00','AUXÍLIO RECLUSÃO PENSIONISTA MILITAR','Registra o valor das variações patrimoniais diminutivas com auxílio reclusão devido a família do servidor ativo militar, afastado por motivo de prisão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.08.00','AUXÍLIO FUNERAL PENSIONISTA MILITAR','Registra o valor das variações patrimoniais diminutivas com o auxílio devido a família do servidor pensionista militar em valor equivalente a um mês de remuneração ou proventos devido também a terceiro e custear comprovadamente as despesas com funeral do pensionista.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.09.00','AUXÍLIO NATALIDADE PENSIONISTA MILITAR','Registra o valor das variações patrimoniais diminutivas com auxílio natalidade pensionista militar devido a servidora, cônjuge ou companheiro do servidor público, por motivo de nascimento de filho.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.10.00','SALÁRIO-FAMÍLIA','Compreende as variações patrimoniais diminutivas com salário-família.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.10.01','SALÁRIO FAMÍLIA-ATIVO PESSOAL MILITAR','Registra o valor das variações patrimoniais diminutivas com salário família-ativo pessoal militar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.10.02','SALÁRIO FAMÍLIA - INATIVO PESSOAL MILITAR','Registra o valor das variações patrimoniais diminutivascom salário família a inativos militares, quando o pagamento for efetuado pela entidade constituida para administrar o RPPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.3.1.10.03','SALÁRIO FAMÍLIA - PENSIONIOSTA PESS. MILITAR','Registra o valor das variações patrimoniais diminutivas com salário família a pensionistas militares, quando o pagamento for efetuado pela entidade constituida para administrar o RPPS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.9.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.2.9.9.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.0.0.0.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende o somatório das variações patrimoniais diminutivas com manutenção e operação da maquina pública, exceto despesas com pessoal e encargos que serão registradas em grupo específico (despesas de pessoal e encargos). Compreende: diárias, material de consumo, material de distribuição gratuita, passagens e despesas com locomoção, serviços de terceiros, arrendamento mercantil operacional, aluguel, depreciação, amortização, exaustão, entre outras.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.0.0.00.00','USO DE MATERIAL DE CONSUMO','Compreende as variações patrimoniais diminutivas provenientes da distribuição do material de consumo. Um material é considerado de consumo quando for de duração inferior a dois anos, frágil, perecível, incorporável, transformável ou cuja finalidade seja para consumo imediato ou para reposição.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.0.00.00','CONSUMO DE MATERIAL','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.01.00','COMBUSTÍVEIS E LUBRIFICANTES AUTOMOTIVOS','Registra as variações Patrimoniais Diminutivas provenientes da utilização de Combustíveis para motores a combustão interna de veículos rodoviários, tratores em geral, embarcações diversas e grupos geradores estacionados ou transportáveis, e todos os óleos lubrificantes destinados aos sistemas hidráulicos hidramáticos de caixa de transmissão de força e graxas grafitadas para altas e baixas temperaturas. aditivos - álcool hidratado - fluído para amortecedores - fluido para transmissão hidráulica - gasolina - graxas - óleo diesel - óleo para carter - óleo para freio e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.03.00','GÁS E OUTROS MATERIAIS ENGARRAFADOS','Registra as variações patrimoniais diminutivas provenientes da utilização de gás de uso industrial, de tratamento de água, de iluminação, de uso médico, bem como gases nobres para uso em laboratório cientifico, tais como: acetileno - carbônico freon - helio - hidrogênio - Liquefeito de petróleo - nitrogênio - oxigênio e outros. Registra, ainda, o valor das despesas com gás, pó químico, água pressurizadas e outros materiais utilizado nas recargas de Extintores de Incêndio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.04.00','EXPLOSIVOS E MUNISSÕES','Registra as variações Patrimoniais Diminutivas provenientes da utilização de cargas de projeção em peças de artilharia, mísseis guiados e não guiados, capsulas ou estojos para recarga e explosivos de uso Militar e Paramilitar. balas e similares - estopim - explosivos, tais como: artefatos explosivos - artigos pirotécnicos - capsulas de detonação - dinamite - espoleta - fogos de artifício - granada - pólvora e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.05.00','ALIMENTOS PARA ANIMAIS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de alimentos destinados a gado bovino, equino, muar, e bufalino, caprinos, suínos, ovinos, aves de qualquer espécie, como também para animais silvestres em cativeiro (jardins zoológicos ou laboratórios) e outros. alfafa - alpiste - capim verde - farelo - farinhas em geral - fubá grosso - milho em grão - ração balanceada - sal mineral - suplementos vitamínicos e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.06.00','GÊNEROS ALIMENTAÇÃO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de gêneros de alimentação ao natural, beneficiados ou conservados. açúcar - adoçante - água mineral - bebidas - café - carnes em geral - cereais - chás - condimentos - frutas - gelo - legumes - refrigerantes -sucos - temperos - verduras e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.07.00','ANIMAIS PARA PESQUISA E ABATE','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de animais para pesquisa e abate. Incluem-se nesta classificação os peixes e mariscos, todas as espécies de mamíferos, abelhas para estudos, pesquisa e produção de Mel, bem assim qualquer outro animal destinado a estudo genético ou alimentação. boi - cabrito - cobaias em geral - macaco - rato - rã e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.08.00','MATERIAL FARMACOLÓGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de medicamentos ou componentes destinados a manipulação de drogas medicamentosas. medicamentos - soro - vacinas e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.09.00','MATERIAL ODONTOLÓGICO','Registra as Variações Patronais Diminutivas provenientes da utilização de materiais para pacientes da área odontológica, bem como os utilizados indiretamente pelos protéticos na convecção de próteses diversas. agulhas - amalgama - anestésicos - broca - cimento odontológico - espátula odontológica - filmes para raio X - platina - resinas odontológicas - seringas - sugador e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.10.00','MATERIAL QUIMÍCO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os elementos ou compostos químicos destinados ao fabrico de Produtos químicos, análises laboratoriais, bem como aqueles destinados ao combate de pragas ou opizootias. ácidos - Inseticidas - produtos químicos para tratamento de água - reagentes químicos - sais - solventes - substâncias utilizadas para combater insetos, fungos e bactérias e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.11.00','MATERIAL DE COUDELARIA OU DE USO ZOOTÉCNICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais utilizados no arreamento de animais destinados a montaria, com exceção da sela, como também aqueles destinados ao adestramento de cães de guarda ou outro animal domestico. argolas de metal - arreamento - barrigueiras - bridões - cabrestos - cinchas - Cravos - escovas para animais - estribos - ferraduras - mantas de pano - material para apicultura - material de ferragem e contenção de animais - peitorais -raspadeiras e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.13.00','MATERIAL DE CAÇA E PESCA','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais de caça e pesca.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.14.00','MATERIAL EDUCATIVO E ESPORTIVO','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais consumidos diretamente nas atividades educativas e esportivas de crianças e adultos. apitos - bolas - bonés - botas especiais - brinquedos educativos - calções - camisas de malha – chuteiras – cordas – esteiras – joelheiras – luvas – materiais pedagógicos – meias – óculos para motociclistas – patins – quimonos – raquetes – redes para pratica de esportes – tênis e sapatilhas – tornozeleiras – touca para natação e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.15.00','MATERIAL PARA FESTIVIDADESE HOMENAGENS','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais de consumo utilizados em festividades e homenagens, incluindo artigos para decoração e Buffet. arranjos e coroas de flores - bebidas - doces - salgados - placas comemorativas (exceto as placas para distribuição gratuita) e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.16.00','MATERIAL DE EXPEDIENTE','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais aplicados diretamente nos trabalhos administrativos, nos escritórios públicos, nos centros de estudos e pesquisas, nas escolas, nas universidades etc. agenda - alfinete de aço - almofada p/carimbos - apagador - apontador de lápis - arquivo p/disquete - bandeja para papeis - bloco p/rascunho - bobina papel p/calculadoras - borracha - caderno - caneta -capa de processo - carimbos em geral - cartolina - classificador -clipe - cola - colchete - corretivo - envelope - espátula - estêncil -estilete - extrator de grampos - fita adesiva - fita p/maquina de escrever e calcular - giz - goma elástica - grafite - grampeador -grampos - guia p/arquivo - guia de endereçamento postal - impressos e formulários em geral - intercalador p/fichário - lacre - lápis -lapiseira - limpa tipos - livros de ata, de ponto e de protocolo -papeis - pastas em geral - percevejo - perfurador - pinça - placas de acrílico - plásticos - porta-lápis - registrador - régua - selos p/correspondência - tesoura - tintas - toner - transparências - etiquetas e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.17.00','MATERIAL DE PROCESSAMENTO DE DADOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de suprimentos de ti, inclusive pecas para reposição. cartuchos de tinta - capas plásticas protetoras para micros e impressoras - cd-rom virgem - disquetes - etiquetas em formulários - contínuos -leitora/smartcard - mouse e teclado (reposição) - mouse pad - pecas e acessórios para computadores e periféricos - recarga de cartuchos de tinta - toner para impressoras a laser - cartões magnéticos - reposição de leitora/token pen-drive/outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.18.00','MATERIAIS E MEDICAMENTOS P/USO VETERINÁRIO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais e medicamentos para uso veterinário. vacinas – medicamentos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.19.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais aplicados diretamente nas preservações, acomodações ou embalagens de qualquer produto. arame - barbante - caixas plásticas, de madeira, papelão e isopor -cordas - engradados - fitas de aço ou metálicas - fitas gomadoras -garrafas e potes - linha - papel de embrulho - papelão - sacolas - sacos - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.20.00','MATERIAL DE CAMA, MESA E BANHO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais utilizados em dormitórios coletivos, residenciais, hotéis, restaurantes etc. cobertores - colchas - colchonetes - fronhas - guardanapos - lençóis -toalhas - travesseiros - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.21.00','MATERIAL DE COPA E COZINHA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para refeitórios de qualquer tipo, cozinhas residenciais, de hotéis, de hospitais, de escolas, de universidades, de fabricas etc. abridor de garrafa - açucareiros - artigos de vidro e plástico -bandejas - coadores - colheres - copos - ebulidores - facas - farinheiras - fósforos - frigideiras - garfos - garrafas térmicas -paliteiros - panelas - panos de cozinha - papel alumínio - pratos -recipientes para água - suportes de copos p/cafezinho - tigelas -velas - xícaras - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.22.00','MATERIAL DE LIMPEZA E PRODUTOS DE HIGIENIZAÇÃO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais destinados a higienização pessoal, de ambientes de trabalho, de hospitais etc. álcool etílico - anticorrosivo - aparelho de barbear descartável -balde plástico - bomba p/inseticida - capacho - cera - cesto p/lixo- creme dental - desinfetante - desodorizante - detergente - escova de dentes - escova p/roupas e sapatos - espanador - esponja - estopa -flanela - inseticida - lustra-móveis - mangueira - naftalina - para lixo - palha de aço - panos p/limpeza - papel higiênico - pasta para limpeza de utensílios – porta - sabão - removedor - rodo - sabão -sabonete - saco p/lixo - saponáceo - soda caustica - toalha de papel- vassoura - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.23.00','UNIFORMES, TECIDOS E AVIAMENTOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de uniformes ou qualquer tecido ou material sintético que se destine a confecção de roupas, com linhas de qualquer espécie destinadas a costuras e outros materiais de consumo empregados direta ou indiretamente na confecção de roupas. agasalhos - artigos de costura - aventais - blusas - botões - cadarços- calcados - calcas - camisas - capas - chapéus - cintos - elásticos -gravatas - guarda-pós - linhas - macacões - meias - tecidos em geral -uniformes militares ou de uso civil - zíperes - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.24.00','MATERIAL P/MANUT. E BENS IMÓVEIS/INSTALAÇÕES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para aplicação, manutenção e reposição de qualquer bem publico. amianto - aparelhos sanitários - arames liso e farpado - areia -basculante - boca de lobo - boia - brita - brocha - cabo metálico -cal - cano - cerâmica - cimento - cola - condutores de fios - conexões- curvas - esquadrias - fechaduras - ferro - gaxetas - grades -impermeabilizantes - isolantes acústicos e térmicos - janelas -joelhos - ladrilhos - lavatórios - lixas - madeira - marcos de concreto - massa corrida - niple - papel de parede - parafusos - - pecas p/elevadores, portões elétricos, ar condicionado central, etc- pias- pigmentos - portas e portais - pregos - rolos solventes - sifão -tacos - tampa p/vaso - tampão de ferro - tanque - tela de estuque -telha - tijolo - tinta - torneira - trincha - tubo de concreto -válvulas - verniz - vidro - aquecedores a gás e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.25.00','MATERIAL PARA MANUTENÇÃO DE BENS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de componentes, pecas, acessórios e sobressalentes para aplicação, manutenção e reposição em bens moveis em geral. cabos - chaves - cilindros p/maquinas copiadoras - compressor p/ar condicionado - mangueira p/fogão - pecas de reposição de aparelhos e maquinas em geral - materiais de reposição para instrumentos musicais - vidro de mesa e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.26.00','MATERIAL ELÉTRICO E ELETRÔNICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para aplicação, manutenção e reposição dos sistemas, aparelhos e equipamentos elétricos e eletrônicos. benjamins - bocais - calhas - capacitores e resistores - chaves de ligação - circuitos eletrônicos - condutores - componentes de aparelho eletrônico - diodos - disjuntores - eletrodos - eliminador de pilhas -espelhos para interruptores - fios e cabos - fita isolante - fusíveis- interruptores - lâmpadas e luminárias - pilhas e baterias - pinos e plugs - placas de baquelita - reatores - receptáculos - resistências -starts - suportes - tomada de corrente - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.27.00','MATERIAL DE MANOBRA E PATRULHAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo utilizados em campanha militar ou paramilitar, em manobras de tropas, em treinamento ou em ação em patrulhamento ostensivo ou rodoviário, em campanha de saúde publica etc. binóculo - carta náutica - cantil - cordas - flâmulas e bandeiras desinalizacao - lanternas - medicamentos de pronto-socorro - mochilas -piquetes - sacolas - sacos de dormir - sinaleiros - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.28.00','MATERIAL DE PROTEÇÃO E SEGURANCA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo utilizados diretamente na proteção de pessoas ou bens públicos, para socorro de pessoas e animais ou para socorro de veículos, aeronaves e embarcações, assim como qualquer outro item aplicado diretamente nas atividades de sobrevivência de pessoas, na selva, no mar ou em sinistros diversos. botas - cadeados - calcados especiais - capacetes - chaves - cintos -coletes - dedais - guarda-chuvas - lona - luvas - mangueira de lona -mascaras - passadeira antiderrapante - óculos - cabina de papelão e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.29.00','MATERIAL PARA ÁUDIO, VÍDEO E FOTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo de emprego direto em filmagem e revelação, ampliações e reproduções de sons e imagens. aetze especial p/chapa de papel - álbuns p/retratos - alto-falantes- antenas - artigos para gravação em acetato - filmes virgens - fitas virgens de áudio e vídeo - lâmpadas especiais - material p/radiografia, microfilmagem e cinematografia - molduras - papel p/revelação de fotografias - pegadores - reveladores - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.30.00','MATERIAL PARA COMUNICAÇÕES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para comunicações, assim como os componentes, circuitos impressos ou integrados, pecas ou acessórios de reposição, chips, e partes de equipamentos de comunicação materiais para instalações: radiofônicas, radiotelegráficas, telegráficas e outros. - bateria para telefone celular- bloqueador telefônico - chave comutadora para telefone - fio para telefone - tomada para telefone - materiais para instalações radiofônicas - radiotelegráficas - telegráficas - outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.31.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de qualquer tipo de semente destinada ao plantio e mudas de plantas frutíferas ou ornamentais, assim como todos os insumos utilizados para fertilização. adubos - argila - plantas ornamentais - borbulhas - bulbos - enxertos- fertilizantes - mudas envasadas ou com raízes nuas - sementes -terra - tubérculos - xaxim - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.32.00','SUPRIMENTO DE AVIAÇÃO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de suplementos para avaliação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.33.00','MATERIAL PARA PRODUÇÃO INDUSTRIAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de matérias-primas utilizadas na transformação, beneficiamento e industrialização de um produto final. borracha - couro - matérias-primas em geral - minérios - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.34.00','SUPRIMENTOS PARA MÁQ. E MOTORES NAVIOS E EMBARCAÇÕES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material para manutenção e reparo de maquinas e motores de navios, inclusive da esquadra, e de embarcações em geral.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.35.00','MATERIAL LABORATORIAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os utensílios usados em analises laboratoriais. almofarizes - bastões - bico de gás - cálices - corantes - filtros de papel - fixadoras - frascos - funis - garra metálica - laminas de vidro p/microscópio - lâmpadas especiais - luvas de borracha - metáfise metaloides p/analise - pinças - rolhas - vidraria: balão volumétrico - becker - conta-gotas - erlemeyer - pipeta - proveta - termômetro- tubo de ensaio - material de laboratório didático e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.36.00','MATERIAL HOSPITALAR','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para área hospitalar ou ambulatorial. agulhas hipodérmicas - algodão - cânulas - cateteres - compressa de gaze - drenos - esparadrapo - fios cirúrgicos - laminas p/ bisturi -luvas - seringas - termômetro clinico - e outros. .','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.37.00','SUPRIMENTOS DE ARMAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Suprimentos de Armamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.38.00','SUPRIMENTO DE PROTEÇÃO AO VOO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Suprimentos de proteção ao Voo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.39.00','MATERIAL PARA MANUTENÇÃO DE VEÍCULOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para aplicação e manutenção de veículos rodoviários, viaturas blindadas e tratores em geral. água destilada - amortecedores - baterias - borrachas - buzina - cabos de acelerador - cabos de embreagem - camará de ar - carburador completo - cifa - colar de embreagem - condensador e platinado - correias- disco de embreagem - ignição - junta homocinetica - lâmpadas e lanternas p/veículos - lonas e pastilhas de freio - mangueiras -material utilizado em lanternagem e pintura - motor de reposição -para-brisa - para-choque - platô - pneus - reparos - retentores -retrovisores - rolamentos - tapetes - válvula da marcha lenta e termostática - velas - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.40.00','MATERIAL BIOLÓGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material Biológico.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.41.00','MATERIAL PARA UTILIZAÇÃO EM GRÁFICA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os materiais de consumo de uso gráfico, tais como: chapas de offset - clichês - cola - espirais - fotolitos - logotipos - papel - solventes - tinta - tipos - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.42.00','FERRAMENTAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os tipos de ferramentas utilizadas em oficinas, carpintarias, jardins etc. alicate - broca - caixa p/ferramentas - canivete - chaves em geral -enxada - espátulas - ferro de solda - foice - lamina de serra - lima -machado - martelo - pa - picareta - ponteira - prumo - serrote -tesoura de podar - trena - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.43.00','MATERIAL PARA REABILITAÇÃO PROFISSIONAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para programas de reabilitação profissional. bastões - bengalas - joelheiras - meias elásticas e assemelhados -óculos - orteses - pesos - próteses, instrumentos de trabalho e implementos profissionais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.44.00','MATERIAL DE SINALIZAÇÃO VISUAL E OUTROS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para identificação, sinalização visual, endereçamento e outros. placas de sinalização em geral, tais como, placas indicativas para o setores e seções, placas para veículos, plaquetas para tombamento de material, placas sinalizadoras de trânsito, cones sinalizadores de trânsito, crachás, botons identificadores para servidores e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.45.00','MATERIAL TÉCNICO PARA SELEÇÃO E TREINAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais técnicos utilizados em processos de seleção e treinamento pela própria unidade gestora ou para distribuição não gratuita, tais como: apostilas e similares - folhetos de orientação - livros - manuais explicativos para candidatos - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.46.00','MATERIAL BIBLIOGRÁFICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material bibliográfico tais como: jornais - revistas - periódicos em geral - anuários médicos - anuário estático - livros em geral e outros, podendo estar na forma de cd-rom e os materiais bibliográficos para bibliotecas públicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.48.00','BENS MÓVEIS NÃO ATIVÁVEIS','Registra as Variações Patrimoniais Diminutivas provenientes da aquisição de bens moveis de natureza permanente não ativáveis, ou seja, aqueles considerados como despesa operacional, para fins de dedução de imposto de renda, desde que atenda as especificações contidas no artigo 301 do rir (regulamento de imposto de renda). esta conta é utilizada exclusivamente pelas unidades regidas pela lei 6404/76.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.49.00','BILHETES DE PASSAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de bilhetes de passagem para guarda em estoque.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.50.00','BANDEIRAS, FLÂMULAS E INSÍGNIAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de bandeiras, flâmulas e insígnias, a saber: brasões, escudos, armas da republica, selo nacional e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.51.00','DISCOTECAS E FILMOTECAS NÃO IMOBILIZÁVEL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de discotecas e filmotecas não imobilizável.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.52.00','MATERIAL DE CARÁTER SECRETO OU RESERVADO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material de caráter secreto ou reservado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.53.00','MATERIAL METEOROLÓGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material meteorológico, tais como: radiossondas, balão de látex, etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.54.00','MATERIAL P/MANUT.CON SERV.DE ESTRADAS E VIAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para reparos, recuperações e adaptações de estradas, ferrovias e rodovias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.55.00','SELOS PARA CONTROLE FISCAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de selos para controle fiscal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.56.00','MATERIAL DE MARCAÇÃO DA FAUNA SILVESTRE','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material de Marcação da Fauna Silvestre.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.57.00','MATERIAL DE CONSUMO - REPARTIÇÕES NO EXTERIOR','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material de Consumo - repartições no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.58.00','SOBRESSALENTES PARA MÁQUINAS E EQUP. PARA PRODUÇÃO INDUSTRIAL','Registra as Variações Patrimoniais Diminutivas provenientes de Sobressalentes para Máquinas e Equipamentos para Produção Industrial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.70.00','AQUISIÇÃO DE SOFTWARES DE BASE','Registra as Variações Patrimoniais Diminutivas provenientes da aquisição de Softwares de Base.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.71.00','MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO','Registra as Variações Patrimoniais Diminutivas provenientes de Materiais para Conservação e Manutenção de Bens de uso Comum do Povo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.98.00','SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS','Registra as Variações Patrimoniais Diminutivas provenientes de Sentenças Judiciais de Fornecedores de Materiais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.1.1.99.00','OUTROS MATERIAIS DE CONSUMO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de outros materiais de consumo que não se enquadrem nas rubricas anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.0.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.01.00','MERCADORIAS DOADAS','Registra as variações patrimoniais diminutivas provenientes da utilização de produtos adquiridos com a finalidade de doação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.02.00','MATERIAL DESTINADO À ASSISTÊNCIA SOCIAL','Registra as variações patrimoniais diminutivas provenientes da utilização de mat.de saúde(farmacológico,odontológico,hospitalar,medicamentos,órtese e prótese),gêneros alimentícios, mater.de cama,mesa,copa,cozinha,limpeza,higienização, uniformes, tecidos, aviamentos,manut.mov/imov.,ferramentas e outros distinados a assistencia social.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.03.00','MATERIAL EDUCACIONAL E CULTURAL','Registra as variações patrimoniais diminutivas provenientes da utilização de material educacional,(material escolar, didático, técnico, material p/áudio, vídeo e foto)e material cultural (material religioso e esportivo).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.04.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as variações patrimoniais diminutivas provenientes da utilização de mate. de acondic. e embalagem.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.05.00','MATERIAL PARA CERIMONIAL','Registra as variações patrimoniais diminutivas provenientes da aquisição de materiais oferecidos a autoridades a titulo de homenagem.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.06.00','MATERIAL PARA DIVULGAÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de material para publicidade e divulgação de programas do governo, para conscientizacao social. ex: camisetas, bonés, chaveiros, canetas, botons, com logomarcas,folders,cartazes,cartilhas e manuais,etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.07.00','MATERIAL DESTINADO A CONTRIBUINTE','Registra as variações patrimoniais diminutivas provenientes da utilização de material (cd-rom, formulários, etc.) para distribuição aos contribuintes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.08.00','MATERIAL P/ IDENTIFICAÇÃO DE BENEFICIÁRIOS','Registra as Variações Patrimoniais Diminutivas provenientes da distribuição de Material para Identificação de Beneficiários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.1.2.1.99.00','OUTROS MATERIAIS DE DISTRIBUIÇÃO GRATUITA','Registra as variações patrimoniais diminutivas provenientes da utilização de materiais para distribuição gratuita, não contemplados em rubricas específicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.0.0.00.00','SERVIÇOS','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços fornecidas à entidade governamental.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.1.0.00.00','DIÁRIAS','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.1.1.00.00','DIÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.1.1.01.00','DIÁRIAS PESSOAL CIVIL','Registra as variações patrimoniais diminutivas provenientes da utilização de diárias de pessoal civil,cobrindo alimentação, pousada e locomoção urbana do servidor público ou celetista que se deslocar de sua sede em objeto de serviço, em caráter eventual ou transitório.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.1.1.02.00','DIÁRIAS - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas provenientes da utilização de diárias decorrentes do deslocamento do militar da sede de sua unidade por motivo de serviço, destinadas à indenização das despesas de alimentação e pousada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.1.1.03.00','DIÁRIAS - COLABORADORES EVENTUAIS','Registra as variações patrimoniais diminutivas provenientes da utilização de diárias pagas a prestadores de serviços de caráter eventual, sem vínculo com a administração pública.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.1.1.04.00','DIÁRIAS A CONSELHEIROS','Registra as variações patrimoniais diminutivas provenientes da utilização de diárias a membros de órgãos de deliberação coletiva (conselhos).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.0.00.00','SERVIÇOS TERCEIROS - PF','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.01.00','CONSULTORIA E ASSESSORIA','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços nas áreas de consultorias e assessorias técnicas, ou assemelhadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.02.00','PERÍCIAS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de perícias realizadas por profissionais técnicos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.03.00','AUDITORIA EXTERNA','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de auditoria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.04.00','HONORÁRIOS ADVOCATÍCIOS - ÔNUS DE SUCUMBÊNCIA','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços advocatícios decorrentes do ônus da sucumbência, entendido este como o ônus que recai sobre a parte vencida numa ação, para pagamento dos honorários advocatícios a vencedora.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.05.00','SERVIÇOS MÉDICOS E ODONTOLÓGICOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços médicos e odontológicos prestados por pessoa física, sem vínculo empregatício. Consultas - raio x - tratamento odontológico - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.06.00','SELECÃO E TREINAMENTO','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados nas áreas de instrução e orientação profissional, recrutamento e seleção de pessoal e treinamento, por pessoa física, inclusive a gratificação por encargo de curso ou concurso, normatizada pelo art. 76-A, da Lei 8112/90 e o Decreto 6114/2007, bolsa senior (servidores aposentados do órgão) bolsa de multiplicadores (servidores da ativa do órgão).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.07.00','COMUNICACAO EM GERAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de comunicação geral prestados por pessoa física, tais como: confecção de material p/ comunicação visual; geração de matérias para divulgação por meio dos veículos de comunicação; e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.08.00','LIMPEZA E CONSERVAÇÃO','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de limpeza e conservação de bens imóveis. Dedetização - faxina - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.09.00','SERVIÇOS DOMÉSTICOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços domésticos prestados por pessoa física sem vínculo empregatício, tais como: cozinha - lavagem de roupas - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.10.00','VIGILÂNCIA OSTENSIVA','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de vigilância ostensiva nos casos em que o contrato especifique o quantitativo físico do pessoal a ser utilizado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.11.00','MANUTENÇÃO E CONSERVAÇÃO','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de manutenção e conservação de bens móveis e imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.12.00','CONDOMÍNIOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços condominiais a conta do locatário, quando previstas no contrato de locação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.13.00','COMISSÕES E CORRETAGENS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por: corretores - despachantes - leiloeiros - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.14.00','DIREITOS AUTORAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de direitos autorais de propriedade de terceiros sobre obras científicas, literárias, etc, em que a divulgação seja de interesse do governo. Registra o valor referente a utilização de serviços decorrentes de incentivos aos autores a título de royalties.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.15.00','SERVIÇOS TÉCNICOS PROFISSIONAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por profissionais técnicos, nas seguintes áreas: administração - advocacia - arquitetura - contabilidade - economia -engenharia - estatística e outras.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.16.00','ESTAGIÁRIOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por estudantes na condição de estagiários ou monitores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.18.00','CAPATAZIA, ESTIVA E PESAGEM','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados na movimentação e pesagem de cargas(mercadorias e produtos).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.19.00','CONFERÊNCIAS, EXPOSIÇÕES E ESPETÁCULOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por conferencistas, expositores e artistas pelos serviços prestados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.20.00','ARMAZENAGEM','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de aluguel de galpões, silos e outros locais destinados a armazenagem de mercadorias e produtos. inclui, ainda, os dispêndios de garantia dos estoques armazenados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.21.00','LOCAÇÕES','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de locação de bens móveis e imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.22.00','FORNECIMENTO DE ALIMENTAÇÃO','Registra as variações patrimoniais diminutivas proveniente da utilização de refeições preparadas,inclusive lanches e similares.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.23.00','SERVIÇOS DE CARÁTER SECRETO OU RESERVADO','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de caráter sigiloso constantes em regulamento do órgão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.24.00','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de reabilitação profissional prestados por pessoa física sem vínculo empregatício, como objetivo de proporcionar aos incapacitados (parcial ou totalmente) os meios indicados para a reeducação e readaptação profissional e social, de modo que possam voltar a participar do mercado de trabalho. ex: contratação de profissional para ministrar curso profissionalizante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.25.00','SERVIÇOS DE ASSISTÊNCIA SOCIAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de assistência social prestados por pessoa física sem vínculo empregatício a servidores, segurados carentes, abrigados, internados e a seus dependentes,tais como ajuda de custo supletiva, gêneros alimentícios, documentação, transporte e sepultamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.26.00','SERV. DE APOIO ADMIN., TÉCNICO E OPERACIONAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de natureza eventual prestados por pessoa física, tais como: assistência técnica - capina - jardinagem - operadores de máquinas e motoristas - recepcionistas - serviços auxiliares - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.27.00','SERV. DE CONSERV. E REBENEFIC. DE MERCADORIAS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de natureza eventual prestados por pessoa física na conservação e rebeneficiamento de mercadorias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.28.00','CONFECÇÃO DE MATERIAL DE ACONDIC. E EMBALAGEM','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por pessoa física na confecção de: bolsas - caixas - mochilas - sacolas - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.29.00','CONFECÇÃO DE UNIFORMES, BANDEIRAS E FLÂMULAS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de costureiras, alfaiates e afins utilizados na confecção de uniformes, bandeiras, flâmulas, brasões e estandartes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.30.00','FRETES E TRANSPORTES DE ENCOMENDAS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por pessoa física em: fretes e carretos - remessa de encomendas - transporte de mercadoriase produtos - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.31.00','JETONS E GRATIFICAÇÕES A CONSELHEIROS','Registra as variações patrimoniais diminutivas proveniente da participação em órgãos de deliberações coletivas(conselhos).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.34.00','SERVIÇOS DE ÁUDIO, VÍDEO E FOTO','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de filmagens, gravações e fotografias, prestados por pessoa física.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.35.00','SERVIÇOS JUDICIÁRIOS','Registra as variações patrimoniais diminutivas proveniente da apropriação de custas processuais decorrentes de ações judiciais, diligências(inclusive condução) salários e honorários dos avaliadores, peritos judiciais e serviços de cartório, quando a nota e emitida em nome do tabelião.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.36.00','SEGUROS EM GERAL','Registra as variações patrimoniais diminutivas proveniente da apropriação de prêmios pagos por seguros de qualquer natureza, inclusive cobertura de danos causados a pessoas ou bens de terceiros, prêmios de seguros de bens do estado ou de terceiros, seguro obrigatório de veículos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.37.00','HOSPEDAGENS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de hospedagens de servidores e convidados do governo em viagens, a locais onde não existem esbelecimentos comerciais habilitados em prestar esse tipo de serviços, pagos diretamente a pessoas físicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.38.00','DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas proveniente da utilização de meios de transportes aéreos,terrestres, fluviais ou marítimas, locação ou uso de veículos para transporte de pessoas e suas respectivas bagagens, inclusive quando ocorrer em decorrência de mudancas de domicílio no interesse da administração.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.39.00','SERVIÇOS GRÁFICOS E EDITORIAIS','Registra as variações patrimoniais diminutivas com serviços de artes gráficas prestados por pessoa física, bem como com serviços editoriais diversos. - confecção de impressos em geral - encadernação de livros jornais e revistas - impressão de jornais - boletins - encartes - folders e assemelhados - plastificação de impressos - serviços de identificação de livros editados usando código de barras - serviços editoriais diversos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.2.1.99.00','OUTROS SERVIÇOS PRESTADOS POR PESSOA FÍSICA','Registra as variações patrimoniais diminutivas provenientes da utilização de outros serviços prestados por pessoa física, não contemplados em itens específicos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.0.00.00','SERVIÇOS TERCEIROS - PJ','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.01.00','CONSULTORIA E ASSESSORIA','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços nas áreas de consultorias e assessorias técnicas, ou assemelhadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.02.00','PERÍCIAS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de perícias realizadas por empresas especializadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.03.00','AUDITORIA EXTERNA','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de auditoria externa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.04.00','COMUNICAÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de comunicação, prestados por pessoa jurídica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.05.00','PUBLICIDADE','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de publicidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.06.00','MANUTENÇÃO E CONSERVAÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de manutenção de bens móveis e imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.07.00','SERVIÇOS DE APOIO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços prestados por pessoa jurídica a título de apoio as atividades administrativas, técnicas e operacionais dos órgãos públicos, nos casos em que o contrato não especifique o quantitativo físico do pessoal a ser utilizado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.08.00','SERVIÇOS DE ÁGUA E ESGOTO, ENERGIA ELÉTRICA, GÁS E OUTROS.','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de agua e esgoto, energia elétrica, gas e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.09.00','SERVIÇOS DE ALIMENTAÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de fornecimento de alimentação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.10.00','LOCAÇÕES','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de locação de bens móveis, imóveis ou intangíveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.11.00','SERVIÇOS RELACIONADOS A TECNOLOGIA DA INFORMAÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de processamento de dados prestados por empresas especializadas na área de informática; atualização e adaptação de programas de processamento de dados; suporte técnico, revisão, correção de problemas operacionais,análise p/acrescentar novas funções, hospedagem de sistemas e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.12.00','SERVIÇOS DE TRANSPORTE','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de transporte de servidores, trabalhadores de uma entidade ou de mercadorias e produtos diversos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.13.00','ARMAZENAGEM','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de aluguelde galpões, silos e outros locais destinados a armazenagem de mercadorias e produtos. inclui, ainda, as variações provenientess de garantia dos estoques armazenados e a utilização de serviço especializado na solucao de gestão de estoque, incluindo gestão de materiais e transporte de materiais e equipamentos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.14.00','ASSINATURAS DE PERIÓDICOS E ANUIDADES','Registra as variações patrimoniais diminutivas provenientes da utilização de assinaturas de tv (tva cabo), jornais, inclusive diário oficial, revistas, recortes de publicações, software, podendo estar na forma de disquete, cd-rom, bole-ins e outros que não se destinem a coleções ou bibliotecas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.15.00','CAPATAZIA, ESTIVA E PESAGEM','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de movimentação e pesagem de cargas(mercadorias e produtos).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.16.00','CLASSIFICAÇÃO DE PRODUTOS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de classificação de produtos de origem animal, mineral e vegetal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.17.00','COMISSÕES E CORRETAGENS','Registra as variações patrimoniais diminutivas provenientes da apropriação de valor referente a comissões e corretagens decorrentes de serviços prestados por empresas de intermediação e representação comercial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.18.00','CONDOMÍNIOS','Registra as variações patrimoniais diminutivas provenientes da apropriação das taxas condominiais a conta do proprietário, ou do locatário, conforme previsto no contrato de locação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.19.00','CONFECÇÃO DE MATERIAL DE ACONDIC. E EMBALAGEM','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de confecção de materiais destinados a preservação, acomodação ou embalagem de produtos diversos, tais como: - bolsas - caixas - mochilas - sacolas e outros. Somente serão classificados como serviços, caso a unidade forneça a matéria-prima.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.20.00','CONFECÇÃO DE UNIFORMES, BANDEIRAS E FLÂMULAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de confecção de:- bandeiras - brasões - estandartes - flâmulas - uniformes ( inclusive as despesas relacionadas com auxílio fardamento descritos na Lei nº 8237/91) e outros. Somente serão classificados como serviços, caso a unidade forneça a matéria-prima.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.21.00','DIREITOS AUTORAIS','Registra as variações patrimoniais diminutivas provenientes da utilização de direitos autorais sobre obras científicas, literárias ou em que a divulgação seja de interesse do governo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.22.00','EXPOSICÕES, CONGRESSOS, CONFERÊNCIAS E OUTROS','Registra as variações patrimoniais diminutivas provenientes de serviços utilizados na instalação e manutenção de: conferências - reuniões técnicas - congressos - exposições - feiras - festejos populares - festivais - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.23.00','FESTIVIDADES E HOMENAGENS','Registra as variações patrimoniais diminutivas provenientes de serviços utilizados na organização de eventos, tais como: coquetéis - festas de congraçamento - recepções - e outras.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.24.00','HONORÁRIOS ADVOCATÍCIOS - ÔNUS DE SUCUMBÊNCIA','Registra as variações patrimoniais diminutivas provenientes da apropriação dos honorários advocatícios decorrentes do ônus da sucumbência, entendido este como o ônus que recai sobre a parte vencida numa ação, para pagamento dos honorários advocatícios a vencedora.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.25.00','HOSPEDAGENS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de hospedagens e alimentação de servidores e convidados do governo em viagens oficiais pagos diretamente a estabelecimentos hoteleiros (quando não houver pagamento de diárias).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.26.00','PATROCÍNIO','Registra as variações patrimoniais diminutivas provenientes da utilização de patrocínios a atividades ou eventos, de natureza cultural, esportiva, educacional, ambiental, científica,comunitária, promocional etc. para influenciar favoravelmente o público e/ou atingir outros objetivos relacionados com a promoção de atos, obras, planos, ações, bens ou serviços. Não inclui o patrocínio de mídia, assim considerados aqueles em que o proponente é um veículo de comunicação ou um gestor de meios ou instalações que funcionem como veículo de mídia alternativa e aqueles em que um veículo de comunicação é o único ou o principal realizador da ação patrocinada, ainda que o proponente do projeto e provedor de conteúdo para a ação patrocinada não se enquadre na definição de veículo de comunicação ou meio de mídia alternativa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.27.00','PRODUÇÕES JORNALÍSTICAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de edição de jornais, revistas, noticiários e materiais jornalísticos para vídeos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.28.00','PROMOÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços realizados por integrantes do sicom ou por terceiros, que empreguem recursos de não-mídia, realizadas com objetivo de incentivar públicos de interesse a conhecerem ou comprarem produtos, serviços, marcas, conceitos ou políticas públicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.29.00','SEGUROS EM GERAL','Registra as variações patrimoniais diminutivas provenientes da apropriação de prêmios pagos por seguros de qualquer natureza, inclusive cobertura de danos causados a pessoas ou bens de terceiros, prêmios de seguros de bens do estado ou de terceiros, seguro obrigatório de veículos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.30.00','SELEÇÃO E TREINAMENTO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços prestados nas áreas de instrução e orientação profissional, recrutamento e seleção de pessoal(concurso público) e treinamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.31.00','SERV.MÉDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços médico-hospitalares, odontológicos e laboratoriais, prestados por pessoas jurídicas sem vínculo empregatício, tais como: análises clinicas - cirurgias - consultas - ecografias - endoscópias -enfermagem - esterilização - exames de laboratorio - raio x -tomografias - tratamento odontológico - ultrassonografias - e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.32.00','SERVIÇOS BANCÁRIOS','Registra as variações patrimoniais diminutivas provenientes da apropriação de comissões, tarifas e remunerações decorrentes de serviços prestados por bancos e outras instituições financeiras, bem como despesas com a guarda/custódia de valores (cofres de aluguel).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.33.00','SERVIÇOS DE ANÁLISES E PESQUISA CIENTÍFICAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de análises físico-químicas e pesquisas científicas, não relacionadas com apoio ao ensino. - análises minerais - análises de solo - análises químicas - coleta de dados em experimentos - tratamento e destinação de resíduos e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.34.00','SERVIÇOS DE APOIO DO ENSINO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços com o objetivo de proporcionar o desenvolvimento e o aperfeicoamento do ensino, em todos os níveis, inclusive pesquisas experiências e assemelhados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.35.00','SERVIÇOS DE ASSISTÊNCIA SOCIAL','Registra as variações patrimoniais diminutivas provenientes de serviços de assistência social prestada a servidores, segurados carentes, abrigados, internados e a seus dependentes, tais como: - ajuda de custo supletiva - gêneros alimentícios - documentação -transporte e sepultamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.36.00','SERVIÇOS DE ÁUDIO VÍDEO E FOTO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de filmagens, gravações, revelações, ampliações e reproduções de sons e imagens. - confecção de álbuns - confecção de crachás funcionais por firmas especializadas - emolduramento de fotografias - imagens de satélites- revelação de filmes - microfilmagem e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.37.00','SERVIÇOS DE CONFECÇÃO SELOS CONTROLE FISCAL','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de confecção de selos/chancelas para controle fiscal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.38.00','SERVIÇOS DE CONSERV. E REBENEF. DE MERCADORIAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços utilizados na conservação e rebeficiamento de mercadorias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.39.00','SERVIÇOS DE CONTROLE AMBIENTAL','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de controle ambiental.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.40.00','SERVIÇOS DE CÓPIAS E REPRODUÇÃO DE DOCUMENTOS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de cópias xerográficas, inclusive a locação e a manutenção de equipamentos reprográficos, cópia se reproduções de documentos e publicações em geral, inclusive por meio magnético e digitalização.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.41.00','SERVIÇOS DE CRECHE E ASSISTÊNCIA PRE ESCOLAR','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por entidades de assistência social para atender os dependentes de servidores do órgão, habilitados a usufruirem desse benefício.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.42.00','SERVIÇOS DE INCINERAÇÃO/DESTRUIÇÃO DE MATERIAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviço de processo de incineração e destruição de materiais, bem como resíduos industriais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.43.00','SERVIÇOS DE PRODUÇÃO INDUSTRIAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de transformação, beneficiamento e industrialização de matérias-primas que resultarão em um produto final. Somente serão classificados como serviços, caso a unidade forneça a matéria-prima.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.44.00','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de reabilitação profissional prestados por pessoa jurídica, com o objetivo de proporcionar aos incapacitados (parcial ou totalmente), os meios indicados para a reeducação e readaptação profissional e social, de modo que possam voltar a participar do mercado de trabalho. ex: contratação de empresa para ministrar curso profissionalizante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.45.00','SERVIÇOS FUNERÁRIOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de remoções, sepultamentos e transladações.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.46.00','SERVIÇOS GRÁFICOS E EDITORIAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de artes gráficas prestados por pessoa jurídica, bem como com serviços editoriais diversos. - confecção de impressos em geral - encadernação de livros jornais e revistas - impressão de jornais - boletins - encartes - folders e assemelhados - plastificação de impressos - serviços de identificação de livros editados usando código de barras - serviços editoriais diversos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.47.00','SERVIÇOS JUDICIÁRIOS','Registra as variações patrimoniais diminutivas proveniente da apropriação de custas processuais decorrentes de ações judiciais, diligências(inclusive condução) salários e honorários dos avaliadores, peritos judiciais e oficiais de justica e serviços de cartório.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.51.00','SERVIÇOS TÉCNICOS PROFISSIONAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por empresas especializadas nas seguintes áreas: advocacia - arquitetura - contabilidade - economia - engenharia -estatística e outras. exceto os serviços de consultoria que devem ser classificados em conta específica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.52.00','TAXA DE ADMINISTRAÇÃO','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de organização e administração prestados por pessoa jurídica, tais como: - taxa de administração paga ao Instituto Euvaldo Lodi e ao centro de integração empresa-escola - CIEE, decorrente dos serviços de seleção e recrutamento de estudantes, tendo como objetivo o ingresso ao mercado de trabalho e programas de estágio; - taxa de administração patrimonial das contribuições do banco central do Brasil, na qualidade de patrocinador, destinado ao custeio das aposentadorias e pensões concedidas com base na Lei 8.112/1990, e outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.54.00','LOCAÇÃO DE MÃO-DE-OBRA','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por pessoas jurídicas para órgãos públicos, tais como limpeza e higiene, vigilância ostensiva e outros, nos casos em que o contrato especifique o quantitativo físico do pessoal a ser utilizado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','Registra as variações patrimoniais diminutivas provenientes de arrendamento mercantil operacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.56.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas proveniente da utilização de passagens (aéreas,terrestres, fluviais ou marítimas), taxas de embarque, seguros, fretamento, pedágios, locação ou uso de veículos para transporte de pessoas e suas respectivas bagagens, inclusive quando ocorrer em decorrência de mudancas de domicílio no interesse da administração.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.3.1.99.00','OUTROS SERVIÇOS TERCEIROS - PJ','Registra as variações patrimoniais diminutivas provenientes das demais prestação de serviços por pessoa jurídica fornecida a entidade governamental.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.4.0.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA – ART. 18 § 1, LC 101/00','Compreende a apropriação das despesas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.2.4.1.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.0.0.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','Compreende o decréscimo no beneficio de um bem durante o período contábil decorrente de depreciação, amortização e exaustão.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.1.0.00.00','DEPRECIAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.1.1.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.1.1.01.00','DEPRECIAÇÃO DE IMOBILIZADO','Compreende a redução do valor dos bens tangíveis, do ativo imobilizado, pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.1.1.01.01','DEPRECIAÇÃO DE BENS MÓVEIS','Registra a redução do valor dos bens móveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.1.1.01.02','DEPRECIAÇÃO DE BENS IMÓVEIS','Registra a redução do valor dos bens imóveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.2.0.00.00','AMORTIZAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.2.1.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.2.1.01.00','AMORTIZAÇÃO DE IMOBILIZADO','Registra a redução do valor aplicado na aquisição de direitos, do ativo imobilizado, com existência ou exercício de duração limitada, ou cujo objeto seja bem de utilização por prazo legal ou contratualmente limitado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.2.1.02.00','AMORTIZAÇÃO DE INTANGÍVEL','Registra a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.3.0.00.00','EXAUSTÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.3.1.00.00','EXAUSTÃO - CONSOLIDAÇÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.3.3.1.01.00','EXAUSTÃO DE IMOBILIZADO','Registra a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.0.0.00.00','CUSTO DE MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende a variação patrimonial diminutiva relativa a materiais, serviços e consumo de capital fixo utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.1.1.01.00','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS E SERVIÇOS','Registra a apropriação de consumo de material e serviços no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.1.1.02.00','CUSTO DE MERCADORIAS VENDIDAS – CONSUMO DE CAPITAL FIXO','Registra a apropriação de consumo de capital fixo no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.2.1.01.00','CUSTO DE PRODUTOS VENDIDOS – MATERIAIS E SERVIÇOS','Registra a apropriação de consumo de material e serviços no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.2.1.02.00','CUSTO DE PRODUTOS VENDIDOS – CONSUMO DE CAPITAL FIXO','Registra a apropriação de consumo de capital fixo no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.3.1.01.00','CUSTO DE SERVIÇOS PRESTADOS – MATERIAIS E SERVIÇOS','Registra a apropriação de consumo de material e serviços no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.3.8.3.1.02.00','CUSTO DE SERVIÇOS PRESTADOS – CONSUMO DE CAPITAL FIXO','Registra a apropriação de consumo de capital fixo no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas com operações financeiras, tais como: juros incorridos, descontos concedidos, comissões, despesas bancarias e correções monetárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos contraídos com pessoas jurídicas de direito público ou privado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.0.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.1.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.1.01.00','JUROS DA DÍVIDA CONTR.C/INSTIT.FINANCEIRAS','Registra a variação patrimonial diminutiva com juros da dívida pública derivada de obrigações assumidas com instituições financeiras com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.1.02.00','ENCARGOS DA DÍVIDA CONTR.C/INSTIT.FINANCEIRAS','Registra a variação patrimonial diminutiva com encargos da dívida pública derivada de obrigações assumidas com instituições financeiras com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.1.99.00','JUROS E ENCARGOS DE OUTRAS DÍVIDAS CONTRATUAIS','Registra a variação patrimonial diminutiva provenientes de juros e encargos de outras dívidas contratadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.3.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.3.01.00','JUROS DA DÍVIDA CONTR. INTERNA INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com juros da dívida pública derivada de obrigações assumidas com a união com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.3.02.00','ENCARGOS DA DÍVIDA CONTR.INTERNA INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com encargos da dívida pública derivada de obrigações assumidas com a união com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.3.99.00','JUROS E ENCARGOS DE OUTRAS DÍVIDAS CONTRATUAIS - INTERNA INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva provenientes de juros e encargos de outras dívidas contratadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.4.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.4.01.00','JUROS DA DÍVIDA CONTR. INTERNA INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com juros da dívida pública derivada de obrigações assumidas com os estados com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.4.02.00','ENCARGOS DA DÍVIDA CONTR.INTERNA INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com encargos da dívida pública derivada de obrigações assumidas com os estados com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.4.99.00','JUROS E ENCARGOS DE OUTRAS DÍVIDAS CONTRATUAIS - INTERNA INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva provenientes de juros e encargos de outras dívidas contratadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.5.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.5.01.00','JUROS DA DÍVIDA CONTR. INTERNA INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com juros da dívida pública derivada de obrigações assumidas com os municípios com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.5.02.00','ENCARGOS DA DÍVIDA CONTR.INTERNA INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com encargos da dívida pública derivada de obrigações assumidas com os municípios com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.1.5.99.00','JUROS E ENCARGOS DE OUTRAS DÍVIDAS CONTRATUAIS - INTERNA INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva provenientes de juros e encargos de outras dívidas contratadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.2.0.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.2.1.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.2.1.01.00','JUROS DA DÍVIDA CONTRATADA NO EXTERIOR','Registra a variação patrimonial diminutiva com juros da dívida pública contratada no exterior com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.2.1.02.00','ENCARGOS DA DÍVIDA CONTRATADA NO EXTERIOR','Registra a variação patrimonial diminutiva com encargos da dívida pública contratada no exterior com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.3.0.00.00','JUROS E ENCARGOS DA DÍVIDA MOBILIÁRIA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.3.1.00.00','JUROS E ENCARGOS DA DÍVIDA MOBILIÁRIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.4.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.4.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.4.1.01.00','JUROS S/ ADIANTAMENTOS BANCÁRIOS','Registra a variação patrimonial diminutiva decorrente de juros incidentes sobre antecipações de créditos contratadas com bancos e outros agentes financeiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.8.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.8.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.8.3.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.8.4.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.8.5.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.9.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.1.9.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','Compreende o montante de variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos contratuais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.1.01.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.1.02.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.3.01.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.3.02.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.4.01.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.4.02.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.5.01.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.1.5.02.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.2.1.01.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.2.1.02.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a título de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.01.00','JUROS DE MORA','Compreende a variação patrimonial diminutiva com juros referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.01.01','JUROS DE SERVIÇOS TERCEIROS - PESSOA FÍSICA','Registra a variação patrimonial diminutiva com juros referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoa física.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.01.02','JUROS DE SERVIÇOS TERCEIROS - PESSOA JURÍDICA','Registra a variação patrimonial diminutiva com juros referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoa jurídica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','Registra a variação patrimonial diminutiva com juros referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de aquisição de bens.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.02.00','MULTAS DEDUTÍVEIS','Compreende a variação patrimonial diminutiva com multas, que sejam dedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.02.01','MULTAS DEDUTÍVEIS SERVIÇOS TERCEIROS - PESSOA FÍSICA','Registra a variação patrimonial diminutiva com multas, que sejam dedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoa física.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.02.02','MULTAS DEDUTÍVEIS SERVIÇOS TERCEIROS - PESSOA JURÍDICA','Registra a variação patrimonial diminutiva com multas, que sejam dedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoa jurídica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.02.03','MULTAS DEDUTÍVEIS SOBRE FORNECIMENTOS DE BENS','Registra a variação patrimonial diminutiva com multas, que sejam dedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de aquisição de bens.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.03.00','MULTAS INDEDUTÍVEIS','Compreende a variação patrimonial diminutiva com multas, que sejam indedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.03.01','MULTAS INDEDUTÍVEIS SERVIÇOS TERCEIROS - PESSOA FÍSICA','Registra a variação patrimonial diminutiva com multas, que sejam indedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoa física.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.03.02','MULTAS INDEDUTÍVEIS SERVIÇOS TERCEIROS - PESSOA JURÍDICA','Registra a variação patrimonial diminutiva com multas, que sejam indedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoa jurídica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.03.03','MULTAS INDEDUTÍVEIS SOBRE FORNECIMENTOS DE BENS','Registra a variação patrimonial diminutiva com multas, que sejam indedutíveis na determinação do lucro real pela legislação,referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de aquisição de bens.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.99.00','OUTROS ENCARGOS DE MORA','Compreende a variação patrimonial diminutiva com outros encargos referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens, que não se enquadrem nos itens anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.99.01','OUTROS ENCARGOS S/ SERVIÇOS TERCEIROS - PESSOA FÍSICA','Registra a variação patrimonial diminutiva com outros encargos referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoas físicas, que não se enquadrem nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.99.02','OUTROS ENCARGOS S/ SERVIÇOS TERCEIROS - PESSOA JURÍDICA','Registra a variação patrimonial diminutiva com outros encargos referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços com pessoas jurídicas, que não se enquadrem nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.3.1.99.03','OUTROS ENCARGOS S/ FONECIMENTO DE BENS','Registra a variação patrimonial diminutiva com outros encargos referentes a penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de aquisição de bens, que não se enquadrem nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.4.1.01.00','JUROS','Registra a variação patrimonial diminutiva com juros a título de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.4.1.02.00','MULTAS DEDUTÍVEIS','Registra a variação patrimonial diminutiva com multas resultantes do pagamento com atraso das obrigações tributárias , como também as multas pagas pelo descumprimento de obrigações acessórias exigidas pela legislação tributária. As multas pagas pela administração pública estão sujeitas ao direito de regresso contra aqueles que lhes deram causa. Esta conta registra as multas consideradas dedutíveis pela legislação na determinação do lucro real, ou seja, apenas as multas por infrações fiscais de natureza compensatória e as impostas por infrações de que não resultem falta ou insuficiência de pagamento de tributo (art. 344, §5º do Decreto 3.000, de 26 de março de 1999 - RIR/99).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.4.1.03.00','MULTAS INDEDUTÍVEIS','Registra a variação patrimonial diminutiva com multas resultantes do pagamento com atraso das obrigações tributárias , como também as multas pagas pelo descumprimento de obrigações acessórias exigidas pela legislação tributária. As multas pagas pela administração pública estão sujeitas ao direito de regresso contra aqueles que lhes deram causa. Esta conta registra as multas consideradas indedutíveis pela legislação na determinação do lucro real, ou seja, todas as multas por infrações fiscais, salvo as de natureza compensatória e as impostas por infrações de que não resultem falta ou insuficiência de pagamento de tributo (art. 344, §5º do Decreto 3.000, de 26 de março de 1999 -RIR/99).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.9.2.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS','Compreende a variação patrimonial diminutiva com juros e encargos a título de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.9.3.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos a título de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a união.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.9.4.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos a título de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.2.9.5.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos a título de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.1.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Registra a Variação Patrimonial Diminutiva proveniente de Variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a Dívida Contratual. Ressalte-se será tratada como variação monetária apenas a Correção Monetária Pós-Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.1.02.00','VARIAÇÕES CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Dívida Contratual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.3.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.4.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.1.5.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.2.1.01.00','VARIAÇÕES MONETÁRIAS DA DÍVIDA CONTRATUAL EXTERNA','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.2.1.02.00','VARIAÇÕES CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Divida Contratual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIÁRIA INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIÁRIA INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.3.1.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA MOBILIÁRIA','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIÁRIA EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIÁRIA EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.4.1.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA MOBILIÁRIA EXTERNA','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.4.1.02.00','VARIAÇÕES CAMBIAIS DE DÍVIDA MOBILIÁRIA EXTERNA','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Divida Contratual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.1.01.00','OUTRAS VARIAÇÕES MONETÁRIAS','Compreende a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.1.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Dedutíveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.1.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Indedutíveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.1.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Precatórios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.1.99.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.01.00','OUTRAS VARIAÇÕES MONETÁRIAS','Compreende a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Dedutíveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Indedutíveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Precatórios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.01.71','ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Tributos Renegociados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.3.02.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.4.01.00','OUTRAS VARIAÇÕES MONETÁRIAS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.4.02.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.5.01.00','OUTRAS VARIAÇÕES MONETÁRIAS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.3.9.5.02.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.4.0.0.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.4.0.1.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - CONSOLIDAÇÃO','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','Compreende outras variações patrimoniais diminutivas financeiras, não abrangidas nos grupos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.1.0.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.1.1.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.2.0.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.2.1.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.9.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.4.9.9.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','Compreende o somatório das variações patrimoniais diminutivas com transferências inter governamentais, transferências intragovernamentais, transferências a instituições multigovernamentais, transferências a instituições privadas com ou sem fins lucrativos, transferências a convênios, transferências ao exterior e execuções orçamentárias delegadas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.01.00','COTA CONCEDIDA','Registra variação patrimonial diminutiva relativa ao valor da concessão de cota do órgão central de programação financeira para órgão setorial correspondente ao orçamento anual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.02.00','REPASSE CONCEDIDO','Registra a variação patrimonial diminutiva relativa ao valor dos recursos concedidos a titulo de transferências financeiras entre órgãos diferentes da administração direta ou indireta, correspondentes ao orçamento anual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.03.00','SUB-REPASSE CONCEDIDO','Registra a variação patrimonial diminutiva relativa ao valor total dos sub-repasses concedidos por transferências financeiras entre UG de um mesmo órgão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.04.00','RECURSOS ARRECADADOS - CONCEDIDOS','Registra a variação patrimonial diminutiva relativa ao valor concedido para outra UG, referente a recursos que foram arrecadados (classificados como receita), para pagamento de variação patrimonial diminutiva na UG recebedora.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA','Registra o valor da cota diferida no processo de baixa dos recursos diferidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','Registra o valor da cota diferida no processo de inscrição dos recursos diferidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.1.2.13.00','CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','Registra a apropriação da transferência de créditos internos entre UG de mesma gestão referentes a contas com saldos financeiras em rotinas contábeis orçamentárias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.0.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras, de bens ou valores, concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores, concedidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS CONCEDIDAS','Registra o valor total das ordens de transferências concedidas referentes a recursos vinculados que deverão permanecer na UG beneficiada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS NÃO FINANCEIROS','Registra a apropriação da transferência de créditos internos entre UG de mesma gestão referentes a contas não financeiras.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','Registra a apropriação da transferência de créditos internos entre órgãos correspondentes a saldos financeiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.01.04','MOVIMENTO DE FUNDOS A CRÉDITOS - MOVIMENTO DE FUNDOS PRÓPRIOS','Registra o somatório dos saldos credores incorporados por integração de balancetes, fusão, cisão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Registra o valor das demais transferências financeiras concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.00','TRANSFERÊNCIAS NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências concedidas de bens ou valores independentes da execução orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.01','TRANSFERÊNCIAS CONCEDIDAS DE BENS IMÓVEIS','Registra o valor das transferências de bens imóveis entre unidades do mesmo órgão .','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.02','DOAÇÕES CONCEDIDAS DE BENS IMÓVEIS','Registra o valor de doações de bens imóveis entre unidades de órgãos diferentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.03','TRANFERÊNCIAS CONCEDIDAS DE BENS MÓVEIS','Registra o valor dos bens móveis concedidos por unidade localizada no exterior para outra unidade, no pais ou no exterior, do mesmo órgão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.04','DOAÇÕES CONCEDIDAS DE BENS MÓVEIS','Registra o valor dos bens móveis concedidos por unidade localizada no país para outra unidade, no país ou no exterior, de órgãos diferentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','Registra o total dos títulos e valores em circulação concedidos por unidade decorrente de transferência a outra unidade de mesma gestão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','Registra a transferência de títulos da dívida ativa de uma UG para a o órgão jurídico competente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Registra o valor das demais transferências concedidas de bens ou valores independentes da execução orçamentária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes., exceto os decorrentes de alíquota de contribuição suplementar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes exceto os decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.01.00','PLANO FINANCEIRO','Compreende o valor total dos valores concedidos pelo RPPS para cobertura de insuficiências financeiras, formação de reserva e outras necessidades financeiras, no âmbito do plano financeiro.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Registra os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pelo ente federativo ao RPPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','Registra o somatório de eventuais aportes de recursos no RPPS para outras necessidades financeiras que não a cobertura de insuficiências financeiras e formação de reservas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','Compreende o valor total concedido ao RPPS para cobertura de déficit financeiro ou atuarial e outros aportes, no âmbito do plano previdenciário.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','Registra o somatório dos recursos necessários ao equilíbrio financeiro do plano previdenciário, ou seja, à cobertura de déficit entre as receitas e despesas previdenciárias, referentes ao exercício atual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','Registra os recursos orçamentários alocados para cobertura de déficit atuarial no exercício de referência, desde que não definidos por lei como contribuições suplementares.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','Registra outros aportes financeiros para o RPPS com outras finalidades previdenciárias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS','Compreende o valor das transferências para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS – INTRA OFSS','Compreende o valor das transferências para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Compreende os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','Registra o montante do orçamento da Seguridade Social realocado da Saúde ou da Assistência Social para a Previdência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','Registra os valores das receitas do orçamento fiscal destinados para cobrir os déficits financeiros da Previdência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pela União ao RGPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','Registra o somatório de eventuais aportes de recursos para o RGPS para outras necessidades financeiras.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes de transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.1.0.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.1.1.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.1.3.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.1.4.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.1.5.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.2.0.00.00','TRANSFERÊNCIAS AO FUNDEB','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.2.4.00.00','TRANSFERÊNCIAS AO FUNDEB - INTER-OFSS – ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, bem como a demais entidades, de bens e/ou valores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (A empresa independente não pertence ao OFSS, mas pertence ao conceito de governamental).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.3.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.3.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra o valor utilizado para as transferências voluntárias não classificadas nas contas anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.4.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.4.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra o valor utilizado para as transferências voluntárias não classificadas nas contas anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.5.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.5.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra o valor utilizado para as transferências voluntárias não classificadas nas contas anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras a instituições privadas, inclusive de bens e valores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.1.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs, OSCIPS e OS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.1.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs,OSCIPS E OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.1.1.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.1.1.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.1.1.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.2.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos que não tenham vínculos com administração pública.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.2.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos, que não tenham vínculos com a administração pública. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.3.2.1.01.00','SUBVENÇÕES ECONÔMICAS','Registra as VPDS com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.4.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, da quais o ente transferidor não participe.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.4.0.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, das quais o ente transferidor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.5.0.0.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.5.0.1.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.6.0.0.00.00','TRANSFERÊNCIAS AO EXTERIOR','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.6.0.1.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal, Municípios ou consórcios públicos) para execução de ações de responsabilidade exclusiva do delegante.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.01.00','DIÁRIAS','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.3.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.01.00','DIÁRIAS','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.4.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.01.00','DIÁRIAS','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.1.5.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.01.00','DIÁRIAS','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.5.7.2.1.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.0.0.0.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS E INCORPORAÇÃO DE PASSIVOS','Compreende a variação patrimonial diminutiva com desvalorização e perdas de ativos, nos casos de reavaliação, redução a valor recuperável, provisões para perdas, perdas com alienação e perdas involuntárias. Compreende também a variação patrimonial diminutiva com incorporação de passivo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.0.0.00.00','REAVALIAÇÃO, REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','Compreende as variações patrimoniais diminutivas relativas a reavaliação, redução a valor recuperável e ajuste para perdas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for inferior ao valor liquido contábil.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis, quando esse for inferior ao valor liquido contábil.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para máquinas, ferramentas, aparelhos, equipamentos, acessórios etc, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes paraequipamentos de processamento de dados e sistemas aplicativos, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para mobiliário em geral e utensílios, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para transportes aéreos, aquáticos e terrestres, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis em andamento, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens permanentes a serem estocados em almoxarifado, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para armas que constituem objetos de defesa ou preparativos de guerra, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para demais bens móveis não classificados em grupos específicos, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens imóveis, quando esse for inferior ao valor liquido contábil.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os valores de bens imóveis em andamento, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os demais bens imóveis não classificados anteriormente nesse plano de contas, quando esse for inferior ao valor liquido contábil.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor lÍquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.3.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for inferior ao valor liquido contábil.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.3.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.1.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.2.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.2.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.2.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.2.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.2.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.3.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.3.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.3.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.3.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.3.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.4.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.4.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.4.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.4.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.4.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.5.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.5.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.5.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.5.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.4.5.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo imobilizado, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo imobilizado, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de bens móveis, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.01','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.03','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de mobiliário em geral e utensílios, entre outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.04','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.05','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de transportes aéreos, aquáticos e terrestres, entre outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.06','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.07','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens móveis em andamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.08','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens permanentes a serem estocados em almoxarifado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.09','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de armas que constituem objetos de defesa ou preparativos de guerra.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.10','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.01.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais bens móveis não classificados em grupos específicos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de bens imóveis, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.01','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.03','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.04','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de valores de bens imóveis em andamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.05','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.06','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.5.1.02.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de os demais bens imóveis não classificados anteriormente nesse plano de contas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.6.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.6.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.6.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de softwares, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.6.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATENTES','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.6.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Por exemplo, a variação patrimonial diminutiva com ajuste para créditos de liquidação duvidosa e ajuste para créditos da divida ativa. Compreende também a variação patrimonial diminutiva com ajuste de perdas em investimentos e aplicações temporários, não destinados à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto e no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende também a variação patrimonial diminutiva com ajuste de perdas em investimentos e aplicações temporários, não destinados à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto e no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETÁRIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.07.00','AJUSTE PARA PERDAS EM INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','Compreende a variação patrimonial diminutiva com ajuste de perdas em investimentos e aplicações temporários, não destinados à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto e no longo prazo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.07.01','AJUSTE PARA PERDAS EM TÍTULOS E VALORES MOBILIÁRIOS','Registra a variação patrimonial diminutiva com ajuste de perdas em aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto ou no longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.07.02','AJUSTE PARA PERDAS EM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','Registra a variação patrimonial diminutiva com ajuste de perdas em aplicações de recursos em metais preciosos, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto ou no longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.07.03','AJUSTE PARA PERDAS EM APLICAÇÕES TEMPORÁRIAS EM SEGMENTO DE IMÓVEIS','Registra a variação patrimonial diminutiva com ajuste de perdas em aplicações de recursos em segmento de imóveis, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto ou no longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.98.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.1.99.00','AJUSTE PARA PERDAS DE DEMAIS INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','Registra a variação patrimonial diminutiva com ajuste de perdas em outros investimentos e aplicações temporários, não especificados acima, não destinados à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto e no longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTRA OFSS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETÁRIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.2.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETÁRIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.3.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETÁRIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.4.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETÁRIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETÁRIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.7.5.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste para perdas de estoques. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.01.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MERCADORIAS PARA REVENDA','Registra a variação patrimonial diminutiva com ajuste para perdas de mercadorias para revenda.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.02.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS ACABADOS','Registra a variação patrimonial diminutiva com ajuste para perdas de produtos e serviços acabados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.03.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Registra a variação patrimonial diminutiva com ajuste para perdas de produtos e serviços em elaboração.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.04.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATÉRIAS-PRIMAS','Registra a variação patrimonial diminutiva com ajuste para perdas de matérias-primas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.05.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATERIAIS EM TRÂNSITO','Registra a variação patrimonial diminutiva com ajuste para perdas de materiais em trânsito.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.06.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ALMOXARIFADO','Registra a variação patrimonial diminutiva com ajuste para perdas de almoxarifado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.07.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ADIANTAMENTOS A FORNECEDORES','Registra a variação patrimonial diminutiva com ajuste para perdas de adiantamentos a fornecedores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.1.8.1.08.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS ESTOQUES','Registra a variação patrimonial diminutiva com ajuste para perdas de outros estoques.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.0.0.00.00','PERDAS COM ALIENAÇÃO','Compreende a perda com alienação de ativos, ou seja, quando o valor alienado do ativo é menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.1.0.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.1.1.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.1.1.01.00','PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva de perdas com alienação de participações permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.1.1.02.00','PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva de perdas com alienação de propriedades para investimento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.1.1.03.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva de perdas com alienação de investimentos do RPPS de longo prazo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.1.1.04.00','PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva de perdas com alienação de demais investimentos permanentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.0.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.00','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS','Compreende a variação patrimonial diminutiva de perdas com alienação de bens móveis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.01','PERDAS COM ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva de perdas com alienação de máquinas, aparelhos, equipamentos e ferramentas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.02','PERDAS COM ALIENAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva de perdas com alienação de bens de informática.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.03','PERDAS COM ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva de perdas com alienação de móveis e utensílios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.04','PERDAS COM ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva de perdas com alienação de materiais culturais, educacionais e de comunicação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.05','PERDAS COM ALIENAÇÃO DE VEÍCULOS','Registra a variação patrimonial diminutiva de perdas com alienação de veículos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.06','PERDAS COM ALIENAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva de perdas com alienação de peças e conjuntos de reposição.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.07','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva de perdas com alienação de móveis em andamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.08','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva de perdas com alienação de bens móveis em almoxarifado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.09','PERDAS COM ALIENAÇÃO DE ARMAMENTOS','Registra a variação patrimonial diminutiva de perdas com alienação de armamentos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.10','PERDAS COM ALIENAÇÃO DE SEMOVENTES','Registra a variação patrimonial diminutiva de perdas com alienação de semoventes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.01.99','PERDAS COM ALIENAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de demais bens móveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.2.1.02.00','PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de bens imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.3.0.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.3.1.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.3.1.01.00','PERDAS COM ALIENAÇÃO DE SOFTWARES','Registra a variação patrimonial diminutiva de perdas com alienação de softwares.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.3.1.02.00','PERDAS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATENTES INDUSTRIAIS','Registra a variação patrimonial diminutiva de perdas com alienação de marcas, direitos e patentes industriais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.2.3.1.03.00','PERDAS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de direito de uso de imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.0.0.00.00','PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário do bem, como o que resulta de sinistros como incêndio e inundações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.0.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','Compreendem o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','Compreende o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.00','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS','Compreende a variação patrimonial diminutiva com perdas involuntárias de bens móveis.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.01','PERDAS INVOLUNTÁRIAS DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva com perdas involuntárias de máquinas, aparelhos, equipamentos e ferramentas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.02','PERDAS INVOLUNTÁRIAS DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva com perdas involuntárias de bens de informática.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.03','PERDAS INVOLUNTÁRIAS DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva com perdas involuntárias de móveis e utensílios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.04','PERDAS INVOLUNTÁRIAS DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva com perdas involuntárias de materiais culturais, educacionais e de comunicação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.05','PERDAS INVOLUNTÁRIAS DE VEÍCULOS','Registra a variação patrimonial diminutiva com perdas involuntárias de veículos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.06','PERDAS INVOLUNTÁRIAS DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva com perdas involuntárias de peças e conjuntos de reposição.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.07','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva com perdas involuntárias de bens móveis em andamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.08','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva com perdas involuntárias de bens móveis em almoxarifado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.09','PERDAS INVOLUNTÁRIAS DE ARMAMENTOS','Registra a variação patrimonial diminutiva com perdas involuntárias de armamentos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.10','PERDAS INVOLUNTÁRIAS DE SEMOVENTES','Registra a variação patrimonial diminutiva com perdas involuntárias de semoventes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.01.99','PERDAS INVOLUNTÁRIAS DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de demais bens móveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.1.1.02.00','PERDAS INVOLUNTÁRIAS DE BENS IMÓVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de bens imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.2.0.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','Compreendem o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.2.1.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','Compreende o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.2.1.01.00','PERDAS INVOLUNTÁRIAS COM SOFTWARES','Registra a variação patrimonial diminutiva com perdas involuntárias com softwares.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.2.1.02.00','PERDAS INVOLUNTÁRIAS COM MARCAS, DIREITOS E PATENTES INDUSTRIAIS','Registra a variação patrimonial diminutiva com perdas involuntárias com marcas, direitos e patentes industriais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.2.1.03.00','PERDAS INVOLUNTÁRIAS COM DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de direitos de uso de imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.0.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','Compreendem o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','Compreende o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.01.00','PERDAS INVOLUNTÁRIAS COM MERCADORIAS PARA REVENDA','Registra a variação patrimonial diminutiva com perdas involuntárias de mercadorias para revendas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.02.00','PERDAS INVOLUNTÁRIAS COM PRODUTOS E SERVIÇOS ACABADOS','Registra a variação patrimonial diminutiva com perdas involuntárias de produtos e serviços acabados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.03.00','PERDAS INVOLUNTÁRIAS COM PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Registra a variação patrimonial diminutiva com perdas involuntárias de produtos e serviços em elboração.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.04.00','PERDAS INVOLUNTÁRIAS COM MATÉRIAS-PRIMAS','Registra a variação patrimonial diminutiva com perdas involuntárias de matérias-primas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.05.00','PERDAS INVOLUNTÁRIAS COM MATERIAIS EM TRÂNSITO','Registra a variação patrimonial diminutiva com perdas involuntárias de materiais em trânsito.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.06.00','PERDAS INVOLUNTÁRIAS COM ALMOXARIFADO','Registra a variação patrimonial diminutiva com perdas involuntárias de almoxarifado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.07.00','PERDAS INVOLUNTÁRIAS COM ADIANTAMENTOS A FORNECEDORES','Registra a variação patrimonial diminutiva com perdas involuntárias de adiantamentos a fornecedores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.3.1.99.00','PERDAS INVOLUNTÁRIAS COM OUTROS ESTOQUES','Registra a variação patrimonial diminutiva com perdas involuntárias de outros estoques.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.9.0.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.3.9.1.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','Compreende o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.4.0.0.00.00','INCORPORAÇÃO DE PASSIVOS','Compreende a contrapartida de incorporação de passivo, como nos casos de extinção e fusão de entidades ou de restos a pagar com prestação interrompida.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.6.4.0.1.00.00','INCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com incorporação de passivo, como nos casos de extinção e fusão de entidades ou de restos a pagar com prestação interrompida. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.0.0.0.00.00','TRIBUTÁRIAS','Compreendem as variações patrimoniais diminutivas relativas aos impostos, taxas, contribuições de melhoria, contribuições sociais, contribuições econômicas e contribuições especiais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreendem as variações patrimoniais diminutivas relativas às obrigações relativas às prestações pecuniárias compulsórias, em moeda ou cujo valor nela possa se exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade vinculada. Como: impostos, taxas e contribuições de melhoria.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.0.00.00','IMPOSTOS','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência, e vinculados à atividade administrativa do contribuinte, definidos no CTN.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.00.00','IMPOSTOS- CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência e vinculados atividade administrativa do contribuinte, definidos no CTN. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.01.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra as variações patrimoniais diminutivas com Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.02.00','IPVA','Registra as variações patrimoniais diminutivas com Imposto sobre a Propriedade de Veículos Automotores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.03.00','ITCMD','Registra as variações patrimoniais diminutivas com Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.04.00','ICMS','Registra as variações patrimoniais diminutivas com Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.05.00','IPTU','Registra as variações patrimoniais diminutivas com Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.06.00','ITBI','Registra as variações patrimoniais diminutivas com Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.07.00','ISS','Registra as variações patrimoniais diminutivas com Imposto Sobre Serviços de Qualquer Natureza.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.08.00','ITR','Registra as variações patrimoniais diminutivas com Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.09.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS - IPI','Registra as variações patrimoniais diminutivas, decorrentes do imposto, de competência da União, sobre produtos industrializados tem como fato gerador: I o seu desembaraço aduaneiro, quando de procedência estrangeira; II a sua saída dos estabelecimentos a que se refere o parágrafo único do artigo 51 do CTN; III a sua arrematação, quando apreendido ou abandonado e levado a leilão. para os efeitos deste imposto, considera se industrializado o produto que tenha sido submetido a qualquer operacao que lhe modifique a natureza ou a finalidade, ou o aperfeicoe para o consumo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.10.00','IMPOSTO S/ OPERAÇÕES FINANCEIRAS - IOF','Registra as variações patrimoniais diminutivas com o imposto, de competência da união, sobre operações de crédito, câmbio e seguro, e sobre operações relativas a titulos e valores mobiliários que tem como fato gerador: I - quanto as operações de crédito, a sua efetivação pela entrega total ou parcial do montante ou do valor que constitua o objeto da obrigação, ou sua colocação a disposição do interessado; II - quanto as operações de câmbio, a sua efetivação pela entrega de moeda nacional ou estrangeira, ou de documento que a represente, ou sua colocação a disposição do interessado em montante equivalente a moeda estrangeira ou nacional entregue ou posta a disposição por este; III - quanto as operações de seguro, a sua efetivaçãopela emissão da apólice ou do documento equivalente, ou recebimento do prêmio, na forma da lei aplicável; IV - quanto as operações relativas a títulos e valores mobiliários, a emissão, transmissão, pagamento ou resgate destes, na forma da lei aplicável.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.11.00','IMPOSTO S/ IMPORTAÇÃO - II','Registra as variações patrimoniais diminutivas, de competência da união, sobre a importação de produtos estrangeiros que tem como fato gerador a entrada destes no territorio nacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.1.1.99.00','OUTROS IMPOSTOS','Registra as variações patrimoniais diminutivas com outros impostos não abrangidos nas rubricas anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.2.0.00.00','TAXAS','Compreende as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.2.1.00.00','TAXAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.2.1.01.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra as variações patrimoniais diminutivas com taxas pelo exercício do poder de polícia.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.2.1.02.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra as variações patrimoniais diminutivas com taxas pela prestação de serviço.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.3.0.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende as variações patrimoniais diminutivas com tributo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou Municípios , amparadas em lei e limitadas ao total da despesa pública realizada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.3.1.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com titulo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou municípios, amparadas em lei e limitadas ao total da despesa pública realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.1.3.1.01.00','CONTRIBUIÇÕES DE MELHORIA','Registra as variações patrimoniais diminutivas com contribuições de melhoria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.0.0.00.00','CONTRIBUIÇÕES','Compreende as variações patrimoniais diminutivas com contribuições sociais, econômicas e outras, decorrentes da intervenção do estado (União, estados, distrito federal e municípios) no domínio econômico e de interesse da categoria de profissionais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.0.00.00','CONTRIBUIÇÕES SOCIAIS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo estado, entre elas o PIS/PASEP, CSLL e COFINS, etc.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS -','Registra o valor da VPD com contribuição para financiamento da seguridade social.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.02.00','PIS/PASEP','Registra o valor da VPD com contribuição para o programa de integração social(PIS) ou para o programa de formação do patrimônio do servidor público(PASEP).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LÍQUIDO - CSLL -','Registra o valor da VPD com contribuição social incidente sobre o lucro da pessoa jurídica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FÍSICA','Registra o valor da VPD com contribuições previdenciárias sobre serviços de terceiros pessoas físicas contratadas para a execução de serviços, sem vínculo com a administração, conforme parecer SOF/DESOC 101 de 17/12/1997.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURÍDICA -','Registra o valor da VPD com encargos incidentes sobre serviços prestados por pessoas jurídicas, tais como: - INSS (Lei 9876/99).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Registra o valor da VPD com outras contribuições sociais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS -','Registra o valor da VPD com contribuição para financiamento da seguridade social.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.02.00','PIS/PASEP','Registra o valor da VPD com contribuição para o programa de integração social(PIS) ou para o programa de formação do patrimônio do servidor público (PASEP).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LÍQUIDO - CSLL -','Registra o valor da VPD com contribuição social incidente sobre o lucro da pessoa jurídica.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FÍSICA','Registra o valor da VPD com contribuições previdenciárias sobre serviços de terceiros pessoas físicas contratadas para a execução de serviços, sem vínculo com a administração, conforme parecer SOF/DESOC 101 de 17/12/1997.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURÍDICA -','Registra o valor da VPD com encargos incidentes sobre serviços prestados por pessoas jurídicas, tais como: - INSS (Lei 9876/99).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.3.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Registra o valor da VPD com outras contribuições sociais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP,CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.2.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.2.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.3.0.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio do serviço de iluminação pública (art.149-A da C.F.)','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.3.1.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio da iluminação pública (art.149-A da C.F.). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.9.0.00.00','OUTRAS CONTRIBUIÇÕES','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.9.1.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.9.1.01.00','CONTRIBUIÇÃO SINDICAL','Registra o valor da variação patrimonial diminutiva com encargos patronais relativo a contribuição sindical.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.2.9.1.99.00','DEMAIS CONTRIBUIÇÕES','Registra variação patrimonial diminutiva relativa ao valor da concessão de cota do órgão central de programação financeira para órgão setorial correspondente ao orçamento anual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.0.0.00.00','CUSTO COM TRIBUTOS','Compreende a variação patrimonial diminutiva relativa a tributos utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.01.00','CMV - IMPOSTOS','Registra a apropriação dos impostos no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.02.00','CMV - TAXAS','Registra a apropriação das taxas no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.03.00','CMV - CONTRIBUIÇÃO DE MELHORIA','Registra a apropriação da contribuição de melhoria no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.04.00','CMV - CONTRIBUIÇÕES SOCIAIS','Registra a apropriação das contribuições sociais no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.05.00','CMV - CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra a apropriação das contribuições de intervenção no domínio econômico no custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.1.07.00','CMV - OUTRAS CONTRIBUIÇÕES','Registra a apropriação de outras contribuições ao custo das mercadorias vendidas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.3.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.4.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.1.5.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.01.00','CPV - IMPOSTOS','Registra a apropriação dos impostos no custo dos produtos vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.02.00','CPV - TAXAS','Registra a apropriação das taxas no custo dos produtos vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.03.00','CPV - CONTRIBUIÇÃO DE MELHORIA','Registra a apropriação da contribuição de melhoria no custo dos produtos vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.04.00','CPV - CONTRIBUIÇÕES SOCIAIS','Registra a apropriação das contribuições sociais no custo dos produtos vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.05.00','CPV - CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra a apropriação das contribuições de intervenção no domínio econômico no custo dos produtos vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.1.07.00','CPV - OUTRAS CONTRIBUIÇÕES','Registra a apropriação de outras contribuições ao custo dos produtos vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.2.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.3.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.4.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.2.5.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.01.00','CSP - IMPOSTOS','Registra a apropriação dos impostos no custo dos serviços vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.02.00','CSP - TAXAS','Registra a apropriação das taxas no custo dos serviços vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.03.00','CSP - CONTRIBUIÇÃO DE MELHORIA','Registra a apropriação da contribuição de melhoria no custo dos serviços vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.04.00','CSP - CONTRIBUIÇÕES SOCIAIS','Registra a apropriação das contribuições sociais no custo dos serviços vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.05.00','CSP - CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra a apropriação das contribuições de intervenção no domínio econômico no custo dos serviços vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.1.99.00','CSP - OUTRAS CONTRIBUIÇÕES','Registra a apropriação de outras contribuições ao custo dos serviços vendidos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.2.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.3.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.4.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.7.8.3.5.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende o somatório das variações patrimoniais diminutivas não incluídas nos grupos anteriores. Compreende: premiações, incentivos, equalizações de preços e taxas, participações e contribuições, resultado negativo com participações, dentre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.0.0.00.00','PREMIAÇÕES','Compreende as aquisições de prêmios, condecorações, medalhas, troféus, etc., bem como com o pagamento de prêmios em pecúnia, inclusive decorrentes de sorteios lotéricos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.1.0.00.00','PREMIAÇÕES CULTURAIS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.1.1.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.2.0.00.00','PREMIAÇÕES ARTÍSTICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.2.1.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.3.0.00.00','PREMIAÇÕES CIENTÍFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.3.1.00.00','PREMIAÇÕES CIENTÍFICAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.4.0.00.00','PREMIAÇÕES DESPORTIVAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.4.1.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.5.0.00.00','ORDENS HONORÍFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.5.1.00.00','ORDENS HONORÍFICAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.9.0.00.00','OUTRAS PREMIAÇÕES','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.1.9.1.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.0.0.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','Compreende a apropriação do resultado negativo de participações, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.1.0.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.1.1.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.1.2.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.1.3.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.1.4.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.2.1.5.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.0.0.00.00','INCENTIVOS','Compreende os incentivos financeiros concedidos relativos à educação, a ciência e a cultura.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.1.0.00.00','INCENTIVOS A EDUCAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.1.1.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.1.1.01.00','BOLSA DE ESTUDOS NO PAÍS','Registra as variações patrimoniais diminutivas realizadas com bolsas de estudo no país, a qualquer título, e demais auxílios financeiros a estudantes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.1.1.02.00','BOLSA DE ESTUDOS NO EXTERIOR','Registra as variações patrimoniais diminutivas realizadas com bolsas de estudo no exterior, a qualquer título.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.1.1.03.00','AUXÍLIOS PARA DESENV. DE ESTUDOS E PESQUISAS','Registra as variações patrimoniais diminutivas realizadas com concessão de auxílios financeiros a estudantes para desenvolvimento de estudos e pesquisas de natureza científica, observado o disposto no art. 26 da lei complementar nº 101, de 2000.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.1.1.99.00','OUTROS INCENTIVOS A EDUCAÇÃO','Registra outras variações patrimoniais diminutivas com incentivos a educação não contemplados nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.2.0.00.00','INCENTIVOS A CIÊNCIA','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.2.1.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.2.1.01.00','AUXÍLIO A PESQUISADORES','Registra as variações patrimoniais diminutivas com auxílio financeiro a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas científicas e tecnológicas, nas suas diversas modalidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.2.1.02.00','AUXÍLIO AS ATIVIDADES AUXILIARES DE PESQUISA','Registra as variações patrimoniais diminutivas com auxílio financeiro a pesquisadores relativo ao apoio as atividades auxiliares de pesquisa, em atendimento a resolução n° 08/06-COPLAD, editada pelo Conselho de Planejamento e Administração da Universidade Federal do Paraná.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.2.1.99.00','OUTROS INCENTIVOS A CIÊNCIA','Registra as demais variações patrimoniais diminutivas com incentivos à ciência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.3.0.00.00','INCENTIVOS A CULTURA','Compreende os incentivos financeiros concedidos, visando à promoção da cultura.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.3.1.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','Compreende os incentivos financeiros concedidos, visando à promoção da cultura. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.3.1.01.00','INCENTIVOS A CULTURA - PESSOAS FÍSICAS','Registra os incentivos financeiros concedidos a pessoas físicas, visando a promoção da cultura.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.3.1.99.00','OUTROS INCENTIVOS A CULTURA','Registra os demais incentivos financeiros concedidos, visando a promoção da cultura.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.4.0.00.00','INCENTIVOS AO ESPORTE','Compreende os incentivos financeiros concedidos, visando à promoção do esporte.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.4.1.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','Compreende os incentivos financeiros concedidos, visando à promoção do esporte. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.4.1.01.00','INCENTIVOS AO ESPORTE - PESSOAS FÍSICAS','Registra os incentivos financeiros concedidos a pessoas físicas, visando a promoção do esporte.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.4.1.99.00','OUTROS INCENTIVOS AO ESPORTE','Registra as demais variações patrimoniais diminutivas com incentivos ao esporte.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.9.0.00.00','OUTROS INCENTIVOS','Compreende outros incentivos financeiros concedidos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.4.9.1.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','Compreende os incentivos financeiros concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.0.00.00','SUBVENÇÕES ECONÔMICAS','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.01.00','CORREÇÃO MONETÁRIA','Registra as variações patrimoniais diminutivas com correção monetária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.02.00','DIFERENCIAL DE JUROS','Registra as variações patrimoniais diminutivas de equalizações com diferencial de taxas de juros, previsto em contrato.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.03.00','PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL','Registra as variações patrimoniais diminutivas com o programa de investimento rural agroindustrial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.04.00','GARANTIA E SUSTENTAÇÃO DE PREÇOS','Registra as variações patrimoniais diminutivas com garantia e sustentação de preços.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.05.00','CUSTOS ADMINISTRATIVOS','Registra as variações patrimoniais diminutivas de equalizações referentes aos custos administrativos pagos aos agentes financeiros sob a forma de remuneração previsto em contrato.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.06.00','CUSTEIO AGROPECUÁRIO','Registra as variações patrimoniais diminutivas do custo de captação e aplicação de recursos no programa de assentamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.07.00','SUBVENÇÃO ECONOMICA AO PRÊMIO DE SEGURO GARANTIA','Registra a subvenção econômica ao prêmio do seguro garantia.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.08.00','AQUISIÇÃO E PRODUÇÃO DE BENS DE CAPITAL','Registra o valor de apropriação de variações patrimoniais diminutivas com equalização de taxas de juros nas operações de financiamento destinados a aquisição e produção de bens de capital e a inovação tecnológica (MP 465, de 2009).','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.5.0.1.99.00','OUTRAS SUBVENÇÕES ECONÔMICAS','Registra as variações patrimoniais diminutivas com outras subvenções econômicas não descritas acima.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.0.0.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','Compreende as participações de terceiros nos lucros, não relativas ao investimento dos acionistas, tais como: participações de debêntures, empregados, administradores e partes beneficiárias, mesmo na forma de instrumentos financeiros, além da contribuição a instituições ou fundos de assistência ou previdência de empregados.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.1.0.00.00','PARTICIPAÇÕES DE DEBÊNTURES','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.1.1.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.2.0.00.00','PARTICIPAÇÕES DE EMPREGADOS','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.2.1.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.3.0.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.3.1.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.4.0.00.00','PARTICIPAÇÕES DE PARTES BENEFICIÁRIAS','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.4.1.00.00','PARTICIPAÇÕES DE PARTES BENEFICIÁRIAS - CONSOLIDAÇÃO','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.5.0.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido, para instituições ou fundos de assistência ou previdência de empregados.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.6.5.1.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro líquido, para instituições ou fundos de assistência ou previdência de empregados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.0.0.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','Compreende a constituição de provisões, entendidas como os passivos de vencimento ou montante incertos. Não se confundem com os passivos derivados de apropriação por competência, como férias e décimo - terceiro salário.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.1.0.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.1.1.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.2.0.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.2.1.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.3.0.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.3.1.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS – CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.4.0.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.4.1.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS – CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamentos de indenizações a fornecedores e clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.5.0.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.5.5.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.6.0.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.6.1.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.9.0.00.00','VPD DE OUTRAS PROVISÕES','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.7.9.1.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.0.0.00.00','CUSTO DE OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende outras variações patrimoniais diminutivas não classificadas em itens específicos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.4.0.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.4.1.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.4.2.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.4.3.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.4.4.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.4.5.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.9.1.01.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS','Registra o valor das consituições das provisões matemáticas previdenciárias.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'3.9.9.9.1.02.00','HONRA DE AVAIS','Registra os valores que a administração é compelida a realizar em decorrencia de honra de avais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','Compreende o aumento no beneficio econômico durante o período contábil sob a forma de entrada de recurso ou aumento de ativo ou diminuição de passivo, que resulte em aumento do patrimônio liquido e que não sejam provenientes de aporte dos proprietários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.0.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: impostos, taxas e contribuições de melhoria.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.0.0.00.00','IMPOSTOS','Compreende como imposto o tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal especifica, relativa ao contribuinte.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.1.0.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','Compreende os impostos sobre operações de comercio exterior, como por exemplo: impostos sobre a importação e imposto sobre a exportação.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.1.1.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','Compreende os impostos sobre operações de comercio exterior, como exemplo: impostos sobre a importação e imposto sobre a exportação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.0.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','Compreende os impostos sobre patrimônio e a renda, como por exemplo: imposto sobre a propriedade territorial rural, imposto sobre a propriedade predial e territorial urbana, imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e impostos sobre a renda e proventos de qualquer natureza.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','Compreende os impostos sobre patrimônio e a renda, como exemplo: imposto sobre a propriedade territorial rural,imposto sobre a propriedade predial e territorial urbana,imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e imposto sobre a renda e proventos de qualquer natureza. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','Registra a variação patrimonial aumentativa decorrente de imposto sobre propriedade territorial rural.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.02.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA','Registra a variação patrimonial aumentativa decorrente de imposto sobre a propriedade predial e territorial urbana.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.03.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Compreende a variação patrimonial aumentativa decorrente de imposto sobre a renda e proventos de qualquer natureza, retidos na fonte.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.03.01','IR - PESSOAS FÍSICAS','Registra o valor total que incide sobre os rendimentos e ganhos de capital percebidos pelas pessoas físicas residentes ou domiciliadas no Brasil. Integram o rendimento bruto sujeito a incidência desse imposto o ganho de capital decorrente da alienação de bens e direitos e os ganhos líquidos auferidos em operações realizadas nas bolsas de valores e assemelhadas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.03.02','IR - PESSOAS JURÍDICAS','Registra o valor da VPA com o imposto de renda das pessoas jurídicas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.04.00','ITBI','Registra a variação patrimonial aumentativa decorrente de imposto sobre a transmissão intervivos de bens imóveis e direitos reais sobre imóveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.2.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de impostos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.3.0.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','Compreende os impostos sobre a produção e a circulação, como por exemplo: imposto sobre produtos industrializados; imposto sobre operações de credito, câmbio e seguro, e sobre operações relativas a títulos e valores mobiliários; imposto sobre serviços de qualquer natureza.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.3.1.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','Compreende os impostos sobre a produção e a circulação como, por exemplo, imposto sobre produtos industrializados;imposto sobre operações de crédito, cambio e seguro, e sobre operações relativas a títulos e valores mobiliários, imposto sobre serviços de qualquer natureza.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.3.1.02.00','ISS','Registra a variação variação patrimonial aumentativa decorrente de ISS.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.3.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de ICMS e ISS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.4.0.00.00','IMPOSTOS EXTRAORDINÁRIOS','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos, gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.4.1.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos,gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.9.0.00.00','OUTROS IMPOSTOS','Compreende os demais impostos não classificados nos grupos anteriores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.1.9.1.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','Compreende os demais impostos não classificados nos grupos anteriores. Compreende os valores de operações efetuadas entre uma unidade pertinente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.0.0.00.00','TAXAS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador o exercício regular do poder de policia, ou a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.0.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a prática de ato ou abstenção de fato, em razão de interesse público.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.11.00','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.11.01','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - SAÚDE','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária - Saúde.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.11.02','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - ANIMAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária - Animal.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.14.00','TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Controle e Fiscalização Ambiental.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.15.00','TAXA DE SERVIÇOS ADMINISTRATIVO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços Administrativos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.15.01','ATOS DA ADMINISTRAÇÃO EM GERAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços de Atos Administração em Geral.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.15.02','ATOS DA SAÚDE PÚBLICA','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços de Atos da Saúde Pública.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.70.00','TAXA DE PREVENÇÃO CONTRA SINISTRO','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Prevenção Contra Sinistro.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.71.00','TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Fiscalização sobre Serviços Públicos de Saneamento Básico.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.72.00','TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Regulação de Serviços de Gás Canalizado.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.00','(-) DEDUÇÕES','Compreende as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.11','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado, referente a Taxa de Fiscalização de Vigilância Sanitária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.14','(-) DEDUÇÃO DA TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado, referente a Taxa de Controle de Fiscalização Ambiental.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.15','(-) DEDUÇÃO TAXA DE SERVIÇOS ADMINISTRATIVOS','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado, referente a Taxa de Controle de Fiscalização Ambiental.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.70','(-) DEDUÇÃO TAXA DE PREVENÇÃO CONTRA SINISTRO','Registra as deduções de variações patrimoniais aumentativas, referente a Taxa de Prevenção contra Sinistros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.71','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','Registra as deduções de variações patrimoniais aumentativas, referente a Taxa de Fiscalização sobre Serviços Públicos de Saneamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.72','(-) DEDUÇÃO TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','Registra as deduções de variações patrimoniais aumentativas, referente a Taxa de Regularização de Serviços de Gás Canalizado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.1.1.97.98','(-) RENÚNCIA','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.0.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível prestado ao contribuinte ou posto a sua disposição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','Registra as variações patrimoniais diminutivas com Emolumentos e Custas Judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','Registra as variações patrimoniais diminutivas com Emolumentos e Custas Processuais Administrativas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.70.00','TAXA JUDICIÁRIA','Registra as variações patrimoniais diminutivas com Taxa Judiciária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.71.00','TAXA DE SEGURANÇA CONTRA INCÊNDIO','Registra as variações patrimoniais diminutivas com Taxa de Segurança Contra Incêndio.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.72.00','TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','Registra as variações patrimoniais diminutivas com Taxa de Segurança Ostensiva Contra Delitos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.73.00','TAXA DE SEGURANÇA PREVENTIVA','Registra as variações patrimoniais diminutivas com Taxa de Segurança Preventiva.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.74.00','TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','Registra as variações patrimoniais diminutivas com Taxa de Aposentados e Serventuários da Justiça.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.00','(-) DEDUÇÕES','Compreende as deduções diversas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.07','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS JUDICIAIS','Registra as deduções de Emolumentos e Custas Judiciais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.09','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','Registra as deduções de Emolumentos e Custas processuais Administrativas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.70','(-) DEDUÇÃO TAXA JUDICIÁRIA','Registra as deduções da Taxa Judiciária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.71','(-) DEDUÇÃO TAXA DE SEGURANÇA CONTRA INCÊNDIO','Registra as deduções da Taxa de Segurança Contra Incêndios.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.72','(-) DEDUÇÃO TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','Registra as deduções da Taxa de Segurança Ostensiva contra delitos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.73','(-) DEDUÇÃO TAXA DE SEGURANÇA PREVENTIVA','Registra as deduções da Taxa de Segurança Preventiva.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.74','(-) DEDUÇÃO TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','Registra as deduções da Taxa de Aposentados e Serventuários da Justiça.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.97.98','(-) RENÚNCIA','Registra os valores de Renúncia diversas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.2.2.1.99.00','OUTRAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra as variações patrimoniais diminutivas com Outras Taxas pela Prestação de Serviços.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.0.0.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende como contribuição de melhoria o tributo cobrado pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, sendo instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária, tendo como limite total a despesa realizada e como limite individual o acréscimo de valor que da obra resultar para cada imóvel beneficiado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.1.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de água potável e esgoto sanitário.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.1.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedade em função da pavimentação asiática, bem como pela colocação de guias, sarjetas e calcamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.1.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de água potável e esgoto sanitário.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.1.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de água potável e esgoto sanitário.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.2.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de iluminação pública na cidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.2.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública na cidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.2.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública na cidade.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.2.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública na cidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.3.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Compreende o valor da arrecadação de receita sobre a cobrança decorrente de valorização de propriedades em função da expansão da rede de iluminação pública rural.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.3.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública rural. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.3.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública rural.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.3.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública rural.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.4.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.4.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.4.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela pavimentação e obras complementares.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.4.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela pavimentação e obras complementares.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.9.0.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.9.1.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.9.1.01.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Registra a variação patrimonial aumentativa decorrente de outras contribuições de melhoria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.1.3.9.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de outras contribuições de melhoria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.0.0.0.00.00','CONTRIBUIÇÕES','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: contribuições.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.0.0.00.00','CONTRIBUIÇÕES SOCIAIS','Compreendem como contribuições sociais: a) as das empresas, incidentes sobre a remuneração paga ou creditada aos segurados a seu serviço; b) as dos empregadores domésticos; c) as dos trabalhadores, incidentes sobre o seu salário-de-contribuição; d) as sobre a receita e faturamento; e) as sobre o lucro; f) do importador de bens ou serviços do exterior; g) e outros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.0.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuição patronal destinada ao custeio do Regime Próprio de Previdência Social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.01.01','CONTRIB. PATRONAL DE SERVIDOR CIVIL - RPPS','Registra a VPA oriunda da participação dos entes para o custeio do plano de seguridade social do servidor, sobre a remuneração mensal dos servidores públicos ativos civis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.01.02','CONTR.PATRONAL - PAGAMENTO DE SENTENCAS JUDICIAIS','Registra a VPA de recolhimento da contribuição patronal, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','Compreende a contribuição ao RPPS dos segurados, servidor ativo, servidor inativo e pensionista sobre a sua remuneração.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.01','CONTRIBUIÇÃO DO SERVIDOR CIVIL - RPPS','Registra a VPA proveniente da contribuição ao RPPS do servidor ativo civil sobre sua remuneração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.02','CONTRIBUIÇÃO DO APOSENTADO CIVIL - RPPS','Registra a VPA proveniente da contribuição ao RPPS do servidor inativo civil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.03','CONTRIBUIÇÃO DE PENSIONISTA CIVIL - RPPS','Registra a VPA proveniente da contribuição ao RPPS do pensionista civil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.04','CONTR.SERV. CIVIL-PAGTO SENT. JUDICIAIS','Registra a VPA oriunda de recolhimento da contribuição do servidor civil ativo, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.05','CONTR. APOSENTADO CIVIL - PAGTO SENT. JUDICIAIS','Registra aVPA oriunda de recolhimento da contribuição do servidor inativo civil, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.02.06','CONTR.PENSIONISTA CIVIL-PAGTO SENT. JUDICIAIS','Registra a VPA oriunda de recolhimento de pensionista civil, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.03.00','CONTRIBUIÇÃO PREVIDENCIÁRIA PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','Registra a VPA oriunda de contribuições previdenciárias para amortização do déficit atuarial.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.04.00','CONTRIBUIÇÕES PARA CUSTEIO DAS PENSÕES MILITARES','Registra as VPA provenientes de contribuição para custeio das pensões militares, efetivadas por todos os militares, com valor correspondente a seu posto ou graduação, observando as exceções previstas na lei especifica. De competência da União e dos Estados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.97.00','(-) DEDUÇÕES','Compreendem as deduções das contribuições sociais – RPPS.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.97.01','(-) RENÚNCIA','Registra a dedução por renúncia de variações patrimoniais aumentativas como, por exemplo, a anistia, a remissão, o subsídio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições, e outros benefícios que correspondam a tratamento diferenciado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das VPA oriundas de contribuições previdenciárias não enquadradas nos subitens anteriores.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuicao patronal destinada ao custeio do regime próprio de previdencia social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','Registra a VPA oriunda da participação da PCASP união, autarquias e fundações públicas federais para o custeio do plano de seguridade social do servidor, sobre a remuneração mensal dos servidores públicos ativos civis da PCASP união, das autarquias, inclusive as em regime especial, e das fundações públicas federais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','Registra a VPA de recolhimento da contribuição patronal, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.97.00','(-) DEDUÇÕES','Compreendem as deducoes das variacoes patrimoniais aumentativas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.97.01','(-) RENÚNCIA','Registra a dedução por renúncia de variações patrimoniais aumentativas como, por exemplo, a anistia, a remissão, o subsídio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições, e outros benefícios que correspondam a tratamento diferenciado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.2.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS – UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuicao patronal destinada ao custeio do regime próprio de previdencia social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','Registra a VPA oriunda da participação da PCASP união, autarquias e fundações públicas federais para o custeio do plano de seguridade social do servidor, sobre a remuneração mensal dos servidores públicos ativos civis da PCASP união, das autarquias, inclusive as em regime especial, e das fundações públicas federais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','Registra a VPA de recolhimento da contribuição patronal, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.97.00','(-) DEDUÇÕES','Compreende as deducoes das variacoes patrimoniais aumentativas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.97.01','(-) RENÚNCIA','Registra a dedução por renúncia de variações patrimoniais aumentativas como, por exemplo, a anistia, a remissão, o subsídio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições, e outros benefícios que correspondam a tratamento diferenciado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.4.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuicao patronal destinada ao custeio do regime próprio de previdencia social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','Registra a VPA oriunda da participação da PCASP união, autarquias e fundações públicas federais para o custeio do plano de seguridade social do servidor, sobre a remuneração mensal dos servidores públicos ativos civis da PCASP união, das autarquias, inclusive as em regime especial, e das fundações públicas federais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','Registra a VPA de recolhimento da contribuição patronal, oriunda do pagamento de sentenças judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.97.00','(-) DEDUÇÕES','Compreende as deducoes das variacoes patrimoniais aumentativas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.97.01','(-) RENÚNCIA','Registra a dedução por renúncia de variações patrimoniais aumentativas como, por exemplo, a anistia, a remissão, o subsídio, o crédito presumido, a concessão de isenção em carater não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições, e outros benefícios que correspondam a tratamento diferenciado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.1.5.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.2.0.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.2.1.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.2.2.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.2.3.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.2.4.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.2.5.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.3.0.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.3.1.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.4.0.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.4.1.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','Compreende a contribuição do empregador,da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.5.0.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNÓSTICO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.5.1.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNÓSTICO - CONSOLIDAÇÃO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.6.0.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.6.1.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.9.0.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.1.9.1.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.2.0.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE-combustível.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.2.0.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE combustível. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.3.0.0.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','Compreende as contribuições de iluminação pública, nos termos do artigo 149-A da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.3.0.1.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','Compreende as contribuições de iluminação pública, nos termos do artigo 149-A da constituição federal, acrescentado pela emenda constitucional nº 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.3.0.1.01.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','Registra as contribuições de iluminação pública, nos termos do artigo 149-A da constituição federal, acrescentado pela emenda constitucional nº 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.4.0.0.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.2.4.0.1.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.0.0.0.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','Compreende as variações patrimoniais aumentativas auferidas com a exploração e venda de bens, serviços e direitos, que resultem em aumento do patrimônio liquido, independentemente de ingresso, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.0.0.00.00','VENDA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda de mercadorias, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.0.00.00','VENDA BRUTA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.01.00','VENDA DE ESTOQUE PRÓPRIO - PAÍS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.11.00','VENDA DE ESTOQUE DE PRODUÇÃO VEGETAL','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.11.01','AGRICULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Agricultura.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.11.02','HORTA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Horta.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.11.03','POMAR','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Pomar.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.11.99','OUTRAS VPAS DE PRODUÇÃO VEGETAL','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Outras VPAS de Produção Vegetal.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.00','VENDA DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.01','GRANJA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Granja.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.02','PISCICULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Piscicultura.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.03','PECUÁRIA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Pecuária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.04','APICULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Apicultura.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.05','SUINOCULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Suinocultura.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.06','OVINOCULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Ovinocultura.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.07','COELHOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Coelhos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.08','GADO LEITEIRO','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Gado Leiteiro.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.09','EQÜINOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Equinos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.10','AVÍCOLA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Avícola.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.12.99','OUTRAS VPAS DE PRODUÇÃO ANIMAL E DERIVADOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Outras VPAS de Produção Animal e Derivados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.13.00','VENDA DE MEDICAMENTOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Medicamentos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.14.00','VENDA DE LIVROS PERIOD. MAT. ESC. E PUBLICID.','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.14.01','VENDA DE LIVROS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Venda de Livros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.14.02','PUBLICAÇÕES','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Publicações.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.14.03','VENDAS REVISTA RAC','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Vendas de Revistas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.14.04','PUBLICAÇÕES TÉCNICAS EPAGRI','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Publicações Técnicas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.14.05','DIVULGAÇÃO E PUBLICIDADE','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Divulgação e Publicidade.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.15.00','VENDA DE PRODUTOS AGROPECUÁRIOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Produtos Agropecuários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.15.99','OUTRAS VPAS AGROPECUÁRIAS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende Outras VPAS Agropecuárias.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.1.1.16.00','VENDA DE FARDAMENTOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Fardamento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.0.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.00','(-) DEDUÇÕES DE VENDAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas Canceladas e Devoluções.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.02','(-) ABATIMENTOS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Abatimentos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Descontos Incondicionais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.05','(-) ICMS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - ICMS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.06','(-) PIS/PASEP','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - PIS/PASEP.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.07','(-) COFINS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - COFINS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Ajuste a Valor Presente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.1.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Outras Dedução de Vendas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.0.0.00.00','VENDA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda de produtos, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.1.0.00.00','VENDA BRUTA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.1.1.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.0.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.00','(-) DEDUÇÕES DE VENDAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas Canceladas e Devoluções.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.02','(-) ABATIMENTOS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Abatimentos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Descontos Incondicionais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.04','(-)IPI','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - IPI.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.05','(-) ICMS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - ICMS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.06','(-) PIS/PASEP','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - PIS/PASEP.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.07','(-) COFINS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - COFINS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Ajuste a Valor Presente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.2.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Outras Dedução de Vendas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.0.0.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.0.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.01.00','PRESTAÇÃO DE SERVIÇOS DE TREINAMENTO','Registra as variações patrimoniais aumentativas provenientes da prestação de instrução.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.02.00','EXPLORAÇÃO DO PATRIMÔNIO IMOBILIÁRIO','Registra o valor das variações patrimoniais aumentativas provenientes da utilização, por terceiros, de bens imóveis pertencentes ao setor público.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.03.00','PRESTAÇÃO DE SERVIÇOS DE LOCAÇÃO','Registra as variações patrimoniais aumentativas provenientes de alugueis, exceto alugueis de imóveis, que ja possui rubrica própria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.04.00','PRESTAÇÃO DE SERVIÇOS DE PESQUISAS E ANALISES','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de pesquisas e análise.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.05.00','SERVIÇOS DE ESTUDOS E PESQUISAS','Registra as variações patrimoniais aumentativas provenientes de serviços de pesquisas e estudos técnico-sociais, econômicos, científicos, culturais etc., realizadas sob contrato.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.06.00','PRESTAÇÃO DE SERVIÇOS DE CONSULTORIA','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de assessoria e consultoria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.07.00','SERVIÇOS CONSULT.ASSIST.TÉC. ANÁLISE PROJETOS','Registra as variações patrimoniais aumentativas provenientes de serviços de consultoria, assistência técnica e análise de projetos prestados. VPA proporcionada por consultorias técnico-financeiras, assessoria, organização e administração de empresas, auditoria, contabilidade e escrituração,perícias contábeis, análise de projetos, etc.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.08.00','PRESTAÇÃO DE SERVIÇOS RELACIONADOS A T.I','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços relacionados a tecnologia da informação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.09.00','PRESTAÇÃO DE SERVIÇOS DE ADM. DE REDE DE COMUNIC. DE DADOS','Registra as variações patrimoniais aumentativas provenientes da prestação serviços de gerenciamento de redes de comunicação de dados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.10.00','SERVIÇOS DE PROCESSAMENTO DE DADOS','Registra as variações patrimoniais aumentativas provenientes de serviços de processamentos de dados prestados. VPA decorrente de prestação de serviços de processamento de dados para terceiros: preparo de programa, análise de sistemas, digitação, conferência, etc.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.11.00','SERVIÇO DE INFORMAÇÕES CIENTÍFICAS E TECNOLÓGICAS','Registra as variações patrimoniais aumentativas provenientes de serviços de informações científicas e tecnológicas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.12.00','PRESTAÇÃO DE SERVIÇOS CIENTIFICOS E TECNOLÓGICOS NUCLEARES','Registra as variações patrimoniais aumentativas provenientes da prestação serviços que envolvam informação científica e tecnológica, aplicações de técnicas nucleares e radioisótopos, metrologia científica e industrial, radiometria e dosimetria, consultorias assistência técnica, análise de projetos, estudos, pesquisas e desenvolvimento da energia nuclear.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.13.00','SERVIÇOS DE TECNOLOGIA','Registra as variações patrimoniais aumentativas provenientes de serviços tecnologicos prestados.VPA proporcionada por: a) análises químicas, ensaios físicos e mecânicos, controle e experimentação qualitativa de matérias-primas, insumos e produtos fabricados; padronização e específicação de produtos; ajustes dos processos e técnicas de produção industrial (sistema de tecnologia) b) específicação e controle de qualidade de medicamentos, insumos farmacêuticos, drogas, cosméticos, produtos químicos, alimentos, e outros, por meio de provas específicas de identificação, de pureza e de testes de contaminação microbiológica.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.14.00','SERVIÇOS DE COMUNICAÇÃO','Registra as variações patrimoniais aumentativas provenientes de atividades de comunicação, conforme descrição abaixo: a) serviço postal, de entrega e transporte de volumes e correspondências; b) serviço de comunicação telefônica local, interurbana e internacional e de transmissão de dados; c) serviço de radiodifusão e de agenciamento de publicidade.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.15.00','PRESTAÇÃO DE SERVIÇOS RELACIONADOS A ARMAZENAGEM','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de armazenagem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.16.00','PRESTAÇÃO DE SERVIÇOS COMPLEMENTARES','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços complementares quando da estocagem em armazenagem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.17.00','PRESTAÇÃO DE SERVIÇOS RELACIONADOS AO BENEFICIAMENTO DE GRÃOS','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de beneficiamento de grãos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.18.00','PRESTAÇÃO DE SERVIÇOS RECEPÇÃO E EMBARQUE DE PRODUTOS','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de movimentação dos produtos nos armazéns/caminhão.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.19.00','PRESTAÇÃO DE SERVIÇOS SERVIÇO DE TRANSBORDO','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de transbordo de mercadorias de trem para caminhão e vice-versa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.20.00','FORNECIMENTO DE MÃO-DE-OBRA','Registra as variações patrimoniais aumentativas provenientes do fornecimento de mão-de-obra.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.21.00','PRESTAÇÃO DE SERVIÇOS DE DISTRIB. DE GÊNEROS ALIMENTÍCIOS','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de distribuição de gêneros alimentícios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.22.00','SERVIÇOS DE HOSPEDAGEM E ALIMENTAÇÃO','Registra as variações patrimoniais aumentativas provenientes de serviços de hospedagem e alimentação prestados. VPA proporcionada por hospedagem, com ou sem alimentação, fornecimento de refeições, lanches e bebidas para consumo imediato. Excluem as VPA provenientes de empresas fornecedoras de alimentos preparados para hospitais, fábricas, etc... que se classificam em VPA de produtos alimentares.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.23.00','CONCESSÃO E PERMISSÃO - SERV. DE TRANSPORTE','Registra as variações patrimoniais aumentativas associadas a outorga dos serviços públicos de transporte a iniciativa privada, proveniente da atuação da fiscalização, da normatização e do controle dos serviços concedidos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.24.00','OUTORGA SERV. EXPL. PROD PETR. GÁS NATURAL','Registra as variações patrimoniais aumentativas provenientes de atividades de exploração, desenvolvimento e produção de petróleo e gás natural, exercidas mediante contratos de concessão.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.25.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','Registra as variações patrimoniais aumentativas provenientes de outorga a particulares de direitos de uso da água.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.26.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','Registra as variações patrimoniais aumentativas provenientes da compensação financeira pela exploração de recursos minerais devido por todas as empresas que realizam o aproveitamento de uma jazida mineral garantida a essas a propriedade do produto da lavra.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.27.00','CONCESSÃO FLORESTAL','Registra as variações patrimoniais aumentativas provenientes de atividades de exploração e gestão de direitos de uso de florestas públicas, recursos florestais, produtos e serviços delas decorrentes, para produção sustentavel, exercidas mediante contratos de concessão, a particulares que estejam em condições de atender as exigências do respectivo edital de licitação e que demonstrem capacidade para seu desempenho, por sua conta e risco e prazo determinado.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.28.00','CONCESSÃO E PERMISSÃO. - DIR. USO DE BENS PUB','Registra as variações patrimoniais aumentativas provenientes da utilização e exploração de bens públicos por terceiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.29.00','COMPENSAÇÕES FINANCEIRAS','Registra as variações patrimoniais aumentativas provenientes dos recursos decorrentes do artigo 20, parágrafo 1º da Constituição Federal, o qual dispõe: "e assegurada, nos termos da lei, aos estados, ao distrito federal e aos municípios, bem como aos órgãos da administração direta da PCASP união, participação no resultado da exploração de petróleo ou gás natural, de recursos hídricos para fins de geração de energia elétrica e de outros recursos minerais no respectivo território, plataforma continental, mar territorial ou zona economia exclusiva, ou compensação financeira por essa exploração".','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.30.00','SERVIÇOS DE TRANSPORTE','Registra as variações patrimoniais aumentativas provenientes de serviços de transporte rodoviário, ferroviário, hidroviário, aéreo, especiais e tarifa de pedágio.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.31.00','SERVIÇOS PORTUÁRIOS','Registra as variações patrimoniais aumentativas provenientes de serviços portuários. Abrangem os recursos oriundos da exploração dos portos, terminais marítimos, atracadouros e ancoradouros, referentes a estiva, desestiva, dragagem, atracação, sinalização, comunicação náutica, docagem, etc....','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.32.00','SERVIÇOS DE SOCORRO MARÍTIMO','Registra as variações patrimoniais aumentativas provenientes de serviço de socorro marítimo prestado. VPA de serviços de salvamento, por navio de socorro ou equipe de salvamento da marinha, de embarcação e cargas perigo (desencalhe, mergulho, outros socorros), bem como serviços de reboque marítimo, dentre outros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.33.00','SERVIÇOS DE SAÚDE','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços de saúde: hospitalares gerais ou especializados, maternidade, centro de reabilitação, assistência médico-odontológica (inclusive ambulatorial), saúde pública, etc...','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.34.00','CERTIFICAÇÃO E HOMOLOGAÇÃO DE PROD. TELECOM.','Registra as variações patrimoniais aumentativas provenientes de certificação e homologação de prod. telecom.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.35.00','SERVIÇOS DE METROLOGIA E CERTIFICAÇÃO','Registra as variações patrimoniais aumentativas provenientes de serviços de metrologia e certificação prestados.VPA de serviços metrológicos em geral, tais como aferição de medidas e instrumentos de medir, serviços de arqueação de tanques para armazenagem, etc.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.36.00','SERVIÇOS DE INSPECAO E FISCALIZACAO','Registra as variações patrimoniais aumentativas provenientes de serviços de inspeção e fiscalização prestados. VPA proporcionada pela constatação das condições higiênico-sanitárias e técnicas de produtos ou estabelecimentos, ou resultantes de ação externa e direta dos órgãos do poder público destinada a verificação do cumprimento da legislação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.37.00','SERVIÇOS ADMINISTRATIVOS','Registra as variações patrimoniais aumentativas provenientes de serviços administrativos prestados, das atividades de apoio administrativo executadas em organizações de qualquer natureza, tais como: a)taxas de expedição de certificados; b)taxas de registro, renovação, vistoria, licença, cadastramento, etc. c)datilografia, microfilmagem, cópias xerográficas, heliográficas,fotostáticas, etc.. d)taxas de inscrição em concursos. e)taxa de administração de serviços. f)venda de editais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.38.00','SERVIÇOS DE METEOROLOGIA','Registra as variações patrimoniais aumentativas provenientes de serviços de meteorologia prestados. VPA proporcionada pelo fornecimento de dados meteorológicos e de pareceres técnicos, bem como conserto, comparação e aferição de equipamentos de meteorologia.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.39.00','SERVIÇOS EDUCACIONAIS','Registra as variações patrimoniais aumentativas provenientes das atividades do sistema educacional, cuja natureza esteja diretamente relacionada a formação do educando (matrículas, anuidades, etc...). as VPA de atividades auxiliares, de apoio ou derivadas dos serviços educacionais propriamente ditos, devem ser classificadas nos títulos apropriados. Exemplos: matrículas e anuidades, serviços educacionais, taxas de expedição de documentos, cópias xerográficas, heliográficas, etc.., serviço de credenciamento, autorização e reconhecimento de cursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.40.00','SERVIÇOS AGROPECUÁRIOS','Registra as variações patrimoniais aumentativas provenientes de serviços agropecuário: a)preparo e correção de solos (destocamento,aração,gradeação, calagem,adubação, drenagem, irrigação, capina, desmatamento, etc.); b)semeadura e plantio; c)combate a pragas (pulverização, dedetização); d)colheita e preparação de produtos agrícolas; e)inseminação artificial; f)incubação de ovos; g)vacinação de animais; h)outros serviços auxiliares de agricultura e pecuária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.41.00','SERVIÇOS DE REPARACÃO,MANUTENÇÃO E INSTALACÃO','Registra as variações patrimoniais aumentativas provenientes de serviços de reparação, manutenção e instalação prestados. VPA de serviços de reparação de artefatos de metal; reparação e manutenção de máquinas e aparelhos de uso doméstico; reparação, manutenção e instalação de máquinas e aparelhos elétricos e eletrônicos e de comunicação; reparação e manutenção de instalações elétricas, de gás, de água, etc...incluem-se também, nesse título, os serviços de confecção sob medida. Não são considerados nesse título, classificando-se em VPA industrial: reparação e manutenção de veículos ferroviários, embarcações e aeronaves (indústria de material de transporte).','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.42.00','SERVIÇOS RECREATIVOS E CULTURAIS','Registra as variações patrimoniais aumentativas provenientes de serviços recreativos e culturais prestados. VPA proporcionada pela exploração de instalações para recreação, prática desportiva e cultural ( cinemas,teatros, salões para recitais, concertos, conferências, planetários,estádios desportivos, autódromos, museus, bibliotecas, promoção e/ou produção de espeáaculos artísticos culturais e esportivos).','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.43.00','SERVIÇOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','Registra as variações patrimoniais aumentativas provenientes de serviços de registro de marcas, patentes e transferência de tecnologias. VPA correspondente aos serviços previstos no código da propriedade industrial, peticões gerais, pedidos e petições relativas a privilégios, pedidos e petições relativas a marcas e patentes,pedidos e petições relativos a contratos de transferência de tecnologia e correlatos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.44.00','SERVIÇOS DE REGISTRO DO COMÉRCIO','Registra as variações patrimoniais aumentativas provenientes de serviços de registro do comércio prestados. VPA advinda da prestação de serviços de registro do comércio e atividades afins, tratando-se de: a) serviços prestados pela junta comercial do distrito federal; b) serviços constantes do cadastro nacional de empresa, devidos no âmbito das juntas comerciais dos estados e do distrito federal; c) remuneração de serviços prestados pelo departamento nacional de registro do comércio.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.45.00','SERVIÇOS DE FORNECIMENTO DE ÁGUA','Registra as variações patrimoniais aumentativas provenientes de serviços prestados de fornecimento de água aos irrigantes a amortização dos investimentos da infra-estrutura de irrigação dos projetos públicos, conforme Dec.89.496, de 29.03.84, relativos a tarifas k-1 e k-2.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.46.00','SERVIÇOS DE PERFURAÇÃO E INSTALAÇÃO DE POÇOS','Registra as variações patrimoniais aumentativas provenientes de serviços prestados de perfuração e instalação de poços tubulares profundos, poços artesianos ou similares.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.47.00','SERVIÇOS DE GEOPROCESSAMENTO','Registra as variações patrimoniais aumentativas provenientes de serviços prestados a terceiros de interpretação de imagem aerofotogramétrica,execução de mapas digitalizados diversos, venda de cartas e imagens de satélites, videográficas e similares.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.48.00','SERVIÇOS DE CADASTRAMENTO DE FORNECEDORES','Registra as variações patrimoniais aumentativas provenientes de prestação de serviços de cadastramento de empresas fornecedoras de bens e serviços ao governo federal.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.49.00','TARIFA DE UTILIZAÇÃO DE FARÓIS','Registra as variações patrimoniais aumentativas provenientes de tarifa de utilização de faróis. VPA proveniente da efetiva utilização, por embarcações estrangeiras, dos serviços de sinalização náutica de proteção à navegação. O produto da arrecadação e destinado integralmente ao fundo naval para aplicação nos serviços que envolvam a manutenção e ampliação da rede de balizamento marítimo, fluvial e lacustre, a cargo da diretoria de hidrografia e navegação do ministério da marinha.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.50.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUÁRIA','Registra as variações patrimoniais aumentativas provenientes de tarifa e adicional sobre tarifa aeroportuária. VPA provenientes de tarifa e adicional cobrados por embarque de passageiros, pouso e permanência de aeronaves nos aeroportos, armazenagem de mercadorias em armazéns de carga aérea e utilização de serviços relativos a manutenção e manuseio de mercadorias em armazéns de carga (tarifa de capatazia). VPA vinculada ao ministério da aeronáutica.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.51.00','SERVIÇOS DE CADASTRO DA ATIVIDADE MINERAL','Registra as variações patrimoniais aumentativas provenientes da taxa de serviços cadastrais quando do requerimento de autorização de pesquisa mineral.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.52.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','Registra as variações patrimoniais aumentativas provenientes de tarifas de inscrição em concursos e processos seletivos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.53.00','SERVIÇO DE COMPENSAÇÃO DE VARIAÇÕES SALARIAIS','Registra as variações patrimoniais aumentativas provenientes da cobranca de contribuições sobre o valor das prestações pagas pelos mutuários do sistema financeiro de habitação-SFH e sobre o saldo dos financiamentos imobiliários concedidos pelos agentes financeiros do SFH,com cobertura do FCVS.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.54.00','GARANTIAS E AVAIS','Registra as variações patrimoniais aumentativas provenientes da prestação de garantias e avais nas operações de crédito. Fato gerador: concessão de garantias e avais, de natureza não-financeiras.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.55.00','CREDENCIAMENTO EMP.PREST.SERVIÇOS DE VISTORIA','Registra as variações patrimoniais aumentativas provenientes do valor a ser pago por empresas na obtenção de credenciamento para prestação de serviços de vistoria. - destinação legal: órgão arrecadador; - amparo legal: resolução CONTRAN 282, de 26 de junho de 2008.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.56.00','SERVIÇOS VETERINÁRIOS','Registra as variações patrimoniais aumentativas provenientes de serviços veterinários.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.57.00','CERTIFICAÇÃO E HOMOLOGAÇÃO ATIVIDADE MINERAL','Registra as variações patrimoniais aumentativas provenientes de taxa de serviços cadastrais quando do requerimento de registro de licença e do registro de permissão de lavra garimpeira.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.58.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','Registra as variações patrimoniais aumentativas provenientes da prestação de serviços voltados a inovação e a pesquisa científica e tecnológica no ambiente produtivo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.59.00','SERVIÇOS FINANCEIROS','Registra as variações patrimoniais aumentativas com serviços financeiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.60.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATICA','Registra as variações patrimoniais aumentativas provenientes da comercialização de produtos, dados e materiais de informática, tais como disquetes,softwares, programas, cd-rom, fitas magnéticas e assemelhados, bem como informações em redes e sistemas de dados disponíveis em meio de hardware.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.61.00','SERVIÇOS DE TURISMO','Registra as variações patrimoniais aumentativas com serviços de turismo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.1.1.99.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTAÇÃO DE SERVIÇOS','Registra as variações patrimoniais aumentativas provenientes da prestação de outros serviços não enquadrados nos itens anteriores.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.0.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUÇÕES','Registra o valor da dedução de VPA de vendas de serviços referentes a cancelamento de vendas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.02.00','(-) ABATIMENTOS','Registra o valor dos abatimentos decorrentes de defeitos de qualidade apresentados nos serviços entregues.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','Registra os descontos incondicionais decorrentes de reduções de preço dadas no momento da venda, que são deduzidas diretamente das NF.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.05.00','(-) ISS','Registra o valor das deduções de impostos incidentes sobre as vendas de serviços referentes ao ISS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.06.00','(-) ICMS','Registra o valor das deduções de impostos incidentes sobre as vendas de serviços referentes ao ICMS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.07.00','(-) PIS','Registra o valor das deduções de impostos incidentes sobre as vendas de serviços referentes ao PIS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.08.00','(-) PASEP','Registra o valor das deduções de impostos incidentes sobre as vendas de serviços referentes ao PASEP.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.09.00','(-) COFINS','Registra o valor das deduções de impostos incidentes sobre as vendas de serviços referentes a COFINS.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.10.00','(-) CONTRIBUIÇÕES PREVIDÊNCIARIAS - INSS PATRONAL','Registra o valor da contribuição patronal devida pelas empresas que prestam exclusivamente serviços de tecnologia da informação (TI) e de tecnologia da informação e comunicação (TIC), incidentes sobre o valor da receita bruta, excluidas as vendas canceladas e os descontos incondicionais concedidos, conforme dispoe o artigo 7º da lei 12.546/2011. A presente metodologia de calculo do INSS patronal terá vigencia ate 31/12/2014.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.3.3.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','Registra o valor de outras deduções de vendas de serviços.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','Compreende o somatório das variações patrimoniais aumentativas com operações financeiras. Compreende: descontos obtidos, juros auferidos, prêmio de resgate de títulos e debêntures, entre outros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas provenientes de juros e encargos de empréstimos e financiamentos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.1.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.1.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.1.3.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.1.4.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.1.5.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.2.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.2.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.3.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.3.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.3.3.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.3.4.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.3.5.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.4.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.1.4.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','Compreende as variações patrimoniais aumentativas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação representando o resultado das aplicações impostas ao contribuinte.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.01.00','MULTAS E JUROS SOBRE IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.05.00','MULTAS E JUROS SOBRE IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.06.00','MULTAS E JUROS SOBRE ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.07.00','MULTAS E JUROS SOBRE ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.08.00','MULTAS E JUROS SOBRE ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.09.00','MULTAS E JUROS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.10.00','MULTAS E JUROS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.11.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.12.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.13.00','MULTAS E JUROS DEMAIS CONTRIBUIÇÕES','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.14.00','MULTAS E JUROS CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.15.00','MULTAS E JUROS CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.16.00','MULTAS E JUROS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores de multas e juros de dívida ativa tributária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.97.00','(-) DEDUÇÕES','Registra as deduções de juros e encargos de mora sobre créditos tributários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.4.1.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CRÉDITOS TRIBUTÁRIOS','Registra os juros e encargos de mora sobre outros créditos tributários.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.3.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.3.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.3.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nos moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.4.0.0.00.00','DESCONTOS FINANCEIROS OBTIDOS','Compreende a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.4.0.1.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.5.0.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','Compreende o valor total das variações patrimoniais aumentativas decorrentes da remuneração do saldo diário dos depósitos da União existentes no banco central, bem como aplicação de recursos da conta única de acordo com a rentabilidade media intrínseca dos títulos do Tesouro.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.5.1.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.5.1.1.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.5.2.0.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.5.2.1.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.4.9.0.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','Compreende o somatório das variações patrimoniais aumentativas com transferências inter governamentais, transferências intragovernamentais, transferências de instituições multigovernamentais, transferências de instituições privadas com ou sem fins lucrativos, transferências de convênios, transferências do exterior e execuções orçamentárias delegadas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repasse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse).Não Inclui o valor repassado para aportes no RPPS ou RGPS.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.2.01.00','COTA RECEBIDA','Registra o valor dos recursos recebidos pela administração direta decorrentes da programação financeira correspondente ao orçamento anual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.2.02.00','REPASSE RECEBIDO','Registra o valor dos recursos recebidos decorrentes de transferências financeiras entre órgãos da admistração direta e indireta, correspondentes ao orçamento anual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.2.04.00','RECURSOS ARRECADADOS - RECEBIDOS','Registra o valor recebido de outro órgão ou entidade referente aos recursos que foram arrecadados (classificados como receita) para pagamento de despesas na unidade recebedora.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA','Registra o valor dos recursos diferidos decorrentes do processo de baixa de recursos diferidos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','Registra os valores no processo de inscrição dos recursos diferidos, subdividindo-se em: cota e repasse diferidos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.0.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências, de bens ou valores, financeiras recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores, recebidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS RECEBIDAS','Registra o valor da ordem de transferência recebida - OTR a título de recursos vinculados que deverão permanecer na própria unidade beneficiada.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITO - SALDOS NÃO FINANCEIROS','Registra a apropriação da transferência de créditos internos entre órgãos correpondentes a saldos não financeiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITOS - SALDOS FINANCEIROS','Registra a apropriação da transferência de créditos internos entre órgãos correpondentes a saldos financeiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Registra o valor das demais transferências financeiras recebidas independentes da execução orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.00','TRANSFERÊNCIAS NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências recebidas de bens ou valores independentes da execução orçamentária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.01','TRANSFERÊNCIAS RECEBIDAS DE BENS IMÓVEIS','Registra o valor das transferências de bens imóveis entre unidades do mesmo órgão .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.02','DOAÇÕES RECEBIDAS DE BENS IMÓVEIS','Registra o valor das transferências de bens imóveis entre unidades entre UG de órgãos diferentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.03','TRANFERÊNCIAS RECEBIDAS DE BENS MÓVEIS','Registra o valor dos bens móveis recebidos pela UG do pais ou exterior decorrente de transferência de outra UG do mesmo órgão, independente de execução orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.04','DOAÇÕES RECEBIDAS DE BENS MÓVEIS','Registra o valor dos bens móveis recebidos de unidade localizada no pais ou no exterior por outra unidade, no pais ou no exterior, de órgãos diferentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','Registra o total dos títulos e valores em circulação recebidos por unidade decorrente de transferência de outra unidade da mesma gestão.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','Registra o recebimento de títulos da dívida ativa de uma UG para a PGFN ou orgão equivalente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Registra o valor das demais transferências recebidas de bens ou valores independentes da execução orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes, exceto os decorrentes de alíquota de contribuição suplementar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes exceto os decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.01.00','PLANO FINANCEIRO','Compreende o valor total dos valores recebidos pelo RPPS para cobertura de insuficiências financeiras, formação de reserva e outras necessidades financeiras, no âmbito do plano financeiro.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Registra os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pelo ente federativo ao RPPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','Registra o somatório do recebimento de eventuais aportes de recursos no RPPS para outras necessidades financeiras que não a cobertura de insuficiências financeiras e formação de reservas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','Compreende o valor total recebido pelo RPPS para cobertura de déficit financeiro ou atuarial e outros aportes, no âmbito do plano previdenciário.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','Registra o somatório dos recebimentos de recursos necessários ao equilíbrio financeiro do plano previdenciário, ou seja, à cobertura de déficit entre as receitas e despesas previdenciárias, referentes ao exercício atual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','Registra os recursos orçamentários alocados para cobertura de déficit atuarial no exercício de referência, desde que não definidos por lei como contribuições suplementares.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','Registra outros aportes financeiros para o RPPS com outras finalidades previdenciárias.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS','Compreende o valor das transferências recebidas para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS – INTRA OFSS','Compreende o valor das transferências recebidas para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Compreende os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','Registra o montante do orçamento da Seguridade Social realocado da Saúde ou da Assistência Social para a Previdência.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','Registra os valores das receitas do orçamento fiscal destinados para cobrir os déficits financeiros da Previdência.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pela União ao RGPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','Registra o somatório do recebimento de eventuais aportes de recursos para o RGPS para outras necessidades financeiras.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes de transferências da União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.0.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.1.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS- CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS – UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.02.00','COTA-PARTE FPM','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Fundo de Participação dos Municípios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.03.00','COTA-PARTE ITR','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto Territorial Rural.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.04.00','COTA-PARTE IPI','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto sobre Produtos Industrializados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.05.00','COTA-PARTE IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, OU RELATIVA A TÍTULOS OU VALORES MOBILIÁRIOS - COMERCIALIZAÇÃO DO OURO','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto sobre Operações de Crédito, Câmbio e Seguro ou relativa a títulos ou valores mobiliários - comercialização do ouro.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.06.00','TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Registra a variação patrimonial aumentativa decorrente da transferência da compensação financeira pela exploração dos recursos naturais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.07.00','TRANSFERÊNCIAS DE RECURSOS DO SUS','Registra a variação patrimonial aumentativa decorrente da transferência de recursos do SUS.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.08.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSITÊNCIA SOCIAL - FNAS','Registra a variação patrimonial aumentativa decorrente da transferência de recursos do Fundo Nacional de Assistência Social - FNAS.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.09.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE','Registra a variação patrimonial aumentativa decorrente da transferência de transferências de recursos do Fundo Nacional do Desenvolvimento da Educação - FNDE.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.10.00','TRANSFERÊNCIA FINANCEIRA DO ICMS DESONERAÇÃO - LC 87/96 (LEI KANDIR)','Registra a variação patrimonial aumentativa decorrente da transferência da transferência financeira do ICMS Desoneração - LC 87/1996 (Lei Kandir).','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.3.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DA UNIÃO','Registra as outras variações patrimoniais aumentativas decorrentes da transferência de receitas da União, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é da União.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.01.00','COTA-PARTE ICMS','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte de ICMS.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.02.00','COTA-PARTE IPVA','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte de IPVA.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.03.00','COTA-PARTE IPI-EXPORTAÇÃO','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte de IPI-Exportação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra o valor total das receitas recebidas pelos Municípios por meio de transferências constitucionais da contribuição de intervenção no domínio econômico (Emenda Constitucional nº 42, de 19/12/2003).','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.05.00','TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Registra o valor da arrecadação de receita com a transferência da cota-parte da compensação financeira proveniente da exploração de recursos naturais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE – REPASSE FUNDO A FUNDO','Registra o valor de receita da transferência de recursos do Sistema Único de Saúde oriundo do Fundo Estadual de Saúde para o Fundo Municipal de Saúde (Ações Básicas de Vigilância Sanitária, Atenção à Saúde dos Povos Indígenas, Programa de Assistência Farmacêutica Básica, Programa de Combate às Carências Nutricionais, Programa de Saúde da Família, Programa de Agentes Comunitários, Programa Nacional de Vigilância Epidemiológica e Controle de Doenças e outros).','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.1.4.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DOS ESTADOS','Registra as outras variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.2.0.00.00','TRANSFERÊNCIAS DO FUNDEB','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.2.3.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007, decorrentes de complementação da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.2.4.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.3.01.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.3.02.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.4.01.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.4.02.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.5.01.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.5.02.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas, inclusive de bens e valores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.1.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.1.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.1.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para convênios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.1.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para combate à fome.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.1.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Registra a variação patrimonial aumentativa decorrente de outras transferências financeiras das instituições privadas sem fins lucrativos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.2.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.2.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.2.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para convênios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.2.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para combate à fome.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.3.2.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Registra a variação patrimonial aumentativa decorrente de outras transferências financeiras das instituições privadas sem fins lucrativos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.4.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.4.0.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.4.0.1.01.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Transferências de Recursos do FUNDEB.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.4.0.1.02.00','TRANSFERÊNCIAS DE RECURSOS DA COMPLEMENTAÇÃO DO FUNDEB','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Transferências de Recursos da Complementação do FUNDEB.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.4.0.1.99.00','OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Outras Transferências Multigovernamentais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.5.0.0.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.5.0.1.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.6.0.0.00.00','TRANSFERÊNCIAS DO EXTERIOR','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.6.0.1.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.01.00','DIÁRIAS','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.3.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.01.00','DIÁRIAS','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.4.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.01.00','DIÁRIAS','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.1.5.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.01.00','DIÁRIAS','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.7.2.1.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.8.0.0.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.5.8.0.1.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.0.0.0.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS E DESINCORPORAÇÃO DE PASSIVOS','Compreende a variação patrimonial aumentativa com reavaliação e ganhos de ativos, bem como com a desincorporação de passivos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.0.0.00.00','REAVALIAÇÃO DE ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo, quando esse for superior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para máquinas, ferramentas, aparelhos, equipamentos, acessórios etc, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes paraequipamentos de processamento de dados e sistemas aplicativos, entre outros, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para mobiliário em geral e utensílios, entre outros, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para transportes aéreos, aquáticos e terrestres, entre outros, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis em andamento, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens permanentes a serem estocados em almoxarifado, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para armas que constituem objetos de defesa ou preparativos de guerra, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para demais bens móveis não classificados em grupos específicos, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens imóveis, quando esse for inferior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os valores de bens imóveis em andamento, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os demais bens imóveis não classificados anteriormente nesse plano de contas, quando esse for inferior ao valor liquido contábil.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.9.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.1.9.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.0.0.00.00','GANHOS COM ALIENAÇÃO','Compreende o ganho com alienação de ativos, ou seja, quando o valor alienado do ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.1.0.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.1.1.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.1.1.01.00','GANHOS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial aumentativa de ganhos com alienação de participações permanentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.1.1.02.00','GANHOS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial aumentativa de ganhos com alienação de propriedades para investimento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.1.1.03.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial aumentativa de ganhos com alienação de investimentos do RPPS de longo prazo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.1.1.99.00','GANHOS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial aumentativa de ganhos com alienação de demais investimentos permanentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.0.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Móveis.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.01','GANHO LÍQUIDO COM A ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Máquinas, Equipamentos e Ferramentas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.02','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS DE INFORMÁTICA','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens de Informática.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.03','GANHO LÍQUIDO COM A ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Móveis e Utensílios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.04','GANHO LÍQUIDO COM A ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Materiais Culturais, Educacionais e de Comunicação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.05','GANHO LÍQUIDO COM A ALIENAÇÃO DE VEÍCULOS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Veículos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.07','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Móveis em Andamento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.08','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Móveis em Almoxarifado.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.09','GANHO LÍQUIDO COM A ALIENAÇÃO DE ARMAMENTOS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Armamentos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.10','GANHO LÍQUIDO COM A ALIENAÇÃO DE SEMOVENTES','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Semoventes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.01.99','GANHO LÍQUIDO COM A ALIENAÇÃO DE DEMAIS BENS MÓVEIS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Demais Bens Móveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.02.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS IMÓVEIS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Imóveis.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.02.01','PRODUTO DE ALIENAÇÕES','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Produtos de Alienações.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.02.02','ALIENAÇÃO DE IMÓVEIS RURAIS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Alienação de Imóveis Rurais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.02.03','ALIENAÇÃO DE IMÓVEIS URBANOS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Alienação de Imóveis Urbanos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.02.99','ALIENAÇÃO DE OUTROS BENS IMÓVEIS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Alienação de Outros Bens Imóveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.97.00','(-) DEDUÇÃO DOS GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende as deduções dos ganho com alienação de ativo imobilizado - Dedução dos Ganhos com Alienação de Imobilizado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.97.01','(-) DEDUÇÃO ALIENAÇÃO DE BENS MÓVEIS','Registra as deduções dos ganho com alienação de ativo imobilizado - Dedução Alienação de Bens Móveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.2.1.97.02','(-) DEDUÇÃO ALIENAÇÃO DE BENS IMÓVEIS','Registra as deduções dos ganho com alienação de ativo imobilizado - Dedução Alienação de Bens Imóveis.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.3.0.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.3.1.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.3.1.01.00','GANHOS COM ALIENAÇÃO DE SOFTWARES','Registra a variação patrimonial aumentativa de ganhos com alienação de softwares.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.3.1.02.00','GANHOS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATENTES INDUSTRIAIS','Registra a variação patrimonial aumentativa de ganhos com alienação de marcas, direitos e patentes industriais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.2.3.1.03.00','GANHOS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial aumentativa de ganhos com alienação de direito de uso de imóveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.0.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de novos ativos descobertos, a contrapartida da incorporação de ativos semoventes nascidos, por exemplo.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.1.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.1.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.2.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.2.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.3.0.00.00','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','Compreende os ganhos  com a incorporação de valores apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.3.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','Compreende os ganhos  com a incorporação de ativos apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.9.0.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de outros novos ativos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.3.9.1.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','Compreende a contrapartida da incorporação de outros novos ativos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.4.0.0.00.00','DESINCORPORAÇÃO DE PASSIVOS','Compreende a contrapartida da desincorporação de passivos, inclusive as baixas de passivo decorrentes do cancelamento de restos a pagar.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.6.4.0.1.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','Compreende a contrapartida da desincorporação de passivos, inclusive as baixas de passivo decorrentes do cancelamento de restos a pagar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende o somatório das demais variações patrimoniais aumentativas não incluídas nos grupos anteriores, tais como: resultado positivo da equivalência patrimonial, dividendos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.1.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.1.0.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.1.0.1.01.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','Registra os valores referentes a variação patrimonial aumentativas de diversas fontes ou origens, que não tenham sido devidamente classificados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.1.0.1.99.00','(-) DEDUCOES DA VARIAÇÃO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','Registra os valores referentes às deduções das variação patrimonial aumentativa de diversas fontes ou origens, que não tenham sido devidamente classificados','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.0.0.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','Compreende o resultado positivo das participações de caráter permanente no capital social de sociedades investidas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.1.0.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.1.1.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.1.2.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.1.3.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.1.4.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.1.5.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.2.0.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.2.2.1.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.0.0.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões e ajustes de perdas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.0.00.00','REVERSÃO DE PROVISÕES','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.00.00','REVERSÃO DE PROVISÕES – CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.01.00','REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS','Registra a variação patrimonial aumentativa proveniente de reversão de provisão para riscos trabalhistas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.02.00','REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','Registra a variação patrimonial aumentativa proveniente de reversão de provisões matemáticas previdenciárias a longo prazo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.03.00','REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS','Registra a variação patrimonial aumentativa proveniente de reversão de provisões para riscos fiscais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.04.00','REVERSÃO DE PROVISÕES PARA RISCOS CÍVEIS','Registra a variação patrimonial aumentativa proveniente de reversão de provisão riscos cíveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.05.00','REVERSÃO DE PROVISÕES REPARTIÇÃO DE CRÉDITO','Registra a variação patrimonial aumentativa proveniente de reversão de provisões por repartição de crédito.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.06.00','REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP','Registra a variação patrimonial aumentativa proveniente de reversão de provisões decorrentes de contratos de PPP.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.1.99.00','REVERSÃO DE OUTRAS PROVISÕES','Registra a variação patrimonial aumentativa proveniente de reversão de outras provisões.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.3.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.4.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - ESTADOS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.1.5.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - MUNICÍPIOS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.0.00.00','REVERSÃO DE AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.1.00.00','REVERSÃO DE AJUSTES DE PERDAS – CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.1.01.00','REVERSÃO DE AJUSTES DE PERDAS DE CRÉDITOS','Registra a variação patrimonial aumentativa proveniente de reversão de ajustes de perdas de créditos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.1.02.00','REVERSÃO DE AJUSTES DE PERDAS DE ESTOQUES','Registra a variação patrimonial aumentativa proveniente de reversão de ajustes de perdas de estoques.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.1.03.00','REVERSÃO DE AJUSTES DE INVESTIMENTOS E APLICAÇÕES','Registra a variação patrimonial aumentativa proveniente de reversão de ajustes de investimentos e aplicações.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.2.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.3.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – UNIÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.4.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – ESTADO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.7.2.5.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende outras variações patrimoniais aumentativas não classificadas em itens específicos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.4.0.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.4.1.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.4.2.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.4.3.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.4.4.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.4.5.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e município.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.5.0.00.00','MULTAS ADMINISTRATIVAS','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.5.1.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.0.00.00','INDENIZAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.1.00.00','INDENIZAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.1.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PÚBLICO','Registra a variação patrimonial aumentativa proveniente de indenizações por danos causados ao patrimônio público.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.1.02.00','INDENIZAÇÃO POR PERDA/QUEBRA DE MERCADORIAS','Registra a variação patrimonial aumentativa proveniente de indenização por perda/quebra de mercadorias.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.1.03.00','INDENIZ. POSSE OU OCUPAÇÃO ILIC. BENS','Registra a variação patrimonial aumentativa proveniente de indenização por posse ou ocupação ilícita de bens.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.1.04.00','REPOSIÇÃO/INDENIZAÇÃO DE SERVIDORES/AGENTES PÚBLICOS','Registra a variação patrimonial aumentativa proveniente de reposição ou indenização por parte de servidores ou agentes públicos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.6.1.99.00','OUTRAS INDENIZAÇÕES','Registra a variação patrimonial aumentativa proveniente de outras indenizações.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.0.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.1.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.1.01.00','VPA DE LEILÕES DE MERCADORIAS APREENDIDAS','Registra as variações patrimoniais aumentativas geradas pela alienação em leilões de mercadorias apreendidas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.1.02.00','VPA DE ALIENAÇÃO DE BENS APREENDIDOS','Registra as variações patrimoniais aumentativas geradas pela alienação de bens apreendidos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.1.03.00','VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS','Registra as variações patrimoniais aumentativas geradas pela alienação de bens apreendidos por tráfico ilícito de entorpecentes, drogas e afins.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.1.70.00','RECEITA DE ALIENAÇÃO DE BENS CAUCIONADOS','Registra as variações patrimoniais aumentativas geradas pela alienação de bens caucionados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.7.1.99.00','OUTRAS VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Registra as demais variações patrimoniais aumentativas geradas pela alienação de bens apreendidos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'4.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.0.0.0.0.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registrar os atos e fatos ligados a execução orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.0.0.0.00.00','PLANEJAMENTO APROVADO','Compreende o somatório dos valores monetários previstos para execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.1.0.0.00.00','PPA - APROVADO','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.1.1.0.00.00','APROVAÇÃO INICIAL DO PPA','Registra os valores monetários previstos inicialmente para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.1.2.0.00.00','REVISÃO DO PPA','Registra o somatório dos valores monetários das revisões anuais autorizadas durante o período de vigência do plano plurianual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.0.0.00.00','PLOA','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no projeto de lei orçamentária anual.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.1.0.00.00','PROJETO INICIAL DA LEI ORÇAMENTÁRIA - RECEITA','Compreende o somatório dos valores monetários constantes do projeto da Lei orçamentária anual remetido pelo poder executivo ao poder legislativo para apreciação e aprovação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.1.1.00.00','PLOA INICIAL DA RECEITA','Registra o somatório dos valores monetários da previsão de receita constante do PLOA inicial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.1.2.00.00','ALTERAÇÕES DO PROJETO INICIAL DA LOA - RECEITA','Registra o somatório das alterações no projeto inicial da loa em relação a receita.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.2.0.00.00','PROJETO INICIAL DA LOA - DESPESA','Compreende o somatório dos valores monetários constantes do projeto da Lei orçamentária anual remetido pelo poder executivo ao poder legislativo para apreciação e aprovação.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.2.1.00.00','PLOA INICIAL DA DESPESA','Registra o somatório dos valores monetários da fixação da despesa constante do PLOA inicial.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.1.2.2.2.00.00','ALTERAÇÕES DO PROJETO INICIAL DA LOA - DESPESA','Registra o somatório das alterações no projeto inicial da loa em relação a despesa.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.0.0.0.00.00','ORÇAMENTO APROVADO','Compreende o somatório dos valores relativos à previsão da receita, fixação da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.0.0.00.00','PREVISÃO DA RECEITA','Compreende o somatório dos valores relativos à previsão da receita pública aprovada pela lei orçamentária anual e suas alterações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.0.00.00','PREVISÃO INICIAL DA RECEITA','Compreende o valor da receita previsão inicial da receita aprovado na LOA.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.1.00.00','PREVISÃO INICIAL DA RECEITA BRUTA','Registra a previsão inicial da receita bruta aprovada na LOA.','D','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.2.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','Compreende a previsão de deduções da receita bruta aprovada na LOA.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.2.01.00','(-) DEDUÇÕES POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','Compreende a previsão de dedução da receita aprovada na LOA por transferências constitucionais e legais.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.2.01.01','(-) FUNDEB','Registra a previsão de dedução da receita aprovada na LOA por transferências ao FUNDEB.','C','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.2.02.00','(-) RENÚNCIA','Registra a previsão de renúncia da receita aprovada na LOA.','C','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.1.2.99.00','(-) OUTRAS DEDUÇÕES','Registra a previsão de outras deduções da receita aprovada na LOA.','C','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.2.0.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','Compreende o valor dos créditos previstos após a aprovação do orçamento independente da autorização já concedida na lei orçamentária para abertura de credito suplementar.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.2.1.00.00','PREVISÃO ADICIONAL DA RECEITA','Compreende o valor adicional da receita para abertura de créditos adicionais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.2.1.01.00','REESTIMATIVA','Registra o valor adicional da receita para abertura de créditos adicionais por motivo de reestimativa da receita.','D','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.2.1.02.00','CORREÇÃO','Registra o valor adicional da receita para abertura de créditos adicionais por motivo de correção de erros ou omissões na estimativa da receita.','D','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.1.2.9.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','Registra o valor da anulação da receita prevista no orçamento, na gestão fundos e nas administrações direta e indireta.','C','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.0.0.00.00','FIXAÇÃO DA DESPESA','Compreende o somatório dos valores relativos à fixação da despesa pública aprovada pela lei orçamentária e suas alterações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.0.00.00','DOTAÇÃO ORÇAMENTÁRIA','Compreende o somatório dos valores monetários da dotação orçamentária inicial, adicional e seus cancelamentos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.1.00.00','DOTAÇÃO INICIAL','Compreende a dotação inicial autorizada na lei orçamentária anual.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.1.01.00','CRÉDITO INICIAL','Registra os valores pertinentes aos créditos inicialmente aprovados para dar suporte a execução orçamentária.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.1.02.00','CRÉDITOS ANTECIPADOS - LDO','Compreende os valores relativos às antecipações de créditos determinados pela Lei de diretrizes orçamentárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.1.02.01','ANTECIPAÇÃO - LDO','Registra os valores pertinentes aos créditos antecipados pela Lei de diretrizes orçamentárias até que o orçamento seja aprovado.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.1.02.09','(-) ANULAÇÃO DA ANTECIPAÇÃO - LDO','Registra o valor referente ao cancelamento de dotação antecipada prevista na Lei de diretrizes orçamentárias - LDO, após aprovação do orçamento.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CRÉDITO','Compreende o somatório dos valores monetários da dotação orçamentária decorrentes da abertura de créditos adicionais e seus cancelamentos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.01.00','CRÉDITO ADICIONAL – SUPLEMENTAR','Registra o somatório dos valores relativos aos créditos adicionais suplementares com vista ao reforço da dotação orçamentária constante da lei orçamentária.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.02.00','CRÉDITO ADICIONAL - ESPECIAL','Compreende o somatório dos valores dos créditos adicionais especiais destinados a atender programas não contemplados na lei orçamentária anual.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.02.01','CRÉDITOS ESPECIAIS ABERTOS','Registra os valores referentes à abertura de créditos especiais autorizados em lei especifica.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.02.02','CRÉDITOS ESPECIAIS REABERTOS','Registra os valores referentes à reabertura de créditos especiais cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.02.03','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos especiais reabertos nos termos do § 2º do art. 167 da C.F./88.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.03.00','CRÉDITO ADICIONAL – EXTRAORDINÁRIO','Compreende o somatório dos valores referentes à abertura de créditos adicionais extraordinários destinados a despesas imprevisíveis e urgentes como as decorrentes de guerra, comoção interna ou calamidade pública.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.03.01','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','Registra os valores referentes aos créditos extraordinários abertos por decreto do poder executivo.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.03.02','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','Registra os valores referentes à reabertura de créditos extraordinários cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.2.03.03','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos extraordinários reabertos nos termos do § 2º do art. 168 da C.F./88.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.00.00','DOTAÇÃO ADICIONAL POR FONTE','Compreende o somatório dos valores da dotação adicional por fonte de recursos para abertura do credito adicional.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.01.00','SUPERÁVIT FINANCEIRO DE EXERCÍCIO ANTERIOR','Registra os valores pertinentes aos créditos adicionais abertos cuja origem de recursos seja superavit financeiro apurado no balanco patrimonial do exercício anterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.02.00','EXCESSO DE ARRECADAÇÃO','Registra os valores pertinentes aos créditos adicionais abertos cuja origem de recursos seja excesso de arrecadação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.03.00','ANULAÇÃO DE DOTACAO','Registra os valores pertinentes aos créditos adicionais abertos cuja origem de recursos seja a anulação parcial ou total de dotações orçamentárias ou créditos adicionais, autorizados em lei.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.04.00','OPERAÇÕES DE CRÉDITO','Registra os valores pertinentes aos créditos adicionais abertos cuja origem de recursos seja operações de crédito autorizadas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.05.00','RESERVA DE CONTINGÊNCIA','Registra os valores pertinentes aos créditos adicionais abertos cuja origem de recursos seja a reserva de contingência.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.06.00','DOTACAO TRANSFERIDA','Registra os valores de alterações da Lei orçamentária com controle por origem de crédito.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.07.00','RECURSOS SEM DESPESAS CORRESPONDENTES','Registra os valores pertinentes aos créditos adicionais abertos cuja origem de recursos seja os recursos que, em decorrência de veto, emenda ou rejeição do projeto de Lei orçamentária anual, ficarem sem despesas correspondentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.09.00','(-) CANCELAMENTO DE DOTAÇÕES','Registra o cancelamento / remanejamento de dotações para abertura de créditos adicionais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.3.99.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','Registra o valor da contrapartida dos lançamentos das dotações adicionais por origem de crédito.','X','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','Compreende o somatório dos valores relativos aos créditos inicial, suplementar, especial e extraordinário cancelados ou remanejados, em casos regularmente previstos.','X','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.01.00','ALTERAÇÃO DO QUADRO DE DETALHAMENTO DA DESPESA','Compreende a movimentação dos créditos por acréscimo ou redução decorrente de alteração do quadro de detalhamento de despesas - QDD (elemento de despesa).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.01.01','ACRÉSCIMO','Registra a movimentação dos créditos por acréscimo decorrente de alteração do quadro de detalhamento de despesas - QDD.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.01.09','(-)REDUÇÃO','Registra a movimentação dos créditos por redução decorrente de alteração do quadro de detalhamento de despesas - QDD.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.02.00','ALTERAÇÃO DA LEI ORÇAMENTÁRIA','Compreende as alterações na Lei orçamentária, inclusive as decorrentes de transposição, remanejamento e transferência de dotações orcamentárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.02.01','ACRÉSCIMO','Registra os valores dos acréscimos resultantes de alterações da Lei orçamentária em virtude de remanejamento.','D','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.02.09','(-)REDUÇÃO','Registra o valor da redução da dotação devido a alteração da Lei orçamentária em virtude de remanejamento.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.1.9.04.00','(-)CANCELAMENTO DE DOTAÇÕES','Registra o valor da redução da dotação devido a alteração da Lei orçamentária em virtude de cancelamento.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','Compreende o somatório dos valores dos recebimentos de créditos orçamentários através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, recebidos ao longo do exercício.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.1.01.00','PROVISÃO RECEBIDA','Registra a parcela de crédito recebida por uma unidade administrativa ou orçamentária, decorrente da descentralização do crédito orçamentário ou adicional, dentro do próprio ministério ou órgão.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.1.02.00','PROVISÃO RECEBIDA - BLOQUEADA','Registra a parcela de créditos orçamentários recebidos mediante provisão e posteriormente bloqueados, em hipóteses especiais, pela unidade concedente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.1.09.00','ALTERAÇÃO DE CRÉDITOS MOVIMENTADOS','Compreende o valor da movimentação de créditos orçamentários por acréscimo ou redução decorrente de alteração do quadro de detalhamento de despesa - QDD, por UG pertencente ao órgão ou entidade da unidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.1.09.01','ACRÉSCIMO','Registra o valor da movimentação de créditos orçamentários por acréscimo decorrente de alteração do quadro de detalhamento de despesa - QDD.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.1.09.09','(-) REDUÇÃO','Registra o valor da movimentação de créditos orçamentários por redução decorrente de alteração do quadro de detalhamento de despesa - QDD.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional recebido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.01.00','ADMINISTRAÇÃO DIRETA','Compreende o valor referente a movimentação de créditos decorrentes de recebimento ou de transferência de outros órgãos e entidades de igual ou de diferente unidade orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.01.01','CRÉDITOS RECEBIDOS','Registra o valor dos créditos recebidos pela administração direta de outros órgãos e entidades.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.01.09','(-) CRÉDITOS TRANSFERIDOS','Registra a movimentação de créditos de entidades da administração indireta ou entre órgãos da administração direta de unidade orçamentária diferente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.02.00','ADMINISTRAÇÃO INDIRETA','Compreende o valor referente a movimentação de créditos decorrentes de recebimento ou de transferência de outros órgãos e entidades de igual ou de diferente unidade orçamentária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.02.01','CRÉDITOS RECEBIDOS','Registra o valor dos créditos recebidos pela administração indireta de mesma ou de diferente unidade orçamentária do órgão emitente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.02.09','(-) CRÉDITOS TRANSFERIDOS','Registra a movimentação de créditos de órgãos da administração direta ou entre entidades da administração indireta de mesma ou de diferente unidade orçamentária, não formalizada a termo de contrato.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.09.00','ALTERAÇÃO DE CRÉDITOS MOVIMENTADOS','Compreende o valor da alteração de créditos orçamentários por acréscimo ou redução do quadro de detalhamento de despesa - qdd, por UG não pertencente ao órgão ou entidade da unidade.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.09.01','ACRÉSCIMO','Registra o valor do acréscimo de crédito disponível por alteração do quadro de detalhamento de despesa-qdd, por UG não pertencente ao órgão ou entidade da unidade orçamentária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.2.09.09','(-) REDUÇÃO','Registra o valor da redução do crédito disponível por alteração do quadro de detalhamento de despesa-qdd, por UG não pertencente ao órgão ou entidade da unidade orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos recebidos por cisão, fusão, extinção, compensação e outras transações.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.9.01.00','CRÉDITOS EXT. RECEB. POR FUSÃO/CISÃO/EXTINÇÃO','Registra o valor dos créditos recebidos por descentralização externa decorrentes de fusão, cisão ou extinção de órgãos, entidades ou UG''s durante o exercício.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.2.9.02.00','CRÉDITOS INT. RECEB. POR FUSÃO/CISÃO/EXTINÇÃO','Registra o valor dos créditos recebidos por descentralização interna decorrentes de fusão, cisão ou extinção de órgãos, entidades ou UG''s durante o exercício.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.3.0.00.00','DETALHAMENTO DE CRÉDITO','Compreende o somatório relativos às dotações detalhadas relativas a cada ação orçamentária (projeto, atividade ou operações especiais).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.3.1.00.00','CRÉDITOS A DETALHAR','Registra o valor dos créditos a detalhar.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores das despesas pré-empenhadas e empenhadas por detalhamento específico.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.1.00.00','PRÉ-EMPENHOS DA DESPESA','Compreende o crédito orçamentário pré-empenhado, para atender objetivo específico, nos casos em que a despesa a ser realizada, por suas características, exige um intervalo de tempo desde a decisão da realização da despesa ate a efetivação da emissão de NE.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.1.01.00','PRÉ-EMPENHOS EMITIDOS','Registra os valores dos pré-empenhos emitidos pela própria unidade gestora detentora pelo crédito disponível.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.1.02.00','REFORÇO DE PRÉ-EMPENHO','Registra os valores de reforço de pré-empenho emitido pela própria unidade detentora do crédito disponível.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.1.03.00','(-)ANULAÇÃO DE PRÉ-EMPENHO','Registra a anulação de pré-empenho emitido pela própria unidade detentora do crédito disponível.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.2.00.00','EMPENHOS POR EMISSÃO','Compreende o somatório dos valores de empenho emitido por ato emanado de autoridade competente que cria para o poder público a obrigação de pagar as despesas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.2.01.00','EXECUÇÃO DA DESPESA POR NOTA DE EMPENHO','Compreende os valores executados da despesa, detalhados por nota de empenho.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.2.01.01','EMISSÃO DE EMPENHOS','Registra o valor da emissão de empenho da despesa, inclusive referente àquela despesa que já se encontra pré-empenhada.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.2.01.02','REFORÇO DE EMPENHOS','Registra o valor da emissão de nota de empenho de despesa visando suplementar o anterior cujo valor seja insuficiente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.2.01.03','(-)ANULAÇÃO DE EMPENHOS','Registra o valor referente a reversão total ou parcial de despesa à dotação inicial correspondente, através da "nota de anulação" da NE.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.2.2.9.2.01.04','(-)CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','Registra o cancelamento de empenhos por falta de disponibilidade de caixa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.0.0.0.00.00','INSCRIÇÃO DE RESTOS A PAGAR','Compreende o somatório relativo ao valor da inscrição das despesas empenhadas e não pagas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.1.0.0.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.1.1.0.00.00','RP NÃO PROCESSADOS INSCRITOS','Registra os valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas até o ultimo dia do exercício financeiro imediatamente anterior.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.1.2.0.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra o valor de restos a pagar não processados relativo a exercícios anteriores que não foram cancelados porque tiveram seu prazo de validade prorrogado.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.1.3.0.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','Registra o valor por restabelecimento de empenho de restos a pagar já cancelados em exercícios anteriores com base em ato normativo específico.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.1.6.0.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar não processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 531100000.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.2.0.0.00.00','INSCRIÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar processados.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.2.1.0.00.00','RP PROCESSADOS - INSCRITOS','Registra o somatório dos valores inscritos em restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro em que foi empenhado.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.2.2.0.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra os valores de restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro subseqüente.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.2.6.0.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'5.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 532100000.','D','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.0.0.0.0.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registra os atos e fatos ligados a execução orçamentária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.0.0.0.00.00','EXECUÇÃO DO PLANEJAMENTO','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.1.0.0.00.00','EXECUÇÃO DO PPA','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.1.1.0.00.00','PPA A ALOCAR EM LEIS ORÇAMENTÁRIAS ANUAIS','Registra o somatório dos valores monetários do plano plurianual durante o seu período de vigência, detalhado por programas de trabalho a serem selecionados na elaboracao das leis orçamentárias anuais, nos quatro anos do PPA.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.1.2.0.00.00','PPA ALOCADO EM LEIS ORÇAMENTÁRIAS ANUAIS','Registra o somatório dos valores monetários do plano plurianual aprovado, detalhado por programa de trabalho, alocado nas leis orçamentárias anuais ou relativos aos valores dos créditos antecipados pela LDO, dentro do período de vigência do PPA.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.1.3.0.00.00','PPA EXECUTADO','Registra o somatório dos valores monetários empenhados do plano plurianual no seu período de vigência, detalhado por programa de trabalho, autorizado nas leis orçamentárias anuais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.2.0.0.00.00','EXECUÇÃO DO PLOA','Compreende o somatório dos valores monetários de receitas e despesas previstos no projeto de lei orçamentária durante as suas fases de tramitação.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.2.1.0.00.00','PROCESSAMENTO DO PLOA -RECEITA','Registra o somatório dos valores monetários das receitas previstas no projeto de Lei orçamentária durante as suas fases de tramitação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.1.2.2.0.00.00','PROCESSAMENTO DO PLOA -DESPESA','Registra o somatório dos valores monetários fixados para as despesas no projeto de Lei orçamentária durante as suas fases de tramitação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.0.0.0.00.00','EXECUÇÃO DO ORÇAMENTO','Compreende o somatório dos valores relativos à realização da receita, execução da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.0.0.00.00','EXECUÇÃO DA RECEITA','Compreende o somatório dos valores relativos à realização da receita pública aprovada pela lei orçamentária anual e suas alterações.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.1.0.00.00','RECEITA A REALIZAR','Registra o somatório dos valores relativos à receita pública aprovada pela lei orçamentária anual e suas alterações, detalhada por natureza da receita.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.2.0.00.00','RECEITA REALIZADA','Registra o somatório dos valores relativos às receitas realizadas, detalhada por natureza de receita.','C','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.3.0.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','Compreende o somatório dos valores relativos às deduções de receitas realizadas (devoluções, restituições, e outras), detalhada por natureza de receita.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.3.1.00.00','(-) DEDUÇÕES POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','Compreende o somatório dos valores relativos às deduções de receitas realizadas por transferências constitucionais e legais, detalhada por natureza de receita.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.3.1.01.00','(-) FUNDEB','Registra o somatório dos valores relativos às deduções de receitas realizadas por transferências ao FUNDEB.','D','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.3.2.00.00','(-) RENÚNCIA','Registra o somatório dos valores relativos às deduções de receitas realizadas por renúncia, detalhada por natureza de receita.','D','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.1.3.4.00.00','(-) OUTRAS DEDUÇÕES DA RECEITA REALIZADA','Registra o somatório dos valores relativos às outras deduções de receitas realizadas, detalhada por natureza de receita.','D','S','','',3);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.0.0.00.00','EXECUÇÃO DA DESPESA','Compreende o somatório da disponibilidade de credito orçamentário e da execução da despesa em suas diversas etapas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.0.00.00','DISPONIBILIDADES DE CRÉDITO','Compreende o somatório da disponibilidade de credito orçamentário e suas alterações.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.1.00.00','CRÉDITO DISPONÍVEL','Registra o valor da disponibilidade de credito referente à dotação inicial e adicional aprovada no orçamento geral da União na loa ou lei especifica ou antecipada pela lei de diretrizes orçamentárias - LDO.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.2.00.00','CRÉDITO INDISPONÍVEL','Compreende o valor da indisponibilidade de credito orçamentário pelo seu contingenciamento ou liberação pendentes de autorização legislativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.2.01.00','BLOQUEIO DE CRÉDITO','Registra o valor da disponibilidade de créditos orçamentários por contenção ou contingenciamento pela setorial orçamentária, sof e outros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.2.02.00','CRÉDITO PRÉ-EMPENHADO','Registra os valores dos pré-empenhos emitidos pela unidade ou por outra unidade gestora.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.2.99.00','OUTRAS INDISPONIBILIDADES','Registra o valor das indisponibilidades de créditos orçamentários de natureza eventual, para as quais não há contas específicas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.00.00','CRÉDITO UTILIZADO','Compreende o somatório dos valores referentes aos créditos orçamentários empenhados.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.01.00','CRÉDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.02.00','CRÉDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.03.00','CRÉDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.04.00','CRÉDITO EMPENHADO LIQUIDADO PAGO','Registra o valor da despesa empenhada liquidada paga.','C','S','','',2);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.05.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS','Registra o montante dos valores a liquidar inscritos em restos a pagar não processados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.06.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS','Registra o montante dos valores em liquidação inscritos em restos a pagar não processados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.07.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','Registra o montante dos valores liquidados inscritos em restos a pagar processados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.1.3.99.00','(-) OUTROS CRÉDITOS UTILIZADOS','Registra o somatório dos demais valores referentes aos créditos orçamentários empenhados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','Compreende o somatório dos valores dos créditos orçamentários concedidos através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, concedidos ao longo do exercício.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.1.01.00','PROVISÃO CONCEDIDA','Registra o crédito concedido pela unidade orçamentária a partir de sua própria dotação ou de um destaque a seu favor, para unidade administrativa ou orçamentária, no âmbito do próprio ministério ou órgão.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.1.02.00','PROVISÃO CONCEDIDA - BLOQUEADA','Registra o bloqueio dos créditos orçamentários concedidos mediante provisão.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.1.09.00','ALTERAÇÃO DE CRÉDITOS MOVIMENTADOS','Compreende o valor da variação de créditos orçamentários disponíveis por acréscimo ou redução do quadro de detalhamento de despesa, por UG pertencente ao órgão ou entidade da unidade orçamentária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.1.09.01','ACRÉSCIMO','Registra o valor do acréscimo de crédito disponível decorrente de alteração do quadro de detalhamento de despesa - qdd, por UG pertencente ao órgão ou entidade da unidade orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.1.09.09','(-) REDUÇÃO','Registra o valor da redução de crédito disponível decorrente de alteração do quadro de detalhamento de despesa, por UG pertencente ao órgão ou entidade da unidade orçamentária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional concedido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.01.00','ADMINISTRAÇÃO DIRETA','Compreende o valor referente ao movimento de créditos decorrentes de concessão pela unidade orçamentária do órgão da administração direta transferidora.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.01.01','CRÉDITOS CONCEDIDOS','Registra o valor referente a movimentação de créditos decorrentes de concessão pela unidade orçamentária do órgão da administração direta transferidora.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.02.00','ADMINISTRAÇÃO INDIRETA','Compreende o valor referente ao movimento de créditos decorrentes de concessão pela unidade orçamentária da entidade da administração indireta transferidora.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.02.01','CRÉDITOS CONCEDIDOS','Registra o valor referente a movimentação de créditos decorrentes de sua concessão pela unidade orçamentária do órgão da administração indireta transferidora.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.09.00','ALTERAÇÃO DE CRÉDITOS MOVIMENTADOS','Compreende o valor da variação de créditos orçamentários disponíveis por acréscimo ou redução do quadro de detalhamento de despesa, por UG não pertencente ao órgão ou entidade da unidade orçamentária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.09.01','ACRÉSCIMO','Registra o valor do acréscimo de crédito disponível decorrente de alteração do quadro de detalhamento de despesa - qdd, por UG não pertencente ao órgão ou entidade da unidade orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.2.09.09','(-) REDUÇÃO','Registra o valor da redução de crédito disponível decorrente de alteração do quadro de detalhamento de despesa, por UG não pertencente ao órgão ou entidade da unidade orçamentária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Registra as movimentações de créditos concedidos por cisão, fusão, extinção, compensação e outras transações.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.3.0.00.00','DETALHAMENTO DE CRÉDITO','Compreende o detalhamento das dotações orçamentárias relativas a cada programa de trabalho.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.3.1.00.00','CRÉDITOS DETALHADOS','Registra o valor dos créditos detalhados por fonte de recursos, UG responsável e natureza de despesa (elemento de despesa e / ou modalidade de aplicação).','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores executados das despesas pré-empenhadas e empenhadas por detalhamento específico.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.1.00.00','DESPESA PRÉ-EMPENHADA','Compreende o somatório dos valores executados das despesas pré-empenhadas pela própria unidade gestora, transferidos ou recebidos por transferência, por detalhamento específico e suas respectivas anulações.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.1.01.00','PRÉ-EMPENHOS A EMPENHAR','Registra os valores dos pré-empenhos emitidos e/ou seus respectivos reforços .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.1.02.00','PRÉ-EMPENHOS EMPENHADOS','Registra os valores dos pré-empenhos e/ou seus respectivos reforcos, emitidos e empenhados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.2.00.00','EMISSÃO DE EMPENHO','Compreende o somatório dos valores executados das despesas empenhadas por detalhamento específico.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.2.01.00','EMPENHOS POR NOTA DE EMPENHO','Compreende o valor da emissão de documentos através dos quais são registrados os estágios das despesas orçamentárias realizadas pela administração pública.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.2.01.01','EMPENHOS A LIQUIDAR','Registra o valor dos empenhos de despesas pendentes de liquidação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.2.01.02','EMPENHOS EM LIQUIDAÇÃO','Registra o somatório das despesas cujo fato gerador tenha ocorrido, tendo iniciado e não concluído o processo de liquidação da despesa orçamentária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.2.01.03','EMPENHOS LIQUIDADOS A PAGAR','Registra o valor dos empenhos após verificação do direito adquirido pelo credor ou entidade beneficiária.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.2.2.9.2.01.04','EMPENHOS LIQUIDADOS PAGOS','Registra o montante dos valores pagos, controlados por nota de empenho e subitem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.0.0.0.00.00','EXECUÇÃO DE RESTOS A PAGAR','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas e não pagas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.0.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.1.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.2.0.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.3.0.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.4.0.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.5.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.6.0.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Compreende o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.7.1.00.00','RP NAO PROCESSADOS A LIQUIDAR- INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas a liquidar inscritas no exercício como restos a pagar não processados, a ser transferido para o exercício seguinte para a conta 631100000.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.7.2.00.00','RP NAO PROCESSADOS EM LIQUIDACAO - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas em liquidação inscritas no exercício como restos a pagar não processados, a ser transferido para o exercício seguinte para a conta 631200000.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.9.0.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.9.1.00.00','CANCELAMENTOS POR INSUFICIÊNCIA DE RECURSOS','Registra o valor dos restos a pagar não processados cancelados nos exercícios subsequentes ao da sua inscrição por insuficiência de recursos financeiros.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.1.9.9.00.00','OUTROS CANCELAMENTOS DE RP','Registra o valor dos restos a pagar não processados cancelados nos exercícios subsequentes ao da sua inscrição, exceto os cancelados por insuficiência de recursos financeiros.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.0.0.00.00','EXECUÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.1.0.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.2.0.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.6.0.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.9.0.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.9.1.00.00','POR VALORES E/OU INSCRIÇÕES INDEVIDAS','Registra o valor dos restos a pagar processados cancelados nos exercícios subsequentes ao da sua inscrição por valores e/ou inscrições.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'6.3.2.9.9.00.00','OUTROS CANCELAMENTOS DE RP','Registra o valor dos restos a pagar processados cancelados nos exercícios subsequentes ao da sua inscrição, exceto os cancelados por insuficiência de recursos financeiros ou por inscrição indevida.','C','S','','',5);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.0.0.0.0.00.00','CONTROLES DEVEDORES','Compreende as contas em que são registrados atos potenciais e controles específicos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.0.0.0.00.00','ATOS POTENCIAIS','Compreende contas relacionadas às situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.0.0.00.00','ATOS POTENCIAIS ATIVOS','Compreende os atos e fatos que possam vir a aumentar o ativo da entidade governamental.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.0.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas recebidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','Compreende o valor recebido de compromisso de adimplência de obrigação financeira ou contratual, no país. compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.00','GARANTIAS RECEBIDAS NO PAÍS','Compreende o valor recebido de compromisso de adimplência de obrigação financeira ou contratual, no país.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.01','AVAIS','Registra o valor da garantia de pagamento de título de crédito exclusivamente, de natureza pessoal, dada por terceiros, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.02','FIANÇAS','Registra o valor da obrigação acessória recebida no país, por órgãos e entidades, pelo cumprimento da obrigação do devedor, caso esse não cumpra.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.03','HIPOTECAS','Registra o total das garantias de valores por hipotecas recebidas no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.04','SEGUROS-GARANTIA','Registra a garantia de valores por seguros recebidos no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.05','CAUÇÕES','Registra a responsabilidade da unidade por títulos, valores e bens recebidos em cauções no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor referente a garantias recebidas na forma prevista em Lei específica, no país e no exterior. Esta categoria inclui as garantias ou riscos assumidos em operações realizadas no âmbito de fundos, programas e operações especiais, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.07','GARANTIAS DA DÍVIDA PÚBLICA','Registra o total das garantias recebidas da dívida pública, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.08','APÓLICES DE SEGUROS','Registra os valores relativos a garantia oferecida por seguradoras na cobertura do ativo da unidade em casos de sinistros, acidentes etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.01.99','OUTRAS GARANTIAS RECEBIDAS NO PAÍS','Registra o valor de outras garantias recebidas, não incluídas nos itens anteriores, sobre obrigações contraídas no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','Compreende o valor recebido de compromisso de adimplência de obrigação financeira ou contratual, no exterior.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.01','AVAIS','Registra o valor da garantia de pagamento de título de crédito exclusivamente, de natureza pessoal, dada por terceiros, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.02','FIANÇAS','Registra o valor da obrigação acessória recebida por órgãos e entidades pelo cumprimento da obrigação do devedor, caso esse não cumpra, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.03','HIPOTECAS','Registra o total das garantias de valores por hipotecas recebidas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.04','SEGUROS-GARANTIA','Registra a garantia de valores por seguros recebidos no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.05','CAUÇÕES','Registra a responsabilidade da unidade por títulos, valores e bens recebidos em cauções no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor referente a garantias recebidas na forma prevista em Lei específica, no país e no exterior. Esta categoria inclui as garantias ou riscos assumidos em operações realizadas no âmbito de fundos, programas e operações especiais, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.07','GARANTIAS DA DÍVIDA PÚBLICA','Registra o total das garantias recebidas da dívida pública, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.08','APÓLICES DE SEGUROS','Registra os valores relativos a garantia oferecida por seguradoras na cobertura do ativo da unidade em casos de sinistros, acidentes etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','Registra o valor de outras garantias recebidas, não incluídas nos itens anteriores, sobre obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.03.00','CONTRAGARANTIAS RECEBIDAS NO PAÍS','Compreende o valor das contragarantias recebidas referentes às concessões de garantias concedidas sobre obrigações contraídas no pais.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.03.01','AVAIS','Registra o valor das contragarantias recebidas decorrentes das concessões de avais por obrigações contraídas, no pais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.03.02','FIANÇAS','Registra o valor das contragarantias recebidas terceiros decorrentes das concessões de fianças avais por obrigações contraídas, no pais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor das contragarantias recebidas decorrentes das concessões de fianças avais por obrigações contraídas no pais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','Registra o valor de outras contragarantias recebidas, não incluidas nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','Compreende o valor das contragarantias recebidas referentes às concessões de garantias concedidas sobre obrigações contraídas no exterior.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.04.01','AVAIS','Registra o valor das contragarantias recebidas decorrentes das concessões de avais por obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.04.02','FIANÇAS','Registra o valor das contragarantias recebidas decorrentes das concessões de fianças por obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor das contragarantias recebidas em virtude de garantias instituídas em Lei específica concedidas sobre obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','Registra o valor de outras contragarantias recebidas, não incluidas nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.2.0.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.2.1.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro, no convenente , dos convênios firmados entre entidades objetivando o cumprimento de finalidades comuns. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.2.1.01.00','DIREITOS CONVENIADOS','Registra o valor total firmado dos convênios firmados mantendo-o originalmente mesmo após a sua fase de aprovação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','Registra valor total recebido dos termos de cooperação firmados mantendo-o originalmente mesmo após a sua fase de aprovação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','Registra o valor total recebido de outros instrumentros congêneres firmados mantendo-o originalmente mesmo após a sua fase de aprovação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.0.00.00','DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de direitos contratuais, quando a administração pública participa como contratada.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.00.00','DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro dos valores de direitos contratuais, quando a administração pública participa como contratada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.01.00','CONTRATOS DE SEGUROS','Registra o valor do contrato de seguros em que a administração pública participa como contratada no instrumento contratual com terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','Registra o valor do contrato de serviços em que a administração pública seja a contratada no instrumento contratual com terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','Registra o valor do contrato de alugueis em que o poder público seja o locador do bem.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','Registra o valor do contrato de fornecimento de bens pela administração pública a terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','Registra o valor do contrato de obrigação da entidade pública com terceiros referente a empréstimos e financiamentos contraídos no exercício.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','Registra o valor por contrato das despesas derivadas de PPP contratadas pelo ente da Federação excluídas as empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados.Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','Registra o valor por contrato das despesas derivadas de PPP contratadas pelas empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados. Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','Registra o valor de outros direitos contratuais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.1.9.0.00.00','OUTROS ATOS POTENCIAIS ATIVOS','Registra os atos potenciais ativos não contemplados em contas especificas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.0.0.00.00','ATOS POTENCIAIS PASSIVOS','Compreende os atos e fatos que possam vir a aumentar o passivo ou diminuir o ativo da entidade governamental.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.0.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','Compreende o valor recebido de compromisso de adimplência de obrigação financeira ou contratual, no país. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.00','GARANTIAS CONCEDIDAS NO PAÍS','Compreende o valor recebido de compromisso de adimplência de obrigação financeira ou contratual, no país.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.01','AVAIS','Registra o valor da garantia de pagamento de título de crédito exclusivamente, de natureza pessoal, dada por terceiros, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.02','FIANÇAS','Registra o valor da obrigação acessória recebida no país, por órgãos e entidades, pelo cumprimento da obrigação do devedor, caso esse não cumpra.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.03','HIPOTECAS','Registra o total das garantias de valores por hipotecas recebidas no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.04','SEGUROS-GARANTIA','Registra a garantia de valores por seguros recebidos no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.05','CAUÇÕES','Registra a responsabilidade da unidade por títulos, valores e bens recebidos em cauções no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor referente a garantias recebidas na forma prevista em Lei específica, no país e no exterior. esta categoria inclui as garantias ou riscos assumidos em operações realizadas no âmbito de fundos, programas e operações especiais, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.01.99','OUTRAS GARANTIAS E CONTRAGARANTIAS RECEBIDAS NO PAÍS','Registra o valor de outras contragarantias recebidas, não incluídas nos itens anteriores, sobre obrigações contraídas no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','Compreende o valor recebido de compromisso de adimplência de obrigação financeira ou contratual, no exterior.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.01','AVAIS','Registra o valor da garantia de pagamento de título de crédito exclusivamente, de natureza pessoal, dada por terceiros, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.02','FIANÇAS','Registra o valor da obrigação acessória recebida por órgãos e entidades pelo cumprimento da obrigação do devedor, caso esse não cumpra, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.03','HIPOTECAS','Registra o total das garantias de valores por hipotecas recebidas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.04','SEGUROS-GARANTIA','Registra a garantia de valores por seguros recebidos no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.05','CAUÇÕES','Registra a responsabilidade da unidade por títulos, valores e bens recebidos em cauções no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor referente a garantias recebidas na forma prevista em Lei específica, no país e no exterior. Esta categoria inclui as garantias ou riscos assumidos em operações realizadas no âmbito de fundos, programas e operações especiais, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.02.99','OUTRAS GARANTIAS E CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','Registra o valor de outras contragarantias recebidas, não incluídas nos itens anteriores, sobre obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAÍS','Compreende o valor das contragarantias concedidas referentes às concessões de garantias concedidas sobre obrigações contraídas no país.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.03.01','AVAIS','Registra o valor das contragarantias decorrentes das concessões de avais por obrigações contraídas, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.03.02','FIANÇAS','Registra o valor das contragarantias decorrentes das concessões de fianças por obrigações contraídas, no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor das contragarantias em virtude de garantias instit uidas em Lei específica concedidas sobre obrigações contraídas no país.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','Registra o valor de outras contragarantias concedidas no pais, não incluidas nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','Compreende o valor das contragarantias concedidas referentes às concessões de garantias concedidas sobre obrigações contraídas no exterior.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.04.01','AVAIS','Registra o valor das contragarantias decorrentes das concessões de avais por obrigações contraídas, no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.04.02','FIANÇAS','Registra o valor das contragarantias decorrentes das concessões de fianças por obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','Registra o valor das contragarantias em virtude de garantias instit uidas em Lei específica concedidas sobre obrigações contraídas no exterior.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','Registra o valor de outras contragarantias concedidas no exterior, não incluidas nos itens anteriores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.2.0.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, do valor dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.2.1.00.00','OBRIGAÇÕES CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro, no convenente , dos convênios firmados entre entidades objetivando o cumprimento de finalidades comuns. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.2.1.01.00','OBRIGAÇÕES CONVENIADOS','Registra o valor total recebido dos convênios firmados mantendo-o originalmente mesmo após a sua fase de aprovação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','Registra valor total recebido dos termos de cooperação firmados mantendo-o originalmente mesmo após a sua fase de aprovação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','Registra o valor total recebido de outros instrumentros congêneres firmados mantendo-o originalmente mesmo após a sua fase de aprovação.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.0.00.00','OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de obrigações contratuais, quando a administração pública participa como contratante.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.00.00','OBRIGAÇÕES CONTRATUAIS - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro dos valores de obrigações contratuais, quando a administração pública participa como contratada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.01.00','CONTRATOS DE SEGUROS','Registra o valor do contrato de seguros em que a administração pública participa como contratada no instrumento contratual com terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','Registra o valor do contrato de serviços em que a administração pública seja a contratada no instrumento contratual com terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','Registra o valor do contrato de alugueis em que o poder público seja o locador do bem.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','Registra o valor do contrato de fornecimento de bens pela administração pública a terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','Registra o valor do contrato de obrigação da entidade pública com terceiros referente a empréstimos e financiamentos contraídos no exercício.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.06.00','CONTRATO DE GESTÃO','Registra os contratos de gestão, nos termos do artigo 37, par. 8º da CF/88.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.07.00','TERMO DE PARCERIA','Registra o valor de termo de parceria de terceiros com órgão/entidade.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.08.00','CONTRATOS DE PPP','Compreende o valor dos passivos decorrentes de contrato de PPP que devem abranger o valor presente da melhoria de um ativo não financeiro passível de transferência ao setor público e das prestações dos serviços objeto do contrato, incluindo a parcela variável condicionada à qualidade do serviço, e também aqueles decorrentes de riscos não provisionados, ou ainda outros valores que se entender necessários.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS','Registra o valor dos ativos contingentes referentes a contraprestações futuras devidas pelo ente ao Parceiro Privado.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.08.02','RISCOS NÃO PROVISIONADOS','Registra o valor dos passivos contingentes referentes a riscos assumidos em decorrência de garantias concedidas ao parceiro privado ou em seu benefício, que não tenham sido registradas com Provisões de PPP.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.08.03','OUTROS PASSIVOS CONTINGENTES','Registra o valor dos demais passivos contingentes referentes a PPP.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.3.1.99.00','OUTROS OBRIGAÇÕES CONTRATUAIS','Registra o valor de outras obrigações contratuais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.1.2.9.0.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','Registra os atos potenciais passivos não contemplados em contas especificas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.0.0.0.00.00','ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da programação financeira e de controle das disponibilidades.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.0.0.00.00','DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram os controles sobre as disponibilidades por destinação de recursos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.1.0.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram as disponibilidades de recursos recebidos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.1.1.00.00','RECURSOS ORDINÁRIOS','Registra as disponibilidades por destinação de recursos ordinários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.1.2.00.00','RECURSOS VINCULADOS','Registra as disponibilidades por destinação de recursos vinculados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.1.3.00.00','RECURSOS EXTRAORÇAMENTÁRIOS','Registra as disponibilidades por destinação de recursos extraorçamentários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.2.0.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','Registra as contas que controlam a inscrição do limite de restos a pagar, classificados por destinação de recursos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.1.3.0.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','Registra as contas que controlam a inscrição dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.2.0.0.00.00','PROGRAMAÇÃO FINANCEIRA','Registra as contas que registram as cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.3.0.0.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','Registra as contas que controlam o limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','Registra as contas que registram o valor da arrecadação liquida da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.0.0.0.00.00','DÍVIDA ATIVA','Compreende o controle dos créditos a serem inscritos em divida ativa, dos que se encontram em processamento. Compreende as contas que controlam os créditos passiveis de serem encaminhados e inscritos em divida ativa o de inscrição e a tramitação dos créditos inscritos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.0.0.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','Compreende os valores passiveis de serem encaminhados e inscritos em divida ativa.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.0.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','Compreende o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.1.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa Tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.1.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa, referentes a impostos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.1.02.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa, referentes a taxas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.1.03.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa, referentes a contribuições de melhoria.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.2.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende o montante dos créditos a encaminhar e encaminhados para inscrição em Dívida Ativa Não-Tributária.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.1.1.2.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra o montante dos créditos a encaminhar e encaminhados para inscrição em Dívida Ativa Não-Tributária.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.2.0.0.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','Compreende as contas que controlam os créditos passiveis de serem inscritos em divida ativa pelo órgão responsável pela inscrição em divida ativa.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.2.1.0.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','Compreende os valores dos créditos passíveis de serem inscritos em dívida ativa pelo órgão responsável pela inscrição em dívida ativa.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.2.1.1.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA','Registra o valor dos créditos de origem tributária passíveis de serem inscritos em dívida ativa pelo órgão competente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.3.2.1.2.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra o valor dos créditos de natureza não-tributára passíveis de serem inscritos em dívida ativa pelo órgão competente.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.0.0.0.00.00','RISCOS FISCAIS','Compreende as contas que controlam os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.0.0.00.00','CONTROLE DE PASSIVOS CONTINGENTES','Compreende as contas que registram o controle dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.0.00.00','PASSIVOS CONTINGENTES','Compreende os riscos fiscais classificados como Passivos Contingentes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.1.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes; c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.2.0.0.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','Compreende as contas que registram os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS','Compreende os riscos fiscais não classificados como passivos contingentes.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','Registra a estimativa do montante de redução de arrecadação que apresenta probabilidade de vir a ocorrer no exercício, decorrente de, por exemplo, cenários macroeconômicos desfavoráveis não previstos na época da elaboração do Orçamento.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','Registra a estimativa do montante de devolução de tributos a maior que apresenta probabilidade de vir a ocorrer no exercício.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','Registra a estimativa do montante de redução no valor dos ingressos ou de aumento no valor dos desembolsos que apresentam probabilidade de vir a ocorrer no exercício, decorrentes de evolução desfavorável de indicadores econômicos empregados na época da elaboração do Orçamento, tais como: a) Taxa de crescimento econômico; b) Taxa de inflação; c) Taxa de câmbio; d) Taxa de juros; e) Salário mínimo; f) Outros indicadores.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de riscos fiscais.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.0.0.0.00.00','CONSÓRCIOS PÚBLICOS','Compreende as contas que controlam o registro de atos dos consórcios públicos (do ente consorciado e/ou do próprio consórcio), incluindo os controles do contrato de rateio, controle da prestação de contas, bem como as informações que serão consolidadas no ente consorciado para fins de elaboração dos demonstrativos dos consórcios, conforme Portaria STN 72/2012.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.1.0.0.00.00','CONTRATO DE RATEIO DE CONSÓRCIOS PÚBLICOS','Registra contas relacionadas ao registro dos valores de obrigações contratuais decorrentes de Consórcios Públicos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.2.0.0.00.00','PRESTAÇÃO DE CONTAS DE CONSÓRCIOS PÚBLICOS','Registra contas relacionadas ao registro do controle da prestação de contas dos Consórcios Públicos.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','Compreende as informações referentes aos Consórcios Públicos, atribuídas ao ente consorciado com base no contrato de rateio,que serão enviadas pelo consórcio para os entes consorciados para fins de elaboração dos demonstrativos fiscais ( Saúde, pessoal, educação e disponibilidade de caixa), em atendimento a Portaria STN nº 72/2012. Conta para uso do ente consorciado.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','Registra os valores repassados pelo ente para execução das despesas nos Consórcios Públicos, com base no Contrato de Rateio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','Registra as despesas executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Registra o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Registra o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','Registra a parcela total da insuficiência de caixa gerada no consórcio público atribuída ao ente consorciado com base no contrato de rateio.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.8.0.0.0.00.00','CUSTOS','Compreende as contas que controlam os custos de bens e serviços produzidos.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.0.0.0.00.00','OUTROS CONTROLES','Compreende de controles não especificados anteriormente nos grupos dessa classe.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.0.0.00.00','RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','Compreende as contas relacionadas ao registro das responsabilidades por valores, títulos e bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.1.0.00.00','RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','Compreende as contas relacionadas ao registro da responsabilidade da administração pública com terceiros por títulos, valores e bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','Registra os depósitos judiciais efetuados por terceiros em títulos, em conta vinculada etc, sob a responsabilidade da unidade, ou depositados por esta para terceiros.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','Registra o somatório dos valores dos depósitos compulsórios realizados.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','Registra responsabilidades com terceiros, não individualizadas nas outras contas desse grupo.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.2.0.00.00','RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','Compreende contas relacionadas ao registro da responsabilidade de terceiros com a administração pública por títulos, valores e bens.','D','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.2.1.00.00','CONTROLE DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','Registra os valores concedidos a servidor responsável para atender despesas que não possam subordinar-se ao processo normal de aplicação,até a sua prestação de contas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.2.2.00.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','Registra o valor dos ativos produzidos por meio de Parcerias Público Privadas contabilizados na Sociedade de Propósito Específico.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.1.2.9.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','Registra o valor de outras responsabilidades de terceiros, de natureza eventual, por títulos, valores e bens, para as quais não há contas específicas.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'7.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','Registra as responsabilidades em fase de apuração decorrentes de atos praticados por gestores, servidores ou terceiros que possam resultarem prejuizos para a fazenda nacional.','D','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.0.0.0.0.00.00','CONTROLES CREDORES','Compreende as contas em que são registradas a execução de atos potenciais e controles específicos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.0.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','Compreende contas relacionadas à execução de situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos e fatos que possa vir a afetar o ativo da entidade governamental.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidos no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidos no país e no exterior, bem como emolumentos consulares e outras garantias e contragarantias. compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO PAÍS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recedidos no país , bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.01','AVAIS A EXECUTAR','Registra o valor das garantias recebidas por aval pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.02','AVAIS EXECUTADOS','Registra o valor recebido das garantias recebidas por aval no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.03','FIANÇAS A EXECUTAR','Registra o valor das garantias recebidas por fianças, pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.04','FIANÇAS EXECUTADAS','Registra o valor recebido das garantias por fianças, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.05','HIPOTECAS A EXECUTAR','Registra o valor das garantias por hipoteca pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.06','HIPOTECAS EXECUTADAS','Registra o valor recebido das garantias por hipoteca no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.07','SEGUROS-GARANTIA A EXECUTAR','Registra o valor dos seguros-garantia pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.08','SEGUROS-GARANTIA EXECUTADAS','Registra o valor recebido dos seguros-garantia, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.09','CAUÇÕES A EXECUTAR','Registra o valor das garantias por cauções pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.10','CAUÇÕES EXECUTADA','Registra o valor recebido das garantias por cauções no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das garantias instituídas por Lei específica pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das garantias instituídas por Lei específica, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','Registra o valor das garantias da dívida pública pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','Registra o valor recebido das garantias da dívida pública, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.15','APÓLICES DE SEGUROS A EXECUTAR','Registra o valor das das apólices de seguros pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.16','APÓLICES DE SEGUROS EXECUTADAS','Registra o valor recebido das apólices de seguros, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.98','OUTRAS GARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','Registra o valor de outras garantias pendentes de execução , no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.01.99','OUTRAS GARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','Registra o valor recebido de outras garantias no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO EXTERIOR','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidas no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.01','AVAIS A EXECUTAR','Registra o valor das garantias por aval pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.02','AVAIS EXECUTADOS','Registra o valor recebido das garantias por aval no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.03','FIANÇAS A EXECUTAR','Registra o valor das garantias por fianças pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.04','FIANÇAS EXECUTADAS','Registra o valor recebido das garantias por fianças, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.05','HIPOTECAS A EXECUTAR','Registra o valor das garantias por hipoteca pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.06','HIPOTECAS EXECUTADAS','Registra o valor recebido das garantias por hipoteca no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.07','SEGUROS-GARANTIA A EXECUTAR','Registra o valor dos seguros-garantia pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.08','SEGUROS-GARANTIA EXECUTADAS','Registra o valor recebido dos seguros-garantia, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.09','CAUÇÕES A EXECUTAR','Registra o valor das garantias por cauções pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.10','CAUÇÕES EXECUTADA','Registra o valor recebido das garantias por cauções no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das garantias instituídas por Lei específica pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das garantias instituídas por Lei específica, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','Registra o valor de outras garantias pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','Registra o valor recebido de outras garantias no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.15','APÓLICES DE SEGUROS A EXECUTAR','Registra o valor das das apólices de seguros pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.16','APÓLICES DE SEGUROS EXECUTADAS','Registra o valor recebido das apólices de seguros, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.98','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','Registra o valor de outras garantias pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','Registra o valor recebido de outras garantias no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO PAÍS','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidas no país bem como outras contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.01','AVAIS A EXECUTAR','Registra o valor das contragarantias recebidas por aval pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.02','AVAIS EXECUTADOS','Registra o valor recebido das contragarantias recebidas por aval no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.03','FIANÇAS A EXECUTAR','Registra o valor das contragarantias recebidas por fianças, pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.04','FIANÇAS EXECUTADAS','Registra o valor recebido das contragarantias por fianças, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das contragarantias instituídas por Lei específica pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das contragarantias instituídas por Lei específica, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','Registra o valor de outras contragarantias pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.03.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','Registra o valor recebido de outras contragarantias no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidas no exterior, bem como outras contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.01','AVAIS A EXECUTAR','Registra o valor das contragarantias recebidas por aval pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.02','AVAIS EXECUTADOS','Registra o valor recebido das contragarantias recebidas por aval no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.03','FIANÇAS A EXECUTAR','Registra o valor das contragarantias recebidas por fianças, pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.04','FIANÇAS EXECUTADAS','Registra o valor recebido das contragarantias por fianças, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das contragarantias instituídas por Lei específica pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das garantias instituídas por Lei específica, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','Registra o valor de outras contragarantias pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','Registra o valor recebido de outras contragarantias no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.0.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.00','EXECUÇÃO DE CONVÊNIOS','Compreende a execução dos valores de convênios para entrada de recursos firmado com outras entidades com a finalidade de atingir objetivos comuns .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.01','CONVÊNIOS A RECEBER','Registra a execução dos valores das parcelas a receber de convênios firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.02','CONVÊNIOS A COMPROVAR','Registra a execução dos valores a comprovar de convênios firmados com outras entidades, após o recebimento das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.03','CONVÊNIOS A APROVAR','Registra a execução dos valores a aprovar de convênios de entrada de recursos firmado com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.04','CONVÊNIOS APROVADOS','Registra a execução dos valores aprovados de convênios de entrada de recursos firmado com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.05','CONVÊNIOS IMPUGNADOS','Registra a execução dos valores impugnados de convênios de entrada de recursos firmado com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','Registra o valor inadimplente do convênio firmado, após a comprovação das parcelas de recursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.07','CONVÊNIO SEM INADIMPLÊNCIA SUSPENSA','Registra o valor inadimplente suspenso de convênio firmado, após a decisão judicial ou administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.08','CONVÊNIOS HOMOLOGADOS','Registra a execução dos valores homologados de convênios de entrada de recursos firmado com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.09','CONVÊNIOS CANCELADOS','Registra o valor cancelado do convênio firmado.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.10','CONVÊNIOS NÃO RECEBIDOS','Registra o valor não recebido relativo ao total firmado do convênio. O valor citado e registrado por meio da transação EXCCONV, tipo de execução nº 13.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.11','CONVÊNIOS ARQUIVADOS','Registra o valor arquivado de convênios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','Registra o valor concluido de convênio firmado , após a aprovação total da prestação de contas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','Compreende a execução dos valores de termo de cooperação para entrada de recursos firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.01','TERMO DE COOPERAÇÃO A RECEBER','Registra a execução dos valores das parcelas a receber de termos de cooperação firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','Registra a execução dos valores a comprovar de termos de cooperação firmados com outras entidades, após o recebimento das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','Registra a execução dos valores a aprovar de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','Registra a execução dos valores aprovados de termos de cooperação de entrada de recursos firmados com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','Registra a execução dos valores impugnados de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','Registra o valor inadimplente de termos de cooperação firmados, após a comprovação das parcelas de recursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','Registra o valor inadimplente suspenso de termos de cooperação firmados, após a decisão judicial ou administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','Registra o valor cancelado de termos de cooperação firmados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.09','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','Registra o valor não recebido relativo ao total firmado de termos de cooperação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','Registra o valor concluído de termos de cooperação firmados , após a aprovação total da prestação de contas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.00','OUTROS INSTRUMENTOS CONGÊNERES','Compreende a execução dos valores de outros instrumentos congêneres para entrada de recursos firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.01','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','Registra a execução dos valores das parcelas a receber de termos de cooperação firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','Registra a execução dos valores a comprovar de termos de cooperação firmados com outras entidades, após o recebimento das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','Registra a execução dos valores a aprovar de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','Registra a execução dos valores aprovados de termos de cooperação de entrada de recursos firmados com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','Registra a execução dos valores impugnados de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','Registra o valor inadimplente de termos de cooperação firmados, após a comprovação das parcelas de recursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','Registra o valor inadimplente suspenso de termos de cooperação firmados, após a decisão judicial ou administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','Registra o valor cancelado de termos de cooperação firmados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','Registra o valor não recebido relativo ao total firmado de termos de cooperação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.2.1.03.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','Registra o valor concluído de termos de cooperação firmados , após a aprovação total da prestação de contas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.0.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de direitos contratuais, quando a administração pública participa como contratada.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro da execução dos valores de direitos contratuais, quando a administração pública participa como contratada. compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.01.00','CONTRATOS DE SEGUROS','Compreende contas relacionas ao registro da execução dos valores do contrato de seguros em que a administração pública participa como contratada no instrumento contratual com terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.01.01','EM EXECUÇÃO','Registra a execução dos valores a aprópriar relativos aos serviços de seguros , conforme previsão contratual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.01.02','EXECUTADOS','Registra a execução dos valores apropriados relativos aos serviços de seguros , conforme previsão contratual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','Compreende contas relacionadas ao registo da execução dos valores do contrato de serviços em que a administração pública seja a contratada no instrumento contratual com terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.02.01','EM EXECUÇÃO','Registra a execução dos valores a realizar relativos a prestação de serviços, conforme instrumento contratual em que a administração pública seja a contratada.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.02.02','EXECUTADOS','Registra a execução dos valores realizados do contrato de serviços em que a administração pública seja a contratada no instrumento contratual com terceiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','Compreende contas relacionadas ao registro da execução dos valores do contrato de alugueis em que o poder público seja o locador do bem.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.03.01','EM EXECUÇÃO','Registra a execução dos valores a aprópriar relativos aos contratos alugueis em que o poder público seja o locador do bem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.03.02','EXECUTADOS','Registra a execução dos valores a apropriados relativos aos contratos alugueis em que o poder público seja o locador do bem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','Compreende contas relacionadas ao registro da execução dos valores do contrato de fornecimento de bens pela administração pública a terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.04.01','EM EXECUÇÃO','Registra a execução dos valores a realizar relativos aos contratos de fornecimento de bens pela administração pública a terceiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.04.02','EXECUTADOS','Registra a execução dos valores realizados relativos aos contrato de fornecimento de bens pela administração pública a terceiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','Compreende valores relacionados a execução execução de contratos de obrigações da entidade pública com terceiros referente a empréstimos e financiamentos contraídos no exercício.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.05.01','EM EXECUÇÃO','Registra a execução de valores a liberar relativos a contratos de obrigações da entidade pública com terceiros referente a empréstimos e financiamentos contraídos no exercício.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.05.02','EXECUTADOS','Registra a execução de valores liberados relativos a contratos de obrigações da entidade pública com terceiros referente a empréstimos e financiamentos contraídos no exercício.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','Compreende o valor por contrato das despesas derivadas de PPP contratadas pelo ente da Federação excluídas as empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados.Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.01','CONTRATOS DE PPP - DO ENTE FEDERADO - EC','Registra, por contrato, os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para o resto do ano.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.02','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 1','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 1º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.03','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 2','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 2º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.04','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 3','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 3º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.05','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 4','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 4º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.06','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 5','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 5º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.07','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 6','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 6º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.08','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 7','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 7º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.09','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 8','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 8º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.06.10','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 9','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 9º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','Compreende o valor por contrato das despesas derivadas de PPP contratadas pelas empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados. Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.01','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC','Registra, por contrato, os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para o resto do ano.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.02','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 1','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 1º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.03','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 2','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 2º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.04','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 3','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 3º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.05','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 4','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 4º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.06','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 5','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 5º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.07','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 6','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 6º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.08','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 7','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 7º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.09','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 8','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 8º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.07.10','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 9','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 9º ano seguinte ao exercício corrente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','Compreende contas relacionas ao registro da execução dos valores de outros direitos contratuais em que a administração pública participa como contratada no instrumento contratual com terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.99.01','EM EXECUÇÃO','Registra a execução dos valores a aprópriar relativos aos serviços de seguros , conforme previsão contratual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.3.1.99.02','EXECUTADOS','Registra a execução dos valores apropriados relativos aos serviços de seguros , conforme previsão contratual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos potenciais ativos não contemplados em contas especificas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.1.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDAÇÃO','Compreende a execução dos atos potenciais ativos não contemplados em contas específicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos e fatos que possa vir a afetar o passivo da entidade governamental.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidos no país e no exterior, bem como emolumentos consulares e outras garantias e contragarantias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.00','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO PAÍS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidos no país , bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.01','AVAIS A EXECUTAR','Registra o valor das garantias recebidas por aval pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.03','AVAIS EXECUTADOS','Registra o valor recebido das garantias recebidas por aval no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.04','FIANÇAS A EXECUTAR','Registra o valor das garantias recebidas por fianças, pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.06','FIANÇAS EXECUTADAS','Registra o valor recebido das garantias por fianças, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.07','HIPOTECAS A EXECUTAR','Registra o valor das garantias por hipoteca pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.09','HIPOTECAS EXECUTADAS','Registra o valor recebido das garantias por hipoteca no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.10','SEGUROS-GARANTIA A EXECUTAR','Registra o valor dos seguros-garantia pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.12','SEGUROS-GARANTIA EXECUTADAS','Registra o valor recebido dos seguros-garantia, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.13','CAUÇÕES A EXECUTAR','Registra o valor das garantias por cauções pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.15','CAUÇÕES EXECUTADA','Registra o valor recebido das garantias por cauções no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das garantias instituídas por Lei específica pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das garantias instituídas por Lei específica, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.19','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','Registra o valor de outras garantias pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.01.21','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','Registra o valor recebido de outras garantias no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.00','EXECUÇÃO DE GARANTIAS E CONCEDIDAS NO EXTERIOR','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidos no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.01','AVAIS A EXECUTAR','Registra o valor das garantias por aval pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.03','AVAIS EXECUTADOS','Registra o valor recebido das garantias por aval no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.04','FIANÇAS A EXECUTAR','Registra o valor das garantias por fianças pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.06','FIANÇAS EXECUTADAS','Registra o valor recebido das garantias por fianças, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.07','HIPOTECAS A EXECUTAR','Registra o valor das garantias por hipoteca pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.09','HIPOTECAS EXECUTADAS','Registra o valor recebido das garantias por hipoteca no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.10','SEGUROS-GARANTIA A EXECUTAR','Registra o valor dos seguros-garantia pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.12','SEGUROS-GARANTIA EXECUTADAS','Registra o valor recebido dos seguros-garantia, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.13','CAUÇÕES A EXECUTAR','Registra o valor das garantias por cauções pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.15','CAUÇÕES EXECUTADA','Registra o valor recebido das garantias por cauções no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das garantias instituídas por Lei específica pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das garantias instituídas por Lei específica, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.19','OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','Registra o valor de outras garantias pendentes de execução, no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.02.21','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','Registra o valor recebido de outras garantias no exterior.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO PAÍS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidos no país , bem como outras contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.01','AVAIS A EXECUTAR','Registra o valor das contragarantias recebidas por aval pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.03','AVAIS EXECUTADOS','Registra o valor recebido das contragarantias recebidas por aval no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.04','FIANÇAS A EXECUTAR','Registra o valor das contragarantias recebidas por fianças, pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.06','FIANÇAS EXECUTADAS','Registra o valor recebido das contragarantias por fianças, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das contragarantias instituídas por Lei específica pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das contragarantias instituídas por Lei específica, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','Registra o valor de outras contragarantias pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','Registra o valor recebido de outras contragarantias no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidos no país, bem como outras contragarantias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.01','AVAIS A EXECUTAR','Registra o valor das contragarantias recebidas por aval pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.03','AVAIS EXECUTADOS','Registra o valor recebido das contragarantias recebidas por aval no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.04','FIANÇAS A EXECUTAR','Registra o valor das contragarantias recebidas por fianças, pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.06','FIANÇAS EXECUTADAS','Registra o valor recebido das contragarantias por fianças, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','Registra o valor das contragarantias instituídas por Lei específica pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','Registra o valor recebido das garantias instituídas por Lei específica, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','Registra o valor de outras contragarantias pendentes de execução, no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.1.1.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','Registra o valor recebido de outras contragarantias no país.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, da execução do valor dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns. compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.00','EXECUÇÃO DE CONVÊNIOS','Compreende a execução dos valores de convênios para entrada de recursos firmado com outras entidades com a finalidade de atingir objetivos comuns .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.01','CONVÊNIOS A RECEBER','Registra a execução dos valores das parcelas a receber de convênios firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.02','CONVÊNIOS A COMPROVAR','Registra a execução dos valores a comprovar de convênios firmados com outras entidades, após o recebimento das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.03','CONVÊNIOS A APROVAR','Registra a execução dos valores a aprovar de convênios de entrada de recursos firmado com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.04','CONVÊNIOS APROVADOS','Registra a execução dos valores aprovados de convênios de entrada de recursos firmado com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.05','CONVÊNIOS IMPUGNADOS','Registra a execução dos valores impugnados de convênios de entrada de recursos firmado com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','Registra o valor inadimplente do convênio firmado, após a comprovação das parcelas de recursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.07','CONVÊNIOS EM INADIMPLÊNCIA SUSPENSA','Registra o valor inadimplente suspenso de convênio firmado, após a decisão judicial ou administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.08','CONVÊNIOS HOMOLOGADOS','Registra a execução dos valores homologados de convênios de entrada de recursos firmado com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.09','CONVÊNIOS CANCELADOS','Registra o valor cancelado do convênio firmado.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.10','CONVÊNIOS NÃO RECEBIDOS','Registra o valor não recebido relativo ao total firmado do convênio. O valor citado e registrado por meio da transação EXCCONV, tipo de execução nº 13.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.11','CONVÊNIOS ARQUIVADOS','Registra o valor arquivado de convênios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','Registra o valor concluido de convênio firmado , após a aprovação total da prestação de contas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','Compreende a execução dos valores de termo de cooperação para entrada de recursos firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.01','TERMO DE COOPERAÇÃO A RECEBER','Registra a execução dos valores das parcelas a receber de termos de cooperação firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','Registra a execução dos valores a comprovar de termos de cooperação firmados com outras entidades, após o recebimento das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','Registra a execução dos valores a aprovar de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','Registra a execução dos valores aprovados de termos de cooperação de entrada de recursos firmados com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','Registra a execução dos valores impugnados de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','Registra o valor inadimplente de termos de cooperação firmados, após a comprovação das parcelas de recursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','Registra o valor inadimplente suspenso de termos de cooperação firmados, após a decisão judicial ou administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','Registra o valor cancelado de termos de cooperação firmados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.09','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','Registra o valor não recebido relativo ao total firmado de termos de cooperação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','Registra o valor concluído de termos de cooperação firmados , após a aprovação total da prestação de contas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.00','OUTROS INSTRUMENTOS CONGÊNERES','Compreende a execução dos valores de outros instrumentos congêneres para entrada de recursos firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.01','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','Registra a execução dos valores das parcelas a receber de termos de cooperação firmados com outras entidades com a finalidade de atingir objetivos comuns .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','Registra a execução dos valores a comprovar de termos de cooperação firmados com outras entidades, após o recebimento das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','Registra a execução dos valores a aprovar de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','Registra a execução dos valores aprovados de termos de cooperação de entrada de recursos firmados com outras entidades, após a aprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','Registra a execução dos valores impugnados de termos de cooperação de entrada de recursos firmados com outras entidades, após a comprovação das parcelas de recursos .','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','Registra o valor inadimplente de termos de cooperação firmados, após a comprovação das parcelas de recursos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','Registra o valor inadimplente suspenso de termos de cooperação firmados, após a decisão judicial ou administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','Registra o valor cancelado de termos de cooperação firmados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','Registra o valor não recebido relativo ao total firmado de termos de cooperação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.2.1.03.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','Registra o valor concluído de termos de cooperação firmados , após a aprovação total da prestação de contas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de obrigações contratuais, quando a administração pública participa como contratante.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.00.00','EXECUÇÃO DE OBRIGAÇÕES -CONSOLIDAÇÃO','Compreende contas relacionadas ao registro da execução dos valores de obrigações contratuais, quando a administração pública participa como contratante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.01.00','CONTRATOS DE SEGUROS','Compreende contas relacionadas ao registro da execução dos valores do contrato de seguros em que a administração pública seja a contratante do instrumento contratual com terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.01.01','A EXECUTAR','Registra a execução dos valores a aprópriar relativo a contratos de seguros , em que administração seja a contratante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.01.02','EXECUTADOS','Registra a execução dos valores a apropriados relativo a contratos de seguros , em que administração seja a contratante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','Compreende contas relacionadas ao registo da execução dos valores do contrato de serviços em que a administração pública seja a contratante .','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.02.01','A EXECUTAR','Registra a execução dos valores a realizar relativos a contratos de serviços, em que a administração pública seja a contratante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.02.02','EXECUTADOS','Registra a execução dos valores realizados do contrato de serviços em que a administração pública seja a contratante.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','Compreende contas relacionadas ao registro da execução dos valores do contrato de alugueis em que o poder público seja o locatário do bem.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.03.01','A EXECUTAR','Registra a execução dos valores a aprópriar relativos aos contratos alugueis em que o poder público seja o locatário do bem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.03.02','EXECUTADOS','Registra a execução dos valores a apropriados relativos aos contratos alugueis em que o poder público seja o locatário do bem.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','Compreende contas relacionadas ao registro da execução dos valores do contrato de fornecimento de bens pela administração pública a terceiros.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.04.01','A EXECUTAR','Registra a execução dos valores a realizar relativos aos contratos de fornecimento de bens por terceiros a administração pública.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.04.02','EXECUTADOS','Registra a execução dos valores realizados realtivos aos contrato de fornecimento de bens por administração a pública.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','Compreende valores relacionados a execução execução de contratos de obrigações da entidade pública com terceiros referente a empréstimos e financiamentos concedidos no exercício.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.05.01','A EXECUTAR','Registra a execução de valores a liberar relativos a contratos de obrigações da entidade pública com terceiros referente a empréstimos e financiamentos concedidos no exercício.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.05.02','EXECUTADOS','Registra a execução de valores a liberaredos relativos a contratos de obrigações da entidade pública com terceiros referente a empréstimos e financiamentos concedidos no exercício.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.06.00','CONTRATO DE GESTÃO','Compreende as contas de registro da execução dos contratos de gestão.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.06.01','A LIQUIDAR','Registra o valor do contrato a liquidar entre a administração pública e privada para gestão de atividades típicas de governo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.06.02','LIQUIDADOS','Registra o valor do contrato liquidado entre a administração pública e privada para gestão de atividades típicas de governo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.07.00','TERMO DE PARCERIA','Compreende valores relacionados a execução de contratos de obrigações da entidade pública com terceiros referente a termo de parceria.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.07.01','A EXECUTAR','Registra a execução de valores a liberar relativos a contratos de obrigações da entidade pública com terceiros referente a termo de parceria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.07.02','EXECUTADOS','Registra a execução de valores a liberaredos relativos a contratos de obrigações da entidade pública com terceiros referente a termo de parceria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.00','CONTRATOS DE PPP','Compreende o valor dos passivos decorrentes de contrato de PPP que devem abranger o valor presente da melhoria de um ativo não financeiro passível de transferência ao setor público e das prestações dos serviços objeto do contrato, incluindo a parcela variável condicionada à qualidade do serviço, e também aqueles decorrentes de riscos não provisionados, ou ainda outros valores que se entender necessários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS - A EXECUTAR','Registra o valor dos ativos contingentes referentes a contraprestações futuras devidas pelo ente ao Parceiro Privado ainda não executadas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.02','CONTRAPRESTAÇÕES FUTURAS - EXECUTADAS','Registra o valor dos ativos contingentes referentes a contraprestações futuras devidas pelo ente ao Parceiro Privado já executadas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.03','RISCOS NÃO PROVISIONADOS - A EXECUTAR','Registra o valor dos passivos contingentes a executar referentes a riscos assumidos em decorrência de garantias concedidas ao parceiro privado ou em seu benefício, que não tenham sido registradas com Provisões de PPP.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.04','RISCOS NÃO PROVISIONADOS - EXECUTADOS','Registra o valor dos passivos contingentes executados referentes a riscos assumidos em decorrência de garantias concedidas ao parceiro privado ou em seu benefício, que não tenham sido registradas com Provisões de PPP.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.05','OUTROS PASSIVOS CONTINGENTES - A EXECUTAR','Registra o valor de outros passivos contingentes a executar.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.08.06','OUTROS PASSIVOS CONTIGENTES - EXECUTADOS','Registra o valor de outros passivos contingentes executados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.99.00','OUTRAS OBRIGAÇÕES CONTRATUAIS','Compreende os valores de outras obrigações contratuais de PPP.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.99.01','A EXECUTAR','Registra os valores de outras obrigações contratuais de PPP a executar.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.3.1.99.02','EXECUTADOS','Registra os valores de outras obrigações contratuais de PPP executados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos potenciais passivos não contemplados em contas especificas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.1.2.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDAÇÃO','Compreende a execução dos atos potenciais passivos não contemplados em contas específicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.0.0.0.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da execução da programação financeira e de controle das disponibilidades.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.0.0.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram a execução dos controles das disponibilidades por destinação de recursos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.0.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram a execução das disponibilidades de recursos a utilizar, comprometidas e utilizadas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.1.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','Registra o valor das disponibilidades de recursos a utilizar.','C','S','','',7);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.2.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','Registra o valor das disponibilidades de recursos comprometidas por ocasião do empenho e não liquidadas.','C','S','','',7);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.3.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','Compreende o valor das disponibilidades de recursos comprometidas por ocasião da liquidação e de entradas compensatórias e não pagas/devolvidas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.3.01.00','COMPROMETIDA POR LIQUIDAÇÃO','Registra o valor das disponibilidades de recursos comprometidas por ocasião da liquidação. O saldo desta conta representa o valor líquido dos empenhos a pagar.','C','S','','',7);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.3.02.00','COMPROMETIDA POR CONSIGNAÇÕES/RETENÇÕES','Registra o valor das disponibilidades de recursos comprometidas por consignação/retenção.','C','S','','',7);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.3.03.00','COMPROMETIDA POR ENTRADAS COMPENSATÓRIAS','Registra o valor das disponibilidades de recursos comprometidas por entradas compensatórias, como depósitos de cauções e outros.','C','S','','',7);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.4.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','Registra o valor das disponibilidades de recursos utilizadas por meio de pagamento de despesa orçamentária, depósitos e/ou outros.','C','S','','',7);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.1.5.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA','Registra o valor das disponibilidades de recursos comprometidas por programação financeira no órgão central de programação financeira.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.2.0.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','Registra as contas que registram a execução financeira do limite de restos a pagar.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.1.3.0.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','Registra as contas que controlam a execução dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.2.0.0.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','Registra as contas que registram a execução das cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.3.0.0.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','Registra as contas que controlam a execução do limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','Registra as contas que registram os valores discriminados da arrecadação da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.0.0.0.00.00','EXECUÇÃO DA DÍVIDA ATIVA','Compreende as contas que controlam a execução dos créditos passiveis de serem encaminhados e inscritos em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.0.0.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','Compreende as contas que registram os valores a serem encaminhados e os já encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.0.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA','Compreende os valores a serem encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.1.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA','Compreende os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.1.01.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a impostos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.1.02.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a taxas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.1.03.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a contribuição de melhoria.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.2.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a créditos não-tributários.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.1.2.01.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a créditos não-tributários.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.0.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','Compreende os valores encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.1.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','Compreende os créditos referentes a tributos encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.1.01.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra os créditos, referentes a impostos, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.1.02.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra os créditos, referentes à taxas, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.1.03.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra os créditos, referentes à contribuições de melhoria, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.2.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO TRIBUTÁRIA','Compreende os créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.2.2.01.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra os créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.0.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','Compreende o cancelamento dos valores indevidamente encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.1.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','Compreende o cancelamento dos créditos de natureza tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.1.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o cancelamento dos créditos de natureza tributária, referentes a impostos, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.1.02.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o cancelamento dos créditos de natureza tributária, referentes a taxas, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.1.03.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra o cancelamento dos créditos de natureza tributária, referentes a contribuição de melhoria, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.2.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende o cancelamento dos créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.1.3.2.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra o cancelamento dos créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.0.0.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','Compreende as contas que registram os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.1.0.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA','Compreende os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.1.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA','Registra os créditos a serem inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.1.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra os créditos a serem inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.2.0.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA DEVOLVIDOS','Compreende os valores a serem inscritos em divida ativa que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.2.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA DEVOLVIDOS','Registra os créditos a serem inscritos em divida ativa tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.2.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO TRIBUTÁRIA DEVOLVIDOS','Registra os créditos a serem inscritos em divida ativa não tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA A RECEBER','Compreende os valores inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.1.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','Compreende os créditos inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.1.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.1.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.2.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','Compreende os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.2.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','Registra os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.3.2.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Registra os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA RECEBIDOS','Compreende os valores recebidos relativos aos créditos anteriormente inscritos em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.1.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.1.01.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária, em fase administrativa de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.1.02.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária, em fase judicial de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.2.00.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.2.01.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária em fase administrativa de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.4.2.02.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária, em fase judicial de cobrança.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.0.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA','Compreende os valores relativos às baixas de créditos inscritos em divida ativa.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.1.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende as baixas de créditos inscritos em divida ativa tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.1.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA ADMINISTRATIVA','Registra as baixas de créditos inscritos em divida ativa tributária, em cobrança administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.1.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA JUDICIAL','Registra as baixas de créditos inscritos em divida ativa tributária, em cobrança judicial.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.2.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende as baixas de créditos inscritos em divida ativa não-tributária.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.2.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMNISTRATIVA','Registra as baixas de créditos inscritos em divida ativa não-tributária, em cobrança administrativa.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.3.2.5.2.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra as baixas de créditos inscritos em divida ativa não-tributária, em cobrança judicial.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.0.0.0.00.00','EXECUÇÃO DOS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.0.0.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.0.00.00','PASSIVOS CONTINGENTES PREVISTOS','Compreende a previsão dos riscos fiscais classificados como Passivos Contingentes.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.1.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes; c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias, etc.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.0.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','Compreende a confirmação da previsão dos riscos fiscais classificados como Passivos Contingentes.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.1.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes; c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.4.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.5.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias, etc.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.1.2.9.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.0.0.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS PREVISTOS','Compreende a previsão dos riscos fiscais não classificados como passivos contingentes.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','Registra a estimativa do montante de redução de arrecadação que apresenta probabilidade de vir a ocorrer no exercício, decorrente de, por exemplo, cenários macroeconômicos desfavoráveis não previstos na época da elaboração do Orçamento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','Registra a estimativa do montante de devolução de tributos a maior que apresenta probabilidade de vir a ocorrer no exercício.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','Registra a estimativa do montante de redução no valor dos ingressos ou de aumento no valor dos desembolsos que apresentam probabilidade de vir a ocorrer no exercício, decorrentes de evolução desfavorável de indicadores econômicos empregados na época da elaboração do Orçamento, tais como: a) Taxa de crescimento econômico; b) Taxa de inflação; c) Taxa de câmbio; d) Taxa de juros; e) Salário mínimo; f) Outros indicadores.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de riscos fiscais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.4.2.2.0.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','Registra a confirmação da previsão dos riscos fiscais não classificados como passivos contingentes.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.0.0.0.00.00','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','Compreende as contas que controlam a execução dos consórcios públicos (do ente consorciado e/ou do próprio consórcio), incluindo os controles do contrato de rateio, controle da prestação de contas, bem como as informações que serão consolidadas no ente consorciado para fins de elaboração dos demonstrativos dos consórcios, conforme Portaria STN 72/2012.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.1.0.0.00.00','EXECUÇÃO DO CONTRATO DE RATEIO DE CONSÓRCIO PÚBLICO','Compreende contas relacionadas ao registro dos valores de obrigações contratuais decorrentes de Consórcios Públicos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.1.1.0.00.00','CONTRATO DE RATEIO - EM EXECUÇÃO','Registra os valores de obrigações contratuais em execução decorrentes de Consórcios Públicos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.1.2.0.00.00','CONTRATO DE RATEIO - EXECUTADOS','Registra os valores de obrigações de obrigações contratuais executados decorrentes de Consórcios Públicos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.0.0.00.00','EXECUÇÃO DA PRESTAÇÃO DE CONTAS DE CONSÓRCIO PÚBLICO','Compreende contas relacionadas ao registro da execução do controle da prestação de contas referentes aos valores transferidos dos Consórcios Públicos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.1.0.00.00','A COMPROVAR','Registra os valores transferidos dos Consórcios Públicos a comprovar.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.2.0.00.00','EM INADIMPLÊNCIA','Registra os valores transferidos dos Consórcios Públicos em que não houve prestação de contas dentro do prazo estipulado.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.3.0.00.00','A APROVAR','Registra os valores transferidos dos Consórcios Públicos a aprovar.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.4.0.00.00','APROVADOS','Registra os valores transferidos dos Consórcios Públicos aprovados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.5.0.00.00','IMPUGNADOS','Registra os valores transferidos dos Consórcios Públicos impugnados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.2.6.0.00.00','CONCLUÍDOS','Registra os valores transferidos dos Consórcios Públicos concluídos.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','Compreende as informações referentes aos Consórcios Públicos, atribuídas ao ente consorciado com base no contrato de rateio,que serão enviadas pelo consórcio para os entes consorciados para fins de elaboração dos demonstrativos fiscais ( Saúde, pessoal, educação e disponibilidade de caixa), em atendimento a Portaria STN n.º 72/2012. Conta para uso do ente consorciado.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','Registra os valores repassados pelo ente para execução das despesas nos Consórcios Públicos, com base no Contrato de Rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','Compreende as despesas executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.2.1.00.00','CRÉDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.2.2.00.00','CRÉDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.2.3.00.00','CRÉDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.2.4.00.00','CRÉDITO EMPENHADO LIQUIDADO PAGO','Demonstra o valor da despesa empenhada liquidada paga, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.1.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.2.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.3.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.4.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.5.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.6.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.7.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.3.8.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.4.1.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.4.2.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.4.3.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.4.4.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.4.5.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','','',4);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','Registra a parcela total da insuficiência de caixa gerada no consórcio público atribuída ao ente consorciado com base no contrato de rateio.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.8.0.0.0.00.00','APURAÇÃO DE CUSTOS','Compreende as contas que controlam a execução dos custos dos bens e serviços produzidos.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.0.0.0.00.00','OUTROS CONTROLES','Compreende as contas de controles da execução não especificados anteriormente nos grupos dessa classe.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.0.0.00.00','EXECUÇÃO DE RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','Compreende as contas relacionadas ao registro das responsabilidades por valores, títulos e bens.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.1.0.00.00','EXECUÇÃO DE RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','Registra as contas relacionadas ao registro da responsabilidade da administração pública com terceiros por títulos, valores e bens.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','Registra os depósitos judiciais efetuados por terceiros em títulos, em conta vinculada etc, sob a responsabilidade da unidade, ou depositados por esta para terceiros.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','Registra o somatório dos valores dos depósitos compulsórios realizados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','Registra responsabilidades com terceiros, não individualizadas nas outras contas desse grupo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.0.00.00','EXECUÇÃO DE RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','Compreende contas relacionadas ao registro da responsabilidade de terceiros com a administração pública por títulos, valores e bens.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.00.00','EXECUÇÃO DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','Compreende os valores concedidos a servidor responsável para atender despesas que não possam subordinar-se ao processo normal de aplicação,ate a sua prestação de contas.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A COMPROVAR','Registra os valores dos adiantamentos concedidos pendentes de comprovação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.02.00','ADIANTAMENTOS A APROVAR','Registra os valores dos adiantamentos concedidos comprovados pendentes de aprovação.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.03.00','ADIANTAMENTOS APROVADOS','Registra os valores dos adiantamentos concedidos aprovados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.04.00','ADIANTAMENTOS IMPUGNADOS','Registra os valores dos adiantamentos concedidos impugnados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.05.00','ADIANTAMENTOS EM INDADIMPLÊNCIA','Registra os valores dos adiantamentos concedidos em inadimplência.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.1.06.00','ADIANTAMENTOS CANCELADOS','Registra os valores dos adiantamentos concedidos cancelados.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.2.00.00','EXECUÇÃO DE ATIVOS DE PPP CONTABILIZADOS NA SPE','Compreende o valor dos ativos produzidos por meio de parcerias público privadas contabilizados na sociedade de propósito específico.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.2.01.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','Registra o valor de outras responsabilidades de terceiros, de natureza eventual, por títulos, valores e bens, para as quais não há contas específicas.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.2.02.00','ATIVOS DE PPP CONTABILIZADOS NA SPE BAIXADOS','Registra as responsabilidades em fase de apuração decorrentes de atospraticados por gestores, servidores ou terceiros que possam resultarem prejuizos para a fazenda nacional.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.1.2.9.00.00','EXECUÇÃO DE OUTRAS RESPONSABILIDADES DE TERCEIROS','Registra responsabilidades com terceiros, não individualizadas nas outras contas desse grupo.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','Compreende as responsabilidades em fase de apuração decorrentes de atos praticados por gestores, servidores ou terceiros que possam resultarem prejuizos para a fazenda nacional.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.1.0.00.00','PAGAMENTOS INDEVIDOS','Registra as responsabilidades em apuração de gestores e outros responsáveis e co-responsáveis por pagamentos efetuados indevidamente, inclusive em casos de superfaturamento.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.2.0.00.00','SALDOS NÃO RECOLHIDOS','Registra os saldos dos valores entregues a funcionarios ou servidores,não recolhidos dentro dos prazos estabelecidos em normas legais ou administrativas cujos processos estejam em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.3.0.00.00','DESFALQUES OU DESVIOS','Registra os desfalques ou desvios de bens e valores da união ou de entidades públicas, em apuração,decorrentes de processos por ações admininistrativas, policiais ou judiciais.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.4.0.00.00','DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos às responsabilidades por irregularidadesem prestação de serviços por terceiros, cujos processos estejam em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.5.0.00.00','RESPONSÁVEIS POR DANOS OU PERDAS','Registra ao registro das responsabilidades em inqueritos administrativos ou policiais contra servidores ou terceiros, por danos e perdascausados a fazenda nacional, e que estejam em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.6.0.00.00','PAGAMENTOS SEM RESPALDO ORÇAMENTÁRIO','Registra as despesas realizadas sem existencia de crédito que as comporte, resultando em pagamento sem prévio empenho ou ainda com classificação imprópria (diferente daquela prevista no orçamento), em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.7.0.00.00','CRÉDITOS ANTECIPADOS','Registra os valores pagos sobre dotações decorrentes de créditos antecipados não realizados ate o fechamento do exercício, em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.8.0.00.00','FALTA OU IRREGULARIDADE DE COMPROVAÇÃO','Registra os valores correspond. a falta de documentação comprobat.da e-xecucao da despesa, inclusive as apresent.fora do prazo legal, bem como a inadimplência na comprov.de instrument.de transfer.ou ainda irregularid. na document., em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.0.00.00','OUTRAS RESPONSABILIDADES EM APURAÇÃO','Compreende outras responsabilidades em apuração.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.00.00','MULTAS E JUROS','Compreende os valores referentes a multas e juros pagos pelo órgão, porém de responsabilidade de servidores e que estejam em fase de apuração.','C','N','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.01.00','FALTA DE LICITAÇÃO','Registra os valores relativos a bens e serviços adquiridos sem a necessária licitação, infringindo a legislação específica, em processos motivados, por determinações administrativas e ou inquéritos, em fase de apuração.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.02.00','FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIÁRIAS','Registra os valores correspondentes a falta de recolhimento ou pagamento de obrigações pecuniárias, tais como: parte do empregador de obrig. patronais, valores descontados de terceiros e não recolhidos,não pagamento de obrigac. para com a união.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.04.00','DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMÓVEL','Registra os débitos oriundos de uso ou aluguel de imóveis.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.05.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','Registra os adiantamentos concedidos irregularmente.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.06.00','FRAUDES EM BENEFÍCIOS','Registra os valores em apuração de fraudes em benefícios.','C','S','','',NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit, atributo_tcepe) VALUES (16, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 16), 1),'8.9.2.9.1.99.00','DEMAIS RESPONSABILIDADES EM APURAÇÃO','Registra responsabilidades em apuração não individualizadas nas outras contas desse grupo.','C','S','','',NULL);

UPDATE contabilidade.plano_conta_estrutura
   SET natureza_informacao ='P'
 WHERE cod_uf = 16
   AND (    codigo_estrutural ilike'1%'
         OR codigo_estrutural ilike'2%'
         OR codigo_estrutural ilike'3%'
         OR codigo_estrutural ilike'4%'
       );

UPDATE contabilidade.plano_conta_estrutura
   SET natureza_informacao ='O'
 WHERE cod_uf = 16
   AND (    codigo_estrutural ilike'5%'
         OR codigo_estrutural ilike'6%'
       );

UPDATE contabilidade.plano_conta_estrutura
   SET natureza_informacao ='C'
 WHERE cod_uf = 16
   AND (    codigo_estrutural ilike'7%'
         OR codigo_estrutural ilike'8%'
       );


----------------
-- Ticket #22263
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3009
     , 487
     , 'FMManterTipoCredor.php'
     , 'manter'
     , 12
     , ''
     , 'Relacionar Tipo de Credor'
     , TRUE
     );

CREATE TABLE tcepe.tipo_credor(
    cod_tipo_credor     INTEGER     NOT NULL,
    descricao           VARCHAR(40) NOT NULL,
    CONSTRAINT pk_tipo_credor       PRIMARY KEY (cod_tipo_credor)
);
GRANT ALL ON tcepe.tipo_credor TO urbem;

INSERT INTO tcepe.tipo_credor VALUES(3, 'Folha de pagamento'                  );
INSERT INTO tcepe.tipo_credor VALUES(4, 'Depósito Judicial'                   );
INSERT INTO tcepe.tipo_credor VALUES(5, 'Pessoa Física Estrangeira sem CPF'   );
INSERT INTO tcepe.tipo_credor VALUES(6, 'Pessoa Jurídica Estrangeira sem CNPJ');


CREATE TABLE tcepe.cgm_tipo_credor(
    cgm_credor          INTEGER     NOT NULL,
    exercicio           CHAR(4)     NOT NULL,
    cod_tipo_credor     INTEGER     NOT NULL,
    CONSTRAINT pk_cgm_tipo_credor   PRIMARY KEY                     (cgm_credor, exercicio),
    CONSTRAINT fk_cgm_tipo_credor_1 FOREIGN KEY                     (cgm_credor)
                                    REFERENCES sw_cgm               (numcgm), 
    CONSTRAINT fk_cgm_tipo_credor_2 FOREIGN KEY                     (cod_tipo_credor)
                                    REFERENCES tcepe.tipo_credor    (cod_tipo_credor)
);
GRANT ALL ON tcepe.cgm_tipo_credor TO urbem;


----------------
-- Ticket #22254
----------------

CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN
    PERFORM 1
       FROM pg_tables
      WHERE tablename  = 'tipo_socio'
        AND schemaname = 'compras'
          ;
    IF NOT FOUND THEN
        CREATE TABLE compras.tipo_socio(
            cod_tipo    INTEGER         NOT NULL,
            descricao   VARCHAR(40)     NOT NULL,
            CONSTRAINT pk_tipo_socio    PRIMARY KEY (cod_tipo)
        );
        GRANT ALL ON compras.tipo_socio TO urbem;
        
        INSERT INTO compras.tipo_socio VALUES (1, 'Representante legal'                );
        INSERT INTO compras.tipo_socio VALUES (2, 'Demais membros do quadro societário');
        INSERT INTO compras.tipo_socio VALUES (3, 'Micro Empreendedor Individual'      );
        
        CREATE TABLE compras.fornecedor_socio(
            id      INTEGER     NOT NULL,
            cgm_fornecedor  INTEGER     NOT NULL,
            cgm_socio       INTEGER     NOT NULL,
            cod_tipo        INTEGER     NOT NULL,
            ativo           BOOLEAN     NOT NULL DEFAULT FALSE,
            CONSTRAINT pk_fornecedor_socio      PRIMARY KEY                  (id),
            CONSTRAINT fk_fornecedor_socio_1    FOREIGN KEY                  (cgm_fornecedor)
                                                REFERENCES compras.fornecedor(cgm_fornecedor),
            CONSTRAINT fk_fornecedor_socio_2    FOREIGN KEY                  (cgm_socio)
                                                REFERENCES sw_cgm            (numcgm),
            CONSTRAINT fk_fornecedor_socio_3    FOREIGN KEY                  (cod_tipo)
                                                REFERENCES compras.tipo_socio(cod_tipo),
            CONSTRAINT uk_fornecedor_socio_1    UNIQUE (cgm_fornecedor, cgm_socio)
        );
        GRANT ALL ON compras.fornecedor_socio TO urbem;
    END IF;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #22282
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
     VALUES
     ( 3010
     , 487
     , 'FMManterTecnicoResponsavel.php'
     , 'incluir'
     , 13
     , ''
     , 'Configurar Responsável Técnico'
     , TRUE
     );


INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3011
     , 487
     , 'FMManterProvedorSistema.php'
     , 'incluir'
     , 14
     , ''
     , 'Configurar Provedor do Sistema'
     , TRUE
     );


CREATE TABLE tcepe.tipo_responsavel(
    cod_tipo    INTEGER     NOT NULL,
    descricao   VARCHAR(30) NOT NULL,
    CONSTRAINT pk_tipo_responsavel  PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcepe.tipo_responsavel TO urbem;


INSERT INTO tcepe.tipo_responsavel VALUES (1, 'Contador');
INSERT INTO tcepe.tipo_responsavel VALUES (2, 'Técnico de Contabilidade');


CREATE TABLE tcepe.responsavel_tecnico(
    cgm_responsavel     INTEGER     NOT NULL,
    cod_entidade        INTEGER     NOT NULL,
    exercicio           CHAR(4)     NOT NULL,
    cod_tipo            INTEGER     NOT NULL,
    crc                 varchar(10)         ,
    dt_inicio           DATE        NOT NULL,
    dt_fim              DATE        NOT NULL,
    CONSTRAINT pk_responsavel_tecnico   PRIMARY KEY                      (cgm_responsavel),
    CONSTRAINT fk_responsavel_tecnico_1 FOREIGN KEY                      (cgm_responsavel)
                                                    REFERENCES sw_cgm    (numcgm),
    CONSTRAINT fk_responsavel_tecnico_2 FOREIGN KEY                      (cod_entidade, exercicio)
                                        REFERENCES orcamento.entidade    (cod_entidade, exercicio),
    CONSTRAINT fk_responsavel_tecnico_3 FOREIGN KEY                      (cod_tipo)
                                        REFERENCES tcepe.tipo_responsavel(cod_tipo)
);
GRANT ALL ON tcepe.responsavel_tecnico TO urbem;


INSERT INTO administracao.configuracao (exercicio, cod_modulo, parametro, valor) VALUES ('2014', 63, 'provedor_sistema', '');


----------------
-- Ticket #22301
----------------

ALTER TABLE tcemg.uniorcam DROP COLUMN cod_unidade_anterior;
ALTER TABLE tcemg.uniorcam ADD  COLUMN exercicio_atual   CHAR(4);
ALTER TABLE tcemg.uniorcam ADD  COLUMN num_orgao_atual   INTEGER;
ALTER TABLE tcemg.uniorcam ADD  COLUMN num_unidade_atual INTEGER;
ALTER TABLE tcemg.uniorcam ADD  CONSTRAINT fk_uniorcam_2 FOREIGN KEY (exercicio_atual, num_orgao_atual, num_unidade_atual)
                                                         REFERENCES orcamento.unidade (exercicio, num_orgao, num_unidade);


----------------
-- Ticket #22294
----------------

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 8
     , 'remuneracao_eventual'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 8
                AND parametro    = 'remuneracao_eventual'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 8
     , 'redutor_teto'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 8
                AND parametro    = 'redutor_teto'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 8
     , 'verbas_indenizatorias'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 8
                AND parametro    = 'verbas_indenizatorias'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 8
     , 'demais_deducoes'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 8
                AND parametro    = 'demais_deducoes'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 8
     , 'pagamento_jetons'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 8
                AND parametro    = 'pagamento_jetons'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'orgao_prefeitura'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'orgao_prefeitura'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'unidade_prefeitura'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'unidade_prefeitura'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'orgao_camara'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'orgao_camara'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'unidade_camara'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'unidade_camara'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'orgao_rpps'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'orgao_rpps'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'unidade_rpps'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'unidade_rpps'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'orgao_outros'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'orgao_outros'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'unidade_outros'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'unidade_outros'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'hash_identificador'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'hash_identificador'
           )
     ;

INSERT
  INTO administracao.configuracao
     ( exercicio
     , cod_modulo
     , parametro
     , valor
     )
SELECT '2014'
     , 58
     , 'exporta_automatico'
     , ''
 WHERE 0 = (
             SELECT COUNT(1)
               FROM administracao.configuracao
              WHERE exercicio    = '2014'
                AND cod_modulo   = 58
                AND parametro    = 'exporta_automatico'
           )
     ;

