/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.03.7
*
* Gelson W. Gonçalves - 20150210
*
*/
----------------
-- Ticket #22674
----------------

INSERT INTO administracao.acao
          ( cod_acao
          , cod_funcionalidade
          , nom_arquivo
          , parametro
          , ordem
          , complemento_acao
          , nom_acao )
     VALUES ( 3042
          , 403
          , 'FMManterVinculoTipoVeiculo.php'
          , 'manter'
          , 50
          , ''
          , 'Configurar Tipo Veículo'
          );

CREATE TABLE tcern.especie_veiculo_tce (
    cod_especie_tce     INTEGER         NOT NULL,
    nom_especie_tce     VARCHAR(20)     NOT NULL,
    CONSTRAINT pk_especie_veiculo_tce   PRIMARY KEY     (cod_especie_tce)
);

GRANT ALL ON tcern.especie_veiculo_tce TO GROUP urbem;

INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (1, 'Passageiro');
INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (2, 'Carga');
INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (3, 'Misto');
INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (4, 'Corrida');
INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (5, 'Tração');
INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (6, 'Especial');
INSERT INTO tcern.especie_veiculo_tce(cod_especie_tce, nom_especie_tce) VALUES (7, 'Coleção');


CREATE TABLE tcern.tipo_veiculo_tce (
    cod_tipo_tce        INTEGER NOT NULL,
    nom_tipo_tce        VARCHAR(20),
    CONSTRAINT pk_tipo_veiculo_tce   PRIMARY KEY (cod_tipo_tce)
);

GRANT ALL ON tcern.tipo_veiculo_tce TO GROUP urbem;

INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (1,'BICICLETA');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (2,'CICLOMOTOR');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (3,'MOTONETA');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (4,'MOTOCICLETA');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (5,'TRICICLO');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (6,'AUTOMÓVEL');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (7,'MICRO ÔNIBUS');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (8,'ONIBUS');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (9,'BONDE');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (10,'REBOQUE');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (11,'SEMI-REBOQUE');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (12,'CHARRETE');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (13,'CAMIONETA');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (14,'CAMINHÃO');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (15,'CARROCA');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (16,'CARRO DE MÃO');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (17,'CAMINHÃO TRATOR');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (18,'TRATOR DE RODAS');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (19,'TRATOR ESTEIRAS');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (20,'TRATOR MISTO');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (21,'QUADRICICLO');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (22,'CAMINHONETE');
INSERT INTO tcern.tipo_veiculo_tce(cod_tipo_tce,nom_tipo_tce) VALUES (23,'EXPERIÊNCIA');

CREATE TABLE tcern.tipo_veiculo_vinculo (
    cod_tipo            INTEGER             NOT NULL,
    cod_especie_tce     INTEGER             NOT NULL,
    cod_tipo_tce        INTEGER             NOT NULL,
    CONSTRAINT pk_tipo_veiculo_vinculo      PRIMARY KEY                             (cod_tipo),
    CONSTRAINT fk_tipo_veiculo_vinculo_1    FOREIGN KEY                             (cod_tipo)
                                            REFERENCES frota.tipo_veiculo           (cod_tipo),
    CONSTRAINT fk_tipo_veiculo_vinculo_2    FOREIGN KEY                             (cod_especie_tce)
                                            REFERENCES tcern.especie_veiculo_tce    (cod_especie_tce),
    CONSTRAINT fk_tipo_veiculo_vinculo_3    FOREIGN KEY                             (cod_tipo_tce)
                                            REFERENCES tcern.tipo_veiculo_tce       (cod_tipo_tce)
);

GRANT ALL ON tcern.tipo_veiculo_vinculo TO GROUP urbem;

----------------
-- Ticket #22675
----------------
CREATE TABLE tcern.categoria_veiculo_tce (
    cod_categoria       INTEGER NOT NULL,
    nom_categoria       VARCHAR(20),
    CONSTRAINT pk_categoria_veiculo_tce  PRIMARY KEY (cod_categoria)
);

GRANT ALL ON tcern.categoria_veiculo_tce TO GROUP urbem;

INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (1,'Particular');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (2,'Aluguel');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (3,'Oficial');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (4,'Experiência');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (5,'Aprendizagem');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (6,'Fabricante');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (7,'Diplomático');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (8,'Consular');
INSERT INTO tcern.categoria_veiculo_tce (cod_categoria,nom_categoria) VALUES (9,'Origem Interna');

CREATE TABLE tcern.veiculo_categoria_vinculo (
    cod_veiculo       INTEGER NOT NULL,
    cod_categoria     INTEGER NOT NULL,
    CONSTRAINT pk_veiculo_categoria_veiculo    PRIMARY KEY (cod_veiculo),
    CONSTRAINT fk_veiculo_categoria_vinculo_1  FOREIGN KEY                            (cod_veiculo)
                                               REFERENCES frota.veiculo               (cod_veiculo),
    CONSTRAINT fk_veiculo_categoria_vinculo_2  FOREIGN KEY                            (cod_categoria)
                                               REFERENCES tcern.categoria_veiculo_tce (cod_categoria)
);

GRANT ALL ON tcern.veiculo_categoria_vinculo TO GROUP urbem;


----------------
-- Ticket #21253
----------------

ALTER TABLE tcemg.processo_adesao_registro_precos RENAME TO registro_precos;


ALTER TABLE tcemg.empenho_registro_precos DROP CONSTRAINT pk_empenho_registro_de_precos;
ALTER TABLE tcemg.empenho_registro_precos DROP CONSTRAINT fk_empenho_registro_de_precos_1;
ALTER TABLE tcemg.item_registro_precos    DROP CONSTRAINT pk_item_registro_precos;
ALTER TABLE tcemg.item_registro_precos    DROP CONSTRAINT fk_item_registro_precos_1;
ALTER TABLE tcemg.lote_registro_precos    DROP CONSTRAINT fk_lote_registro_precos_1;
ALTER TABLE tcemg.lote_registro_precos    DROP CONSTRAINT pk_lote_registro_precos;
ALTER TABLE tcemg.lote_registro_precos    DROP CONSTRAINT uk_lote_registro_precos_1;
ALTER TABLE tcemg.registro_precos         DROP CONSTRAINT pk_processo_adesao_registro_precos;
ALTER TABLE tcemg.registro_precos         DROP CONSTRAINT fk_processo_adesao_registro_precos_1;
ALTER TABLE tcemg.registro_precos         DROP CONSTRAINT fk_processo_adesao_registro_precos_2;
ALTER TABLE tcemg.registro_precos         DROP CONSTRAINT fk_processo_adesao_registro_precos_3;


ALTER TABLE tcemg.registro_precos      RENAME COLUMN numero_processo_adesao         TO numero_registro_precos;
ALTER TABLE tcemg.registro_precos      RENAME COLUMN data_abertura_processo_adesao  TO data_abertura_registro_precos;
ALTER TABLE tcemg.registro_precos      RENAME COLUMN exercicio                      TO exercicio_unidade;
ALTER TABLE tcemg.registro_precos      RENAME COLUMN exercicio_adesao               TO exercicio;
ALTER TABLE tcemg.registro_precos      RENAME COLUMN objeto_adesao                  TO objeto;
ALTER TABLE tcemg.registro_precos      RENAME COLUMN numcgm                         TO numcgm_gerenciador;
ALTER TABLE tcemg.registro_precos      ALTER  COLUMN numero_processo_licitacao      TYPE VARCHAR(12);
ALTER TABLE tcemg.registro_precos      DROP   COLUMN natureza_procedimento;
ALTER TABLE tcemg.registro_precos      DROP   COLUMN data_publicacao_aviso_intencao;
ALTER TABLE tcemg.registro_precos      DROP   COLUMN exercicio_unidade;
ALTER TABLE tcemg.registro_precos      DROP   COLUMN num_unidade;
ALTER TABLE tcemg.registro_precos      DROP   COLUMN num_orgao;
ALTER TABLE tcemg.registro_precos      ADD    COLUMN interno BOOLEAN NOT NULL DEFAULT TRUE;

ALTER TABLE tcemg.lote_registro_precos RENAME COLUMN numero_processo_adesao TO numero_registro_precos;
ALTER TABLE tcemg.lote_registro_precos RENAME COLUMN exercicio_adesao       TO exercicio;
ALTER TABLE tcemg.lote_registro_precos ADD    COLUMN interno BOOLEAN;
UPDATE      tcemg.lote_registro_precos SET           interno = TRUE;
ALTER TABLE tcemg.lote_registro_precos ALTER  COLUMN interno SET NOT NULL;
ALTER TABLE tcemg.lote_registro_precos ADD    COLUMN numcgm_gerenciador INTEGER;
UPDATE tcemg.lote_registro_precos
   SET numcgm_gerenciador = registro_precos.numcgm_gerenciador
  FROM tcemg.registro_precos
 WHERE lote_registro_precos.cod_entidade           = registro_precos.cod_entidade
   AND lote_registro_precos.numero_registro_precos = registro_precos.numero_registro_precos
   AND lote_registro_precos.exercicio              = registro_precos.exercicio
   AND lote_registro_precos.interno                = registro_precos.interno
     ;
ALTER TABLE tcemg.lote_registro_precos ALTER  COLUMN numcgm_gerenciador SET NOT NULL;

ALTER TABLE tcemg.item_registro_precos RENAME COLUMN numero_processo_adesao TO numero_registro_precos;
ALTER TABLE tcemg.item_registro_precos RENAME COLUMN exercicio_adesao       TO exercicio;
ALTER TABLE tcemg.item_registro_precos RENAME COLUMN cgm_vencedor           TO cgm_fornecedor;
ALTER TABLE tcemg.item_registro_precos ADD    COLUMN interno BOOLEAN;
UPDATE      tcemg.item_registro_precos SET           interno = TRUE;
ALTER TABLE tcemg.item_registro_precos ALTER  COLUMN interno SET NOT NULL;
ALTER TABLE tcemg.item_registro_precos ADD    COLUMN ordem_classificacao_fornecedor INTEGER;
UPDATE      tcemg.item_registro_precos SET           ordem_classificacao_fornecedor = 1;
ALTER TABLE tcemg.item_registro_precos ALTER  COLUMN ordem_classificacao_fornecedor SET NOT NULL;
ALTER TABLE tcemg.item_registro_precos ADD    COLUMN numcgm_gerenciador INTEGER;
UPDATE tcemg.item_registro_precos
   SET numcgm_gerenciador = lote_registro_precos.numcgm_gerenciador
  FROM tcemg.lote_registro_precos
 WHERE item_registro_precos.cod_entidade           = lote_registro_precos.cod_entidade
   AND item_registro_precos.numero_registro_precos = lote_registro_precos.numero_registro_precos
   AND item_registro_precos.exercicio              = lote_registro_precos.exercicio
   AND item_registro_precos.interno                = lote_registro_precos.interno
   AND item_registro_precos.cod_lote               = lote_registro_precos.cod_lote
     ;
ALTER TABLE tcemg.item_registro_precos ALTER  COLUMN numcgm_gerenciador SET NOT NULL;


ALTER TABLE tcemg.empenho_registro_precos RENAME COLUMN numero_processo_adesao TO numero_registro_precos;
ALTER TABLE tcemg.empenho_registro_precos RENAME COLUMN exercicio_adesao       TO exercicio;
ALTER TABLE tcemg.empenho_registro_precos ADD    COLUMN interno BOOLEAN;
UPDATE      tcemg.empenho_registro_precos SET           interno = TRUE;
ALTER TABLE tcemg.empenho_registro_precos ALTER  COLUMN interno SET NOT NULL;
ALTER TABLE tcemg.empenho_registro_precos ADD    COLUMN cod_entidade_empenho INTEGER;
UPDATE      tcemg.empenho_registro_precos SET           cod_entidade_empenho = cod_entidade;
ALTER TABLE tcemg.empenho_registro_precos ALTER  COLUMN cod_entidade_empenho SET NOT NULL;
ALTER TABLE tcemg.empenho_registro_precos ADD    COLUMN numcgm_gerenciador INTEGER;
UPDATE tcemg.empenho_registro_precos
   SET numcgm_gerenciador = registro_precos.numcgm_gerenciador
  FROM tcemg.registro_precos
 WHERE empenho_registro_precos.cod_entidade           = registro_precos.cod_entidade
   AND empenho_registro_precos.numero_registro_precos = registro_precos.numero_registro_precos
   AND empenho_registro_precos.exercicio              = registro_precos.exercicio
   AND empenho_registro_precos.interno                = registro_precos.interno
     ;
ALTER TABLE tcemg.lote_registro_precos ALTER  COLUMN numcgm_gerenciador SET NOT NULL;



ALTER TABLE tcemg.registro_precos         ADD  CONSTRAINT pk_registro_precos             PRIMARY KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador);
ALTER TABLE tcemg.registro_precos         ADD  CONSTRAINT fk_registro_precos_1           FOREIGN KEY                             (numcgm_gerenciador)
                                                                                         REFERENCES sw_cgm                       (numcgm);
ALTER TABLE tcemg.registro_precos         ADD  CONSTRAINT fk_registro_precos_2           FOREIGN KEY                             (cgm_responsavel)
                                                                                         REFERENCES sw_cgm_pessoa_fisica         (numcgm);
ALTER TABLE tcemg.lote_registro_precos    ADD  CONSTRAINT fk_lote_registro_precos_1      FOREIGN KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador)
                                                                                         REFERENCES tcemg.registro_precos        (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador);
ALTER TABLE tcemg.lote_registro_precos    ADD  CONSTRAINT pk_lote_registro_precos        PRIMARY KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador, cod_lote);
ALTER TABLE tcemg.lote_registro_precos    ADD  CONSTRAINT uk_lote_registro_precos_1      UNIQUE                                  (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador, descricao_lote);
ALTER TABLE tcemg.item_registro_precos    ADD  CONSTRAINT pk_item_registro_precos        PRIMARY KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador, cod_lote, cod_item, cgm_fornecedor);
ALTER TABLE tcemg.item_registro_precos    ADD  CONSTRAINT fk_item_registro_precos_1      FOREIGN KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador, cod_lote)
                                                                                         REFERENCES tcemg.lote_registro_precos   (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador, cod_lote);
ALTER TABLE tcemg.empenho_registro_precos ADD CONSTRAINT pk_empenho_registro_de_precos   PRIMARY KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador, cod_entidade_empenho, cod_empenho, exercicio_empenho);
ALTER TABLE tcemg.empenho_registro_precos ADD CONSTRAINT fk_empenho_registro_de_precos_2 FOREIGN KEY                             (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador)
                                                                                         REFERENCES tcemg.registro_precos        (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador);
ALTER TABLE tcemg.empenho_registro_precos ADD CONSTRAINT fk_empenho_registro_de_precos_1 FOREIGN KEY                             (cod_entidade_empenho, cod_empenho, exercicio_empenho)
                                                                                         REFERENCES empenho.empenho              (cod_entidade, cod_empenho, exercicio);


CREATE TABLE tcemg.registro_precos_orgao(
    cod_entidade                    INTEGER         NOT NULL,
    numero_registro_precos          INTEGER         NOT NULL,
    exercicio_registro_precos       CHAR(4)         NOT NULL,
    interno                         BOOLEAN         NOT NULL,
    numcgm_gerenciador              INTEGER         NOT NULL,
    exercicio_unidade               CHAR(4)         NOT NULL,
    num_unidade                     INTEGER         NOT NULL,
    num_orgao                       INTEGER         NOT NULL,
    participante                    BOOLEAN         NOT NULL DEFAULT TRUE,
    numero_processo_adesao          INTEGER                 ,
    exercicio_adesao                CHAR(4)                 ,
    dt_publicacao_aviso_intencao    DATE                    ,
    dt_adesao                       DATE                    ,
    gerenciador                     BOOLEAN         NOT NULL DEFAULT FALSE,
    CONSTRAINT pk_registro_precos_orgao             PRIMARY KEY                      (cod_entidade, numero_registro_precos, exercicio_registro_precos, interno, numcgm_gerenciador, exercicio_unidade, num_unidade, num_orgao),
    CONSTRAINT fk_registro_precos_orgao_1           FOREIGN KEY                      (cod_entidade, numero_registro_precos, exercicio_registro_precos, interno, numcgm_gerenciador)
                                                    REFERENCES tcemg.registro_precos (cod_entidade, numero_registro_precos, exercicio, interno, numcgm_gerenciador),
    CONSTRAINT fk_registro_precos_orgao_2           FOREIGN KEY                      (exercicio_unidade, num_unidade, num_orgao)
                                                    REFERENCES orcamento.unidade     (exercicio        , num_unidade, num_orgao)
);
GRANT ALL ON tcemg.registro_precos_orgao TO urbem;


CREATE TABLE tcemg.registro_precos_orgao_item(
    cod_entidade                INTEGER         NOT NULL,
    numero_registro_precos      INTEGER         NOT NULL,
    exercicio_registro_precos   CHAR(4)         NOT NULL,
    interno                     BOOLEAN         NOT NULL,
    numcgm_gerenciador          INTEGER         NOT NULL,
    exercicio_unidade           CHAR(4)         NOT NULL,
    num_unidade                 INTEGER         NOT NULL,
    num_orgao                   INTEGER         NOT NULL,
    cod_lote                    INTEGER         NOT NULL,
    cod_item                    INTEGER         NOT NULL,
    cgm_fornecedor              INTEGER         NOT NULL,
    quantidade                  NUMERIC(14,4)   NOT NULL,
    CONSTRAINT pk_registro_precos_orgao_item    PRIMARY KEY                            (cod_entidade, numero_registro_precos, exercicio_registro_precos, interno, numcgm_gerenciador, exercicio_unidade, num_unidade, num_orgao, cod_lote, cod_item, cgm_fornecedor),
    CONSTRAINT fk_registro_precos_orgao_item_1  FOREIGN KEY                            (cod_entidade, numero_registro_precos, exercicio_registro_precos, interno, numcgm_gerenciador, exercicio_unidade, num_unidade, num_orgao)
                                                REFERENCES tcemg.registro_precos_orgao (cod_entidade, numero_registro_precos, exercicio_registro_precos, interno, numcgm_gerenciador, exercicio_unidade, num_unidade, num_orgao),
    CONSTRAINT fk_registro_precos_orgao_item_2  FOREIGN KEY                            (cod_entidade, numero_registro_precos, exercicio_registro_precos, interno, numcgm_gerenciador, cod_lote, cod_item, cgm_fornecedor)
                                                REFERENCES tcemg.item_registro_precos  (cod_entidade, numero_registro_precos, exercicio                , interno, numcgm_gerenciador, cod_lote, cod_item, cgm_fornecedor)
);
GRANT ALL ON tcemg.registro_precos_orgao_item TO urbem;


----------------
-- Ticket #22507
----------------

ALTER TABLE patrimonio.bem_comprado ADD COLUMN caminho_nf VARCHAR (100);


----------------
-- Ticket #20489
----------------

INSERT INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3041
     , 451
     , 'FMManterConfiguracaoProjecaoAtuarial.php'
     , 'manter'
     , 44
     , ''
     , 'Configurar Projeção Atuarial'
     , TRUE
     );

CREATE TABLE tcemg.projecao_atuarial (
    exercicio           CHAR(4)         NOT NULL,
    cod_entidade        INTEGER         NOT NULL,
    exercicio_entidade  CHAR(4)         NOT NULL,
    vl_patronal         NUMERIC(14,2)           ,
    vl_receita          NUMERIC(14,2)           ,
    vl_despesa          NUMERIC(14,2)           ,
    vl_rpps             NUMERIC(14,2)           ,
    CONSTRAINT pk_projecao_atuarial     PRIMARY KEY                   (exercicio, cod_entidade, exercicio_entidade),
    CONSTRAINT fk_projecao_atuarial_1   FOREIGN KEY                   (cod_entidade, exercicio_entidade)
                                        REFERENCES orcamento.entidade (cod_entidade, exercicio)
);
GRANT ALL ON tcemg.projecao_atuarial TO urbem;


----------------
-- Ticket #20200
----------------

ALTER TABLE patrimonio.depreciacao DROP CONSTRAINT fk_depreciacao_1;
ALTER TABLE patrimonio.depreciacao ADD  CONSTRAINT fk_depreciacao_1 FOREIGN KEY              (cod_bem)
                                                                    REFERENCES patrimonio.bem(cod_bem);
ALTER TABLE patrimonio.depreciacao ALTER COLUMN timestamp SET DEFAULT ('now'::text)::timestamp(3) with time zone;


----------------
-- Ticket #22797
----------------

INSERT INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3043
     , 451
     , 'FMManterOperacoesCreditoARO.php'
     , 'manter'
     , 45
     , ''
     , 'Operações de Crédito ARO'
     , TRUE
     );


CREATE TABLE tcemg.operacao_credito_aro (
    exercicio           CHAR(4)              NOT NULL,
    cod_entidade        INTEGER              NOT NULL,
    dt_contratacao      DATE                 NOT NULL,
    vl_contratado       NUMERIC(14,2)        NOT NULL,
    dt_principal        DATE                 NOT NULL,
    dt_juros            DATE                 NOT NULL,
    dt_encargos         DATE                 NOT NULL,
    vl_liquidacao       NUMERIC(14,2)        NOT NULL,
    CONSTRAINT pk_operacao_credito_aro       PRIMARY KEY                   (exercicio, cod_entidade),
    CONSTRAINT fk_operacao_credito_aro_1     FOREIGN KEY                   (exercicio, cod_entidade)
                                             REFERENCES orcamento.entidade (exercicio, cod_entidade)
);
GRANT ALL ON tcemg.operacao_credito_aro TO urbem;


----------------
-- Ticket #22801
----------------

CREATE TABLE tcemg.licitacao_tc(
    cod_licitacao           INTEGER     NOT NULL,
    cod_modalidade          INTEGER     NOT NULL,
    cod_entidade            INTEGER     NOT NULL,
    exercicio               CHAR(4)     NOT NULL,
    numero_licitacao        VARCHAR(12) NOT NULL,
    exercicio_licitacao     CHAR(4)     NOT NULL,
    CONSTRAINT pk_licitacao_tc          PRIMARY KEY                   (cod_licitacao, cod_modalidade, cod_entidade, exercicio),
    CONSTRAINT fk_licitacao_tc_1        FOREIGN KEY                   (cod_licitacao, cod_modalidade, cod_entidade, exercicio)
                                        REFERENCES licitacao.licitacao(cod_licitacao, cod_modalidade, cod_entidade, exercicio)
);
GRANT ALL ON tcemg.licitacao_tc TO urbem;


CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN

    PERFORM 1
       FROM administracao.configuracao
      WHERE cod_modulo = 2
        AND exercicio  = '2015'
        AND parametro  = 'cnpj'
        AND valor      = '18301002000186'
          ;
    IF FOUND THEN
        UPDATE licitacao.homologacao SET timestamp = '2013-12-18'::TIMESTAMP WHERE cod_licitacao =  5 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-11-04'::TIMESTAMP WHERE cod_licitacao =  6 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2011-08-25'::TIMESTAMP WHERE cod_licitacao = 15 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-12-02'::TIMESTAMP WHERE cod_licitacao = 21 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-03-10'::TIMESTAMP WHERE cod_licitacao = 31 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-04-04'::TIMESTAMP WHERE cod_licitacao = 32 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-05-06'::TIMESTAMP WHERE cod_licitacao = 33 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-05-06'::TIMESTAMP WHERE cod_licitacao = 34 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-04'::TIMESTAMP WHERE cod_licitacao = 35 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-07'::TIMESTAMP WHERE cod_licitacao = 36 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-12'::TIMESTAMP WHERE cod_licitacao = 37 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-23'::TIMESTAMP WHERE cod_licitacao = 38 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-24'::TIMESTAMP WHERE cod_licitacao = 39 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-02'::TIMESTAMP WHERE cod_licitacao = 40 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-02'::TIMESTAMP WHERE cod_licitacao = 41 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-15'::TIMESTAMP WHERE cod_licitacao = 42 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-12-02'::TIMESTAMP WHERE cod_licitacao =  2 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-22'::TIMESTAMP WHERE cod_licitacao = 43 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-07-26'::TIMESTAMP WHERE cod_licitacao = 18 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-15'::TIMESTAMP WHERE cod_licitacao = 30 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-22'::TIMESTAMP WHERE cod_licitacao = 43 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-02-20'::TIMESTAMP WHERE cod_licitacao = 29 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-22'::TIMESTAMP WHERE cod_licitacao = 44 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-10-30'::TIMESTAMP WHERE cod_licitacao =  3 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-01-03'::TIMESTAMP WHERE cod_licitacao =  5 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-04-04'::TIMESTAMP WHERE cod_licitacao =  7 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-11'::TIMESTAMP WHERE cod_licitacao =  8 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-24'::TIMESTAMP WHERE cod_licitacao =  9 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-24'::TIMESTAMP WHERE cod_licitacao = 10 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-30'::TIMESTAMP WHERE cod_licitacao = 11 AND cod_modalidade = 2 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2010-02-04'::TIMESTAMP WHERE cod_licitacao =  1 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2010-09-29'::TIMESTAMP WHERE cod_licitacao =  3 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-05-09'::TIMESTAMP WHERE cod_licitacao =  4 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2010-03-08'::TIMESTAMP WHERE cod_licitacao =  6 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2011-01-03'::TIMESTAMP WHERE cod_licitacao =  9 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-05-06'::TIMESTAMP WHERE cod_licitacao = 11 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2008-12-30'::TIMESTAMP WHERE cod_licitacao = 14 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2009-12-10'::TIMESTAMP WHERE cod_licitacao = 16 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-12-11'::TIMESTAMP WHERE cod_licitacao = 18 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2011-07-05'::TIMESTAMP WHERE cod_licitacao = 21 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-08-30'::TIMESTAMP WHERE cod_licitacao = 22 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-12-12'::TIMESTAMP WHERE cod_licitacao = 27 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2010-02-04'::TIMESTAMP WHERE cod_licitacao = 28 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2001-01-28'::TIMESTAMP WHERE cod_licitacao = 30 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2011-04-01'::TIMESTAMP WHERE cod_licitacao = 31 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-05-09'::TIMESTAMP WHERE cod_licitacao = 32 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2010-12-30'::TIMESTAMP WHERE cod_licitacao = 34 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2010-02-12'::TIMESTAMP WHERE cod_licitacao = 35 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-01-08'::TIMESTAMP WHERE cod_licitacao = 36 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-01-10'::TIMESTAMP WHERE cod_licitacao = 37 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-01-15'::TIMESTAMP WHERE cod_licitacao = 38 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-02-11'::TIMESTAMP WHERE cod_licitacao = 39 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-02-25'::TIMESTAMP WHERE cod_licitacao = 40 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2013-11-19'::TIMESTAMP WHERE cod_licitacao = 41 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-02-28'::TIMESTAMP WHERE cod_licitacao = 42 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-02-28'::TIMESTAMP WHERE cod_licitacao = 43 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-03-25'::TIMESTAMP WHERE cod_licitacao = 44 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-03-25'::TIMESTAMP WHERE cod_licitacao = 45 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-05-22'::TIMESTAMP WHERE cod_licitacao = 46 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-05-26'::TIMESTAMP WHERE cod_licitacao = 47 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-05-27'::TIMESTAMP WHERE cod_licitacao = 48 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-10'::TIMESTAMP WHERE cod_licitacao = 49 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-06-18'::TIMESTAMP WHERE cod_licitacao = 50 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-11'::TIMESTAMP WHERE cod_licitacao = 52 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-11'::TIMESTAMP WHERE cod_licitacao = 53 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-16'::TIMESTAMP WHERE cod_licitacao = 54 AND cod_modalidade = 8 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-01-31'::TIMESTAMP WHERE cod_licitacao =  3 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-05-14'::TIMESTAMP WHERE cod_licitacao =  6 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-08-08'::TIMESTAMP WHERE cod_licitacao =  7 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-14'::TIMESTAMP WHERE cod_licitacao =  9 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-16'::TIMESTAMP WHERE cod_licitacao = 10 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-16'::TIMESTAMP WHERE cod_licitacao = 11 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-24'::TIMESTAMP WHERE cod_licitacao = 12 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-24'::TIMESTAMP WHERE cod_licitacao = 14 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-30'::TIMESTAMP WHERE cod_licitacao = 15 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-30'::TIMESTAMP WHERE cod_licitacao = 16 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2015-11-22'::TIMESTAMP WHERE cod_licitacao =  2 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-07-31'::TIMESTAMP WHERE cod_licitacao = 17 AND cod_modalidade = 9 AND cod_entidade = 2 AND exercicio_licitacao = '2014';
        UPDATE licitacao.homologacao SET timestamp = '2014-01-29'::TIMESTAMP WHERE cod_licitacao = 25 AND cod_modalidade = 6 AND cod_entidade = 2 AND exercicio_licitacao = '2014';

        INSERT INTO tcemg.licitacao_tc VALUES ( 5, 6, 2, '2014',          '169', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES ( 6, 6, 2, '2014',           '84', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (15, 6, 2, '2014',           '58', '2011');
        INSERT INTO tcemg.licitacao_tc VALUES (21, 6, 2, '2014',          '158', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (31, 6, 2, '2014', '20298.000001', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (32, 6, 2, '2014', '20298.000023', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (33, 6, 2, '2014', '20298.000033', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (34, 6, 2, '2014', '20298.000041', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (35, 6, 2, '2014', '20298.000057', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (36, 6, 2, '2014', '20298.000017', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (37, 6, 2, '2014', '20298.000045', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (38, 6, 2, '2014', '20298.000042', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (39, 6, 2, '2014', '20298.000011', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (40, 6, 2, '2014', '20298.000076', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (41, 6, 2, '2014', '20298.000048', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (42, 6, 2, '2014', '20298.000062', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 2, 6, 2, '2014',          '140', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (43, 6, 2, '2014', '20298.000080', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (18, 6, 2, '2014',           '51', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (30, 6, 2, '2014', '20298.000019', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (29, 6, 2, '2014',          '175', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (44, 6, 2, '2014', '20298.000085', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 3, 2, 2, '2014',           '77', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES ( 5, 2, 2, '2014',          '176', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES ( 7, 2, 2, '2014', '20298.000014', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 8, 2, 2, '2014', '20298.000037', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 9, 2, 2, '2014',          '193', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (10, 2, 2, '2014', '20298.000068', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (11, 2, 2, '2014', '20298.000067', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 1, 8, 2, '2014',           '15', '2010');
        INSERT INTO tcemg.licitacao_tc VALUES ( 3, 8, 2, '2014',           '90', '2010');
        INSERT INTO tcemg.licitacao_tc VALUES ( 4, 8, 2, '2014',           '39', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES ( 6, 8, 2, '2014',           '18', '2010');
        INSERT INTO tcemg.licitacao_tc VALUES ( 9, 8, 2, '2014',            '1', '2011');
        INSERT INTO tcemg.licitacao_tc VALUES (11, 8, 2, '2014',           '53', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (14, 8, 2, '2014',          '384', '2008');
        INSERT INTO tcemg.licitacao_tc VALUES (16, 8, 2, '2014',           '19', '2009');
        INSERT INTO tcemg.licitacao_tc VALUES (18, 8, 2, '2014',          '181', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (21, 8, 2, '2014',           '77', '2011');
        INSERT INTO tcemg.licitacao_tc VALUES (22, 8, 2, '2014',          '121', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (27, 8, 2, '2014',          '156', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (28, 8, 2, '2014',           '15', '2010');
        INSERT INTO tcemg.licitacao_tc VALUES (30, 8, 2, '2014',            '9', '2011');
        INSERT INTO tcemg.licitacao_tc VALUES (31, 8, 2, '2014',           '14', '2011');
        INSERT INTO tcemg.licitacao_tc VALUES (32, 8, 2, '2014',           '63', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (34, 8, 2, '2014',            '8', '2010');
        INSERT INTO tcemg.licitacao_tc VALUES (35, 8, 2, '2014',           '16', '2010');
        INSERT INTO tcemg.licitacao_tc VALUES (36, 8, 2, '2014', '20298.000002', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (37, 8, 2, '2014',          '189', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (38, 8, 2, '2014', '20298.000013', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (39, 8, 2, '2014', '20298.000024', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (40, 8, 2, '2014', '20298.000025', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (41, 8, 2, '2014',          '174', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (42, 8, 2, '2014', '20298.000040', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (43, 8, 2, '2014', '20298.000028', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (44, 8, 2, '2014', '20298.000044', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (45, 8, 2, '2014', '20298.000047', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (46, 8, 2, '2014', '20298.000072', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (47, 8, 2, '2014', '20298.000058', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (48, 8, 2, '2014', '20298.000071', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (49, 8, 2, '2014', '20298.000079', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (50, 8, 2, '2014', '20298.000078', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (52, 8, 2, '2014', '20298.000091', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (53, 8, 2, '2014', '20298.000096', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (54, 8, 2, '2014', '20298.000099', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 3, 9, 2, '2014', '20298.000021', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 6, 9, 2, '2014', '20298.000069', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 7, 9, 2, '2014', '20298.000118', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 9, 9, 2, '2014', '20298.000086', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (10, 9, 2, '2014', '20298.000094', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (11, 9, 2, '2014', '20298.000093', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (12, 9, 2, '2014', '20298.000095', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (14, 9, 2, '2014', '20298.000111', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (15, 9, 2, '2014', '20298.000109', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (16, 9, 2, '2014', '20298.000110', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES ( 2, 9, 2, '2014',          '135', '2013');
        INSERT INTO tcemg.licitacao_tc VALUES (17, 9, 2, '2014', '20298.000112', '2014');
        INSERT INTO tcemg.licitacao_tc VALUES (25, 6, 2, '2014',          '198', '2013');
    END IF;

END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #21123
----------------

CREATE TABLE tcemg.arquivo_pessoa(
    numcgm      INTEGER     NOT NULL,
    ano         CHAR(4)     NOT NULL,
    mes         INTEGER     NOT NULL,
    CONSTRAINT pk_arquivo_pessoa    PRIMARY KEY      (numcgm),
    CONSTRAINT fk_arquivo_pessoa_1  FOREIGN KEY      (numcgm)
                                    REFERENCES sw_cgm(numcgm)
);
GRANT ALL ON tcemg.arquivo_pessoa TO urbem;


ALTER TABLE sw_cgm ADD COLUMN timestamp_inclusao  TIMESTAMP;
ALTER TABLE sw_cgm ADD COLUMN timestamp_alteracao TIMESTAMP;


CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE
    tsDataImplantacao       TIMESTAMP;
BEGIN
    PERFORM 1
       FROM administracao.configuracao
      WHERE cod_modulo = 2
        AND exercicio  = '2015'
        AND parametro  = 'cnpj'
        AND valor      = '18301002000186'
          ;
    IF FOUND THEN
        UPDATE sw_cgm
           SET timestamp_inclusao  = '2014-01-01'::timestamp(3)
             , timestamp_alteracao = '2014-01-01'::timestamp(3)
             ;

           INSERT
             INTO tcemg.arquivo_pessoa
           SELECT sw_cgm.numcgm
                , '2014'    AS ano
                , 1         AS mes
             FROM SW_CGM
        LEFT JOIN sw_cgm_pessoa_fisica
               ON SW_CGM.numcgm = sw_cgm_pessoa_fisica.numcgm
        LEFT JOIN sw_cgm_pessoa_juridica
               ON SW_CGM.numcgm = sw_cgm_pessoa_juridica.numcgm
        LEFT JOIN sw_cga
               ON SW_CGM.numcgm = sw_cga.numcgm
            WHERE SW_CGM.numcgm > 0
              AND SW_CGM.dt_cadastro <= TO_DATE('31/01/2014','DD/MM/YYYY')
              AND (
                        sw_cgm_pessoa_fisica.cpf    IS NOT NULL
                    OR  sw_cgm_pessoa_juridica.cnpj IS NOT NULL
                  )
         GROUP BY SW_CGM.numcgm
                , sw_cgm_pessoa_fisica.cpf
                , sw_cgm_pessoa_juridica.cnpj
                , sw_cgm_pessoa_fisica.numcgm
                , sw_cgm_pessoa_juridica.numcgm
                ;

    ELSE
        SELECT COALESCE(valor::timestamp(3), '2000-01-01'::timestamp(3))
          INTO tsDataImplantacao
          FROM administracao.configuracao
         WHERE cod_modulo = 9
           AND exercicio  = '2015'
           AND parametro  = 'data_implantacao'
           AND valor     IS NOT NULL
             ;
        IF tsDataImplantacao IS NULL THEN
            tsDataImplantacao := '2000-01-01'::timestamp(3);
        END IF;
             RAISE NOTICE 'timestamp: %', tsDataImplantacao;
        UPDATE sw_cgm
           SET timestamp_inclusao  = tsDataImplantacao
             , timestamp_alteracao = tsDataImplantacao
             ;
    END IF;

END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #21277
----------------

CREATE TABLE tcemg.arquivo_ext (
    cod_plano   INTEGER     NOT NULL,
    exercicio   CHAR(4),
    mes         CHAR(2),
    CONSTRAINT pk_arquivo_ext      PRIMARY KEY                              (cod_plano, exercicio),
    CONSTRAINT fk_arquivo_ext_1    FOREIGN KEY                              (cod_plano, exercicio)
                                   REFERENCES contabilidade.plano_analitica (cod_plano, exercicio)
);
GRANT ALL ON tcemg.arquivo_ext TO urbem;


----------------
-- Ticket #21151
----------------

CREATE TABLE tcemg.arquivo_item (
    cod_item    INTEGER     NOT NULL,
    exercicio   CHAR(4)     NOT NULL,
    mes         CHAR(2)     NOT NULL,
    CONSTRAINT pk_arquivo_item     PRIMARY KEY                          (cod_item),
    CONSTRAINT fk_arquivo_item_1   FOREIGN KEY                          (cod_item)
                                   REFERENCES almoxarifado.catalogo_item(cod_item)
);
GRANT ALL ON tcemg.arquivo_item TO urbem;


----------------
-- Ticket #21244
----------------

CREATE TABLE tcemg.arquivo_ctb(
    cod_ctb        INTEGER      NOT NULL,
    cod_ctb_view   VARCHAR      NOT NULL,
    cod_orgao      INTEGER      NOT NULL,
    tipo_conta     INTEGER      NOT NULL,
    tipo_aplicacao CHAR (2)             ,
    ano            CHAR(4)      NOT NULL,
    mes            INTEGER      NOT NULL,
    CONSTRAINT pk_arquivo_ctb   PRIMARY KEY      (cod_ctb_view)
);

GRANT ALL ON tcemg.arquivo_ctb TO urbem;


CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN
    PERFORM 1
       FROM administracao.configuracao
      WHERE cod_modulo = 2
        AND exercicio  = '2015'
        AND parametro  = 'cnpj'
        AND valor      = '18301002000186'
          ;
    IF FOUND THEN
          INSERT
            INTO tcemg.arquivo_ctb
          SELECT c.cod_ctb
               , c.cod_ctb_view
               , c.cod_orgao
               , c.tipo_conta
               , tipo_aplicacao
               , '2014' as ano
               , 1 as mes
            FROM (
                       SELECT '20'::VARCHAR AS tipo_registro
                            , cod_ctb
                            , tipo_conta||regexp_replace((conta), '[-|,|.|x]', '', 'gi') AS cod_ctb_view
                            , tipo_aplicacao
                            , tipo_conta
                            , cod_orgao
                            , plano_recurso.cod_recurso
                            , plano_analitica.cod_plano
                            , plano_analitica.exercicio
                            , saldo_inicial.saldo_anterior AS vl_saldo_inicial_fonte
                            , saldo_inicial.saldo_atual AS vl_saldo_final_fonte
                            , CASE WHEN (vl_lancamento IS NOT NULL) THEN 1 END AS movimentacao
                            , conta
                         FROM tcemg.contasCTB('2014', '2') as retorno
                                             (  cod_conta                        INTEGER
                                             , tipo_aplicacao                    VARCHAR
                                             , cod_ctb                           INTEGER
                                             , tipo_conta                        INTEGER
                                             , exercicio                         CHAR(4)
                                             , conta                             TEXT
                                             , conta_bancaria                    TEXT
                                             , conta_corrente                    TEXT
                                             , cod_orgao                         INTEGER
                                             , banco                             VARCHAR
                                             , agencia                           TEXT
                                             , digito_verificador_agencia        TEXT
                                             , digito_verificador_conta_bancaria TEXT
                                             , desc_conta_bancaria               VARCHAR
                                             )
                   INNER JOIN contabilidade.plano_analitica
                           ON retorno.cod_conta = plano_analitica.cod_conta
                          AND retorno.exercicio = plano_analitica.exercicio
                   INNER JOIN contabilidade.plano_banco
                           ON plano_analitica.cod_plano = plano_banco.cod_plano
                          AND plano_analitica.exercicio = plano_banco.exercicio
                    LEFT JOIN  tcemg.convenio_plano_banco
                           ON  convenio_plano_banco.cod_plano = plano_banco.cod_plano
                          AND  convenio_plano_banco.exercicio = plano_banco.exercicio
                   INNER JOIN  contabilidade.plano_recurso
                           ON  plano_analitica.cod_plano = plano_recurso.cod_plano
                          AND  plano_analitica.exercicio = plano_recurso.exercicio
                    LEFT JOIN (
                                   SELECT cod_plano
                                        , exercicio
                                        , cod_lote
                                        , tipo
                                        , sequencia
                                        , tipo_valor
                                        , cod_entidade
                                        , '1'::VARCHAR AS tipo_movimentacao
                                     FROM contabilidade.conta_debito
                                UNION ALL
                                   SELECT cod_plano
                                        , exercicio
                                        , cod_lote
                                        , tipo
                                        , sequencia
                                        , tipo_valor
                                        , cod_entidade
                                        , '2'::VARCHAR AS tipo_movimentacao
                                     FROM contabilidade.conta_credito
                              ) AS conta_debito_credito
                           ON plano_analitica.cod_plano = conta_debito_credito.cod_plano
                          AND plano_analitica.exercicio = conta_debito_credito.exercicio
                    LEFT JOIN contabilidade.valor_lancamento AS vl
                           ON conta_debito_credito.cod_lote     = vl.cod_lote
                          AND conta_debito_credito.tipo         = vl.tipo
                          AND conta_debito_credito.sequencia    = vl.sequencia
                          AND conta_debito_credito.exercicio    = vl.exercicio
                          AND conta_debito_credito.tipo_valor   = vl.tipo_valor
                          AND conta_debito_credito.cod_entidade = vl.cod_entidade
                    LEFT JOIN contabilidade.lancamento
                           ON lancamento.exercicio    = vl.exercicio
                          AND lancamento.cod_entidade = vl.cod_entidade
                          AND lancamento.tipo         = vl.tipo
                          AND lancamento.cod_lote     = vl.cod_lote
                          AND lancamento.sequencia    = vl.sequencia
                    LEFT JOIN contabilidade.lancamento_receita
                           ON lancamento_receita.exercicio    = lancamento.exercicio
                          AND lancamento_receita.cod_entidade = lancamento.cod_entidade
                          AND lancamento_receita.tipo         = lancamento.tipo
                          AND lancamento_receita.cod_lote     = lancamento.cod_lote
                          AND lancamento_receita.sequencia    = lancamento.sequencia
                    LEFT JOIN contabilidade.lote AS lo
                           ON vl.cod_lote     = lo.cod_lote
                          AND vl.exercicio    = lo.exercicio
                          AND vl.cod_entidade = lo.cod_entidade
                          AND  lo.dt_lote BETWEEN TO_DATE('01/01/2014','dd/mm/yyyy') AND TO_DATE('31/01/2014','dd/mm/yyyy')
                          AND  lo.exercicio = '2014'
                   INNER JOIN (
                                SELECT *
                                     , ((vl_debito - vl_credito) + saldo_anterior) as saldo_atual
                                  FROM tesouraria.fn_relatorio_demostrativo_saldos( '2014'
                                                                                  , '2'
                                                                                  , '01/01/2014'
                                                                                  , '31/01/2014'
                                                                                  , ''
                                                                                  , ''
                                                                                  , ''
                                                                                  , ''
                                                                                  , ''
                                                                                  , 'S'
                                                                                  , ''
                                                                                  , ''
                                                                                  , 'true'
                                                                                  ) as retorno
                                                                                  ( exercicio          VARCHAR
                                                                                  , cod_estrutural     VARCHAR
                                                                                  , cod_plano          INTEGER
                                                                                  , nom_conta          VARCHAR
                                                                                  , saldo_anterior     NUMERIC
                                                                                  , vl_credito         NUMERIC
                                                                                  , vl_debito          NUMERIC
                                                                                  , cod_recurso        INTEGER
                                                                                  , nom_recurso        VARCHAR
                                                                                  )
                              ) AS saldo_inicial
                           ON saldo_inicial.exercicio = plano_analitica.exercicio
                          AND saldo_inicial.cod_plano = plano_analitica.cod_plano
                          AND saldo_inicial.cod_recurso = plano_recurso.cod_recurso
                        WHERE  plano_banco.exercicio = '2014'
                          AND  plano_banco.cod_entidade IN (2)
                     GROUP BY cod_ctb
                            , cod_ctb_view
                            , cod_orgao
                            , tipo_conta
                            , tipo_aplicacao
                            , plano_recurso.cod_recurso
                            , plano_analitica.cod_plano
                            , plano_analitica.exercicio
                            , movimentacao
                            , saldo_inicial.saldo_anterior
                            , saldo_inicial.saldo_atual
                            , conta
                     ORDER BY cod_ctb
                 ) AS c
        GROUP BY c.cod_ctb
               , c.cod_ctb_view
               , c.tipo_aplicacao
               , c.tipo_conta
               , c.cod_orgao
               , c.conta
        ORDER BY c.cod_ctb
               ;
    END IF;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #21298
----------------

CREATE TABLE tcemg.arquivo_cvc (
    cod_veiculo INTEGER NOT NULL,
    num_orgao   INTEGER NOT NULL,
    num_unidade INTEGER NOT NULL,
    exercicio   CHAR(4) NOT NULL,
    mes         CHAR(2) NOT NULL,
    CONSTRAINT pk_arquivo_cvc      PRIMARY KEY                  (cod_veiculo, num_orgao, num_unidade, exercicio),
    CONSTRAINT fk_arquivo_cvc_1    FOREIGN KEY                  (cod_veiculo)
                                   REFERENCES frota.veiculo     (cod_veiculo),
    CONSTRAINT fk_arquivo_cvc_2    FOREIGN KEY                  (num_orgao, num_unidade, exercicio)
                                   REFERENCES orcamento.unidade (num_orgao, num_unidade, exercicio)
);
GRANT ALL ON tcemg.arquivo_cvc TO urbem;


----------------
-- Ticket #22454
----------------

ALTER TABLE administracao.relatorio ALTER COLUMN arquivo TYPE VARCHAR(80);

INSERT
  INTO administracao.relatorio
     ( cod_gestao
     , cod_modulo
     , cod_relatorio
     , nom_relatorio
     , arquivo )
VALUES
     ( 6
     , 55
     , 16
     , 'Razão da Despesa Empenho Liquidado Pago'
     , 'LHTCEMGRelatorioRazaoDespesaEmpenhoLiquidadoPago.php'
     );
 


----------------
-- Ticket #22863
----------------

CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN

    PERFORM 1
       FROM administracao.configuracao
      WHERE cod_modulo = 2
        AND exercicio  = '2015'
        AND parametro  = 'cnpj'
        AND valor      = '18301002000186';

    IF FOUND THEN

        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 63);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 61);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 71);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 66);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 86);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 82);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 87);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 83);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 79);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 76);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 90);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 91);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 75);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 70);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 89);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 85);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 94);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 98);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 93);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 92);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 97);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 62);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 81);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 78);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 96);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 99);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 74);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 69);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 88);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 84);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 65);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 64);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 80);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 77);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 72);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 67);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 68);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 73);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 95);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45530);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 46154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 2098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 5235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 8972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 1654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 3263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 9842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 4035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6918);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 6847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 7208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18477);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21186);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21185);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22755);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22759);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37371);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15507);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54490);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26372);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27489);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58508);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48537);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58505);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48522);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48525);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48523);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45719);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48514);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48512);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48226);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48225);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48229);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58493);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48606);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48601);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48602);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48532);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48540);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48636);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48645);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48635);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48647);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48634);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48630);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48646);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48404);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48520);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14384);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26076);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30706);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14400);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14383);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14381);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36757);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36758);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36756);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59650);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36762);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36761);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36760);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4215);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2240);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9000);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43744);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43743);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56990);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51204);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51205);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51214);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55231);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55746);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55745);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35631);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43963);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43986);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43974);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43982);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43973);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43971);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43978);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23910);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23906);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23907);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23908);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23909);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24557);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23921);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57923);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57924);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57927);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57928);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57929);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57930);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59187);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59188);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42657);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42658);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42659);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42656);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42660);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45764);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55747);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54638);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17830);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17826);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17827);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17829);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17825);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17828);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17824);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16847);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36479);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9989);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19494);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19498);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1560);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1559);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17558);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27753);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28741);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17529);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19502);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19501);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11382);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10539);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10536);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24087);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11228);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11227);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24134);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24138);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24163);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24135);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24164);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24170);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24150);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24166);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24129);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24117);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24169);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37395);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9531);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36919);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31822);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31820);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54393);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43122);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32470);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59925);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13916);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47497);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1644);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43784);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55749);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30556);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56510);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 20732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16182);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54991);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3976);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3535);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3088);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2633);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2394);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40378);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1380);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19183);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15390);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8554);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8555);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39136);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2585);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23361);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23365);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 23366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48854);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48855);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48859);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48850);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48849);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48848);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48856);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2001);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5787);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5785);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5786);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37581);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37578);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37584);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39116);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39078);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 25264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9385);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9386);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58528);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55161);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58527);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58526);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50898);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56718);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56714);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56715);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56717);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47123);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   515);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   375);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   374);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   373);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8608);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5965);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35858);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35857);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55376);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54542);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13655);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5964);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16983);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16984);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16985);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36629);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36612);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18358);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11202);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 24389);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30458);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30459);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30460);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30450);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30461);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30454);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30453);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30416);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30456);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30457);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30413);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30412);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30409);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30406);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55905);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55904);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36036);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36039);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36038);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16179);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37034);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32237);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16992);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16993);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35895);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8118);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8120);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8121);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5791);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5788);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8130);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8587);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8582);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8562);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8790);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8579);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8792);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8159);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11209);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35861);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35860);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11201);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8568);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8920);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8561);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8917);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8607);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8605);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9148);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18291);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18270);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18286);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18292);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18285);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18289);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18279);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18272);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18287);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18248);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18255);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18274);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18273);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18271);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18267);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18290);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18337);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18329);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18324);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18323);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18334);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18302);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18296);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18294);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18321);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18298);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18303);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18299);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18332);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18333);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18297);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18293);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18328);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18331);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18336);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18335);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11206);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35620);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7379);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51033);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51032);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51029);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16156);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9180);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56295);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48716);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27307);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27304);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27305);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27306);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1534);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4931);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57932);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59189);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57938);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57939);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57941);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56732);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57940);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56733);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57943);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59192);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57945);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57948);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54952);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57543);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54751);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54750);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54951);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54999);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57603);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54654);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54707);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54980);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18688);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18687);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18669);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18666);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18686);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34509);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13190);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22765);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32599);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32600);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 42312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36865);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36867);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36866);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36864);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36863);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 36862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34524);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32720);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37037);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10258);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10257);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10246);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10247);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10249);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10253);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9368);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10259);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31250);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31251);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31252);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9339);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11043);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10212);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10211);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10213);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10210);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50352);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50353);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51044);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55571);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2276);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2275);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9823);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39947);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28308);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40936);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57949);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4455);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14748);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58269);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12516);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56586);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53752);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4471);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4462);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4473);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4464);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4475);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4466);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4463);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29152);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28942);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4476);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29042);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29154);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29077);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4478);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4469);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4481);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4485);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4482);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4480);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4486);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26604);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4184);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26597);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27960);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27959);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58967);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55754);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27622);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27618);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27615);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27619);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27614);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28852);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28853);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58232);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58245);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57024);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30351);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16944);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57025);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30277);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57026);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17912);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17915);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17913);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17914);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17911);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16868);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16870);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16869);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16871);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31330);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57027);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19020);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19022);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19016);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19015);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19023);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19017);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19021);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19018);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19002);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15239);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15236);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15234);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15238);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15241);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58233);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18994);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33344);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33341);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33349);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33345);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33348);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31977);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31284);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17774);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17776);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 19223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16045);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37049);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37050);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37052);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37047);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37056);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37053);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37054);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37048);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37051);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34544);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32119);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32126);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32125);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32131);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32133);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32127);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54552);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18067);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18070);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18069);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18071);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18068);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18074);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18066);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18075);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54553);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18059);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18058);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18061);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18060);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18057);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17934);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17933);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 17935);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12616);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32041);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18995);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18996);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52322);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52317);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52316);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52315);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52325);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52326);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52318);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52319);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52313);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52309);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52312);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52314);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52311);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52310);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11491);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11487);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11499);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11503);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11492);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11496);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11488);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11500);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11504);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11433);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57268);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11511);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11468);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11580);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11583);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11639);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53793);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53795);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53796);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53797);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55474);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56979);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57742);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15662);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15663);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15664);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14569);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13097);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13089);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13098);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13103);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13104);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13100);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13090);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13091);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13096);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13092);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13108);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13102);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13095);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13107);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13105);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13101);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13207);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16981);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 18176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10640);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10632);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49842);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49844);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49843);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49839);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49845);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49838);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49841);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49840);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54846);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7357);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7364);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7363);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7359);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7367);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7366);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7370);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26763);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59320);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50975);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3789);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28007);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16837);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16836);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59821);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57705);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57708);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9301);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16832);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16835);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16833);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16834);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16831);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57235);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16799);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16798);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16806);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16817);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16816);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16805);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16804);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16803);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16800);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16801);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16807);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16802);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 16814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34648);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37149);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32734);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32613);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32533);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13191);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 44340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4106);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27667);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27668);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28704);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40139);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40146);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   327);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   208);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52447);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52396);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52439);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52446);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52399);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52423);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52432);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52442);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52443);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52444);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52419);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52434);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52417);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52431);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52418);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52435);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52421);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52440);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52408);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52401);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52414);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52420);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52407);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52430);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52436);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52438);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52424);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52429);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52403);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52426);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52427);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52402);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52411);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52415);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52425);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52397);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52428);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54665);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58147);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53451);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53452);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40141);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40142);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40143);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40145);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8028);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1521);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48673);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48676);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48674);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48671);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48670);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48677);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48672);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48675);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54178);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4961);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4962);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4969);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4953);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4966);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 33878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57596);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27392);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7628);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7627);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7781);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7782);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50342);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7736);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7738);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7735);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7574);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7576);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7575);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7573);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7577);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7739);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7637);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7783);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6203);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8055);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12300);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6641);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6230);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7779);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7780);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50598);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 50547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7624);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7625);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7626);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7897);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7642);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7643);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40165);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12035);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54818);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57369);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35595);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35588);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35591);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35590);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35589);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 34483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55405);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47610);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47609);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 32740);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57950);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59288);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54472);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57350);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56484);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31902);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31901);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31899);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31903);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 31900);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8223);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8224);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8222);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8220);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8221);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56483);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37194);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37195);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37196);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37200);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37197);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37198);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37199);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 37193);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8174);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8172);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12709);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12712);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12713);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12711);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12710);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8171);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   565);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',   564);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22062);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21696);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21699);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21698);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21702);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21693);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21700);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21689);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21697);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21703);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21701);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21691);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 21690);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22546);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22548);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22551);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22547);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22550);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 22549);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56242);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56243);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56005);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56244);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26410);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26649);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26653);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52772);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52766);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52770);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52769);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52768);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52771);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52773);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52767);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1541);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26651);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1513);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1517);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1518);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52878);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52872);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52891);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52887);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52875);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52893);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52892);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52883);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52876);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52894);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52877);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52886);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52888);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52889);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52890);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52873);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52882);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52885);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52874);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52881);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3775);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26652);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54819);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47111);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47112);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47115);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47114);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 47099);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10448);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10449);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 49884);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4422);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  6256);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43879);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43880);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11997);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57181);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56019);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45519);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4124);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27260);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40851);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39162);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4140);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39160);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39158);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4132);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4137);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4151);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4144);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29094);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40355);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4153);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27346);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27347);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29065);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29063);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29064);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40937);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4155);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40356);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40360);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28998);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29086);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29083);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29085);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29082);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29080);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29081);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29084);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 29079);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27262);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27263);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27265);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27264);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27280);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27282);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27283);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27281);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4157);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28722);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28721);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28725);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28729);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28730);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28728);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28727);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28726);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28723);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28724);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28731);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2266);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27398);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28495);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 43572);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57545);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55006);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1538);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 52896);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54692);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11563);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 13046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 11570);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 10465);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12040);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12046);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26566);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26567);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57621);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 15173);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14808);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 14810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 53956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1387);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 35506);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41678);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41681);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41682);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41679);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 41680);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59777);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7814);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7813);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7812);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7811);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7810);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  7684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51073);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 51072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  5031);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1343);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1340);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1338);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40815);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 59445);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 58093);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45216);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45218);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45217);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 45219);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28987);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28988);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40354);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2617);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2623);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38592);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38593);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38594);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1778);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 38030);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 39128);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26946);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26955);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26957);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26956);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26954);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26958);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1862);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 55661);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 26972);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30012);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30013);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30008);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30010);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30009);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30011);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 30014);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54467);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48684);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48685);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 48683);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2261);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 56278);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 57377);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  4072);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40809);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  2254);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 40694);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27362);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8922);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  8926);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3794);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28167);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28168);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28695);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  3437);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9003);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  9004);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01',  1737);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28970);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28109);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28110);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 12441);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 27968);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 54611);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28113);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28175);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28176);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '01', 28177);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '03', 56391);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '03', 56388);
        INSERT INTO tcemg.arquivo_item ( exercicio, mes, cod_item) VALUES ('2014', '10', 58936);
        
    END IF;

END;

$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();
