/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.03.9
*
* Fabio Bertoldi - 20150430
*
*/

----------------
-- Ticket #22900
----------------

ALTER TABLE licitacao.licitacao ADD COLUMN registro_precos BOOLEAN NOT NULL DEFAULT FALSE;


----------------
-- Ticket #22844
----------------

ALTER TABLE contabilidade.plano_conta ADD COLUMN escrituracao_pcasp CHAR(1) NOT NULL DEFAULT 'N';
ALTER TABLE contabilidade.plano_conta ADD CONSTRAINT ck_plano_conta_4 CHECK (escrituracao_pcasp IN ('N', 'S'));


----------------------------------------------------------
-- CONCEDENDO PERMISSOES QUE FALTARAM EM tcemg.nota_fiscal
----------------------------------------------------------

GRANT ALL ON tcemg.nota_fiscal TO urbem;


----------------
-- Ticket #22932
----------------

CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE
    stSQL       VARCHAR;
    reRecord    RECORD;
    inCodConta  INTEGER;
    stExercicio VARCHAR;
BEGIN

    PERFORM 1
       FROM pg_class
       JOIN pg_attribute
         ON pg_attribute.attrelid = pg_class.oid
       JOIN pg_namespace
         ON pg_class.relnamespace = pg_namespace.oid
      WHERE pg_namespace.nspname = 'contabilidade'
        AND pg_class.relname = 'plano_conta'
        AND pg_attribute.attname = 'obrigatorio_tcmgo'
        AND pg_attribute.attnum > 0
          ;
    IF NOT FOUND THEN
        ALTER TABLE contabilidade.plano_conta ADD COLUMN obrigatorio_tcmgo BOOLEAN NOT NULL DEFAULT FALSE;

        DELETE FROM tcmgo.vinculo_plano_contas_tcmgo WHERE exercicio = '2015';
        DELETE FROM tcmgo.plano_contas_tcmgo WHERE exercicio = '2015';
        ALTER TABLE tcmgo.plano_contas_tcmgo ALTER COLUMN titulo TYPE VARCHAR(150);

        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   1,'2015','1.0.0.0.0.00.00','ATIVO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   2,'2015','1.1.0.0.0.00.00','ATIVO CIRCULANTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   3,'2015','1.1.1.0.0.00.00','CAIXA E EQUIVALENTES DE CAIXA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   4,'2015','1.1.1.1.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   5,'2015','1.1.1.1.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   6,'2015','1.1.1.1.1.01.00','CAIXA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   7,'2015','1.1.1.1.1.02.00','CONTA ÚNICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   8,'2015','1.1.1.1.1.06.00','CONTA ÚNICA RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (   9,'2015','1.1.1.1.1.06.01','BANCOS CONTA MOVIMENTO – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  10,'2015','1.1.1.1.1.06.02','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  11,'2015','1.1.1.1.1.06.03','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  12,'2015','1.1.1.1.1.06.04','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  13,'2015','1.1.1.1.1.19.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  14,'2015','1.1.1.1.1.30.00','REDE BANCARIA - ARRECADACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  15,'2015','1.1.1.1.1.50.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  16,'2015','1.1.1.1.1.50.01','TÍTULOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  17,'2015','1.1.1.1.1.50.02','POUPANÇA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  18,'2015','1.1.1.1.1.50.03','FUNDOS DE INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  19,'2015','1.1.1.1.1.50.04','CDB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  20,'2015','1.1.1.1.1.50.99','OUTRAS APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  21,'2015','1.1.1.1.2.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  22,'2015','1.1.1.1.2.06.00','CONTA ÚNICA RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  23,'2015','1.1.1.1.2.06.01','BANCOS CONTA MOVIMENTO – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  24,'2015','1.1.1.1.2.06.02','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  25,'2015','1.1.1.1.2.06.03','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  26,'2015','1.1.1.1.2.06.04','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  27,'2015','1.1.1.2.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  28,'2015','1.1.1.2.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  29,'2015','1.1.1.2.1.01.00','CAIXA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  30,'2015','1.1.1.2.1.02.00','BANCOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  31,'2015','1.1.1.2.1.03.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  32,'2015','1.1.2.0.0.00.00','CRÉDITOS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  33,'2015','1.1.2.1.0.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  34,'2015','1.1.2.1.1.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  35,'2015','1.1.2.1.1.01.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  36,'2015','1.1.2.1.1.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  37,'2015','1.1.2.1.1.01.02','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  38,'2015','1.1.2.1.1.01.03','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  39,'2015','1.1.2.1.1.01.04','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  40,'2015','1.1.2.1.1.01.05','IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  41,'2015','1.1.2.1.1.01.06','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  42,'2015','1.1.2.1.1.01.07','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  43,'2015','1.1.2.1.1.01.08','ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  44,'2015','1.1.2.1.1.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  45,'2015','1.1.2.1.1.02.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  46,'2015','1.1.2.1.1.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  47,'2015','1.1.2.1.1.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  48,'2015','1.1.2.1.1.03.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  49,'2015','1.1.2.1.1.03.01','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  50,'2015','1.1.2.1.1.04.00','DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  51,'2015','1.1.2.1.1.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  52,'2015','1.1.2.1.1.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  53,'2015','1.1.2.1.2.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  54,'2015','1.1.2.1.2.01.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  55,'2015','1.1.2.1.2.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  56,'2015','1.1.2.1.2.01.02','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  57,'2015','1.1.2.1.2.01.03','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  58,'2015','1.1.2.1.2.01.04','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  59,'2015','1.1.2.1.2.01.05','IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  60,'2015','1.1.2.1.2.01.06','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  61,'2015','1.1.2.1.2.01.07','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  62,'2015','1.1.2.1.2.01.08','ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  63,'2015','1.1.2.1.2.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  64,'2015','1.1.2.1.2.02.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  65,'2015','1.1.2.1.2.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  66,'2015','1.1.2.1.2.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  67,'2015','1.1.2.1.2.03.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  68,'2015','1.1.2.1.2.03.01','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  69,'2015','1.1.2.1.2.04.00','DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  70,'2015','1.1.2.1.2.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  71,'2015','1.1.2.1.2.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  72,'2015','1.1.2.1.3.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  73,'2015','1.1.2.1.3.01.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  74,'2015','1.1.2.1.3.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  75,'2015','1.1.2.1.3.01.02','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  76,'2015','1.1.2.1.3.01.03','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  77,'2015','1.1.2.1.3.01.04','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  78,'2015','1.1.2.1.3.01.05','IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  79,'2015','1.1.2.1.3.01.06','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  80,'2015','1.1.2.1.3.01.07','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  81,'2015','1.1.2.1.3.01.08','ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  82,'2015','1.1.2.1.3.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  83,'2015','1.1.2.1.3.02.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  84,'2015','1.1.2.1.3.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  85,'2015','1.1.2.1.3.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  86,'2015','1.1.2.1.3.03.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  87,'2015','1.1.2.1.3.03.01','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  88,'2015','1.1.2.1.3.04.00','DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  89,'2015','1.1.2.1.3.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  90,'2015','1.1.2.1.3.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  91,'2015','1.1.2.1.4.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS – ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  92,'2015','1.1.2.1.4.01.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  93,'2015','1.1.2.1.4.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  94,'2015','1.1.2.1.4.01.02','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  95,'2015','1.1.2.1.4.01.03','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  96,'2015','1.1.2.1.4.01.04','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  97,'2015','1.1.2.1.4.01.05','IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  98,'2015','1.1.2.1.4.01.06','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (  99,'2015','1.1.2.1.4.01.07','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 100,'2015','1.1.2.1.4.01.08','ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 101,'2015','1.1.2.1.4.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 102,'2015','1.1.2.1.4.02.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 103,'2015','1.1.2.1.4.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 104,'2015','1.1.2.1.4.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 105,'2015','1.1.2.1.4.03.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 106,'2015','1.1.2.1.4.03.01','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 107,'2015','1.1.2.1.4.04.00','DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 108,'2015','1.1.2.1.4.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 109,'2015','1.1.2.1.4.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 110,'2015','1.1.2.1.5.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 111,'2015','1.1.2.1.5.01.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 112,'2015','1.1.2.1.5.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 113,'2015','1.1.2.1.5.01.02','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 114,'2015','1.1.2.1.5.01.03','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 115,'2015','1.1.2.1.5.01.04','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 116,'2015','1.1.2.1.5.01.05','IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 117,'2015','1.1.2.1.5.01.06','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 118,'2015','1.1.2.1.5.01.07','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 119,'2015','1.1.2.1.5.01.08','ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 120,'2015','1.1.2.1.5.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 121,'2015','1.1.2.1.5.02.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 122,'2015','1.1.2.1.5.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 123,'2015','1.1.2.1.5.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 124,'2015','1.1.2.1.5.03.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 125,'2015','1.1.2.1.5.03.01','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 126,'2015','1.1.2.1.5.04.00','DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 127,'2015','1.1.2.1.5.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 128,'2015','1.1.2.1.5.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 129,'2015','1.1.2.2.0.00.00','CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 130,'2015','1.1.2.2.1.00.00','CLIENTES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 131,'2015','1.1.2.2.1.01.00','FATURAS/DUPLICATAS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 132,'2015','1.1.2.2.1.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 133,'2015','1.1.2.2.2.00.00','CLIENTES - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 134,'2015','1.1.2.2.2.01.00','FATURAS/DUPLICATAS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 135,'2015','1.1.2.2.2.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 136,'2015','1.1.2.2.3.00.00','CLIENTES - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 137,'2015','1.1.2.2.3.01.00','FATURAS/DUPLICATAS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 138,'2015','1.1.2.2.3.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 139,'2015','1.1.2.2.4.00.00','CLIENTES - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 140,'2015','1.1.2.2.4.01.00','FATURAS/DUPLICATAS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 141,'2015','1.1.2.2.4.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 142,'2015','1.1.2.2.5.00.00','CLIENTES - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 143,'2015','1.1.2.2.5.01.00','FATURAS/DUPLICATAS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 144,'2015','1.1.2.2.5.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 145,'2015','1.1.2.3.0.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 146,'2015','1.1.2.3.1.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 147,'2015','1.1.2.3.1.01.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE INSTITUIÇÕES PRIVADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 148,'2015','1.1.2.3.1.02.00','CRÉDITOS DE CONSÓRCIOS PÚBLICOS DECORRENTES DE CONTRATO DE RATEIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 149,'2015','1.1.2.3.3.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS – UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 150,'2015','1.1.2.3.3.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DA UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 151,'2015','1.1.2.3.3.01.01','COTA-PARTE DO FPE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 152,'2015','1.1.2.3.3.01.02','COTA-PARTE DO FPM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 153,'2015','1.1.2.3.3.01.03','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 154,'2015','1.1.2.3.3.01.04','COTA-PARTE DO IPI - ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 155,'2015','1.1.2.3.3.01.05','COTA-PARTE DA CIDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 156,'2015','1.1.2.3.3.02.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 157,'2015','1.1.2.3.3.02.01','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECUROS HÍDRICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 158,'2015','1.1.2.3.3.02.02','COTA-PARTE CA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 159,'2015','1.1.2.3.3.02.03','COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 160,'2015','1.1.2.3.3.03.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO SUS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 161,'2015','1.1.2.3.3.04.00','CRÉDITOS DECORRENTES DO FNAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 162,'2015','1.1.2.3.3.05.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO FNDE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 163,'2015','1.1.2.3.3.05.01','COTA-PARTE DO SALÁRIO-EDUCAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 164,'2015','1.1.2.3.3.06.00','CRÉDITOS DECORRENTES DAS TRANSFERÊNCIAS DO ICMS - DESONERAÇÃO - LC 87/96','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 165,'2015','1.1.2.3.3.06.01','TRANSFERÊNCIA FINANCEIRA DO ICMS - DESONERAÇÃO - LC 87/96','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 166,'2015','1.1.2.3.3.07.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 167,'2015','1.1.2.3.3.07.01','FUNDEB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 168,'2015','1.1.2.3.3.08.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE CONVÊNIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 169,'2015','1.1.2.3.3.09.00','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 170,'2015','1.1.2.3.4.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 171,'2015','1.1.2.3.4.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DOS ESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 172,'2015','1.1.2.3.4.01.01','COTA-PARTE DO ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 173,'2015','1.1.2.3.4.01.02','COTA-PARTE DO IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 174,'2015','1.1.2.3.5.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 175,'2015','1.1.2.4.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 176,'2015','1.1.2.4.1.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 177,'2015','1.1.2.4.1.01.00','EMPRÉSTIMOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 178,'2015','1.1.2.4.1.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 179,'2015','1.1.2.4.1.02.00','FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 180,'2015','1.1.2.4.1.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 181,'2015','1.1.2.4.1.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 182,'2015','1.1.2.4.1.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 183,'2015','1.1.2.4.1.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 184,'2015','1.1.2.4.1.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 185,'2015','1.1.2.4.1.07.01','EMPRÉSTIMOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 186,'2015','1.1.2.4.1.07.02','FINANCIAMENTOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 187,'2015','1.1.2.4.1.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 188,'2015','1.1.2.4.1.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 189,'2015','1.1.2.4.2.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 190,'2015','1.1.2.4.2.01.00','EMPRÉSTIMOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 191,'2015','1.1.2.4.2.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 192,'2015','1.1.2.4.2.02.00','FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 193,'2015','1.1.2.4.2.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 194,'2015','1.1.2.4.2.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 195,'2015','1.1.2.4.2.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 196,'2015','1.1.2.4.2.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 197,'2015','1.1.2.4.2.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 198,'2015','1.1.2.4.2.07.01','EMPRÉSTIMOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 199,'2015','1.1.2.4.2.07.02','FINANCIAMENTOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 200,'2015','1.1.2.4.2.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 201,'2015','1.1.2.4.2.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 202,'2015','1.1.2.4.3.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 203,'2015','1.1.2.4.3.01.00','EMPRÉSTIMOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 204,'2015','1.1.2.4.3.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 205,'2015','1.1.2.4.3.02.00','FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 206,'2015','1.1.2.4.3.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 207,'2015','1.1.2.4.3.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 208,'2015','1.1.2.4.3.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 209,'2015','1.1.2.4.3.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 210,'2015','1.1.2.4.3.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 211,'2015','1.1.2.4.3.07.01','EMPRÉSTIMOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 212,'2015','1.1.2.4.3.07.02','FINANCIAMENTOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 213,'2015','1.1.2.4.3.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 214,'2015','1.1.2.4.3.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 215,'2015','1.1.2.4.4.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 216,'2015','1.1.2.4.4.01.00','EMPRÉSTIMOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 217,'2015','1.1.2.4.4.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 218,'2015','1.1.2.4.4.02.00','FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 219,'2015','1.1.2.4.4.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 220,'2015','1.1.2.4.4.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 221,'2015','1.1.2.4.4.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 222,'2015','1.1.2.4.4.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 223,'2015','1.1.2.4.4.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 224,'2015','1.1.2.4.4.07.01','EMPRÉSTIMOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 225,'2015','1.1.2.4.4.07.02','FINANCIAMENTOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 226,'2015','1.1.2.4.4.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 227,'2015','1.1.2.4.4.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 228,'2015','1.1.2.4.5.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 229,'2015','1.1.2.4.5.01.00','EMPRÉSTIMOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 230,'2015','1.1.2.4.5.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 231,'2015','1.1.2.4.5.02.00','FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 232,'2015','1.1.2.4.5.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 233,'2015','1.1.2.4.5.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 234,'2015','1.1.2.4.5.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 235,'2015','1.1.2.4.5.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 236,'2015','1.1.2.4.5.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 237,'2015','1.1.2.4.5.07.01','EMPRÉSTIMOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 238,'2015','1.1.2.4.5.07.02','FINANCIAMENTOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 239,'2015','1.1.2.4.5.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 240,'2015','1.1.2.4.5.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 241,'2015','1.1.2.5.0.00.00','DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 242,'2015','1.1.2.5.1.00.00','DÍVIDA ATIVA TRIBUTÁRIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 243,'2015','1.1.2.5.1.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 244,'2015','1.1.2.5.1.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 245,'2015','1.1.2.5.1.01.02','DÍVIDA ATIVA DO IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 246,'2015','1.1.2.5.1.01.03','DÍVIDA ATIVA DO ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 247,'2015','1.1.2.5.1.01.04','DÍVIDA ATIVA DO ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 248,'2015','1.1.2.5.1.01.05','DÍVIDA ATIVA DO IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 249,'2015','1.1.2.5.1.01.06','DÍVIDA ATIVA DO ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 250,'2015','1.1.2.5.1.01.07','DÍVIDA ATIVA DO ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 251,'2015','1.1.2.5.1.01.08','DÍVIDA ATIVA DO ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 252,'2015','1.1.2.5.1.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 253,'2015','1.1.2.5.1.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 254,'2015','1.1.2.5.1.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 255,'2015','1.1.2.5.1.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 256,'2015','1.1.2.5.1.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 257,'2015','1.1.2.5.1.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 258,'2015','1.1.2.5.1.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 259,'2015','1.1.2.5.1.05.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 260,'2015','1.1.2.5.1.06.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 261,'2015','1.1.2.5.1.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 262,'2015','1.1.2.5.2.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 263,'2015','1.1.2.5.2.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 264,'2015','1.1.2.5.2.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 265,'2015','1.1.2.5.2.01.02','DÍVIDA ATIVA DO IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 266,'2015','1.1.2.5.2.01.03','DÍVIDA ATIVA DO ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 267,'2015','1.1.2.5.2.01.04','DÍVIDA ATIVA DO ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 268,'2015','1.1.2.5.2.01.05','DÍVIDA ATIVA DO IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 269,'2015','1.1.2.5.2.01.06','DÍVIDA ATIVA DO ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 270,'2015','1.1.2.5.2.01.07','DÍVIDA ATIVA DO ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 271,'2015','1.1.2.5.2.01.08','DÍVIDA ATIVA DO ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 272,'2015','1.1.2.5.2.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 273,'2015','1.1.2.5.2.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 274,'2015','1.1.2.5.2.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 275,'2015','1.1.2.5.2.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 276,'2015','1.1.2.5.2.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 277,'2015','1.1.2.5.2.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 278,'2015','1.1.2.5.2.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 279,'2015','1.1.2.5.2.99.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 280,'2015','1.1.2.5.3.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 281,'2015','1.1.2.5.3.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 282,'2015','1.1.2.5.3.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 283,'2015','1.1.2.5.3.01.02','DÍVIDA ATIVA DO IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 284,'2015','1.1.2.5.3.01.03','DÍVIDA ATIVA DO ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 285,'2015','1.1.2.5.3.01.04','DÍVIDA ATIVA DO ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 286,'2015','1.1.2.5.3.01.05','DÍVIDA ATIVA DO IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 287,'2015','1.1.2.5.3.01.06','DÍVIDA ATIVA DO ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 288,'2015','1.1.2.5.3.01.07','DÍVIDA ATIVA DO ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 289,'2015','1.1.2.5.3.01.08','DÍVIDA ATIVA DO ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 290,'2015','1.1.2.5.3.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 291,'2015','1.1.2.5.3.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 292,'2015','1.1.2.5.3.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 293,'2015','1.1.2.5.3.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 294,'2015','1.1.2.5.3.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 295,'2015','1.1.2.5.3.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 296,'2015','1.1.2.5.3.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 297,'2015','1.1.2.5.3.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 298,'2015','1.1.2.5.4.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 299,'2015','1.1.2.5.4.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 300,'2015','1.1.2.5.4.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 301,'2015','1.1.2.5.4.01.02','DÍVIDA ATIVA DO IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 302,'2015','1.1.2.5.4.01.03','DÍVIDA ATIVA DO ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 303,'2015','1.1.2.5.4.01.04','DÍVIDA ATIVA DO ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 304,'2015','1.1.2.5.4.01.05','DÍVIDA ATIVA DO IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 305,'2015','1.1.2.5.4.01.06','DÍVIDA ATIVA DO ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 306,'2015','1.1.2.5.4.01.07','DÍVIDA ATIVA DO ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 307,'2015','1.1.2.5.4.01.08','DÍVIDA ATIVA DO ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 308,'2015','1.1.2.5.4.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 309,'2015','1.1.2.5.4.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 310,'2015','1.1.2.5.4.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 311,'2015','1.1.2.5.4.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 312,'2015','1.1.2.5.4.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 313,'2015','1.1.2.5.4.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 314,'2015','1.1.2.5.4.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 315,'2015','1.1.2.5.4.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 316,'2015','1.1.2.5.5.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 317,'2015','1.1.2.5.5.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 318,'2015','1.1.2.5.5.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 319,'2015','1.1.2.5.5.01.02','DÍVIDA ATIVA DO IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 320,'2015','1.1.2.5.5.01.03','DÍVIDA ATIVA DO ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 321,'2015','1.1.2.5.5.01.04','DÍVIDA ATIVA DO ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 322,'2015','1.1.2.5.5.01.05','DÍVIDA ATIVA DO IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 323,'2015','1.1.2.5.5.01.06','DÍVIDA ATIVA DO ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 324,'2015','1.1.2.5.5.01.07','DÍVIDA ATIVA DO ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 325,'2015','1.1.2.5.5.01.08','DÍVIDA ATIVA DO ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 326,'2015','1.1.2.5.5.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 327,'2015','1.1.2.5.5.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 328,'2015','1.1.2.5.5.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 329,'2015','1.1.2.5.5.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 330,'2015','1.1.2.5.5.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 331,'2015','1.1.2.5.5.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 332,'2015','1.1.2.5.5.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 333,'2015','1.1.2.5.5.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 334,'2015','1.1.2.6.0.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 335,'2015','1.1.2.6.1.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 336,'2015','1.1.2.6.1.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 337,'2015','1.1.2.6.2.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 338,'2015','1.1.2.6.2.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 339,'2015','1.1.2.6.3.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 340,'2015','1.1.2.6.3.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 341,'2015','1.1.2.6.4.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 342,'2015','1.1.2.6.4.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 343,'2015','1.1.2.6.5.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 344,'2015','1.1.2.6.5.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 345,'2015','1.1.2.9.0.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 346,'2015','1.1.2.9.1.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 347,'2015','1.1.2.9.1.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 348,'2015','1.1.2.9.1.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 349,'2015','1.1.2.9.1.01.02','(-) PERDAS ESTIMADAS EM TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 350,'2015','1.1.2.9.1.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 351,'2015','1.1.2.9.1.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 352,'2015','1.1.2.9.1.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 353,'2015','1.1.2.9.1.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 354,'2015','1.1.2.9.1.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 355,'2015','1.1.2.9.1.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 356,'2015','1.1.2.9.1.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 357,'2015','1.1.2.9.1.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 358,'2015','1.1.2.9.1.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 359,'2015','1.1.2.9.1.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 360,'2015','1.1.2.9.1.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 361,'2015','1.1.2.9.1.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 362,'2015','1.1.2.9.1.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 363,'2015','1.1.2.9.1.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 364,'2015','1.1.2.9.2.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 365,'2015','1.1.2.9.2.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 366,'2015','1.1.2.9.2.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 367,'2015','1.1.2.9.2.01.02','(-) PERDAS ESTIMADAS EM TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 368,'2015','1.1.2.9.2.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 369,'2015','1.1.2.9.2.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 370,'2015','1.1.2.9.2.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 371,'2015','1.1.2.9.2.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 372,'2015','1.1.2.9.2.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 373,'2015','1.1.2.9.2.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 374,'2015','1.1.2.9.2.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 375,'2015','1.1.2.9.2.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 376,'2015','1.1.2.9.2.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 377,'2015','1.1.2.9.2.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 378,'2015','1.1.2.9.2.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 379,'2015','1.1.2.9.2.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 380,'2015','1.1.2.9.2.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 381,'2015','1.1.2.9.2.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 382,'2015','1.1.2.9.3.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 383,'2015','1.1.2.9.3.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 384,'2015','1.1.2.9.3.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 385,'2015','1.1.2.9.3.01.02','(-) PERDAS ESTIMADAS EM TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 386,'2015','1.1.2.9.3.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 387,'2015','1.1.2.9.3.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 388,'2015','1.1.2.9.3.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 389,'2015','1.1.2.9.3.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 390,'2015','1.1.2.9.3.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 391,'2015','1.1.2.9.3.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 392,'2015','1.1.2.9.3.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 393,'2015','1.1.2.9.3.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 394,'2015','1.1.2.9.3.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 395,'2015','1.1.2.9.3.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 396,'2015','1.1.2.9.3.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 397,'2015','1.1.2.9.3.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 398,'2015','1.1.2.9.3.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 399,'2015','1.1.2.9.3.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 400,'2015','1.1.2.9.4.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 401,'2015','1.1.2.9.4.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 402,'2015','1.1.2.9.4.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 403,'2015','1.1.2.9.4.01.02','(-) PERDAS ESTIMADAS EM TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 404,'2015','1.1.2.9.4.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 405,'2015','1.1.2.9.4.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 406,'2015','1.1.2.9.4.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 407,'2015','1.1.2.9.4.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 408,'2015','1.1.2.9.4.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 409,'2015','1.1.2.9.4.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 410,'2015','1.1.2.9.4.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 411,'2015','1.1.2.9.4.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 412,'2015','1.1.2.9.4.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 413,'2015','1.1.2.9.4.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 414,'2015','1.1.2.9.4.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 415,'2015','1.1.2.9.4.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 416,'2015','1.1.2.9.4.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 417,'2015','1.1.2.9.4.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 418,'2015','1.1.2.9.5.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 419,'2015','1.1.2.9.5.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 420,'2015','1.1.2.9.5.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 421,'2015','1.1.2.9.5.01.02','(-) PERDAS ESTIMADAS EM TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 422,'2015','1.1.2.9.5.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 423,'2015','1.1.2.9.5.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 424,'2015','1.1.2.9.5.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 425,'2015','1.1.2.9.5.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 426,'2015','1.1.2.9.5.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 427,'2015','1.1.2.9.5.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 428,'2015','1.1.2.9.5.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 429,'2015','1.1.2.9.5.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 430,'2015','1.1.2.9.5.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 431,'2015','1.1.2.9.5.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 432,'2015','1.1.2.9.5.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 433,'2015','1.1.2.9.5.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 434,'2015','1.1.2.9.5.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 435,'2015','1.1.2.9.5.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 436,'2015','1.1.3.0.0.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 437,'2015','1.1.3.1.0.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 438,'2015','1.1.3.1.1.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 439,'2015','1.1.3.1.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 440,'2015','1.1.3.1.1.01.01','SALÁRIOS E ORDENADOS - ADIANTAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 441,'2015','1.1.3.1.1.01.02','13  SALÁRIO - ADIANTAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 442,'2015','1.1.3.1.1.01.03','FÉRIAS - ADIANTAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 443,'2015','1.1.3.1.1.01.04','1/3 DE FÉRIAS - ADIANTAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 444,'2015','1.1.3.1.1.01.05','VIAGENS - ADIANTAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 445,'2015','1.1.3.1.1.01.99','OUTROS ADIANTAMENTOS A PESSOAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 446,'2015','1.1.3.1.1.02.00','SUPRIMENTO DE FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 447,'2015','1.1.3.1.1.03.00','ADIANTAMENTOS DE TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 448,'2015','1.1.3.1.1.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 449,'2015','1.1.3.2.0.00.00','TRIBUTOS A RECUPERAR/COMPENSAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 450,'2015','1.1.3.2.1.00.00','TRIBUTOS A RECUPERAR/COMPENSAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 451,'2015','1.1.3.2.1.01.00','IPI A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 452,'2015','1.1.3.2.1.02.00','ICMS A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 453,'2015','1.1.3.2.1.03.00','ICMS DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 454,'2015','1.1.3.2.1.04.00','IRRF A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 455,'2015','1.1.3.2.1.05.00','IR E CSLL A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 456,'2015','1.1.3.2.1.06.00','IR E CSLL DIFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 457,'2015','1.1.3.2.1.07.00','ISS A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 458,'2015','1.1.3.2.1.08.00','IPVA A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 459,'2015','1.1.3.2.1.09.00','IPTU A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 460,'2015','1.1.3.2.1.10.00','ITR A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 461,'2015','1.1.3.2.1.11.00','INSS A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 462,'2015','1.1.3.2.1.12.00','COFINS A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 463,'2015','1.1.3.2.1.13.00','PIS/PASEP A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 464,'2015','1.1.3.2.1.14.00','CIP A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 465,'2015','1.1.3.2.1.99.00','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 466,'2015','1.1.3.3.0.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 467,'2015','1.1.3.3.1.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 468,'2015','1.1.3.3.1.01.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 469,'2015','1.1.3.4.0.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 470,'2015','1.1.3.4.1.00.00','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 471,'2015','1.1.3.4.1.01.00','CRÉDITOS POR DANOS AO PATRIMONIO DECORRENTES DE CRÉDITOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 472,'2015','1.1.3.4.1.02.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM  TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 473,'2015','1.1.3.4.1.03.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 474,'2015','1.1.3.5.0.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 475,'2015','1.1.3.5.1.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 476,'2015','1.1.3.5.1.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 477,'2015','1.1.3.5.1.02.00','DEPÓSITOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 478,'2015','1.1.3.5.1.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 479,'2015','1.1.3.5.1.04.00','DEPÓSITOS ESPECIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 480,'2015','1.1.3.5.1.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 481,'2015','1.1.3.5.1.06.00','DEPÓSITOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 482,'2015','1.1.3.5.1.07.00','DEPÓSITOS COMPULSÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 483,'2015','1.1.3.5.1.08.00','CONTA ESPECIAL - PRECATÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 484,'2015','1.1.3.5.1.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 485,'2015','1.1.3.8.0.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 486,'2015','1.1.3.8.1.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 487,'2015','1.1.3.8.1.01.00','ALUGUÉIS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 488,'2015','1.1.3.8.1.02.00','CRÉDITOS A RECEBER DECORRENTES DE PERMISSÃO DE USO DE BENS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 489,'2015','1.1.3.8.1.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZAÇÕES POR SINISTROS PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 490,'2015','1.1.3.8.1.04.00','VALES, TICKETS E BILHETES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 491,'2015','1.1.3.8.1.06.00','VALORES EM TRÂNSITO REALIZÁVEIS A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 492,'2015','1.1.3.8.1.07.00','CRÉDITOS A RECEBER DECORRENTES DE INFRAÇÕES LEGAIS E CONTRATUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 493,'2015','1.1.3.8.1.08.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO FAMÍLIA PAGO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 494,'2015','1.1.3.8.1.09.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO MATERNIDADE PAGO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 495,'2015','1.1.3.8.1.10.00','AUXÍLIO NATALIDADE PAGO A RECUPERAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 496,'2015','1.1.3.8.1.11.00','CRÉDITOS A RECEBER POR REEMBOLSO DE AUXÍLIO DOENÇA E ACIDENTES PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 497,'2015','1.1.3.8.1.12.00','CRÉDITOS A RECEBER POR CESSÃO DE PESSOAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 498,'2015','1.1.3.8.1.13.00','CRÉDITOS A RECEBER DECORRENTES DE CESSÃO DE ÁREAS PÚBLICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 499,'2015','1.1.3.8.1.14.00','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 500,'2015','1.1.3.8.1.15.00','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESA DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 501,'2015','1.1.3.8.1.16.00','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDORES E EX-SERVIDORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 502,'2015','1.1.3.8.1.17.00','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 503,'2015','1.1.3.8.1.18.00','DIVIDENDOS PROPOSTOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 504,'2015','1.1.3.8.1.20.00','REMUNERAÇÃO DE DEBÊNTURES A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 505,'2015','1.1.3.8.1.27.00','TÍTULOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 506,'2015','1.1.3.8.1.28.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 507,'2015','1.1.3.8.1.29.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 508,'2015','1.1.3.8.1.31.00','CRÉDITOS A RECEBER DE PARCELAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 509,'2015','1.1.3.8.1.99.00','OUTROS CRÉDITOS A RECEBER E VALORES DE  CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 510,'2015','1.1.3.9.0.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 511,'2015','1.1.3.9.1.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 512,'2015','1.1.3.9.1.03.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 513,'2015','1.1.3.9.1.04.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS POR DANOS AO PATRIMÔNIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 514,'2015','1.1.3.9.1.04.01','(-) AJUSTE  PARA PERDAS EM CRÉDITOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 515,'2015','1.1.3.9.1.04.02','(-) AJUSTE  PARA PERDAS EM CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 516,'2015','1.1.3.9.1.04.03','(-) AJUSTE  PARA PERDAS EM CRÉDITOS APURADOS EM PROCESSOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 517,'2015','1.1.3.9.1.99.00','(-) AJUSTE  PARA PERDAS DE DEMAIS CRÉDITOS E  VALORES A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 518,'2015','1.1.4.0.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 519,'2015','1.1.4.1.0.00.00','TÍTULOS E VALORES MOBILIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 520,'2015','1.1.4.1.1.00.00','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 521,'2015','1.1.4.1.1.01.00','TÍTULOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 522,'2015','1.1.4.1.1.02.00','AÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 523,'2015','1.1.4.1.1.03.00','DERIVATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 524,'2015','1.1.4.1.1.09.00','APLICAÇÕES EM SEGMENTO DE RENDA FIXA - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 525,'2015','1.1.4.1.1.09.01','TÍTULOS DE RESPONSABILIDADE DO TESOURO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 526,'2015','1.1.4.1.1.09.02','TÍTULOS DE RESPONSABILIDADE DO BANCO CENTRAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 527,'2015','1.1.4.1.1.09.03','POUPANÇA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 528,'2015','1.1.4.1.1.09.04','FUNDOS DE INVESTIMENTO EM RENDA FIXA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 529,'2015','1.1.4.1.1.09.05','FUNDOS DE INVESTIMENTO EM RENDA FIXA - CRÉDITO PRIVADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 530,'2015','1.1.4.1.1.09.06','FUNDOS DE INVESTIMENTOS REFERENCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 531,'2015','1.1.4.1.1.09.07','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 532,'2015','1.1.4.1.1.09.08','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 533,'2015','1.1.4.1.1.09.09','OPERACOES COMPROMISSADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 534,'2015','1.1.4.1.1.10.00','APLICACOES EM SEGMENTO DE RENDA VARIAVEL - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 535,'2015','1.1.4.1.1.10.01','FUNDO DE AÇÕES REFERENCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 536,'2015','1.1.4.1.1.10.02','FUNDOS DE ACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 537,'2015','1.1.4.1.1.10.03','FUNDO MULTIMERCADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 538,'2015','1.1.4.1.1.10.04','FUNDOS DE INDICES REFERENCIADOS EM ACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 539,'2015','1.1.4.1.1.10.05','FUNDOS DE INVESTIMENTOS EM PARTICIPACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 540,'2015','1.1.4.1.1.10.06','FUNDOS DE INVESTIMENTOS IMOBILIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 541,'2015','1.1.4.1.1.11.00','APLICACOES EM SEGMENTO IMOBILIARIO - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 542,'2015','1.1.4.1.1.11.01','FUNDOS DE INVESTIMENTO IMOBILIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 543,'2015','1.1.4.1.1.12.00','APLICACOES EM ENQUADRAMENTO - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 544,'2015','1.1.4.1.1.12.01','TITULOS E VALORES EM ENQUADRAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 545,'2015','1.1.4.1.1.13.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 546,'2015','1.1.4.1.1.13.01','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 547,'2015','1.1.4.1.1.14.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 548,'2015','1.1.4.1.1.14.01','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 549,'2015','1.1.4.1.1.15.00','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 550,'2015','1.1.4.1.1.99.00','OUTROS TÍTULOS E VALORES MOBILIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 551,'2015','1.1.4.2.0.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 552,'2015','1.1.4.2.1.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 553,'2015','1.1.4.3.0.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 554,'2015','1.1.4.3.1.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 555,'2015','1.1.4.9.0.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 556,'2015','1.1.4.9.1.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 557,'2015','1.1.4.9.1.01.00','(-) AJUSTE DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 558,'2015','1.1.4.9.1.02.00','(-) AJUSTE DE PERDAS COM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 559,'2015','1.1.5.0.0.00.00','ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 560,'2015','1.1.5.1.0.00.00','MERCADORIAS PARA REVENDA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 561,'2015','1.1.5.1.1.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 562,'2015','1.1.5.1.1.01.00','MERCADORIAS PARA VENDA OU REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 563,'2015','1.1.5.1.1.02.00','MERCADORIAS ESTOQUES REGULATÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 564,'2015','1.1.5.1.1.99.00','OUTRAS MERCADORIAS PARA REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 565,'2015','1.1.5.2.0.00.00','PRODUTOS E SERVIÇOS ACABADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 566,'2015','1.1.5.2.1.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 567,'2015','1.1.5.2.1.01.00','PRODUTOS ACABADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 568,'2015','1.1.5.2.1.02.00','SERVICOS ACABADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 569,'2015','1.1.5.3.0.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 570,'2015','1.1.5.3.1.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 571,'2015','1.1.5.3.1.01.00','PRODUTOS EM ELABORACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 572,'2015','1.1.5.3.1.02.00','SERVICOS EM ELABORACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 573,'2015','1.1.5.4.0.00.00','MATÉRIAS-PRIMAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 574,'2015','1.1.5.4.1.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 575,'2015','1.1.5.4.1.01.00','MATERIAS-PRIMAS - ARMAZENS PROPRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 576,'2015','1.1.5.4.1.02.00','MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 577,'2015','1.1.5.5.0.00.00','MATERIAIS EM TRANSITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 578,'2015','1.1.5.5.1.00.00','MATERIAIS EM TRANSITO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 579,'2015','1.1.5.5.1.01.00','MATERIAL EM TRANSITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 580,'2015','1.1.5.6.0.00.00','ALMOXARIFADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 581,'2015','1.1.5.6.1.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 582,'2015','1.1.5.6.1.01.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 583,'2015','1.1.5.6.1.02.00','GÊNEROS ALIMENTÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 584,'2015','1.1.5.6.1.03.00','MATERIAIS DE CONSTRUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 585,'2015','1.1.5.6.1.04.00','AUTOPEÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 586,'2015','1.1.5.6.1.05.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 587,'2015','1.1.5.6.1.06.00','MATERIAIS GRÁFICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 588,'2015','1.1.5.6.1.07.00','MATERIAL DE EXPEDIENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 589,'2015','1.1.5.6.1.08.00','MATERIAIS A CLASSIFICAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 590,'2015','1.1.5.6.1.09.00','ESTOQUE SOBRESSALENTES A ALIENAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 591,'2015','1.1.5.7.0.00.00','ADIANTAMENTOS A FORNECEDORES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 592,'2015','1.1.5.7.1.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 593,'2015','1.1.5.8.0.00.00','OUTROS ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 594,'2015','1.1.5.8.1.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 595,'2015','1.1.5.9.0.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 596,'2015','1.1.5.9.1.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 597,'2015','1.1.5.9.1.01.00','(-) AJUSTE DE PERDAS DE ESTOQUES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 598,'2015','1.1.5.9.1.02.00','(-) AJUSTE DE PERDAS PARA REDUCAO AO VALOR DE MERCADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 599,'2015','1.1.9.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 600,'2015','1.1.9.1.0.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 601,'2015','1.1.9.1.1.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 602,'2015','1.1.9.2.0.00.00','VPD FINANCEIRAS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 603,'2015','1.1.9.2.1.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 604,'2015','1.1.9.3.0.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 605,'2015','1.1.9.3.1.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 606,'2015','1.1.9.4.0.00.00','ALUGUEIS PAGOS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 607,'2015','1.1.9.4.1.00.00','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 608,'2015','1.1.9.5.0.00.00','TRIBUTOS PAGOS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 609,'2015','1.1.9.5.1.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 610,'2015','1.1.9.6.0.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 611,'2015','1.1.9.6.1.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 612,'2015','1.1.9.7.0.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 613,'2015','1.1.9.7.1.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 614,'2015','1.1.9.8.0.00.00','DEMAIS VPD A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 615,'2015','1.1.9.8.1.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 616,'2015','1.2.0.0.0.00.00','ATIVO NÃO CIRCULANTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 617,'2015','1.2.1.0.0.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 618,'2015','1.2.1.1.0.00.00','CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 619,'2015','1.2.1.1.1.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 620,'2015','1.2.1.1.1.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 621,'2015','1.2.1.1.1.01.01','IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 622,'2015','1.2.1.1.1.01.02','TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 623,'2015','1.2.1.1.1.01.03','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 624,'2015','1.2.1.1.1.01.04','DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 625,'2015','1.2.1.1.1.01.70','CRÉDITOS TRIBUTÁRIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 626,'2015','1.2.1.1.1.02.00','CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 627,'2015','1.2.1.1.1.02.01','FATURAS/DUPLICATAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 628,'2015','1.2.1.1.1.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 629,'2015','1.2.1.1.1.03.01','EMPRÉSTIMOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 630,'2015','1.2.1.1.1.03.02','FINANCIAMENTOS CONCEDIDOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 631,'2015','1.2.1.1.1.03.03','EMPRÉSTIMOS A RECEBER - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 632,'2015','1.2.1.1.1.04.00','DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 633,'2015','1.2.1.1.1.04.01','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 634,'2015','1.2.1.1.1.04.02','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 635,'2015','1.2.1.1.1.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 636,'2015','1.2.1.1.1.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 637,'2015','1.2.1.1.1.99.01','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 638,'2015','1.2.1.1.1.99.02','(-) AJUSTE DE PERDAS DE CLIENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 639,'2015','1.2.1.1.1.99.03','(-) AJUSTE DE PERDAS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 640,'2015','1.2.1.1.1.99.04','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 641,'2015','1.2.1.1.1.99.05','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 642,'2015','1.2.1.1.2.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 643,'2015','1.2.1.1.2.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 644,'2015','1.2.1.1.2.02.00','CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 645,'2015','1.2.1.1.2.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 646,'2015','1.2.1.1.2.04.00','DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 647,'2015','1.2.1.1.2.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 648,'2015','1.2.1.1.2.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 649,'2015','1.2.1.1.3.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 650,'2015','1.2.1.1.3.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 651,'2015','1.2.1.1.3.02.00','CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 652,'2015','1.2.1.1.3.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 653,'2015','1.2.1.1.3.04.00','DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 654,'2015','1.2.1.1.3.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 655,'2015','1.2.1.1.3.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 656,'2015','1.2.1.1.4.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 657,'2015','1.2.1.1.4.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 658,'2015','1.2.1.1.4.02.00','CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 659,'2015','1.2.1.1.4.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 660,'2015','1.2.1.1.4.04.00','DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 661,'2015','1.2.1.1.4.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 662,'2015','1.2.1.1.4.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 663,'2015','1.2.1.1.5.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 664,'2015','1.2.1.1.5.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 665,'2015','1.2.1.1.5.02.00','CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 666,'2015','1.2.1.1.5.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 667,'2015','1.2.1.1.5.04.00','DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 668,'2015','1.2.1.1.5.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 669,'2015','1.2.1.1.5.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 670,'2015','1.2.1.2.0.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 671,'2015','1.2.1.2.1.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 672,'2015','1.2.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 673,'2015','1.2.1.2.1.01.01','ADIANTAMENTOS CONCEDIDOS A PESSOAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 674,'2015','1.2.1.2.1.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 675,'2015','1.2.1.2.1.02.00','TRIBUTOS A RECUPERAR/COMPENSAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 676,'2015','1.2.1.2.1.02.01','IPI A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 677,'2015','1.2.1.2.1.02.02','ICMS A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 678,'2015','1.2.1.2.1.02.03','ICMS DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 679,'2015','1.2.1.2.1.02.04','IRRF A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 680,'2015','1.2.1.2.1.02.05','IR E CSLL A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 681,'2015','1.2.1.2.1.02.06','IR E CSLL DIFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 682,'2015','1.2.1.2.1.02.07','ISS A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 683,'2015','1.2.1.2.1.02.08','IPVA A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 684,'2015','1.2.1.2.1.02.09','IPTU A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 685,'2015','1.2.1.2.1.02.10','ITR A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 686,'2015','1.2.1.2.1.02.11','INSS A  COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 687,'2015','1.2.1.2.1.02.12','COFINS A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 688,'2015','1.2.1.2.1.02.13','PIS/PASEP A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 689,'2015','1.2.1.2.1.02.14','CIP A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 690,'2015','1.2.1.2.1.02.99','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 691,'2015','1.2.1.2.1.03.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 692,'2015','1.2.1.2.1.04.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 693,'2015','1.2.1.2.1.04.01','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 694,'2015','1.2.1.2.1.04.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 695,'2015','1.2.1.2.1.04.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 696,'2015','1.2.1.2.1.04.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 697,'2015','1.2.1.2.1.04.05','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 698,'2015','1.2.1.2.1.04.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 699,'2015','1.2.1.2.1.04.07','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 700,'2015','1.2.1.2.1.04.08','CREDITOS A RECEBER POR USO INDEVIDO DE COTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 701,'2015','1.2.1.2.1.04.09','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 702,'2015','1.2.1.2.1.04.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 703,'2015','1.2.1.2.1.04.99','OUTROS CREDITOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 704,'2015','1.2.1.2.1.05.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 705,'2015','1.2.1.2.1.05.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 706,'2015','1.2.1.2.1.05.02','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 707,'2015','1.2.1.2.1.05.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 708,'2015','1.2.1.2.1.05.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 709,'2015','1.2.1.2.1.05.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 710,'2015','1.2.1.2.1.05.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 711,'2015','1.2.1.2.1.05.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 712,'2015','1.2.1.2.1.05.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 713,'2015','1.2.1.2.1.05.09','CREDITOS  A RECEBER DECORRENTES DE FALTA DE LICITACAO  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 714,'2015','1.2.1.2.1.05.10','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 715,'2015','1.2.1.2.1.05.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 716,'2015','1.2.1.2.1.05.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS  - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 717,'2015','1.2.1.2.1.05.13','CREDITOS  A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE   - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 718,'2015','1.2.1.2.1.05.14','CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 719,'2015','1.2.1.2.1.05.15','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 720,'2015','1.2.1.2.1.05.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 721,'2015','1.2.1.2.1.06.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 722,'2015','1.2.1.2.1.06.01','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 723,'2015','1.2.1.2.1.06.02','DEPÓSITOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 724,'2015','1.2.1.2.1.06.03','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 725,'2015','1.2.1.2.1.06.04','DEPÓSITOS ESPECIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 726,'2015','1.2.1.2.1.06.05','VALORES APREENDIDOS POR DECISÃO JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 727,'2015','1.2.1.2.1.06.06','DEPÓSITOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 728,'2015','1.2.1.2.1.06.07','DEPÓSITOS COMPULSÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 729,'2015','1.2.1.2.1.06.99','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 730,'2015','1.2.1.2.1.98.00','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 731,'2015','1.2.1.2.1.98.01','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 732,'2015','1.2.1.2.1.98.02','CRÉDITOS A RECEBER POR CESSÃO DE CRÉDITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 733,'2015','1.2.1.2.1.98.03','CRÉDITOS ORIUNDOS DE CONCESSÕES DE DIREITOS DE USO E DE EXPLORAÇÃO DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 734,'2015','1.2.1.2.1.98.04','CRÉDITOS A RECEBER DE DEVEDORES DE CONVÊNIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 735,'2015','1.2.1.2.1.98.05','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 736,'2015','1.2.1.2.1.98.06','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX-SERVIDOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 737,'2015','1.2.1.2.1.98.07','CRÉDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 738,'2015','1.2.1.2.1.98.08','INDENIZAÇÕES A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 739,'2015','1.2.1.2.1.98.99','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 740,'2015','1.2.1.2.1.99.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 741,'2015','1.2.1.2.1.99.01','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 742,'2015','1.2.1.2.1.99.02','(-) AJUSTE DE PERDAS DE CRÉDITOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 743,'2015','1.2.1.2.1.99.03','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 744,'2015','1.2.1.2.1.99.07','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 745,'2015','1.2.1.2.1.99.98','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 746,'2015','1.2.1.3.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 747,'2015','1.2.1.3.1.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 748,'2015','1.2.1.3.1.01.00','TÍTULOS E VALORES MOBILIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 749,'2015','1.2.1.3.1.01.01','TÍTULOS PÚBLICOS - MERCADO ABERTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 750,'2015','1.2.1.3.1.01.02','AÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 751,'2015','1.2.1.3.1.01.03','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 752,'2015','1.2.1.3.1.01.99','OUTROS TÍTULOS E VALORES MOBILIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 753,'2015','1.2.1.3.1.02.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 754,'2015','1.2.1.3.1.02.01','APLICAÇÃO TEMPORÁRIA EM OURO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 755,'2015','1.2.1.3.1.02.02','APLICAÇÃO TEMPORÁRIA EM OUTROS METAIS PRECIOSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 756,'2015','1.2.1.3.1.03.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 757,'2015','1.2.1.3.1.99.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 758,'2015','1.2.1.3.1.99.01','(-) AJUSTE DE PERDAS COM TITULOS E VALORES MOBILIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 759,'2015','1.2.1.3.1.99.02','(-) AJUSTE DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 760,'2015','1.2.1.3.1.99.03','(-) AJUSTE DE PERDAS COM APLICAÇÕES EM SEGMENTO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 761,'2015','1.2.1.4.0.00.00','ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 762,'2015','1.2.1.4.1.00.00','ESTOQUES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 763,'2015','1.2.1.4.1.01.00','MERCADORIAS PARA REVENDA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 764,'2015','1.2.1.4.1.02.00','PRODUTOS E SERVIÇOS ACABADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 765,'2015','1.2.1.4.1.03.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 766,'2015','1.2.1.4.1.04.00','MATÉRIAS-PRIMAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 767,'2015','1.2.1.4.1.05.00','MATÉRIAIS EM TRANSITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 768,'2015','1.2.1.4.1.06.00','ALMOXARIFADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 769,'2015','1.2.1.4.1.07.00','ADIANTAMENTOS A FORNECEDORES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 770,'2015','1.2.1.4.1.98.00','OUTROS ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 771,'2015','1.2.1.4.1.99.00','(-) AJUSTE DE PERDAS DE ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 772,'2015','1.2.1.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 773,'2015','1.2.1.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 774,'2015','1.2.1.9.1.01.00','PRÊMIOS DE SEGUROS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 775,'2015','1.2.1.9.1.02.00','VPD FINANCEIRAS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 776,'2015','1.2.1.9.1.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 777,'2015','1.2.1.9.1.04.00','ALUGUEIS PAGOS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 778,'2015','1.2.1.9.1.05.00','TRIBUTOS PAGOS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 779,'2015','1.2.1.9.1.06.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 780,'2015','1.2.1.9.1.07.00','BENEFÍCIOS A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 781,'2015','1.2.1.9.1.99.00','DEMAIS VPD A APROPRIAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 782,'2015','1.2.2.0.0.00.00','INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 783,'2015','1.2.2.1.0.00.00','PARTICIPAÇÕES PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 784,'2015','1.2.2.1.1.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 785,'2015','1.2.2.1.1.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 786,'2015','1.2.2.1.1.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 787,'2015','1.2.2.1.1.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 788,'2015','1.2.2.1.1.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 789,'2015','1.2.2.1.1.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 790,'2015','1.2.2.1.1.01.05','ÁGIO SOBRE OS INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 791,'2015','1.2.2.1.1.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 792,'2015','1.2.2.1.1.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 793,'2015','1.2.2.1.1.01.08','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 794,'2015','1.2.2.1.1.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 795,'2015','1.2.2.1.1.01.95','OUTRAS PARTICIPAÇÕES - MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 796,'2015','1.2.2.1.1.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 797,'2015','1.2.2.1.1.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 798,'2015','1.2.2.1.1.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 799,'2015','1.2.2.1.1.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 800,'2015','1.2.2.1.1.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 801,'2015','1.2.2.1.1.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 802,'2015','1.2.2.1.1.02.03','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 803,'2015','1.2.2.1.1.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 804,'2015','1.2.2.1.1.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 805,'2015','1.2.2.1.1.02.99','OUTRAS PARTICICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 806,'2015','1.2.2.1.2.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 807,'2015','1.2.2.1.2.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 808,'2015','1.2.2.1.2.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 809,'2015','1.2.2.1.2.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 810,'2015','1.2.2.1.2.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 811,'2015','1.2.2.1.2.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 812,'2015','1.2.2.1.2.01.05','ÁGIO SOBRE OS INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 813,'2015','1.2.2.1.2.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 814,'2015','1.2.2.1.2.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 815,'2015','1.2.2.1.2.01.08','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 816,'2015','1.2.2.1.2.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 817,'2015','1.2.2.1.2.01.95','OUTRAS PARTICIPAÇÕES - MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 818,'2015','1.2.2.1.2.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 819,'2015','1.2.2.1.2.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 820,'2015','1.2.2.1.2.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 821,'2015','1.2.2.1.2.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 822,'2015','1.2.2.1.2.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 823,'2015','1.2.2.1.2.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 824,'2015','1.2.2.1.2.02.03','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 825,'2015','1.2.2.1.2.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 826,'2015','1.2.2.1.2.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 827,'2015','1.2.2.1.2.02.99','OUTRAS PARTICICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 828,'2015','1.2.2.1.3.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 829,'2015','1.2.2.1.3.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 830,'2015','1.2.2.1.3.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 831,'2015','1.2.2.1.3.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 832,'2015','1.2.2.1.3.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 833,'2015','1.2.2.1.3.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 834,'2015','1.2.2.1.3.01.05','ÁGIO SOBRE OS INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 835,'2015','1.2.2.1.3.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 836,'2015','1.2.2.1.3.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 837,'2015','1.2.2.1.3.01.08','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 838,'2015','1.2.2.1.3.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 839,'2015','1.2.2.1.3.01.95','OUTRAS PARTICIPAÇÕES - MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 840,'2015','1.2.2.1.3.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 841,'2015','1.2.2.1.3.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 842,'2015','1.2.2.1.3.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 843,'2015','1.2.2.1.3.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 844,'2015','1.2.2.1.3.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 845,'2015','1.2.2.1.3.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 846,'2015','1.2.2.1.3.02.03','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 847,'2015','1.2.2.1.3.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 848,'2015','1.2.2.1.3.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 849,'2015','1.2.2.1.3.02.99','OUTRAS PARTICICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 850,'2015','1.2.2.1.4.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 851,'2015','1.2.2.1.4.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 852,'2015','1.2.2.1.4.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 853,'2015','1.2.2.1.4.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 854,'2015','1.2.2.1.4.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 855,'2015','1.2.2.1.4.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 856,'2015','1.2.2.1.4.01.05','ÁGIO SOBRE OS INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 857,'2015','1.2.2.1.4.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 858,'2015','1.2.2.1.4.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 859,'2015','1.2.2.1.4.01.08','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 860,'2015','1.2.2.1.4.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 861,'2015','1.2.2.1.4.01.95','OUTRAS PARTICIPAÇÕES - MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 862,'2015','1.2.2.1.4.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 863,'2015','1.2.2.1.4.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 864,'2015','1.2.2.1.4.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 865,'2015','1.2.2.1.4.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 866,'2015','1.2.2.1.4.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 867,'2015','1.2.2.1.4.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 868,'2015','1.2.2.1.4.02.03','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 869,'2015','1.2.2.1.4.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 870,'2015','1.2.2.1.4.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 871,'2015','1.2.2.1.4.02.99','OUTRAS PARTICICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 872,'2015','1.2.2.1.5.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 873,'2015','1.2.2.1.5.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 874,'2015','1.2.2.1.5.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 875,'2015','1.2.2.1.5.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 876,'2015','1.2.2.1.5.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 877,'2015','1.2.2.1.5.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 878,'2015','1.2.2.1.5.01.05','ÁGIO SOBRE OS INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 879,'2015','1.2.2.1.5.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 880,'2015','1.2.2.1.5.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 881,'2015','1.2.2.1.5.01.08','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 882,'2015','1.2.2.1.5.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 883,'2015','1.2.2.1.5.01.95','OUTRAS PARTICIPAÇÕES - MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 884,'2015','1.2.2.1.5.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 885,'2015','1.2.2.1.5.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 886,'2015','1.2.2.1.5.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 887,'2015','1.2.2.1.5.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 888,'2015','1.2.2.1.5.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 889,'2015','1.2.2.1.5.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 890,'2015','1.2.2.1.5.02.03','PARTICIPAÇÃO EM FUNDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 891,'2015','1.2.2.1.5.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 892,'2015','1.2.2.1.5.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 893,'2015','1.2.2.1.5.02.99','OUTRAS PARTICICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 894,'2015','1.2.2.2.0.00.00','PROPRIEDADES PARA INVESTIMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 895,'2015','1.2.2.2.1.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 896,'2015','1.2.2.2.1.01.00','BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 897,'2015','1.2.2.2.1.01.01','TERRENOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 898,'2015','1.2.2.2.1.01.02','EDIFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 899,'2015','1.2.2.2.1.02.00','BENS IMOVEIS NÃO DESTINADOS A USO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 900,'2015','1.2.2.2.1.02.01','TERRENOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 901,'2015','1.2.2.2.1.02.02','EDIFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 902,'2015','1.2.2.2.1.99.00','OUTRAS PROPRIEDADES PARA INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 903,'2015','1.2.2.3.0.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 904,'2015','1.2.2.3.1.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 905,'2015','1.2.2.3.1.01.00','TITULOS E VALORES MOBILIÁRIOS - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 906,'2015','1.2.2.3.1.01.01','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TÍTULOS E VALORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 907,'2015','1.2.2.3.1.01.02','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN - TÍTULOS E VALORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 908,'2015','1.2.2.3.1.02.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 909,'2015','1.2.2.3.1.02.01','IMÓVEIS – RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 910,'2015','1.2.2.7.0.00.00','DEMAIS INVESTIMENTOS PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 911,'2015','1.2.2.7.1.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 912,'2015','1.2.2.7.1.01.00','OBRAS DE ARTE E OUTROS BENS SINGULARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 913,'2015','1.2.2.7.1.02.00','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 914,'2015','1.2.2.7.1.03.00','BENS MOVEIS NÃO DESTINADOS A USO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 915,'2015','1.2.2.7.1.04.00','BENS INTANGIVEIS NÃO DESTINADOS A USO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 916,'2015','1.2.2.7.1.99.00','DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 917,'2015','1.2.2.8.0.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 918,'2015','1.2.2.8.1.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 919,'2015','1.2.2.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS – CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 920,'2015','1.2.2.8.1.01.01','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 921,'2015','1.2.2.8.1.01.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMOVEIS NÃO DESTINADOS A USO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 922,'2015','1.2.2.8.1.01.99','(-) DEPRECIAÇÃO ACUMULADA OUTRAS PROPRIEDADES PARA INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 923,'2015','1.2.2.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 924,'2015','1.2.2.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 925,'2015','1.2.2.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 926,'2015','1.2.2.9.1.01.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 927,'2015','1.2.2.9.1.01.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 928,'2015','1.2.2.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 929,'2015','1.2.2.9.1.02.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 930,'2015','1.2.2.9.1.02.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMOVEIS NÃO DESTINADOS A USO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 931,'2015','1.2.2.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 932,'2015','1.2.2.9.1.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 933,'2015','1.2.2.9.2.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 934,'2015','1.2.2.9.2.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 935,'2015','1.2.2.9.2.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 936,'2015','1.2.2.9.3.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 937,'2015','1.2.2.9.3.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 938,'2015','1.2.2.9.3.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 939,'2015','1.2.2.9.4.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 940,'2015','1.2.2.9.4.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 941,'2015','1.2.2.9.4.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 942,'2015','1.2.2.9.5.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 943,'2015','1.2.2.9.5.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 944,'2015','1.2.2.9.5.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 945,'2015','1.2.3.0.0.00.00','IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 946,'2015','1.2.3.1.0.00.00','BENS MOVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 947,'2015','1.2.3.1.1.00.00','BENS MOVEIS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 948,'2015','1.2.3.1.1.01.00','MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 949,'2015','1.2.3.1.1.01.01','APARELHOS DE MEDIÇÃO E ORIENTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 950,'2015','1.2.3.1.1.01.02','APARELHOS E EQUIPAMENTOS DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 951,'2015','1.2.3.1.1.01.03','APARELHOS, EQUIPAMENTOS E UTENSÍLIOS MÉDICOS, ODONTOLÓGICOS, LABORATORIAIS E HOSPITALARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 952,'2015','1.2.3.1.1.01.04','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 953,'2015','1.2.3.1.1.01.05','EQUIPAMENTO DE PROTEÇÃO, SEGURANÇA E SOCORRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 954,'2015','1.2.3.1.1.01.06','MÁQUINAS E EQUIPAMENTOS INDUSTRIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 955,'2015','1.2.3.1.1.01.07','MÁQUINAS E EQUIPAMENTOS ENERGÉTICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 956,'2015','1.2.3.1.1.01.08','MÁQUINAS E EQUIPAMENTOS GRÁFICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 957,'2015','1.2.3.1.1.01.09','MÁQUINAS, FERRAMENTAS E UTENSÍLIOS DE OFICINA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 958,'2015','1.2.3.1.1.01.10','EQUIPAMENTOS DE MONTARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 959,'2015','1.2.3.1.1.01.11','EQUIPAMENTOS E MATERIAL SIGILOSO E RESERVADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 960,'2015','1.2.3.1.1.01.12','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS PARA AUTOMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 961,'2015','1.2.3.1.1.01.13','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS MARÍTIMOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 962,'2015','1.2.3.1.1.01.14','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS AERONÁUTICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 963,'2015','1.2.3.1.1.01.15','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS DE PROTEÇÃO AO VOO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 964,'2015','1.2.3.1.1.01.16','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 965,'2015','1.2.3.1.1.01.17','EQUIPAMENTOS DE MANOBRAS E PATRULHAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 966,'2015','1.2.3.1.1.01.18','EQUIPAMENTOS DE PROTEÇÃO E VIGILÂNCIA AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 967,'2015','1.2.3.1.1.01.19','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS AGROPECUÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 968,'2015','1.2.3.1.1.01.20','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS RODOVIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 969,'2015','1.2.3.1.1.01.21','EQUIPAMENTOS HIDRÁULICOS E ELÉTRICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 970,'2015','1.2.3.1.1.01.99','OUTRAS MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 971,'2015','1.2.3.1.1.02.00','BENS DE INFORMÁTICA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 972,'2015','1.2.3.1.1.02.01','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 973,'2015','1.2.3.1.1.02.02','EQUIPAMENTOS DE TECNOLOGIA DA INFORMAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 974,'2015','1.2.3.1.1.02.03','SISTEMAS APLICATIVOS - SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 975,'2015','1.2.3.1.1.03.00','MÓVEIS E UTENSÍLIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 976,'2015','1.2.3.1.1.03.01','APARELHOS E UTENSÍLIOS DOMÉSTICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 977,'2015','1.2.3.1.1.03.02','MÁQUINAS E UTENSÍLIOS DE ESCRITÓRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 978,'2015','1.2.3.1.1.03.03','MOBILIÁRIO EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 979,'2015','1.2.3.1.1.03.04','UTENSÍLIOS EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 980,'2015','1.2.3.1.1.04.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 981,'2015','1.2.3.1.1.04.01','BANDEIRAS, FLÂMULAS E INSÍGNIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 982,'2015','1.2.3.1.1.04.02','COLEÇÕES E MATERIAIS BIBLIOGRÁFICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 983,'2015','1.2.3.1.1.04.03','DISCOTECAS E FILMOTECAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 984,'2015','1.2.3.1.1.04.04','INSTRUMENTOS MUSICAIS E ARTÍSTICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 985,'2015','1.2.3.1.1.04.05','EQUIPAMENTOS PARA ÁUDIO, VÍDEO E FOTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 986,'2015','1.2.3.1.1.04.06','OBRAS DE ARTE E PEÇAS PARA EXPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 987,'2015','1.2.3.1.1.04.99','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 988,'2015','1.2.3.1.1.05.00','VEÍCULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 989,'2015','1.2.3.1.1.05.01','VEÍCULOS EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 990,'2015','1.2.3.1.1.05.02','VEÍCULOS FERROVIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 991,'2015','1.2.3.1.1.05.03','VEÍCULOS DE TRAÇÃO MECÂNICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 992,'2015','1.2.3.1.1.05.04','CARROS DE COMBATE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 993,'2015','1.2.3.1.1.05.05','AERONAVES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 994,'2015','1.2.3.1.1.05.06','EMBARCAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 995,'2015','1.2.3.1.1.06.00','PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 996,'2015','1.2.3.1.1.07.00','BENS MÓVEIS EM ANDAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 997,'2015','1.2.3.1.1.07.01','BENS MÓVEIS EM ELABORACÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 998,'2015','1.2.3.1.1.07.02','IMPORTAÇÕES EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES ( 999,'2015','1.2.3.1.1.07.04','ALMOXARIFADO DE MATERIAIS A SEREM APLICADOS EM BENS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1000,'2015','1.2.3.1.1.08.00','BENS MÓVEIS EM ALMOXARIFADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1001,'2015','1.2.3.1.1.08.01','ESTOQUE INTERNO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1002,'2015','1.2.3.1.1.08.03','BENS MÓVEIS A REPARAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1003,'2015','1.2.3.1.1.08.05','BENS MÓVEIS INSERVÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1004,'2015','1.2.3.1.1.09.00','ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1005,'2015','1.2.3.1.1.10.00','SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1006,'2015','1.2.3.1.1.99.00','DEMAIS BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1007,'2015','1.2.3.1.1.99.01','BENS MÓVEIS A ALIENAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1008,'2015','1.2.3.1.1.99.02','BENS EM PODER DE OUTRA UNIDADE OU TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1009,'2015','1.2.3.1.1.99.08','BENS MÓVEIS A CLASSIFICAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1010,'2015','1.2.3.1.1.99.99','OUTROS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1011,'2015','1.2.3.2.0.00.00','BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1012,'2015','1.2.3.2.1.00.00','BENS IMOVEIS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1013,'2015','1.2.3.2.1.01.00','BENS DE USO ESPECIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1014,'2015','1.2.3.2.1.01.01','IMÓVEIS RESIDENCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1015,'2015','1.2.3.2.1.01.02','IMÓVEIS COMERCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1016,'2015','1.2.3.2.1.01.03','EDIFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1017,'2015','1.2.3.2.1.01.04','TERRENOS/GLEBAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1018,'2015','1.2.3.2.1.01.05','ARMAZÉNS/GALPÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1019,'2015','1.2.3.2.1.01.06','AQUARTELAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1020,'2015','1.2.3.2.1.01.07','AEROPORTOS/ESTAÇÕES/AERÓDROMOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1021,'2015','1.2.3.2.1.01.08','IMÓVEIS DE USO EDUCACIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1022,'2015','1.2.3.2.1.01.09','REPRESAS/AÇUDES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1023,'2015','1.2.3.2.1.01.10','FAZENDAS, PARQUES E RESERVAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1024,'2015','1.2.3.2.1.01.11','IMÓVEIS DE USO RECREATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1025,'2015','1.2.3.2.1.01.12','FARÓIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1026,'2015','1.2.3.2.1.01.13','MUSEUS/PALÁCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1027,'2015','1.2.3.2.1.01.14','LABORATÓRIOS/OBSERVATÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1028,'2015','1.2.3.2.1.01.15','HOSPITAIS E UNIDADES DE SAÚDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1029,'2015','1.2.3.2.1.01.16','HOTÉIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1030,'2015','1.2.3.2.1.01.17','PRESÍDIOS/DELEGACIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1031,'2015','1.2.3.2.1.01.18','PORTOS/ESTALEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1032,'2015','1.2.3.2.1.01.19','COMPLEXOS/FÁBRICAS/USINAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1033,'2015','1.2.3.2.1.01.20','CEMITÉRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1034,'2015','1.2.3.2.1.01.21','ESTACIONAMENTOS E GARAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1035,'2015','1.2.3.2.1.01.22','POSTOS DE FISCALIZAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1036,'2015','1.2.3.2.1.01.98','OUTROS BENS IMÓVEIS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1037,'2015','1.2.3.2.1.04.00','BENS DOMINICAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1038,'2015','1.2.3.2.1.04.01','EDIFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1039,'2015','1.2.3.2.1.04.02','APARTAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1040,'2015','1.2.3.2.1.04.03','ARMAZÉNS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1041,'2015','1.2.3.2.1.04.04','CASAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1042,'2015','1.2.3.2.1.04.05','CEMITÉRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1043,'2015','1.2.3.2.1.04.06','EDIFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1044,'2015','1.2.3.2.1.04.07','GARAGENS E ESTACIONAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1045,'2015','1.2.3.2.1.04.08','FAZENDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1046,'2015','1.2.3.2.1.04.09','GALPÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1047,'2015','1.2.3.2.1.04.10','GLEBAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1048,'2015','1.2.3.2.1.04.11','LOJAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1049,'2015','1.2.3.2.1.04.12','SALAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1050,'2015','1.2.3.2.1.04.13','TERRENOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1051,'2015','1.2.3.2.1.04.14','LOTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1052,'2015','1.2.3.2.1.04.15','LOTES INDUSTRIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1053,'2015','1.2.3.2.1.04.16','GLEBAS URBANAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1054,'2015','1.2.3.2.1.04.17','GLEBAS URBANIZADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1055,'2015','1.2.3.2.1.04.18','GLEBAS RURAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1056,'2015','1.2.3.2.1.04.99','OUTROS BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1057,'2015','1.2.3.2.1.05.00','BENS DE USO COMUM DO POVO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1058,'2015','1.2.3.2.1.05.01','RUAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1059,'2015','1.2.3.2.1.05.02','PRAÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1060,'2015','1.2.3.2.1.05.03','ESTRADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1061,'2015','1.2.3.2.1.05.04','PONTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1062,'2015','1.2.3.2.1.05.05','VIADUTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1063,'2015','1.2.3.2.1.05.06','SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1064,'2015','1.2.3.2.1.05.07','SISTEMAS DE ABASTECIMETNO DE ENERGIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1065,'2015','1.2.3.2.1.05.08','REDES DE TELECOMUNICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1066,'2015','1.2.3.2.1.05.09','BENS DO PATRIMONIO CULTURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1067,'2015','1.2.3.2.1.05.99','OUTROS BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1068,'2015','1.2.3.2.1.06.00','BENS IMÓVEIS EM ANDAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1069,'2015','1.2.3.2.1.06.01','OBRAS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1070,'2015','1.2.3.2.1.06.05','ESTUDOS E PROJETOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1071,'2015','1.2.3.2.1.07.00','INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1072,'2015','1.2.3.2.1.08.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1073,'2015','1.2.3.2.1.99.00','DEMAIS BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1074,'2015','1.2.3.2.1.99.01','BENS IMÓVEIS LOCADOS PARA TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1075,'2015','1.2.3.2.1.99.02','IMÓVEIS EM PODER DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1076,'2015','1.2.3.2.1.99.03','MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1077,'2015','1.2.3.2.1.99.05','BENS IMÓVEIS A CLASSIFICAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1078,'2015','1.2.3.2.1.99.06','BENS IMÓVEIS A ALIENAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1079,'2015','1.2.3.2.1.99.99','OUTROS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1080,'2015','1.2.3.8.0.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1081,'2015','1.2.3.8.1.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1082,'2015','1.2.3.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA – BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1083,'2015','1.2.3.8.1.01.01','(-) DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1084,'2015','1.2.3.8.1.01.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1085,'2015','1.2.3.8.1.01.03','(-) DEPRECIAÇÃO ACUMULADA DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1086,'2015','1.2.3.8.1.01.04','(-) DEPRECIAÇÃO ACUMULADA DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1087,'2015','1.2.3.8.1.01.05','(-) DEPRECIAÇÃO ACUMULADA DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1088,'2015','1.2.3.8.1.01.06','(-) DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1089,'2015','1.2.3.8.1.01.07','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1090,'2015','1.2.3.8.1.01.08','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1091,'2015','1.2.3.8.1.01.09','(-) DEPRECIAÇÃO ACUMULADA DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1092,'2015','1.2.3.8.1.01.10','(-) DEPRECIAÇÃO ACUMULADA DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1093,'2015','1.2.3.8.1.01.99','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1094,'2015','1.2.3.8.1.02.00','(-) DEPRECIAÇÃO ACUMULADA – BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1095,'2015','1.2.3.8.1.02.01','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1096,'2015','1.2.3.8.1.02.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1097,'2015','1.2.3.8.1.02.03','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1098,'2015','1.2.3.8.1.02.04','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1099,'2015','1.2.3.8.1.02.05','(-) DEPRECIAÇÃO ACUMULADA DE INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1100,'2015','1.2.3.8.1.02.06','(-) DEPRECIAÇÃO ACUMULADA DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1101,'2015','1.2.3.8.1.02.99','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1102,'2015','1.2.3.8.1.03.00','(-) EXAUSTÃO ACUMULADA – BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1103,'2015','1.2.3.8.1.04.00','(-) EXAUSTÃO ACUMULADA – BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1104,'2015','1.2.3.8.1.05.00','(-) AMORTIZAÇÃO ACUMULADA – BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1105,'2015','1.2.3.8.1.06.00','(-) AMORTIZAÇÃO ACUMULADA – BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1106,'2015','1.2.3.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1107,'2015','1.2.3.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1108,'2015','1.2.3.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MOVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1109,'2015','1.2.3.9.1.01.01','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1110,'2015','1.2.3.9.1.01.02','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1111,'2015','1.2.3.9.1.01.03','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1112,'2015','1.2.3.9.1.01.04','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1113,'2015','1.2.3.9.1.01.05','(-) REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1114,'2015','1.2.3.9.1.01.06','(-) REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1115,'2015','1.2.3.9.1.01.07','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1116,'2015','1.2.3.9.1.01.08','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1117,'2015','1.2.3.9.1.01.09','(-) REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1118,'2015','1.2.3.9.1.01.10','(-) REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1119,'2015','1.2.3.9.1.01.99','(-) REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1120,'2015','1.2.3.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1121,'2015','1.2.3.9.1.02.01','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1122,'2015','1.2.3.9.1.02.02','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1123,'2015','1.2.3.9.1.02.03','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1124,'2015','1.2.3.9.1.02.04','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1125,'2015','1.2.3.9.1.02.05','(-) REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1126,'2015','1.2.3.9.1.02.06','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1127,'2015','1.2.3.9.1.02.99','(-) REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1128,'2015','1.2.4.0.0.00.00','INTANGÍVEL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1129,'2015','1.2.4.1.0.00.00','SOFTWARES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1130,'2015','1.2.4.1.1.00.00','SOFTWARES- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1131,'2015','1.2.4.1.1.01.00','SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1132,'2015','1.2.4.1.1.02.00','SOFTWARES EM DESENVOLVIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1133,'2015','1.2.4.2.0.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1134,'2015','1.2.4.2.1.00.00','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1135,'2015','1.2.4.2.1.01.00','MARCAS E PATENTES INDUSTRIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1136,'2015','1.2.4.2.1.02.00','CONCESSÃO DE DIREITO DE USO DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1137,'2015','1.2.4.2.1.03.00','DIREITOS AUTORAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1138,'2015','1.2.4.2.1.04.00','DIREITOS SOBRE RECURSOS NATURAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1139,'2015','1.2.4.2.1.05.00','ADIANTAMENTO PARA TRANFERÊNCIA DE TECNOLOGIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1140,'2015','1.2.4.2.1.99.00','OUTROS DIREITOS - BENS INTANGÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1141,'2015','1.2.4.3.0.00.00','DIREITO DE USO DE IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1142,'2015','1.2.4.3.1.00.00','DIREITO DE USO DE IMOVEIS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1143,'2015','1.2.4.8.0.00.00','(-) AMORTIZAÇÃO ACUMULADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1144,'2015','1.2.4.8.1.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1145,'2015','1.2.4.8.1.01.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1146,'2015','1.2.4.8.1.02.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATÉNTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1147,'2015','1.2.4.8.1.03.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1148,'2015','1.2.4.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1149,'2015','1.2.4.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1150,'2015','1.2.4.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1151,'2015','1.2.4.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATÉNTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1152,'2015','1.2.4.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1153,'2015','1.2.5.0.0.00.00','DIFERIDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1154,'2015','1.2.5.1.0.00.00','GASTOS DE IMPLANTAÇÃO E PRÉ-OPERACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1155,'2015','1.2.5.1.1.00.00','GASTOS DE IMPLANTAÇÃO E PRÉ-OPERACIONAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1156,'2015','1.2.5.2.0.00.00','GASTOS DE REORGANIZAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1157,'2015','1.2.5.2.1.00.00','GASTOS DE REORGANIZAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1158,'2015','1.2.5.9.0.00.00','(-) AMORTIZAÇÃO ACUMULADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1159,'2015','1.2.5.9.1.00.00','(-) AMORTIZAÇÃO ACUMULADA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1160,'2015','1.2.5.9.1.01.00','(-) AMORTIZAÇÃO ACUMULADA - GASTOS DE IMPLANTAÇÃO E PRÉ-OPERACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1161,'2015','1.2.5.9.1.02.00','(-) AMORTIZAÇÃO ACUMULADA - GASTOS DE REORGANIZAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1162,'2015','2.0.0.0.0.00.00','PASSIVO E PATRIMÔNIO LIQUIDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1163,'2015','2.1.0.0.0.00.00','PASSIVO CIRCULANTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1164,'2015','2.1.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1165,'2015','2.1.1.1.0.00.00','PESSOAL A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1166,'2015','2.1.1.1.1.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1167,'2015','2.1.1.1.1.01.00','PESSOAL A PAGAR DO EXERCÍCIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1168,'2015','2.1.1.1.1.01.01','SALÁRIOS, REMUNERACOES E BENEFÍCIOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1169,'2015','2.1.1.1.1.01.02','DÉCIMO TERCEIRO SALÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1170,'2015','2.1.1.1.1.01.03','FÉRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1171,'2015','2.1.1.1.1.01.04','LICENÇA- PRÊMIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1172,'2015','2.1.1.1.1.01.05','PARTICIPAÇÕES A EMPREGADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1173,'2015','2.1.1.1.1.02.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1174,'2015','2.1.1.1.1.02.01','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERC. ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1175,'2015','2.1.1.1.1.02.02','PARTICIPAÇÕES A EMPREGADOS - EXERC. ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1176,'2015','2.1.1.1.1.03.00','PRECATORIOS DE PESSOAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1177,'2015','2.1.1.1.1.03.01','PRECATORIOS DE PESSOAL DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1178,'2015','2.1.1.1.1.03.02','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1179,'2015','2.1.1.1.1.03.03','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1180,'2015','2.1.1.1.1.03.04','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1181,'2015','2.1.1.1.1.03.05','PRECATORIOS DE PESSOAL - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1182,'2015','2.1.1.1.1.03.06','PRECATORIOS DE PESSOAL - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1183,'2015','2.1.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1184,'2015','2.1.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1185,'2015','2.1.1.2.1.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1186,'2015','2.1.1.2.1.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1187,'2015','2.1.1.2.1.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1188,'2015','2.1.1.2.1.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1189,'2015','2.1.1.2.1.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1190,'2015','2.1.1.2.1.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1191,'2015','2.1.1.2.1.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1192,'2015','2.1.1.2.1.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1193,'2015','2.1.1.2.1.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1194,'2015','2.1.1.2.2.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1195,'2015','2.1.1.2.2.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1196,'2015','2.1.1.2.2.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1197,'2015','2.1.1.2.2.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1198,'2015','2.1.1.2.2.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1199,'2015','2.1.1.2.2.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1200,'2015','2.1.1.2.2.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1201,'2015','2.1.1.2.2.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1202,'2015','2.1.1.2.2.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1203,'2015','2.1.1.2.2.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1204,'2015','2.1.1.2.3.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR-INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1205,'2015','2.1.1.2.3.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1206,'2015','2.1.1.2.3.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1207,'2015','2.1.1.2.3.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1208,'2015','2.1.1.2.3.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1209,'2015','2.1.1.2.3.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1210,'2015','2.1.1.2.3.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1211,'2015','2.1.1.2.3.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1212,'2015','2.1.1.2.3.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1213,'2015','2.1.1.2.3.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1214,'2015','2.1.1.2.4.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1215,'2015','2.1.1.2.4.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1216,'2015','2.1.1.2.4.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1217,'2015','2.1.1.2.4.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1218,'2015','2.1.1.2.4.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1219,'2015','2.1.1.2.4.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1220,'2015','2.1.1.2.4.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1221,'2015','2.1.1.2.4.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1222,'2015','2.1.1.2.4.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1223,'2015','2.1.1.2.4.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1224,'2015','2.1.1.2.5.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1225,'2015','2.1.1.2.5.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1226,'2015','2.1.1.2.5.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1227,'2015','2.1.1.2.5.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1228,'2015','2.1.1.2.5.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1229,'2015','2.1.1.2.5.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1230,'2015','2.1.1.2.5.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1231,'2015','2.1.1.2.5.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1232,'2015','2.1.1.2.5.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1233,'2015','2.1.1.2.5.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1234,'2015','2.1.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1235,'2015','2.1.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1236,'2015','2.1.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1237,'2015','2.1.1.3.1.02.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1238,'2015','2.1.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1239,'2015','2.1.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1240,'2015','2.1.1.4.2.01.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1241,'2015','2.1.1.4.2.99.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1242,'2015','2.1.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1243,'2015','2.1.1.4.3.01.00','INSS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1244,'2015','2.1.1.4.3.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1245,'2015','2.1.1.4.3.01.02','INSS - DEBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1246,'2015','2.1.1.4.3.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1247,'2015','2.1.1.4.3.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1248,'2015','2.1.1.4.3.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1249,'2015','2.1.1.4.3.03.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1250,'2015','2.1.1.4.3.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1251,'2015','2.1.1.4.3.04.00','PREVIDÊNCIA SOCIAL RURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1252,'2015','2.1.1.4.3.05.00','FGTS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1253,'2015','2.1.1.4.3.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1254,'2015','2.1.1.4.3.07.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1255,'2015','2.1.1.4.3.98.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1256,'2015','2.1.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1257,'2015','2.1.1.4.4.01.00','INSS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1258,'2015','2.1.1.4.4.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1259,'2015','2.1.1.4.4.01.02','INSS - DEBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1260,'2015','2.1.1.4.4.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1261,'2015','2.1.1.4.4.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1262,'2015','2.1.1.4.4.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1263,'2015','2.1.1.4.4.03.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1264,'2015','2.1.1.4.4.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1265,'2015','2.1.1.4.4.04.00','PREVIDÊNCIA SOCIAL RURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1266,'2015','2.1.1.4.4.05.00','FGTS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1267,'2015','2.1.1.4.4.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1268,'2015','2.1.1.4.4.98.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1269,'2015','2.1.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1270,'2015','2.1.1.4.5.01.00','INSS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1271,'2015','2.1.1.4.5.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1272,'2015','2.1.1.4.5.01.02','INSS - DEBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1273,'2015','2.1.1.4.5.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1274,'2015','2.1.1.4.5.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1275,'2015','2.1.1.4.5.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1276,'2015','2.1.1.4.5.03.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1277,'2015','2.1.1.4.5.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1278,'2015','2.1.1.4.5.04.00','PREVIDÊNCIA SOCIAL RURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1279,'2015','2.1.1.4.5.05.00','FGTS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1280,'2015','2.1.1.4.5.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1281,'2015','2.1.1.4.5.98.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1282,'2015','2.1.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1283,'2015','2.1.2.1.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1284,'2015','2.1.2.1.1.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1285,'2015','2.1.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1286,'2015','2.1.2.1.1.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1287,'2015','2.1.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1288,'2015','2.1.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1289,'2015','2.1.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1290,'2015','2.1.2.1.1.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1291,'2015','2.1.2.1.1.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1292,'2015','2.1.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1293,'2015','2.1.2.1.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1294,'2015','2.1.2.1.3.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1295,'2015','2.1.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1296,'2015','2.1.2.1.3.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1297,'2015','2.1.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1298,'2015','2.1.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1299,'2015','2.1.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1300,'2015','2.1.2.1.3.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1301,'2015','2.1.2.1.3.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1302,'2015','2.1.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1303,'2015','2.1.2.1.3.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1304,'2015','2.1.2.1.4.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1305,'2015','2.1.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1306,'2015','2.1.2.1.4.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1307,'2015','2.1.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1308,'2015','2.1.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1309,'2015','2.1.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1310,'2015','2.1.2.1.4.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1311,'2015','2.1.2.1.4.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1312,'2015','2.1.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1313,'2015','2.1.2.1.4.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1314,'2015','2.1.2.1.5.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1315,'2015','2.1.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1316,'2015','2.1.2.1.5.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1317,'2015','2.1.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1318,'2015','2.1.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1319,'2015','2.1.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1320,'2015','2.1.2.1.5.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1321,'2015','2.1.2.1.5.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1322,'2015','2.1.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1323,'2015','2.1.2.1.5.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1324,'2015','2.1.2.2.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1325,'2015','2.1.2.2.1.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1326,'2015','2.1.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1327,'2015','2.1.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS  - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1328,'2015','2.1.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1329,'2015','2.1.2.3.0.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1330,'2015','2.1.2.3.1.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1331,'2015','2.1.2.3.1.01.00','FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1332,'2015','2.1.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1333,'2015','2.1.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1334,'2015','2.1.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1335,'2015','2.1.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1336,'2015','2.1.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1337,'2015','2.1.2.3.1.03.00','FATURAS / DUPLICATAS DESCONTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1338,'2015','2.1.2.3.3.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1339,'2015','2.1.2.3.3.01.00','FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1340,'2015','2.1.2.3.3.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1341,'2015','2.1.2.3.3.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1342,'2015','2.1.2.3.3.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1343,'2015','2.1.2.3.3.01.98','OUTROS FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1344,'2015','2.1.2.3.3.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1345,'2015','2.1.2.3.4.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1346,'2015','2.1.2.3.4.01.00','FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1347,'2015','2.1.2.3.4.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1348,'2015','2.1.2.3.4.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1349,'2015','2.1.2.3.4.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1350,'2015','2.1.2.3.4.01.98','OUTROS FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1351,'2015','2.1.2.3.4.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1352,'2015','2.1.2.3.5.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1353,'2015','2.1.2.4.0.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1354,'2015','2.1.2.4.1.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1355,'2015','2.1.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1356,'2015','2.1.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1357,'2015','2.1.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1358,'2015','2.1.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1359,'2015','2.1.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1360,'2015','2.1.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1361,'2015','2.1.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1362,'2015','2.1.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1363,'2015','2.1.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1364,'2015','2.1.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1365,'2015','2.1.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1366,'2015','2.1.2.5.3.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1367,'2015','2.1.2.5.3.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1368,'2015','2.1.2.5.3.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1369,'2015','2.1.2.5.3.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1370,'2015','2.1.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1371,'2015','2.1.2.5.4.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1372,'2015','2.1.2.5.4.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1373,'2015','2.1.2.5.4.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1374,'2015','2.1.2.5.4.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1375,'2015','2.1.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1376,'2015','2.1.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1377,'2015','2.1.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – EXTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1378,'2015','2.1.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1379,'2015','2.1.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1380,'2015','2.1.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1381,'2015','2.1.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1382,'2015','2.1.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1383,'2015','2.1.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1384,'2015','2.1.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1385,'2015','2.1.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1386,'2015','2.1.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1387,'2015','2.1.2.8.3.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1388,'2015','2.1.2.8.3.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1389,'2015','2.1.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1390,'2015','2.1.2.8.4.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1391,'2015','2.1.2.8.4.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1392,'2015','2.1.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS – MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1393,'2015','2.1.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1394,'2015','2.1.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1395,'2015','2.1.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1396,'2015','2.1.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1397,'2015','2.1.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1398,'2015','2.1.3.1.0.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1399,'2015','2.1.3.1.1.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1400,'2015','2.1.3.1.1.01.00','FORNECEDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1401,'2015','2.1.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1402,'2015','2.1.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1403,'2015','2.1.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1404,'2015','2.1.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1405,'2015','2.1.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1406,'2015','2.1.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1407,'2015','2.1.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – ANTERIORES A 05/5/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1408,'2015','2.1.3.1.1.02.03','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – A PARTIR DE 05/5/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1409,'2015','2.1.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1410,'2015','2.1.3.1.1.02.05','PRECATORIOS DE FORNECEDORES NACIONAIS  - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1411,'2015','2.1.3.1.1.03.00','CONTAS A PAGAR CREDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1412,'2015','2.1.3.1.1.03.01','CONTAS NÃO FINANCIADAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1413,'2015','2.1.3.1.1.03.02','CONTAS FINANCIADS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1414,'2015','2.1.3.1.1.03.03','PARCELAMENTO DE CONTAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1415,'2015','2.1.3.1.1.03.99','DEMAIS CONTAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1416,'2015','2.1.3.1.1.04.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1417,'2015','2.1.3.1.1.04.01','PRECATÓRIOS DE  CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1418,'2015','2.1.3.1.1.04.02','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1419,'2015','2.1.3.1.1.04.03','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1420,'2015','2.1.3.1.1.04.04','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1421,'2015','2.1.3.2.0.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1422,'2015','2.1.3.2.1.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1423,'2015','2.1.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1424,'2015','2.1.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1425,'2015','2.1.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1426,'2015','2.1.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1427,'2015','2.1.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1428,'2015','2.1.3.2.1.02.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1429,'2015','2.1.3.2.1.02.01','CONTAS NÃO FINANCIADAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1430,'2015','2.1.3.2.1.02.02','CONTAS FINANCIADS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1431,'2015','2.1.3.2.1.02.03','PARCELAMENTO DE CONTAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1432,'2015','2.1.3.2.1.02.99','DEMAIS CONTAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1433,'2015','2.1.4.0.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1434,'2015','2.1.4.1.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1435,'2015','2.1.4.1.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1436,'2015','2.1.4.1.1.01.00','IPI A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1437,'2015','2.1.4.1.1.02.00','IRPJ A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1438,'2015','2.1.4.1.1.03.00','PASSIVO FISCAL DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1439,'2015','2.1.4.1.1.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1440,'2015','2.1.4.1.1.05.00','IOF A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1441,'2015','2.1.4.1.1.06.00','ITR A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1442,'2015','2.1.4.1.1.08.00','CIDE A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1443,'2015','2.1.4.1.1.09.00','CSSL A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1444,'2015','2.1.4.1.1.10.00','COFINS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1445,'2015','2.1.4.1.1.11.00','PIS/PASEP A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1446,'2015','2.1.4.1.1.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1447,'2015','2.1.4.1.1.13.00','RECURSOS FISCAIS - DARF A EMITIR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1448,'2015','2.1.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1449,'2015','2.1.4.1.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1450,'2015','2.1.4.1.2.01.00','IPI A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1451,'2015','2.1.4.1.2.02.00','IRPJ A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1452,'2015','2.1.4.1.2.03.00','PASSIVO FISCAL DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1453,'2015','2.1.4.1.2.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1454,'2015','2.1.4.1.2.05.00','IOF A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1455,'2015','2.1.4.1.2.06.00','ITR A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1456,'2015','2.1.4.1.2.08.00','CIDE A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1457,'2015','2.1.4.1.2.09.00','CSSL A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1458,'2015','2.1.4.1.2.10.00','COFINS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1459,'2015','2.1.4.1.2.11.00','PIS/PASEP A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1460,'2015','2.1.4.1.2.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1461,'2015','2.1.4.1.2.13.00','RECURSOS FISCAIS - DARF A EMITIR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1462,'2015','2.1.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1463,'2015','2.1.4.1.3.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1464,'2015','2.1.4.1.3.01.00','IPI A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1465,'2015','2.1.4.1.3.02.00','IRPJ A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1466,'2015','2.1.4.1.3.03.00','PASSIVO FISCAL DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1467,'2015','2.1.4.1.3.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1468,'2015','2.1.4.1.3.05.00','IOF A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1469,'2015','2.1.4.1.3.06.00','ITR A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1470,'2015','2.1.4.1.3.08.00','CIDE A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1471,'2015','2.1.4.1.3.09.00','CSSL A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1472,'2015','2.1.4.1.3.10.00','COFINS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1473,'2015','2.1.4.1.3.11.00','PIS/PASEP A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1474,'2015','2.1.4.1.3.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1475,'2015','2.1.4.1.3.13.00','RECURSOS FISCAIS - DARF A EMITIR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1476,'2015','2.1.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1477,'2015','2.1.4.2.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1478,'2015','2.1.4.2.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1479,'2015','2.1.4.2.1.01.00','ICMS A RECOLHER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1480,'2015','2.1.4.2.1.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1481,'2015','2.1.4.2.1.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1482,'2015','2.1.4.2.1.02.00','IPVA A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1483,'2015','2.1.4.2.1.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1484,'2015','2.1.4.2.1.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1485,'2015','2.1.4.2.1.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1486,'2015','2.1.4.2.1.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1487,'2015','2.1.4.2.1.07.00','RECURSOS FISCAIS ESTADUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1488,'2015','2.1.4.2.1.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1489,'2015','2.1.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1490,'2015','2.1.4.2.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1491,'2015','2.1.4.2.2.01.00','ICMS A RECOLHER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1492,'2015','2.1.4.2.2.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1493,'2015','2.1.4.2.2.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1494,'2015','2.1.4.2.2.02.00','IPVA A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1495,'2015','2.1.4.2.2.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1496,'2015','2.1.4.2.2.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1497,'2015','2.1.4.2.2.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1498,'2015','2.1.4.2.2.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1499,'2015','2.1.4.2.2.07.00','RECURSOS FISCAIS ESTADUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1500,'2015','2.1.4.2.2.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1501,'2015','2.1.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1502,'2015','2.1.4.2.4.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1503,'2015','2.1.4.2.4.01.00','ICMS A RECOLHER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1504,'2015','2.1.4.2.4.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1505,'2015','2.1.4.2.4.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1506,'2015','2.1.4.2.4.02.00','IPVA A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1507,'2015','2.1.4.2.4.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1508,'2015','2.1.4.2.4.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1509,'2015','2.1.4.2.4.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1510,'2015','2.1.4.2.4.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1511,'2015','2.1.4.2.4.07.00','RECURSOS FISCAIS ESTADUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1512,'2015','2.1.4.2.4.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1513,'2015','2.1.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1514,'2015','2.1.4.3.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1515,'2015','2.1.4.3.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1516,'2015','2.1.4.3.1.01.00','ISS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1517,'2015','2.1.4.3.1.02.00','IPTU/TLP A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1518,'2015','2.1.4.3.1.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1519,'2015','2.1.4.3.1.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1520,'2015','2.1.4.3.1.06.00','RECURSOS FISCAIS MUNICIPAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1521,'2015','2.1.4.3.1.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1522,'2015','2.1.4.3.1.08.00','TAXA DE INSPEÇÃO VEICULAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1523,'2015','2.1.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1524,'2015','2.1.4.3.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1525,'2015','2.1.4.3.2.01.00','ISS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1526,'2015','2.1.4.3.2.02.00','IPTU/TLP A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1527,'2015','2.1.4.3.2.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1528,'2015','2.1.4.3.2.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1529,'2015','2.1.4.3.2.06.00','RECURSOS FISCAIS MUNICIPAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1530,'2015','2.1.4.3.2.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1531,'2015','2.1.4.3.2.08.00','TAXA DE INSPEÇÃO VEICULAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1532,'2015','2.1.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1533,'2015','2.1.4.3.5.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1534,'2015','2.1.4.3.5.01.00','ISS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1535,'2015','2.1.4.3.5.02.00','IPTU/TLP A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1536,'2015','2.1.4.3.5.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1537,'2015','2.1.4.3.5.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1538,'2015','2.1.4.3.5.06.00','RECURSOS FISCAIS MUNICIPAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1539,'2015','2.1.4.3.5.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1540,'2015','2.1.4.3.5.08.00','TAXA DE INSPEÇÃO VEICULAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1541,'2015','2.1.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1542,'2015','2.1.5.0.0.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1543,'2015','2.1.5.0.3.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1544,'2015','2.1.5.0.4.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1545,'2015','2.1.5.0.5.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1546,'2015','2.1.5.0.5.01.00','REPARTIÇÃO DA COTA DE ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1547,'2015','2.1.5.0.5.02.00','REPARTIÇÃO DA COTA DE IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1548,'2015','2.1.5.0.5.03.00','REPARTIÇÃO DA COTA-PARTE DO IPI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1549,'2015','2.1.5.0.5.99.00','REPARTIÇÃO DA COTA DE OUTROS TRIBUTOS/RECEITAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1550,'2015','2.1.7.0.0.00.00','PROVISÕES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1551,'2015','2.1.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1552,'2015','2.1.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1553,'2015','2.1.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1554,'2015','2.1.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1555,'2015','2.1.7.3.0.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1556,'2015','2.1.7.3.1.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1557,'2015','2.1.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1558,'2015','2.1.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1559,'2015','2.1.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1560,'2015','2.1.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1561,'2015','2.1.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1562,'2015','2.1.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1563,'2015','2.1.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1564,'2015','2.1.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1565,'2015','2.1.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1566,'2015','2.1.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1567,'2015','2.1.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1568,'2015','2.1.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1569,'2015','2.1.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1570,'2015','2.1.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1571,'2015','2.1.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1572,'2015','2.1.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1573,'2015','2.1.7.5.5.01.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1574,'2015','2.1.7.5.5.02.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1575,'2015','2.1.7.5.5.03.00','PROVISÃO PARA REPARTIÇÃO DA COTA-PARTE DO IPI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1576,'2015','2.1.7.5.5.99.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE OUTROS TRIBUTOS/RECEITAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1577,'2015','2.1.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1578,'2015','2.1.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1579,'2015','2.1.7.9.0.00.00','OUTRAS PROVISÕES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1580,'2015','2.1.7.9.1.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1581,'2015','2.1.7.9.1.01.00','PROVISÃO PARA GARANTIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1582,'2015','2.1.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1583,'2015','2.1.7.9.1.99.00','OUTRAS PROVISÕES A CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1584,'2015','2.1.8.0.0.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1585,'2015','2.1.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1586,'2015','2.1.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1587,'2015','2.1.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1588,'2015','2.1.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1589,'2015','2.1.8.3.0.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1590,'2015','2.1.8.3.1.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1591,'2015','2.1.8.3.1.01.00','ARRENDAMENTO OPERACIONAL A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1592,'2015','2.1.8.4.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1593,'2015','2.1.8.4.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1594,'2015','2.1.8.4.1.01.00','DEBENTURES CONVERSIVEIS EM ACOES NO CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1595,'2015','2.1.8.4.1.02.00','DEBENTURES NAO-CONVERSIVEIS EM ACOES NO CURTO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1596,'2015','2.1.8.4.1.96.00','AGIO NA EMISSAO DE DEBENTURES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1597,'2015','2.1.8.4.1.97.00','(-) DESAGIO NA EMISSAO DE DEBENTURES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1598,'2015','2.1.8.4.1.98.00','(-) CUSTO DA TRANSACAO A AMORTIZAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1599,'2015','2.1.8.4.1.99.00','OUTROS TITULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1600,'2015','2.1.8.5.0.00.00','DIVIDENDOS E JUROS SOBRE CAPITAL PRÓRIO A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1601,'2015','2.1.8.5.1.00.00','DIVIDENDOS E JUROS SOBRE CAPITAL PRÓRIO A PAGAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1602,'2015','2.1.8.5.1.01.00','DIVIDENDOS A PAGAR - TESOURO ESTADUAL/MUNICIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1603,'2015','2.1.8.5.1.02.00','DIVIDENDOS A PAGAR - TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1604,'2015','2.1.8.5.1.03.00','JUROS SOBRE CAPITAL PRÓPRIO A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1605,'2015','2.1.8.8.0.00.00','VALORES RESTITUÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1606,'2015','2.1.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1607,'2015','2.1.8.8.1.01.00','CONSIGNACOES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1608,'2015','2.1.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1609,'2015','2.1.8.8.1.01.02','INSS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1610,'2015','2.1.8.8.1.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1611,'2015','2.1.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1612,'2015','2.1.8.8.1.01.05','INDENIZAÇÕES E RESTITUICOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1613,'2015','2.1.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1614,'2015','2.1.8.8.1.01.07','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1615,'2015','2.1.8.8.1.01.08','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1616,'2015','2.1.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1617,'2015','2.1.8.8.1.01.10','PENSAO ALIMENTICIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1618,'2015','2.1.8.8.1.01.11','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1619,'2015','2.1.8.8.1.01.12','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1620,'2015','2.1.8.8.1.01.13','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1621,'2015','2.1.8.8.1.01.14','RETENCOES - PLANOS DE SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1622,'2015','2.1.8.8.1.01.15','RETENCOES - EMPRÉSTIMOS E FINANCIAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1623,'2015','2.1.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1624,'2015','2.1.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1625,'2015','2.1.8.8.1.01.99','OUTROS CONSIGNATARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1626,'2015','2.1.8.8.1.02.00','GARANTIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1627,'2015','2.1.8.8.1.03.00','DEPOSITOS JUDICIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1628,'2015','2.1.8.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1629,'2015','2.1.8.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1630,'2015','2.1.8.8.1.04.00','DEPOSITOS NAO JUDICIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1631,'2015','2.1.8.8.1.04.01','DEPOSITOS E CAUCOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1632,'2015','2.1.8.8.1.04.02','DEPOSITOS ESPECIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1633,'2015','2.1.8.8.1.04.03','DEPOSITOS DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1634,'2015','2.1.8.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1635,'2015','2.1.8.8.1.04.05','DEPOSITOS A TRANSFERIR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1636,'2015','2.1.8.8.1.04.99','OUTROS DEPOSITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1637,'2015','2.1.8.8.1.99.00','OUTROS VALORES RESTITUIVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1638,'2015','2.1.8.9.0.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1639,'2015','2.1.8.9.1.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1640,'2015','2.1.8.9.1.01.00','INDENIZACOES E RESTITUICOES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1641,'2015','2.1.8.9.1.01.01','INDENIZAÇÕES A SERVIDORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1642,'2015','2.1.8.9.1.01.02','INDENIZAÇÕES E RESTITUICOES DIVERSAS DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1643,'2015','2.1.8.9.1.01.03','INDENIZAÇÕES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1644,'2015','2.1.8.9.1.02.00','DIARIAS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1645,'2015','2.1.8.9.1.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1646,'2015','2.1.8.9.1.05.00','CONVENIOS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1647,'2015','2.1.8.9.1.05.01','CONVENIOS A PAGAR DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1648,'2015','2.1.8.9.1.05.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1649,'2015','2.1.8.9.1.09.00','TERMOS DE PARCERIA A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1650,'2015','2.1.8.9.1.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1651,'2015','2.1.8.9.1.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1652,'2015','2.1.8.9.1.10.00','TERMO DE COMPROMISSO A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1653,'2015','2.1.8.9.1.11.00','CONTRATOS DE GESTAO A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1654,'2015','2.1.8.9.1.12.00','SUBVENCOES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1655,'2015','2.1.8.9.1.13.00','TRANSFERÊNCIAS ORCAMENTARIAS A LIBERAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1656,'2015','2.1.8.9.1.14.00','CONSÓRCIOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1657,'2015','2.1.8.9.2.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1658,'2015','2.2.0.0.0.00.00','PASSIVO NAO-CIRCULANTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1659,'2015','2.2.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1660,'2015','2.2.1.1.0.00.00','PESSOAL A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1661,'2015','2.2.1.1.1.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1662,'2015','2.2.1.1.1.01.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1663,'2015','2.2.1.1.1.02.00','PRECATORIOS DE PESSOAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1664,'2015','2.2.1.1.1.02.01','PRECATORIOS DE PESSOAL - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1665,'2015','2.2.1.1.1.02.02','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  ANTERIORES  05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1666,'2015','2.2.1.1.1.02.03','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1667,'2015','2.2.1.1.1.02.04','PRECATORIOS DE PESSOAL - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1668,'2015','2.2.1.1.1.02.05','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1669,'2015','2.2.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1670,'2015','2.2.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1671,'2015','2.2.1.2.1.01.00','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1672,'2015','2.2.1.2.1.01.01','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1673,'2015','2.2.1.2.1.01.02','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS DE EXERCICIOS ANTERIORES -  ANTERIORES A 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1674,'2015','2.2.1.2.1.01.03','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1675,'2015','2.2.1.2.1.01.04','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1676,'2015','2.2.1.2.1.01.05','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1677,'2015','2.2.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1678,'2015','2.2.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1679,'2015','2.2.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1680,'2015','2.2.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1681,'2015','2.2.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1682,'2015','2.2.1.4.1.01.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1683,'2015','2.2.1.4.1.02.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1684,'2015','2.2.1.4.1.03.00','FGTS - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1685,'2015','2.2.1.4.1.99.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1686,'2015','2.2.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1687,'2015','2.2.1.4.2.01.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1688,'2015','2.2.1.4.2.99.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1689,'2015','2.2.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1690,'2015','2.2.1.4.3.01.00','INSS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1691,'2015','2.2.1.4.3.01.01','INSS - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1692,'2015','2.2.1.4.3.99.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1693,'2015','2.2.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1694,'2015','2.2.1.4.4.01.00','INSS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1695,'2015','2.2.1.4.4.01.01','INSS - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1696,'2015','2.2.1.4.4.99.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1697,'2015','2.2.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1698,'2015','2.2.1.4.5.01.00','INSS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1699,'2015','2.2.1.4.5.01.01','INSS - DÉBITO PARCELADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1700,'2015','2.2.1.4.5.99.00','OUTROS ENCARGOS SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1701,'2015','2.2.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1702,'2015','2.2.2.1.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1703,'2015','2.2.2.1.1.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1704,'2015','2.2.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1705,'2015','2.2.2.1.1.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1706,'2015','2.2.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1707,'2015','2.2.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1708,'2015','2.2.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1709,'2015','2.2.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1710,'2015','2.2.2.1.1.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1711,'2015','2.2.2.1.3.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1712,'2015','2.2.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1713,'2015','2.2.2.1.3.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1714,'2015','2.2.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1715,'2015','2.2.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1716,'2015','2.2.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1717,'2015','2.2.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1718,'2015','2.2.2.1.3.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1719,'2015','2.2.2.1.4.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1720,'2015','2.2.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1721,'2015','2.2.2.1.4.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1722,'2015','2.2.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1723,'2015','2.2.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1724,'2015','2.2.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1725,'2015','2.2.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1726,'2015','2.2.2.1.4.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1727,'2015','2.2.2.1.5.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1728,'2015','2.2.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1729,'2015','2.2.2.1.5.01.01','DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1730,'2015','2.2.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1731,'2015','2.2.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1732,'2015','2.2.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1733,'2015','2.2.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1734,'2015','2.2.2.1.5.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1735,'2015','2.2.2.2.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1736,'2015','2.2.2.2.1.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1737,'2015','2.2.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1738,'2015','2.2.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS  - EM CONTRATOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1739,'2015','2.2.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1740,'2015','2.2.2.3.0.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1741,'2015','2.2.2.3.1.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1742,'2015','2.2.2.3.1.01.00','FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1743,'2015','2.2.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1744,'2015','2.2.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1745,'2015','2.2.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1746,'2015','2.2.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1747,'2015','2.2.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1748,'2015','2.2.2.3.3.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1749,'2015','2.2.2.3.4.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1750,'2015','2.2.2.3.5.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1751,'2015','2.2.2.4.0.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1752,'2015','2.2.2.4.1.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1753,'2015','2.2.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1754,'2015','2.2.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1755,'2015','2.2.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1756,'2015','2.2.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1757,'2015','2.2.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1758,'2015','2.2.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1759,'2015','2.2.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1760,'2015','2.2.2.5.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1761,'2015','2.2.2.5.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1762,'2015','2.2.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1763,'2015','2.2.2.5.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1764,'2015','2.2.2.5.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1765,'2015','2.2.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1766,'2015','2.2.2.5.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1767,'2015','2.2.2.5.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1768,'2015','2.2.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1769,'2015','2.2.2.5.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1770,'2015','2.2.2.5.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1771,'2015','2.2.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1772,'2015','2.2.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1773,'2015','2.2.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1774,'2015','2.2.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1775,'2015','2.2.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – EXTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1776,'2015','2.2.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1777,'2015','2.2.2.6.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1778,'2015','2.2.2.6.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1779,'2015','2.2.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1780,'2015','2.2.2.6.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1781,'2015','2.2.2.6.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1782,'2015','2.2.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1783,'2015','2.2.2.6.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1784,'2015','2.2.2.6.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1785,'2015','2.2.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1786,'2015','2.2.2.6.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1787,'2015','2.2.2.6.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1788,'2015','2.2.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1789,'2015','2.2.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1790,'2015','2.2.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1791,'2015','2.2.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1792,'2015','2.2.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1793,'2015','2.2.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1794,'2015','2.2.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS – MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1795,'2015','2.2.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1796,'2015','2.2.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – EXTERNO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1797,'2015','2.2.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1798,'2015','2.2.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1799,'2015','2.2.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1800,'2015','2.2.3.1.0.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1801,'2015','2.2.3.1.1.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1802,'2015','2.2.3.1.1.01.00','FORNECEDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1803,'2015','2.2.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1804,'2015','2.2.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1805,'2015','2.2.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1806,'2015','2.2.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1807,'2015','2.2.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1808,'2015','2.2.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO  - A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1809,'2015','2.2.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO - ANTES DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1810,'2015','2.2.3.1.1.02.03','PRECATORIOS DE FORNECEDORES NACIONAIS  - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1811,'2015','2.2.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1812,'2015','2.2.3.1.1.03.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1813,'2015','2.2.3.1.1.03.01','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1814,'2015','2.2.3.1.1.03.02','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1815,'2015','2.2.3.1.1.03.03','PRECATORIOS DE CONTAS A PAGAR NACIONAIS  - REGIME ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1816,'2015','2.2.3.1.1.03.04','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1817,'2015','2.2.3.2.0.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1818,'2015','2.2.3.2.1.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1819,'2015','2.2.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1820,'2015','2.2.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1821,'2015','2.2.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1822,'2015','2.2.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1823,'2015','2.2.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1824,'2015','2.2.4.0.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1825,'2015','2.2.4.1.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1826,'2015','2.2.4.1.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1827,'2015','2.2.4.1.1.01.00','PASSIVO FISCAL DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1828,'2015','2.2.4.1.1.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1829,'2015','2.2.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1830,'2015','2.2.4.1.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1831,'2015','2.2.4.1.2.01.00','PASSIVO FISCAL DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1832,'2015','2.2.4.1.2.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1833,'2015','2.2.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1834,'2015','2.2.4.1.3.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1835,'2015','2.2.4.1.3.01.00','PASSIVO FISCAL DIFERIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1836,'2015','2.2.4.1.3.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1837,'2015','2.2.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1838,'2015','2.2.4.2.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1839,'2015','2.2.4.2.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1840,'2015','2.2.4.2.1.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1841,'2015','2.2.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1842,'2015','2.2.4.2.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1843,'2015','2.2.4.2.2.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1844,'2015','2.2.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1845,'2015','2.2.4.2.4.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1846,'2015','2.2.4.2.4.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1847,'2015','2.2.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1848,'2015','2.2.4.3.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1849,'2015','2.2.4.3.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1850,'2015','2.2.4.3.1.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1851,'2015','2.2.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1852,'2015','2.2.4.3.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1853,'2015','2.2.4.3.2.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1854,'2015','2.2.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1855,'2015','2.2.4.3.5.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1856,'2015','2.2.4.3.5.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1857,'2015','2.2.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1858,'2015','2.2.7.0.0.00.00','PROVISÕES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1859,'2015','2.2.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1860,'2015','2.2.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1861,'2015','2.2.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1862,'2015','2.2.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1863,'2015','2.2.7.2.0.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1864,'2015','2.2.7.2.1.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1865,'2015','2.2.7.2.1.01.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1866,'2015','2.2.7.2.1.01.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1867,'2015','2.2.7.2.1.01.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1868,'2015','2.2.7.2.1.01.03','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1869,'2015','2.2.7.2.1.01.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1870,'2015','2.2.7.2.1.01.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1871,'2015','2.2.7.2.1.01.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1872,'2015','2.2.7.2.1.01.07','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1873,'2015','2.2.7.2.1.02.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1874,'2015','2.2.7.2.1.02.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1875,'2015','2.2.7.2.1.02.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1876,'2015','2.2.7.2.1.02.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1877,'2015','2.2.7.2.1.02.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1878,'2015','2.2.7.2.1.02.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1879,'2015','2.2.7.2.1.02.06','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1880,'2015','2.2.7.2.1.03.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1881,'2015','2.2.7.2.1.03.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1882,'2015','2.2.7.2.1.03.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1883,'2015','2.2.7.2.1.03.03','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1884,'2015','2.2.7.2.1.03.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1885,'2015','2.2.7.2.1.03.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1886,'2015','2.2.7.2.1.03.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS DO PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1887,'2015','2.2.7.2.1.04.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1888,'2015','2.2.7.2.1.04.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1889,'2015','2.2.7.2.1.04.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1890,'2015','2.2.7.2.1.04.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1891,'2015','2.2.7.2.1.04.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1892,'2015','2.2.7.2.1.04.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1893,'2015','2.2.7.2.1.05.00','PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1894,'2015','2.2.7.2.1.05.98','(-) OUTROS CRÉDITOS DO PLANO DE AMORTIZAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1895,'2015','2.2.7.2.1.06.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1896,'2015','2.2.7.2.1.06.01','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1897,'2015','2.2.7.2.1.07.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1898,'2015','2.2.7.2.1.07.01','AJUSTE DE RESULTADO ATUARIAL SUPERAVITÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1899,'2015','2.2.7.2.1.07.02','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1900,'2015','2.2.7.2.1.07.03','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1901,'2015','2.2.7.2.1.07.04','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1902,'2015','2.2.7.2.1.07.98','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1903,'2015','2.2.7.3.0.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1904,'2015','2.2.7.3.1.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1905,'2015','2.2.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1906,'2015','2.2.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1907,'2015','2.2.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1908,'2015','2.2.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1909,'2015','2.2.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1910,'2015','2.2.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1911,'2015','2.2.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1912,'2015','2.2.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1913,'2015','2.2.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1914,'2015','2.2.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1915,'2015','2.2.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1916,'2015','2.2.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1917,'2015','2.2.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1918,'2015','2.2.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1919,'2015','2.2.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1920,'2015','2.2.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1921,'2015','2.2.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1922,'2015','2.2.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1923,'2015','2.2.7.9.0.00.00','OUTRAS PROVISÕES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1924,'2015','2.2.7.9.1.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1925,'2015','2.2.7.9.1.01.00','PROVISÃO PARA GARANTIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1926,'2015','2.2.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1927,'2015','2.2.7.9.1.03.00','PROVISÕES DO FCVS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1928,'2015','2.2.7.9.1.03.01','PROVISÕES DO FCVS - RISCOS EXPIRADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1929,'2015','2.2.7.9.1.03.02','PROVISÕES DO FCVS - RISCOS NÃO EXPIRADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1930,'2015','2.2.7.9.1.99.00','OUTRAS PROVISÕES A LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1931,'2015','2.2.8.0.0.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1932,'2015','2.2.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1933,'2015','2.2.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1934,'2015','2.2.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1935,'2015','2.2.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1936,'2015','2.2.8.3.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1937,'2015','2.2.8.3.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1938,'2015','2.2.8.4.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1939,'2015','2.2.8.4.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1940,'2015','2.2.8.8.0.00.00','VALORES RESTITUÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1941,'2015','2.2.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1942,'2015','2.2.8.8.1.01.00','CONSIGNACOES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1943,'2015','2.2.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1944,'2015','2.2.8.8.1.01.02','INSS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1945,'2015','2.2.8.8.1.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1946,'2015','2.2.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1947,'2015','2.2.8.8.1.01.05','INDENIZAÇÕES E RESTITUICOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1948,'2015','2.2.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1949,'2015','2.2.8.8.1.01.07','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1950,'2015','2.2.8.8.1.01.08','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1951,'2015','2.2.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1952,'2015','2.2.8.8.1.01.10','PENSAO ALIMENTICIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1953,'2015','2.2.8.8.1.01.11','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1954,'2015','2.2.8.8.1.01.12','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1955,'2015','2.2.8.8.1.01.13','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1956,'2015','2.2.8.8.1.01.14','RETENCOES - PLANOS DE SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1957,'2015','2.2.8.8.1.01.15','RETENCOES - EMPRÉSTIMOS E FINANCIAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1958,'2015','2.2.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1959,'2015','2.2.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1960,'2015','2.2.8.8.1.01.99','OUTROS CONSIGNATARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1961,'2015','2.2.8.8.1.02.00','GARANTIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1962,'2015','2.2.8.8.1.03.00','DEPOSITOS JUDICIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1963,'2015','2.2.8.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1964,'2015','2.2.8.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1965,'2015','2.2.8.8.1.04.00','DEPOSITOS NAO JUDICIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1966,'2015','2.2.8.8.1.04.01','DEPOSITOS E CAUCOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1967,'2015','2.2.8.8.1.04.02','DEPOSITOS ESPECIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1968,'2015','2.2.8.8.1.04.03','DEPOSITOS DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1969,'2015','2.2.8.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1970,'2015','2.2.8.8.1.04.05','DEPOSITOS A TRANSFERIR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1971,'2015','2.2.8.8.1.04.99','OUTROS DEPOSITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1972,'2015','2.2.8.8.1.99.00','OUTROS VALORES RESTITUIVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1973,'2015','2.2.8.9.0.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1974,'2015','2.2.8.9.1.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1975,'2015','2.2.9.0.0.00.00','RESULTADO DIFERIDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1976,'2015','2.2.9.1.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1977,'2015','2.2.9.1.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1978,'2015','2.2.9.2.0.00.00','(-) CUSTO DIFERIDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1979,'2015','2.2.9.2.1.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1980,'2015','2.3.0.0.0.00.00','PATRIMÔNIO LIQUIDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1981,'2015','2.3.1.0.0.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1982,'2015','2.3.1.1.0.00.00','PATRIMÔNIO SOCIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1983,'2015','2.3.1.1.1.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1984,'2015','2.3.1.2.0.00.00','CAPITAL SOCIAL REALIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1985,'2015','2.3.1.2.1.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1986,'2015','2.3.1.2.2.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1987,'2015','2.3.1.2.3.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1988,'2015','2.3.1.2.4.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1989,'2015','2.3.1.2.5.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1990,'2015','2.3.2.0.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1991,'2015','2.3.2.0.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1992,'2015','2.3.2.0.2.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1993,'2015','2.3.2.0.3.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1994,'2015','2.3.2.0.4.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1995,'2015','2.3.2.0.5.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS – MUNICÍPIO.','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1996,'2015','2.3.3.0.0.00.00','RESERVAS DE CAPITAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1997,'2015','2.3.3.1.0.00.00','ÁGIO NA EMISSÃO DE AÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1998,'2015','2.3.3.1.1.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (1999,'2015','2.3.3.1.2.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2000,'2015','2.3.3.1.3.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2001,'2015','2.3.3.1.4.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2002,'2015','2.3.3.1.5.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2003,'2015','2.3.3.2.0.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2004,'2015','2.3.3.2.1.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2005,'2015','2.3.3.2.2.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2006,'2015','2.3.3.2.3.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2007,'2015','2.3.3.2.4.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2008,'2015','2.3.3.2.5.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2009,'2015','2.3.3.3.0.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2010,'2015','2.3.3.3.1.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2011,'2015','2.3.3.3.2.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2012,'2015','2.3.3.3.3.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2013,'2015','2.3.3.3.4.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2014,'2015','2.3.3.3.5.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2015,'2015','2.3.3.4.0.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2016,'2015','2.3.3.4.1.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2017,'2015','2.3.3.4.2.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2018,'2015','2.3.3.4.3.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2019,'2015','2.3.3.4.4.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2020,'2015','2.3.3.4.5.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2021,'2015','2.3.3.9.0.00.00','OUTRAS RESERVAS DE CAPITAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2022,'2015','2.3.3.9.1.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2023,'2015','2.3.3.9.1.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2024,'2015','2.3.3.9.1.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2025,'2015','2.3.3.9.1.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2026,'2015','2.3.3.9.1.99.00','DEMAIS RESERVAS DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2027,'2015','2.3.3.9.2.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2028,'2015','2.3.3.9.2.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2029,'2015','2.3.3.9.2.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2030,'2015','2.3.3.9.2.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2031,'2015','2.3.3.9.2.99.00','DEMAIS RESERVAS DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2032,'2015','2.3.3.9.3.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2033,'2015','2.3.3.9.4.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2034,'2015','2.3.3.9.5.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2035,'2015','2.3.4.0.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2036,'2015','2.3.4.1.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2037,'2015','2.3.4.1.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2038,'2015','2.3.4.2.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2039,'2015','2.3.4.2.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2040,'2015','2.3.5.0.0.00.00','RESERVAS DE LUCROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2041,'2015','2.3.5.1.0.00.00','RESERVA LEGAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2042,'2015','2.3.5.1.1.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2043,'2015','2.3.5.1.2.00.00','RESERVA LEGAL- INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2044,'2015','2.3.5.1.3.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2045,'2015','2.3.5.1.4.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2046,'2015','2.3.5.1.5.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2047,'2015','2.3.5.2.0.00.00','RESERVAS ESTATUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2048,'2015','2.3.5.2.1.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2049,'2015','2.3.5.2.2.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2050,'2015','2.3.5.2.3.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2051,'2015','2.3.5.2.4.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2052,'2015','2.3.5.2.5.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2053,'2015','2.3.5.3.0.00.00','RESERVA PARA CONTINGENCIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2054,'2015','2.3.5.3.1.00.00','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2055,'2015','2.3.5.3.2.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2056,'2015','2.3.5.3.3.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2057,'2015','2.3.5.3.4.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2058,'2015','2.3.5.3.5.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2059,'2015','2.3.5.4.0.00.00','RESERVA DE INCENTIVOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2060,'2015','2.3.5.4.1.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2061,'2015','2.3.5.4.2.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2062,'2015','2.3.5.4.3.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2063,'2015','2.3.5.4.4.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2064,'2015','2.3.5.4.5.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2065,'2015','2.3.5.5.0.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2066,'2015','2.3.5.5.1.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2067,'2015','2.3.5.5.2.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2068,'2015','2.3.5.5.3.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2069,'2015','2.3.5.5.4.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS –ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2070,'2015','2.3.5.5.5.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2071,'2015','2.3.5.6.0.00.00','RESERVA DE LUCROS A REALIZAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2072,'2015','2.3.5.6.1.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2073,'2015','2.3.5.6.2.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2074,'2015','2.3.5.6.3.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2075,'2015','2.3.5.6.4.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2076,'2015','2.3.5.6.5.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2077,'2015','2.3.5.7.0.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2078,'2015','2.3.5.7.1.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2079,'2015','2.3.5.7.2.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2080,'2015','2.3.5.7.3.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2081,'2015','2.3.5.7.4.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2082,'2015','2.3.5.7.5.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2083,'2015','2.3.5.8.0.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2084,'2015','2.3.5.8.1.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2085,'2015','2.3.5.8.2.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2086,'2015','2.3.5.8.3.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2087,'2015','2.3.5.8.4.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2088,'2015','2.3.5.8.5.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2089,'2015','2.3.5.9.0.00.00','OUTRAS RESERVAS DE LUCRO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2090,'2015','2.3.5.9.1.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2091,'2015','2.3.5.9.2.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2092,'2015','2.3.5.9.3.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2093,'2015','2.3.5.9.4.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2094,'2015','2.3.5.9.5.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2095,'2015','2.3.6.0.0.00.00','DEMAIS RESERVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2096,'2015','2.3.6.1.0.00.00','RESERVA DE REAVALIAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2097,'2015','2.3.6.1.1.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2098,'2015','2.3.6.1.2.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2099,'2015','2.3.6.1.3.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2100,'2015','2.3.6.1.4.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2101,'2015','2.3.6.1.5.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2102,'2015','2.3.6.9.0.00.00','OUTRAS RESERVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2103,'2015','2.3.6.9.1.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2104,'2015','2.3.6.9.2.00.00','OUTRAS RESERVAS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2105,'2015','2.3.6.9.3.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2106,'2015','2.3.6.9.4.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2107,'2015','2.3.6.9.5.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2108,'2015','2.3.7.0.0.00.00','RESULTADOS ACUMULADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2109,'2015','2.3.7.1.0.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2110,'2015','2.3.7.1.1.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2111,'2015','2.3.7.1.1.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2112,'2015','2.3.7.1.1.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2113,'2015','2.3.7.1.1.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2114,'2015','2.3.7.1.1.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2115,'2015','2.3.7.1.2.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2116,'2015','2.3.7.1.2.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2117,'2015','2.3.7.1.2.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2118,'2015','2.3.7.1.2.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2119,'2015','2.3.7.1.2.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2120,'2015','2.3.7.1.3.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2121,'2015','2.3.7.1.3.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2122,'2015','2.3.7.1.3.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2123,'2015','2.3.7.1.3.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2124,'2015','2.3.7.1.3.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2125,'2015','2.3.7.1.4.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2126,'2015','2.3.7.1.4.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2127,'2015','2.3.7.1.4.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2128,'2015','2.3.7.1.4.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2129,'2015','2.3.7.1.4.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2130,'2015','2.3.7.1.5.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2131,'2015','2.3.7.1.5.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2132,'2015','2.3.7.1.5.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2133,'2015','2.3.7.1.5.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2134,'2015','2.3.7.1.5.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2135,'2015','2.3.7.2.0.00.00','LUCROS E PREJUÍZOS ACUMULADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2136,'2015','2.3.7.2.1.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2137,'2015','2.3.7.2.1.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2138,'2015','2.3.7.2.1.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2139,'2015','2.3.7.2.1.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2140,'2015','2.3.7.2.1.04.00','LUCROS A DESTINAR DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2141,'2015','2.3.7.2.1.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2142,'2015','2.3.7.2.1.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2143,'2015','2.3.7.2.2.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2144,'2015','2.3.7.2.2.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2145,'2015','2.3.7.2.2.02.00','LUCROS EPREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2146,'2015','2.3.7.2.2.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2147,'2015','2.3.7.2.2.04.00','LUCROS A DESTINAR DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2148,'2015','2.3.7.2.2.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2149,'2015','2.3.7.2.2.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2150,'2015','2.3.7.2.3.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2151,'2015','2.3.7.2.3.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2152,'2015','2.3.7.2.3.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2153,'2015','2.3.7.2.3.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2154,'2015','2.3.7.2.3.04.00','LUCROS A DESTINAR DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2155,'2015','2.3.7.2.3.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2156,'2015','2.3.7.2.3.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2157,'2015','2.3.7.2.4.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2158,'2015','2.3.7.2.4.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2159,'2015','2.3.7.2.4.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2160,'2015','2.3.7.2.4.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2161,'2015','2.3.7.2.4.04.00','LUCROS A DESTINAR DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2162,'2015','2.3.7.2.4.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2163,'2015','2.3.7.2.4.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2164,'2015','2.3.7.2.5.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2165,'2015','2.3.7.2.5.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2166,'2015','2.3.7.2.5.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2167,'2015','2.3.7.2.5.03.00','AJUSTES DE EXERCICIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2168,'2015','2.3.7.2.5.04.00','LUCROS A DESTINAR DO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2169,'2015','2.3.7.2.5.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2170,'2015','2.3.7.2.5.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2171,'2015','2.3.9.0.0.00.00','(-) AÇÕES/COTAS EM TESOURARIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2172,'2015','2.3.9.1.0.00.00','(-) AÇÕES EM TESOURARIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2173,'2015','2.3.9.1.1.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2174,'2015','2.3.9.1.2.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2175,'2015','2.3.9.1.3.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2176,'2015','2.3.9.1.4.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2177,'2015','2.3.9.1.5.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS – MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2178,'2015','2.3.9.2.0.00.00','(-) COTAS EM TESOURARIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2179,'2015','2.3.9.2.1.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2180,'2015','2.3.9.2.2.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2181,'2015','2.3.9.2.3.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2182,'2015','2.3.9.2.4.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2183,'2015','2.3.9.2.5.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2184,'2015','3.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2185,'2015','3.1.0.0.0.00.00','PESSOAL E ENCARGOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2186,'2015','3.1.1.0.0.00.00','REMUNERAÇÃO A PESSOAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2187,'2015','3.1.1.1.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2188,'2015','3.1.1.1.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2189,'2015','3.1.1.1.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2190,'2015','3.1.1.1.1.01.01','VENCIMENTOS E SALÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2191,'2015','3.1.1.1.1.01.02','ADICIONAL NOTURNO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2192,'2015','3.1.1.1.1.01.03','INCORPORAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2193,'2015','3.1.1.1.1.01.04','ABONO DE PERMANÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2194,'2015','3.1.1.1.1.01.05','ADICIONAL DE PERICULOSIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2195,'2015','3.1.1.1.1.01.06','ADICIONAL DE INSALUBRIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2196,'2015','3.1.1.1.1.01.07','ADICIONAL DE ATIVIDADES PENOSAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2197,'2015','3.1.1.1.1.01.08','INCENTIVO Á QUALIFICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2198,'2015','3.1.1.1.1.01.09','REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2199,'2015','3.1.1.1.1.01.10','RETRIBUIÇÃO ADICIONAL VARIÁVEL E PRÓ-LABORE (LEI 7711/88)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2200,'2015','3.1.1.1.1.01.12','VANTAGEM PECUNIÁRIA INDIVIDUAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2201,'2015','3.1.1.1.1.01.13','ABONO PROVISÓRIO – PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2202,'2015','3.1.1.1.1.01.14','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2203,'2015','3.1.1.1.1.01.15','INCREMENTO PLANO DE CARGOS E SALÁRIOS DO PODER JUDICIÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2204,'2015','3.1.1.1.1.01.16','GRATIFICAÇÃO POR EXERCÍCIO DE FUNÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2205,'2015','3.1.1.1.1.01.17','INDENIZAÇÃO E LOCAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2206,'2015','3.1.1.1.1.01.18','GRATIFICAÇÃO DE TEMPO DE SERVIÇO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2207,'2015','3.1.1.1.1.01.19','GRATIFICAÇÕES ESPECIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2208,'2015','3.1.1.1.1.01.20','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2209,'2015','3.1.1.1.1.01.21','FÉRIAS VENCIDAS E PROPORCIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2210,'2015','3.1.1.1.1.01.22','13. SALÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2211,'2015','3.1.1.1.1.01.23','FÉRIAS – ABONO PECUNIÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2212,'2015','3.1.1.1.1.01.24','FÉRIAS – ABONO CONSTITUCIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2213,'2015','3.1.1.1.1.01.25','LICENÇA-PRÊMIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2214,'2015','3.1.1.1.1.01.26','LICENÇA CAPACITAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2215,'2015','3.1.1.1.1.01.27','ADIANTAMENTO PECUNIÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2216,'2015','3.1.1.1.1.01.28','REPRESENTAÇÃO MENSAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2217,'2015','3.1.1.1.1.01.29','COMPLEMENTAÇÃO SALARIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2218,'2015','3.1.1.1.1.01.30','ADICIONAL – TETO PARLAMENTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2219,'2015','3.1.1.1.1.01.31','SUBSÍDIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2220,'2015','3.1.1.1.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2221,'2015','3.1.1.1.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2222,'2015','3.1.1.1.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2223,'2015','3.1.1.1.1.01.36','REMUN. PARTICIP. ÓRGÃOS DELIBERAÇÃO COLETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2224,'2015','3.1.1.1.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS – PESSOAL CIVIL RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2225,'2015','3.1.1.1.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2226,'2015','3.1.1.1.1.02.01','SUBSTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2227,'2015','3.1.1.1.1.02.02','ADICIONAL VARIÁVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2228,'2015','3.1.1.1.1.02.03','SERVIÇOS EXTRAORDINÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2229,'2015','3.1.1.1.1.02.04','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2230,'2015','3.1.1.1.1.02.05','GRATIFICAÇÃO ELEITORAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2231,'2015','3.1.1.1.1.02.06','LICENÇA SEM REMUNERAÇÃO INCENTIVADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2232,'2015','3.1.1.1.1.02.07','ADICIONAL POR PLANTÃO HOSPITALAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2233,'2015','3.1.1.1.1.02.08','CONVOCACAO EXTRAORDINARIA LEGISLATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2234,'2015','3.1.1.1.1.02.09','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2235,'2015','3.1.1.1.1.02.10','AUXILIO MORADIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2236,'2015','3.1.1.1.1.02.11','INDENIZAÇÕES  E RESTITUIÇÕES TRABALHISTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2237,'2015','3.1.1.1.1.02.12','INDENIZ. E RESTIT. DECORR. DE PLANOS DE DEMISSÃO VOLUNTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2238,'2015','3.1.1.1.1.02.13','RESSARCIMENTO DE DESP. DE PESSOAL REQUISITADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2239,'2015','3.1.1.1.1.02.99','OUTROS VENCIMENTOS E VANTAGENS VARIÁVEIS – PESSOAL CIVIL RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2240,'2015','3.1.1.1.1.03.00','SENTENCAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2241,'2015','3.1.1.2.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2242,'2015','3.1.1.2.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2243,'2015','3.1.1.2.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2244,'2015','3.1.1.2.1.01.01','VENCIMENTOS E SALARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2245,'2015','3.1.1.2.1.01.02','ADICIONAL NOTURNO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2246,'2015','3.1.1.2.1.01.03','INCORPORACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2247,'2015','3.1.1.2.1.01.04','ABONO DE PERMANENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2248,'2015','3.1.1.2.1.01.05','ADICIONAL DE PERICULOSIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2249,'2015','3.1.1.2.1.01.06','ADICIONAL DE INSALUBRIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2250,'2015','3.1.1.2.1.01.07','REMUNERACAO PARTICIPANTES DE ORGAO DE DELIBERACAO COLETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2251,'2015','3.1.1.2.1.01.08','INCENTIVO A QUALIFICACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2252,'2015','3.1.1.2.1.01.09','ADICIONAL DE TRANSFERÊNCIA - ART. 469/CLT','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2253,'2015','3.1.1.2.1.01.10','RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2254,'2015','3.1.1.2.1.01.11','REMUNERACAO DE DIRETORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2255,'2015','3.1.1.2.1.01.12','VANTAGEM PECUNIARIA INDIVIDUAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2256,'2015','3.1.1.2.1.01.13','ABONO PROVISORIO - PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2257,'2015','3.1.1.2.1.01.14','GRATIFICACAO POR EXERCICIO DE CARGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2258,'2015','3.1.1.2.1.01.15','INDENIZACAO A ANISTIADO POLITICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2259,'2015','3.1.1.2.1.01.16','GRATIFICACAO POR EXERCICIO DE FUNCOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2260,'2015','3.1.1.2.1.01.17','INDENIZACAO DE LOCALIZACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2261,'2015','3.1.1.2.1.01.18','GRATIFICACAO DE TEMPO DE  SERVICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2262,'2015','3.1.1.2.1.01.19','GRATIFICACOES ESPECIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2263,'2015','3.1.1.2.1.01.20','GRATIFICACAO POR ATIVIDADES EXPOSTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2264,'2015','3.1.1.2.1.01.21','FERIAS VENCIDAS E PROPORCIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2265,'2015','3.1.1.2.1.01.22','13. SALARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2266,'2015','3.1.1.2.1.01.23','FERIAS - ABONO PECUNIARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2267,'2015','3.1.1.2.1.01.24','FERIAS - ABONO CONSTITUCIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2268,'2015','3.1.1.2.1.01.25','LICENCA-PREMIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2269,'2015','3.1.1.2.1.01.26','LICENCA CAPACITACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2270,'2015','3.1.1.2.1.01.27','ADIANTAMENTO  PECUNIARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2271,'2015','3.1.1.2.1.01.28','REPRESENTACAO MENSAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2272,'2015','3.1.1.2.1.01.29','COMPLEMENTACAO SALARIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2273,'2015','3.1.1.2.1.01.30','ADICIONAL – TETO PARLAMENTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2274,'2015','3.1.1.2.1.01.31','SUBSÍDIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2275,'2015','3.1.1.2.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2276,'2015','3.1.1.2.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2277,'2015','3.1.1.2.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2278,'2015','3.1.1.2.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2279,'2015','3.1.1.2.1.02.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2280,'2015','3.1.1.2.1.02.01','SUBSTITUICOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2281,'2015','3.1.1.2.1.02.02','ADICIONAL VARIAVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2282,'2015','3.1.1.2.1.02.03','SERVICOS EXTRAORDINARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2283,'2015','3.1.1.2.1.02.04','GRATIFICACAO POR EMBARQUE FLUVIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2284,'2015','3.1.1.2.1.02.05','AVISO PREVIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2285,'2015','3.1.1.2.1.02.06','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2286,'2015','3.1.1.2.1.02.07','GRATIFICACAO ELEITORAL (RGPS)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2287,'2015','3.1.1.2.1.02.08','LICENCA SEM REMUNERACAO INCENTIVADA (RGPS)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2288,'2015','3.1.1.2.1.02.09','CONVOCACAO EXTRAORDINARIA LEGISLATIVA (RGPS)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2289,'2015','3.1.1.2.1.02.10','AUXILIO MORADIA (RGPS)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2290,'2015','3.1.1.2.1.02.99','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2291,'2015','3.1.1.2.1.03.00','SENTENCAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2292,'2015','3.1.1.2.1.04.00','CONTRATACAO POR TEMPO DETERMINADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2293,'2015','3.1.1.2.1.04.01','SALARIO CONTRATO TEMPORARIO - LEI 8.745/93','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2294,'2015','3.1.1.2.1.04.02','ADICIONAL NOTURNO DE CONTRATO TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2295,'2015','3.1.1.2.1.04.03','ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2296,'2015','3.1.1.2.1.04.04','ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2297,'2015','3.1.1.2.1.04.05','ADICIONAL DE ATIVIDADES PENOSAS - CONTR. TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2298,'2015','3.1.1.2.1.04.06','SERVICOS EVENTUAIS DE MEDICOS RESIDENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2299,'2015','3.1.1.2.1.04.07','RESIDENCIA MULTIPROFISSIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2300,'2015','3.1.1.2.1.04.08','ADICIONAL DE IRRADIACAO IONIZANTE CONT. TEMP.','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2301,'2015','3.1.1.2.1.04.09','GRATIFICACAO DE RAIO-X CONTRATO TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2302,'2015','3.1.1.2.1.04.10','SERVICOS EXTRAORDINARIOS CONTRATO TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2303,'2015','3.1.1.2.1.04.11','SERVICOS EXTRAORDINARIOS NOTURNO CONT. TEMP.','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2304,'2015','3.1.1.2.1.04.12','FERIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2305,'2015','3.1.1.2.1.04.13','13º SALARIO CONTRATO TEMPORARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2306,'2015','3.1.1.2.1.04.14','FERIAS - ABONO CONSTITUCIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2307,'2015','3.1.1.2.1.04.15','FERIAS - PAGAMENTO ANTECIPADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2308,'2015','3.1.1.2.1.04.16','SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXT','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2309,'2015','3.1.1.2.1.04.17','SERVICOS EVENTUAIS DE PROFESSORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2310,'2015','3.1.1.2.1.04.18','SERVICOS EVENTUAIS DE ASSISTENCIA SOCIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2311,'2015','3.1.1.2.1.04.19','SERV EVENT ENFERMAG FISIOT TERAPIA OCUPAC','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2312,'2015','3.1.1.2.1.04.20','SERVICOS EVENTUAIS DE NATUREZA INDUSTRIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2313,'2015','3.1.1.2.1.04.21','SERVICOS EVENTUAIS DE AGENTES DE SAUDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2314,'2015','3.1.1.2.1.04.22','SERVICOS EVENTUAIS DE DENTISTAS E PSICOLOGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2315,'2015','3.1.1.2.1.04.23','SERVICOS EVENTUAIS DE MAO-DE-OBRA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2316,'2015','3.1.1.2.1.04.24','SERVIÇOS TEMPORÁRIOS DE AGENTES PRISIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2317,'2015','3.1.1.2.1.04.25','OBRIGACOES PATRONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2318,'2015','3.1.1.2.1.04.26','INSS PATRONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2319,'2015','3.1.1.2.1.04.27','FGTS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2320,'2015','3.1.1.2.1.04.99','OUTRAS CONTRATACOES POR TEMPO DETERMINADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2321,'2015','3.1.1.3.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR – ABRANGIDOS PELO  RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2322,'2015','3.1.1.3.1.00.00','REMUNERAÇÃO A PESSOAL  ATIVO MILITAR – ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2323,'2015','3.1.1.3.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2324,'2015','3.1.1.3.1.01.01','SOLDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2325,'2015','3.1.1.3.1.01.02','ADICIONAL DE PERMANENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2326,'2015','3.1.1.3.1.01.03','ADICIONAL DE TEMPO DE SERVICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2327,'2015','3.1.1.3.1.01.04','ADICIONAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2328,'2015','3.1.1.3.1.01.05','ADICIONAL DE COMPENSACAO ORGANICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2329,'2015','3.1.1.3.1.01.06','ADICIONAL DE HABITACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2330,'2015','3.1.1.3.1.01.07','GRATIFICACAO DE LOCALIDADE ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2331,'2015','3.1.1.3.1.01.08','GRATIFICACAO DE REPRESENTACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2332,'2015','3.1.1.3.1.01.09','GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2333,'2015','3.1.1.3.1.01.10','GRATIFICACAO DE SERVICO VOLUNTARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2334,'2015','3.1.1.3.1.01.11','VANTAGEM PECUNIARIA ESPECIAL - VPE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2335,'2015','3.1.1.3.1.01.12','INDENIZACAO DE REPRESENTACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2336,'2015','3.1.1.3.1.01.13','GRATIFICACAO DE EXERCICIOS DE CARGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2337,'2015','3.1.1.3.1.01.14','FERIAS VENCIDAS E PROPORCIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2338,'2015','3.1.1.3.1.01.15','ADICIONAL NATALINO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2339,'2015','3.1.1.3.1.01.16','FERIAS - ABONO CONSTITUCIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2340,'2015','3.1.1.3.1.01.17','COMPLEMENTACAO SALARIAL - PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2341,'2015','3.1.1.3.1.01.99','OUTRAS VPD FIXAS - PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2342,'2015','3.1.1.3.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2343,'2015','3.1.1.3.1.02.01','INDENIZACOES/MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2344,'2015','3.1.1.3.1.02.02','ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2345,'2015','3.1.1.3.1.02.03','ADICIONAL NOTURNO - MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2346,'2015','3.1.1.3.1.02.04','HORA-EXTRA, HORAS DE SOBREAVISO E PLANTÃO - MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2347,'2015','3.1.1.3.1.03.00','SENTENCAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2348,'2015','3.1.2.0.0.00.00','ENCARGOS PATRONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2349,'2015','3.1.2.1.0.00.00','ENCARGOS PATRONAIS - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2350,'2015','3.1.2.1.2.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2351,'2015','3.1.2.1.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2352,'2015','3.1.2.1.2.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2353,'2015','3.1.2.1.2.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2354,'2015','3.1.2.2.0.00.00','ENCARGOS PATRONAIS - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2355,'2015','3.1.2.2.1.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2356,'2015','3.1.2.2.1.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2357,'2015','3.1.2.2.1.03.00','SEGURO DE ACIDENTE NO TRABALHO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2358,'2015','3.1.2.2.1.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2359,'2015','3.1.2.2.1.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2360,'2015','3.1.2.2.1.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2361,'2015','3.1.2.2.1.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2362,'2015','3.1.2.2.2.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2363,'2015','3.1.2.2.3.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2364,'2015','3.1.2.2.3.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2365,'2015','3.1.2.2.3.03.00','SEGURO DE ACIDENTE NO TRABALHO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2366,'2015','3.1.2.2.3.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2367,'2015','3.1.2.2.3.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2368,'2015','3.1.2.2.3.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2369,'2015','3.1.2.2.3.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2370,'2015','3.1.2.2.4.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2371,'2015','3.1.2.2.5.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2372,'2015','3.1.2.3.0.00.00','ENCARGOS PATRONAIS - FGTS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2373,'2015','3.1.2.3.1.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2374,'2015','3.1.2.3.1.01.00','FGTS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2375,'2015','3.1.2.3.1.02.00','FGTS - PDV','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2376,'2015','3.1.2.3.1.03.00','FGTS - PRORROGAÇÃO SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2377,'2015','3.1.2.4.0.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2378,'2015','3.1.2.4.1.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2379,'2015','3.1.2.4.1.01.00','SISTEMAS SOCIAIS AUTÔNOMOS -  ATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2380,'2015','3.1.2.4.1.02.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2381,'2015','3.1.2.4.1.03.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO REFERENTE A PRORROGAÇÃO DE SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2382,'2015','3.1.2.4.1.99.00','OUTRAS CONSTRIBUIÇÕES SOCIAIS GERAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2383,'2015','3.1.2.5.0.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2384,'2015','3.1.2.5.1.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2385,'2015','3.1.2.5.1.01.00','COMPLEMENTAÇÃO DE PREVIDÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2386,'2015','3.1.2.5.1.02.00','SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2387,'2015','3.1.2.5.1.03.00','CONTRIBUIÇÃO PATRONAL PREVIDÊNCIA PRIVADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2388,'2015','3.1.2.5.1.04.00','COMPLEMENTAÇÃO PREVIDENCIÁRIA REFERENTE A PRORROGAÇÃO SALÁRIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2389,'2015','3.1.2.5.1.99.00','OUTRAS CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2390,'2015','3.1.2.9.0.00.00','OUTROS ENCARGOS PATRONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2391,'2015','3.1.2.9.1.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2392,'2015','3.1.2.9.1.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2393,'2015','3.1.2.9.1.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2394,'2015','3.1.2.9.1.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2395,'2015','3.1.2.9.1.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2396,'2015','3.1.2.9.1.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2397,'2015','3.1.2.9.1.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2398,'2015','3.1.2.9.2.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2399,'2015','3.1.2.9.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2400,'2015','3.1.2.9.2.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2401,'2015','3.1.2.9.2.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2402,'2015','3.1.2.9.2.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2403,'2015','3.1.2.9.2.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2404,'2015','3.1.2.9.2.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2405,'2015','3.1.2.9.3.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2406,'2015','3.1.2.9.4.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2407,'2015','3.1.2.9.4.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2408,'2015','3.1.2.9.4.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2409,'2015','3.1.2.9.4.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2410,'2015','3.1.2.9.4.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2411,'2015','3.1.2.9.4.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2412,'2015','3.1.2.9.4.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2413,'2015','3.1.2.9.5.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2414,'2015','3.1.3.0.0.00.00','BENEFÍCIOS A PESSOAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2415,'2015','3.1.3.1.0.00.00','BENEFÍCIOS A PESSOAL - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2416,'2015','3.1.3.1.1.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2417,'2015','3.1.3.2.0.00.00','BENEFÍCIOS A PESSOAL - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2418,'2015','3.1.3.2.1.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2419,'2015','3.1.3.3.0.00.00','BENEFÍCIOS A PESSOAL - MILITAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2420,'2015','3.1.3.3.1.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2421,'2015','3.1.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2422,'2015','3.1.9.1.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2423,'2015','3.1.9.1.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2424,'2015','3.1.9.2.0.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2425,'2015','3.1.9.2.1.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2426,'2015','3.1.9.9.0.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2427,'2015','3.1.9.9.1.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2428,'2015','3.1.9.9.1.01.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2429,'2015','3.1.9.9.1.02.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - ENCARGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2430,'2015','3.2.0.0.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2431,'2015','3.2.1.0.0.00.00','APOSENTADORIAS E REFORMAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2432,'2015','3.2.1.1.0.00.00','APOSENTADORIAS - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2433,'2015','3.2.1.1.1.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2434,'2015','3.2.1.1.1.01.00','PROVENTOS - PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2435,'2015','3.2.1.1.1.02.00','ABONO PROVISÓRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2436,'2015','3.2.1.1.1.03.00','APOSENTADORIAS PENDENTES DE APROVACAO - PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2437,'2015','3.2.1.1.1.06.00','13º. SALARIO – PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2438,'2015','3.2.1.1.1.07.00','GRATIFICAÇÃO TEMPO DE SERVIÇO - ANUÊNIO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2439,'2015','3.2.1.1.1.10.00','VANTAGENS INCORPORADAS - PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2440,'2015','3.2.1.1.1.11.00','PROVENTOS ORIGINÁRIAS DE GRATIFICAÇÕES POR EXERCÍCIO DE FUNÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2441,'2015','3.2.1.1.1.12.00','PROVENTOS ORIGINÁRIAS DE GRATIFICAÇÕES POR EXERCÍCIO DE CARGO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2442,'2015','3.2.1.1.1.15.00','GRATIFICAÇÕES ESPECIAIS A APOSENTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2443,'2015','3.2.1.1.1.16.00','COMPLEMENTAÇÃO DE APOSENTADORIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2444,'2015','3.2.1.1.1.70.00','SENTENÇAS JUDICIAIS DE BENEFÍCIOS PREVIDENCIÁRIOS PESSOAL CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2445,'2015','3.2.1.1.1.99.00','OUTRAS APOSENTADORIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2446,'2015','3.2.1.2.0.00.00','APOSENTADORIAS - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2447,'2015','3.2.1.2.1.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2448,'2015','3.2.1.3.0.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2449,'2015','3.2.1.3.1.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2450,'2015','3.2.1.3.1.01.00','PROVENTOS - PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2451,'2015','3.2.1.3.1.02.00','GRATIFICAÇÃO TEMPO DE SERVIÇO-ANUÊNIO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2452,'2015','3.2.1.3.1.04.00','AJUDA DE CUSTO (TRANSF. P/RESERVA REM.)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2453,'2015','3.2.1.3.1.05.00','ADICIONAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2454,'2015','3.2.1.3.1.06.00','COMPLEMENTAÇÃO APOSENTADORIA -  PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2455,'2015','3.2.1.3.1.07.00','VANTAGENS INCORPORADAS - PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2456,'2015','3.2.1.3.1.08.00','AUXÍLIO-INVALIDEZ - PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2457,'2015','3.2.1.3.1.09.00','13º. SALARIO PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2458,'2015','3.2.1.3.1.70.00','SENTENÇAS JUDICIAIS DE BENEFÍCIOS PREVIDENCIÁRIOS PESSOAL MILITAR - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2459,'2015','3.2.1.3.1.99.00','OUTRAS REFORMAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2460,'2015','3.2.1.9.0.00.00','OUTRAS APOSENTADORIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2461,'2015','3.2.1.9.1.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2462,'2015','3.2.2.0.0.00.00','PENSÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2463,'2015','3.2.2.1.0.00.00','PENSÕES - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2464,'2015','3.2.2.1.1.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2465,'2015','3.2.2.2.0.00.00','PENSÕES - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2466,'2015','3.2.2.2.1.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2467,'2015','3.2.2.3.0.00.00','PENSÕES - MILITAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2468,'2015','3.2.2.3.1.00.00','PENSÕES - MILITAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2469,'2015','3.2.2.9.0.00.00','OUTRAS PENSÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2470,'2015','3.2.2.9.1.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2471,'2015','3.2.3.0.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2472,'2015','3.2.3.1.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2473,'2015','3.2.3.1.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2474,'2015','3.2.3.1.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2475,'2015','3.2.3.2.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2476,'2015','3.2.3.2.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2477,'2015','3.2.3.2.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2478,'2015','3.2.3.9.0.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2479,'2015','3.2.3.9.1.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2480,'2015','3.2.4.0.0.00.00','BENEFÍCIOS EVENTUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2481,'2015','3.2.4.1.0.00.00','AUXÍLIO POR NATALIDADE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2482,'2015','3.2.4.1.1.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2483,'2015','3.2.4.2.0.00.00','AUXÍLIO POR MORTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2484,'2015','3.2.4.2.1.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2485,'2015','3.2.4.3.0.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2486,'2015','3.2.4.3.1.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2487,'2015','3.2.4.4.0.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2488,'2015','3.2.4.4.1.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2489,'2015','3.2.4.9.0.00.00','OUTROS BENEFÍCIOS EVENTUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2490,'2015','3.2.4.9.1.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2491,'2015','3.2.5.0.0.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2492,'2015','3.2.5.0.1.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2493,'2015','3.2.9.0.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2494,'2015','3.2.9.1.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2495,'2015','3.2.9.1.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2496,'2015','3.2.9.1.1.01.00','AUXILIO FUNERAL ATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2497,'2015','3.2.9.1.1.02.00','AUXILIO FUNERAL INATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2498,'2015','3.2.9.1.1.03.00','AUXILIO NATALIDADE ATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2499,'2015','3.2.9.1.1.04.00','AUXILIO NATALIDADE INATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2500,'2015','3.2.9.1.1.05.00','AUXILIO RECLUSAO ATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2501,'2015','3.2.9.1.1.06.00','AUXILIO RECLUSAO INATIVO CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2502,'2015','3.2.9.1.1.07.00','AUXILIO FUNERAL PENSIONISTA CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2503,'2015','3.2.9.1.1.08.00','AUXILIO RECLUSAO PENSIONISTA CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2504,'2015','3.2.9.1.1.09.00','AUXILIO NATALIDADE PENSIONISTA CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2505,'2015','3.2.9.1.1.10.00','AUXILIO-DOENCA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2506,'2015','3.2.9.1.1.11.00','SALARIO MATERNIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2507,'2015','3.2.9.1.1.12.00','SALARIO-FAMILIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2508,'2015','3.2.9.1.1.12.01','SALARIO FAMILIA - ATIVO PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2509,'2015','3.2.9.1.1.12.02','SALARIO FAMILIA-INATIVO PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2510,'2015','3.2.9.1.1.12.03','SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2511,'2015','3.2.9.2.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2512,'2015','3.2.9.2.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2513,'2015','3.2.9.3.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2514,'2015','3.2.9.3.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2515,'2015','3.2.9.3.1.01.00','AUXILIO FUNERAL ATIVO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2516,'2015','3.2.9.3.1.02.00','AUXILIO FUNERAL INATIVO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2517,'2015','3.2.9.3.1.03.00','AUXILIO NATALIDADE ATIVO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2518,'2015','3.2.9.3.1.04.00','AUXILIO NATALIDADE INATIVO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2519,'2015','3.2.9.3.1.05.00','AUXILIO RECLUSAO ATIVO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2520,'2015','3.2.9.3.1.06.00','AUXILIO RECLUSAO INATIVO MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2521,'2015','3.2.9.3.1.07.00','AUXILIO RECLUSAO PENSIONISTA MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2522,'2015','3.2.9.3.1.08.00','AUXILIO FUNERAL PENSIONISTA MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2523,'2015','3.2.9.3.1.09.00','AUXILIO NATALIDADE PENSIONISTA MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2524,'2015','3.2.9.3.1.10.00','SALARIO-FAMILIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2525,'2015','3.2.9.3.1.10.01','SALARIO FAMILIA-ATIVO PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2526,'2015','3.2.9.3.1.10.02','SALARIO FAMILIA - INATIVO PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2527,'2015','3.2.9.3.1.10.03','SALARIO FAMILIA - PENSIONIOSTA PESS. MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2528,'2015','3.2.9.9.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2529,'2015','3.2.9.9.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2530,'2015','3.3.0.0.0.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2531,'2015','3.3.1.0.0.00.00','USO DE MATERIAL DE CONSUMO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2532,'2015','3.3.1.1.0.00.00','CONSUMO DE MATERIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2533,'2015','3.3.1.1.1.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2534,'2015','3.3.1.1.1.01.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2535,'2015','3.3.1.1.1.03.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2536,'2015','3.3.1.1.1.04.00','EXPLOSIVOS E MUNISSÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2537,'2015','3.3.1.1.1.05.00','ALIMENTOS PARA ANIMAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2538,'2015','3.3.1.1.1.06.00','GENEROS ALIMENTACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2539,'2015','3.3.1.1.1.07.00','ANIMAIS PARA PESQUISA E ABATE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2540,'2015','3.3.1.1.1.08.00','MATERIAL FARMACOLÓGICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2541,'2015','3.3.1.1.1.09.00','MATERIAL ODONTOLÓGICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2542,'2015','3.3.1.1.1.10.00','MATERIAL QUIMÍCO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2543,'2015','3.3.1.1.1.11.00','MATERIAL DE COUDELARIA OU DE USO ZOOTÉCNICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2544,'2015','3.3.1.1.1.13.00','MATERIAL DE CAÇA E PESCA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2545,'2015','3.3.1.1.1.14.00','MATERIAL EDUCATIVO E ESPORTIVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2546,'2015','3.3.1.1.1.15.00','MATERIAL PARA FESTIVIDADESE HOMENAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2547,'2015','3.3.1.1.1.16.00','MATERIAL DE EXPEDIENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2548,'2015','3.3.1.1.1.17.00','MATERIAL DE PROCESSAMENTO DE DADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2549,'2015','3.3.1.1.1.18.00','MATERIAIS E MEDICAMENTOS P/USO VETERINÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2550,'2015','3.3.1.1.1.19.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2551,'2015','3.3.1.1.1.20.00','MATERIAL DE CAMA, MESA E BANHO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2552,'2015','3.3.1.1.1.21.00','MATERIAL DE COPA E COZINHA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2553,'2015','3.3.1.1.1.22.00','MATERIAL DE LIMPEZA E PRODUTOS DE HIGIENIZACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2554,'2015','3.3.1.1.1.23.00','UNIFORMES, TECIDOS E AVIAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2555,'2015','3.3.1.1.1.24.00','MATERIAL P/MANUT. E BENS IMÓVEIS/INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2556,'2015','3.3.1.1.1.25.00','MATERIAL PARA MANUTENCAO DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2557,'2015','3.3.1.1.1.26.00','MATERIAL ELETRICO E ELETRONICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2558,'2015','3.3.1.1.1.27.00','MATERIAL DE MANOBRA E PATRULHAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2559,'2015','3.3.1.1.1.28.00','MATERIAL DE PROTECAO E SEGURANCA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2560,'2015','3.3.1.1.1.29.00','MATERIAL PARA AUDIO, VIDEO E FOTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2561,'2015','3.3.1.1.1.30.00','MATERIAL PARA COMUNICACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2562,'2015','3.3.1.1.1.31.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2563,'2015','3.3.1.1.1.32.00','SUPRIMENTO DE AVIAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2564,'2015','3.3.1.1.1.33.00','MATERIAL PARA PRODUÇÃO INDUSTRIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2565,'2015','3.3.1.1.1.34.00','SUPRIMENTOS PARA MAQ. E MOTORES NAVIOS E EMBARCAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2566,'2015','3.3.1.1.1.35.00','MATERIAL LABORATORIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2567,'2015','3.3.1.1.1.36.00','MATERIAL HOSPITALAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2568,'2015','3.3.1.1.1.37.00','SUPRIMENTOS DE ARMAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2569,'2015','3.3.1.1.1.38.00','SUPRIMENTO DE PROTEÇÃO AO VOO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2570,'2015','3.3.1.1.1.39.00','MATERIAL PARA MANUTENCAO DE VEICULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2571,'2015','3.3.1.1.1.40.00','MATERIAL BIOLÓGICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2572,'2015','3.3.1.1.1.41.00','MATERIAL PARA UTILIZAÇÃO EM GRÁFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2573,'2015','3.3.1.1.1.42.00','FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2574,'2015','3.3.1.1.1.43.00','MATERIAL PARA REABILITAÇÃO PROFISSIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2575,'2015','3.3.1.1.1.44.00','MATERIAL DE SINALIZAÇÃO VISUAL E OUTROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2576,'2015','3.3.1.1.1.45.00','MATERIAL TÉCNICO PARA SELEÇÃO E TREINAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2577,'2015','3.3.1.1.1.46.00','MATERIAL BIBLIOGRAFICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2578,'2015','3.3.1.1.1.48.00','BENS MÓVEIS NÃO ATIVÁVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2579,'2015','3.3.1.1.1.49.00','BILHETES DE PASSAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2580,'2015','3.3.1.1.1.50.00','BANDEIRAS, FLÂMULAS E INSIGNIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2581,'2015','3.3.1.1.1.51.00','DISCOTECAS E FILMOTECAS NÃO IMOBILIZÁVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2582,'2015','3.3.1.1.1.52.00','MATERIAL DE CARÁTER SECRETO OU RESERVADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2583,'2015','3.3.1.1.1.53.00','MATERIAL METEOROLÓGICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2584,'2015','3.3.1.1.1.54.00','MATERIAL P/MANUT.CON SERV.DE ESTRADAS E VIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2585,'2015','3.3.1.1.1.55.00','SELOS PARA CONTROLE FISCAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2586,'2015','3.3.1.1.1.56.00','MATERIAL DE MARCAÇÃO DA FAUNA SILVESTRE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2587,'2015','3.3.1.1.1.57.00','MATERIAL DE CONSUMO - REPARTIÇÕES NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2588,'2015','3.3.1.1.1.58.00','SOBRESSALENTES PARA MÁQUINAS E EQUP. PARA PRODUÇÃO INDUSTRIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2589,'2015','3.3.1.1.1.70.00','AQUISIÇÃO DE SOFTWARES DE BASE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2590,'2015','3.3.1.1.1.71.00','MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2591,'2015','3.3.1.1.1.98.00','SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2592,'2015','3.3.1.1.1.99.00','OUTROS MATERIAIS DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2593,'2015','3.3.1.2.0.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2594,'2015','3.3.1.2.1.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2595,'2015','3.3.1.2.1.01.00','MERCADORIAS DOADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2596,'2015','3.3.1.2.1.02.00','MATERIAL DESTINADO À ASSISTÊNCIA SOCIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2597,'2015','3.3.1.2.1.03.00','MATERIAL EDUCACIONAL E CULTURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2598,'2015','3.3.1.2.1.04.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2599,'2015','3.3.1.2.1.05.00','MATERIAL PARA CERIMONIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2600,'2015','3.3.1.2.1.06.00','MATERIAL PARA DIVULGAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2601,'2015','3.3.1.2.1.07.00','MATERIAL DESTINADO A CONTRIBUINTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2602,'2015','3.3.1.2.1.08.00','MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2603,'2015','3.3.1.2.1.99.00','OUTROS MATERIAIS DE DISTRIBUIÇÃO GRATUITA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2604,'2015','3.3.2.0.0.00.00','SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2605,'2015','3.3.2.1.0.00.00','DIÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2606,'2015','3.3.2.1.1.00.00','DIÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2607,'2015','3.3.2.1.1.01.00','DIARIAS  PESSOAL CIVIL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2608,'2015','3.3.2.1.1.02.00','DIARIAS - PESSOAL MILITAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2609,'2015','3.3.2.1.1.03.00','DIARIAS - COLABORADORES EVENTUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2610,'2015','3.3.2.1.1.04.00','DIARIAS A CONSELHEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2611,'2015','3.3.2.2.0.00.00','SERVIÇOS TERCEIROS - PF','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2612,'2015','3.3.2.2.1.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2613,'2015','3.3.2.2.1.01.00','CONSULTORIA E ASSESSORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2614,'2015','3.3.2.2.1.02.00','PERICIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2615,'2015','3.3.2.2.1.03.00','AUDITORIA EXTERNA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2616,'2015','3.3.2.2.1.04.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2617,'2015','3.3.2.2.1.05.00','SERVICOS MEDICOS E ODONTOLOGICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2618,'2015','3.3.2.2.1.06.00','SELECAO E TREINAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2619,'2015','3.3.2.2.1.07.00','COMUNICACAO EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2620,'2015','3.3.2.2.1.08.00','LIMPEZA E CONSERVACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2621,'2015','3.3.2.2.1.09.00','SERVICOS DOMESTICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2622,'2015','3.3.2.2.1.10.00','VIGILANCIA OSTENSIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2623,'2015','3.3.2.2.1.11.00','MANUTENCAO E CONSERVACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2624,'2015','3.3.2.2.1.12.00','CONDOMINIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2625,'2015','3.3.2.2.1.13.00','COMISSOES E CORRETAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2626,'2015','3.3.2.2.1.14.00','DIREITOS AUTORAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2627,'2015','3.3.2.2.1.15.00','SERVICOS TECNICOS PROFISSIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2628,'2015','3.3.2.2.1.16.00','ESTAGIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2629,'2015','3.3.2.2.1.18.00','CAPATAZIA, ESTIVA E PESAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2630,'2015','3.3.2.2.1.19.00','CONFERENCIAS, EXPOSICOES E ESPETACULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2631,'2015','3.3.2.2.1.20.00','ARMAZENAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2632,'2015','3.3.2.2.1.21.00','LOCACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2633,'2015','3.3.2.2.1.22.00','FORNECIMENTO DE ALIMENTACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2634,'2015','3.3.2.2.1.23.00','SERVICOS DE CARATER SECRETO OU RESERVADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2635,'2015','3.3.2.2.1.24.00','SERVICOS DE REABILITACAO PROFISSIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2636,'2015','3.3.2.2.1.25.00','SERVICOS DE ASSISTENCIA SOCIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2637,'2015','3.3.2.2.1.26.00','SERV. DE APOIO ADMIN., TECNICO E OPERACIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2638,'2015','3.3.2.2.1.27.00','SERV. DE CONSERV. E REBENEFIC. DE MERCADORIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2639,'2015','3.3.2.2.1.28.00','CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2640,'2015','3.3.2.2.1.29.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2641,'2015','3.3.2.2.1.30.00','FRETES E TRANSPORTES DE ENCOMENDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2642,'2015','3.3.2.2.1.31.00','JETONS E GRATIFICACOES A CONSELHEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2643,'2015','3.3.2.2.1.34.00','SERVICOS DE AUDIO, VIDEO E FOTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2644,'2015','3.3.2.2.1.35.00','SERVICOS JUDICIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2645,'2015','3.3.2.2.1.36.00','SEGUROS EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2646,'2015','3.3.2.2.1.37.00','HOSPEDAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2647,'2015','3.3.2.2.1.38.00','DESPESAS COM LOCOMOCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2648,'2015','3.3.2.2.1.39.00','SERVICOS GRAFICOS E EDITORIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2649,'2015','3.3.2.2.1.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2650,'2015','3.3.2.3.0.00.00','SERVIÇOS TERCEIROS - PJ','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2651,'2015','3.3.2.3.1.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2652,'2015','3.3.2.3.1.01.00','CONSULTORIA E ASSESSORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2653,'2015','3.3.2.3.1.02.00','PERICIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2654,'2015','3.3.2.3.1.03.00','AUDITORIA EXTERNA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2655,'2015','3.3.2.3.1.04.00','COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2656,'2015','3.3.2.3.1.05.00','PUBLICIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2657,'2015','3.3.2.3.1.06.00','MANUTENÇÃO E CONSERVAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2658,'2015','3.3.2.3.1.07.00','SERVIÇOS DE APOIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2659,'2015','3.3.2.3.1.08.00','SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2660,'2015','3.3.2.3.1.09.00','SERVIÇOS DE ALIMENTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2661,'2015','3.3.2.3.1.10.00','LOCAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2662,'2015','3.3.2.3.1.11.00','SERVIÇOS RELACIONADOS A TECNOLOGIA DA INFORMAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2663,'2015','3.3.2.3.1.12.00','SERVIÇOS DE TRANSPORTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2664,'2015','3.3.2.3.1.13.00','ARMAZENAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2665,'2015','3.3.2.3.1.14.00','ASSINATURAS DE PERIODICOS E ANUIDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2666,'2015','3.3.2.3.1.15.00','CAPATAZIA, ESTIVA E PESAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2667,'2015','3.3.2.3.1.16.00','CLASSIFICAÇÃO DE PRODUTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2668,'2015','3.3.2.3.1.17.00','COMISSOES E CORRETAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2669,'2015','3.3.2.3.1.18.00','CONDOMINIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2670,'2015','3.3.2.3.1.19.00','CONFECÇÃO DE MATERIAL DE ACONDIC. E EMBALAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2671,'2015','3.3.2.3.1.20.00','CONFECÇÃO DE UNIFORMES, BANDEIRAS E FLAMULAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2672,'2015','3.3.2.3.1.21.00','DIREITOS AUTORAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2673,'2015','3.3.2.3.1.22.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2674,'2015','3.3.2.3.1.23.00','FESTIVIDADES E HOMENAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2675,'2015','3.3.2.3.1.24.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2676,'2015','3.3.2.3.1.25.00','HOSPEDAGENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2677,'2015','3.3.2.3.1.26.00','PATROCINIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2678,'2015','3.3.2.3.1.27.00','PRODUCOES JORNALISTICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2679,'2015','3.3.2.3.1.28.00','PROMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2680,'2015','3.3.2.3.1.29.00','SEGUROS EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2681,'2015','3.3.2.3.1.30.00','SELEÇÃO E TREINAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2682,'2015','3.3.2.3.1.31.00','SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2683,'2015','3.3.2.3.1.32.00','SERVIÇOS BANCARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2684,'2015','3.3.2.3.1.33.00','SERVIÇOS DE ANALISES E PESQUISA CIENTIFICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2685,'2015','3.3.2.3.1.34.00','SERVIÇOS DE APOIO DO ENSINO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2686,'2015','3.3.2.3.1.35.00','SERVIÇOS DE ASSISTENCIA SOCIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2687,'2015','3.3.2.3.1.36.00','SERVIÇOS DE AUDIO VIDEO E FOTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2688,'2015','3.3.2.3.1.37.00','SERVIÇOS DE CONFECÇÃO SELOS CONTROLE FISCAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2689,'2015','3.3.2.3.1.38.00','SERVIÇOS DE CONSERV. E REBENEF. DE MERCADORIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2690,'2015','3.3.2.3.1.39.00','SERVIÇOS DE CONTROLE AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2691,'2015','3.3.2.3.1.40.00','SERVIÇOS DE COPIAS E REPRODUÇÃO DE DOCUMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2692,'2015','3.3.2.3.1.41.00','SERVIÇOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2693,'2015','3.3.2.3.1.42.00','SERVIÇOS DE INCINERAÇÃO/DESTRUIÇÃO DE MATERIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2694,'2015','3.3.2.3.1.43.00','SERVIÇOS DE PRODUÇÃO INDUSTRIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2695,'2015','3.3.2.3.1.44.00','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2696,'2015','3.3.2.3.1.45.00','SERVIÇOS FUNERARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2697,'2015','3.3.2.3.1.46.00','SERVIÇOS GRÁFICOS E EDITORIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2698,'2015','3.3.2.3.1.47.00','SERVIÇOS JUDICIARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2699,'2015','3.3.2.3.1.51.00','SERVIÇOS TECNICOS PROFISSIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2700,'2015','3.3.2.3.1.52.00','TAXA DE ADMINISTRAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2701,'2015','3.3.2.3.1.54.00','LOCAÇÃO DE MAO-DE-OBRA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2702,'2015','3.3.2.3.1.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2703,'2015','3.3.2.3.1.56.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2704,'2015','3.3.2.3.1.99.00','OUTROS SERVIÇOS TERCEIROS - PJ','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2705,'2015','3.3.2.4.0.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA – ART. 18 § 1, LC 101/00','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2706,'2015','3.3.2.4.1.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2707,'2015','3.3.3.0.0.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2708,'2015','3.3.3.1.0.00.00','DEPRECIAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2709,'2015','3.3.3.1.1.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2710,'2015','3.3.3.1.1.01.00','DEPRECIAÇÃO DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2711,'2015','3.3.3.1.1.01.01','DEPRECIAÇÃO DE BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2712,'2015','3.3.3.1.1.01.02','DEPRECIAÇÃO DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2713,'2015','3.3.3.2.0.00.00','AMORTIZAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2714,'2015','3.3.3.2.1.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2715,'2015','3.3.3.2.1.01.00','AMORTIZAÇÃO DE IMOBILIZADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2716,'2015','3.3.3.2.1.02.00','AMORTIZAÇÃO DE INTANGÍVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2717,'2015','3.3.3.3.0.00.00','EXAUSTÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2718,'2015','3.3.3.3.1.00.00','EXAUSTÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2719,'2015','3.3.3.3.1.01.00','EXAUSTÃO DE IMOBILIZADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2720,'2015','3.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2721,'2015','3.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2722,'2015','3.4.1.1.0.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2723,'2015','3.4.1.1.1.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2724,'2015','3.4.1.1.1.01.00','JUROS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2725,'2015','3.4.1.1.1.02.00','ENCARGOS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2726,'2015','3.4.1.1.1.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2727,'2015','3.4.1.1.3.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2728,'2015','3.4.1.1.3.01.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - UNIÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2729,'2015','3.4.1.1.3.02.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - UNIÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2730,'2015','3.4.1.1.3.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - UNIÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2731,'2015','3.4.1.1.4.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2732,'2015','3.4.1.1.4.01.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - ESTADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2733,'2015','3.4.1.1.4.02.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - ESTADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2734,'2015','3.4.1.1.4.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - ESTADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2735,'2015','3.4.1.1.5.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2736,'2015','3.4.1.1.5.01.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - MUNICÍPIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2737,'2015','3.4.1.1.5.02.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - MUNICÍPIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2738,'2015','3.4.1.1.5.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - MUNICÍPIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2739,'2015','3.4.1.2.0.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2740,'2015','3.4.1.2.1.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2741,'2015','3.4.1.2.1.01.00','JUROS DA DIVIDA CONTRATADA NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2742,'2015','3.4.1.2.1.02.00','ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2743,'2015','3.4.1.3.0.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2744,'2015','3.4.1.3.1.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2745,'2015','3.4.1.4.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2746,'2015','3.4.1.4.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2747,'2015','3.4.1.4.1.01.00','JUROS S/ ADIANTAMENTOS BANCARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2748,'2015','3.4.1.8.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2749,'2015','3.4.1.8.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2750,'2015','3.4.1.8.3.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2751,'2015','3.4.1.8.4.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2752,'2015','3.4.1.8.5.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2753,'2015','3.4.1.9.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2754,'2015','3.4.1.9.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2755,'2015','3.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2756,'2015','3.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2757,'2015','3.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2758,'2015','3.4.2.1.1.01.00','JUROS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2759,'2015','3.4.2.1.1.02.00','ENCARGOS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2760,'2015','3.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2761,'2015','3.4.2.1.3.01.00','JUROS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2762,'2015','3.4.2.1.3.02.00','ENCARGOS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2763,'2015','3.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2764,'2015','3.4.2.1.4.01.00','JUROS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2765,'2015','3.4.2.1.4.02.00','ENCARGOS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2766,'2015','3.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2767,'2015','3.4.2.1.5.01.00','JUROS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2768,'2015','3.4.2.1.5.02.00','ENCARGOS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2769,'2015','3.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2770,'2015','3.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2771,'2015','3.4.2.2.1.01.00','JUROS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2772,'2015','3.4.2.2.1.02.00','ENCARGOS DE MORA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2773,'2015','3.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2774,'2015','3.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2775,'2015','3.4.2.3.1.01.00','JUROS DE MORA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2776,'2015','3.4.2.3.1.01.01','JUROS DE  SERVICOS TERCEIROS - PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2777,'2015','3.4.2.3.1.01.02','JUROS DE SERVICOS TERCEIROS - PESSOA JURIDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2778,'2015','3.4.2.3.1.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2779,'2015','3.4.2.3.1.02.00','MULTAS DEDUTIVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2780,'2015','3.4.2.3.1.02.01','MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2781,'2015','3.4.2.3.1.02.02','MULTAS DEDUTIVEIS  SERVICOS TERCEIROS - PESSOA JURIDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2782,'2015','3.4.2.3.1.02.03','MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2783,'2015','3.4.2.3.1.03.00','MULTAS INDEDUTIVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2784,'2015','3.4.2.3.1.03.01','MULTAS INDEDUTIVEIS  SERVICOS TERCEIROS - PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2785,'2015','3.4.2.3.1.03.02','MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2786,'2015','3.4.2.3.1.03.03','MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2787,'2015','3.4.2.3.1.99.00','OUTROS ENCARGOS DE MORA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2788,'2015','3.4.2.3.1.99.01','OUTROS ENCARGOS S/  SERVICOS TERCEIROS - PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2789,'2015','3.4.2.3.1.99.02','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2790,'2015','3.4.2.3.1.99.03','OUTROS ENCARGOS S/  FONECIMENTO DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2791,'2015','3.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2792,'2015','3.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2793,'2015','3.4.2.4.1.01.00','JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2794,'2015','3.4.2.4.1.02.00','MULTAS DEDUTIVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2795,'2015','3.4.2.4.1.03.00','MULTAS INDEDUTIVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2796,'2015','3.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2797,'2015','3.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2798,'2015','3.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2799,'2015','3.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2800,'2015','3.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2801,'2015','3.4.3.1.1.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2802,'2015','3.4.3.1.1.02.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2803,'2015','3.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2804,'2015','3.4.3.1.3.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2805,'2015','3.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2806,'2015','3.4.3.1.4.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2807,'2015','3.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2808,'2015','3.4.3.1.5.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2809,'2015','3.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2810,'2015','3.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2811,'2015','3.4.3.2.1.01.00','VARIAÇÕES MONETÁRIAS DA DIVIDA CONTRATUAL EXTERNA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2812,'2015','3.4.3.2.1.02.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2813,'2015','3.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2814,'2015','3.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2815,'2015','3.4.3.3.1.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA MOBILIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2816,'2015','3.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2817,'2015','3.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2818,'2015','3.4.3.4.1.01.00','VARIAÇÕES MONETARIAS DE DIVIDA MOBILIARIA EXTERNA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2819,'2015','3.4.3.4.1.02.00','VARIAÇÕES CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2820,'2015','3.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2821,'2015','3.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2822,'2015','3.4.3.9.1.01.00','OUTRAS VARIAÇÕES MONETARIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2823,'2015','3.4.3.9.1.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2824,'2015','3.4.3.9.1.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2825,'2015','3.4.3.9.1.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2826,'2015','3.4.3.9.1.99.00','OUTRAS VARIAÇÕES CAMBIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2827,'2015','3.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2828,'2015','3.4.3.9.3.01.00','OUTRAS VARIAÇÕES MONETARIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2829,'2015','3.4.3.9.3.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2830,'2015','3.4.3.9.3.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2831,'2015','3.4.3.9.3.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2832,'2015','3.4.3.9.3.01.71','ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2833,'2015','3.4.3.9.3.02.00','OUTRAS VARIAÇÕES CAMBIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2834,'2015','3.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2835,'2015','3.4.3.9.4.01.00','OUTRAS VARIAÇÕES MONETARIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2836,'2015','3.4.3.9.4.02.00','OUTRAS VARIAÇÕES CAMBIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2837,'2015','3.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2838,'2015','3.4.3.9.5.01.00','OUTRAS VARIAÇÕES MONETARIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2839,'2015','3.4.3.9.5.02.00','OUTRAS VARIAÇÕES CAMBIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2840,'2015','3.4.4.0.0.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2841,'2015','3.4.4.0.1.00.00','DESCONTOS FINANCEIROS CONCEDIDOS  - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2842,'2015','3.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2843,'2015','3.4.9.1.0.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2844,'2015','3.4.9.1.1.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2845,'2015','3.4.9.2.0.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2846,'2015','3.4.9.2.1.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2847,'2015','3.4.9.9.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2848,'2015','3.4.9.9.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2849,'2015','3.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2850,'2015','3.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2851,'2015','3.5.1.1.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2852,'2015','3.5.1.1.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA -  INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2853,'2015','3.5.1.1.2.01.00','COTA CONCEDIDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2854,'2015','3.5.1.1.2.02.00','REPASSE CONCEDIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2855,'2015','3.5.1.1.2.03.00','SUB-REPASSE CONCEDIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2856,'2015','3.5.1.1.2.04.00','RECURSOS ARRECADADOS - CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2857,'2015','3.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2858,'2015','3.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2859,'2015','3.5.1.1.2.13.00','CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2860,'2015','3.5.1.2.0.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2861,'2015','3.5.1.2.2.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2862,'2015','3.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2863,'2015','3.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS CONCEDIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2864,'2015','3.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS NAO FINANCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2865,'2015','3.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2866,'2015','3.5.1.2.2.01.04','MOVIMENTO DE FUNDOS A CRÉDITOS - MOVIMENTO DE FUNDOS PRÓPRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2867,'2015','3.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2868,'2015','3.5.1.2.2.02.00','TRANSFERÊNCIAS  NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2869,'2015','3.5.1.2.2.02.01','TRANSFERÊNCIAS CONCEDIDAS DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2870,'2015','3.5.1.2.2.02.02','DOAÇÕES CONCEDIDAS DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2871,'2015','3.5.1.2.2.02.03','TRANFERÊNCIAS CONCEDIDAS DE BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2872,'2015','3.5.1.2.2.02.04','DOAÇÕES CONCEDIDAS DE BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2873,'2015','3.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2874,'2015','3.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2875,'2015','3.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS  NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2876,'2015','3.5.1.3.0.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2877,'2015','3.5.1.3.2.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2878,'2015','3.5.1.3.2.01.00','PLANO FINANCEIRO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2879,'2015','3.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2880,'2015','3.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2881,'2015','3.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2882,'2015','3.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2883,'2015','3.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2884,'2015','3.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2885,'2015','3.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2886,'2015','3.5.1.4.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2887,'2015','3.5.1.4.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS  – INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2888,'2015','3.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2889,'2015','3.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2890,'2015','3.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2891,'2015','3.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2892,'2015','3.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2893,'2015','3.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2894,'2015','3.5.2.1.0.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2895,'2015','3.5.2.1.1.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2896,'2015','3.5.2.1.3.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2897,'2015','3.5.2.1.4.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2898,'2015','3.5.2.1.5.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2899,'2015','3.5.2.1.5.01.00','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2900,'2015','3.5.2.1.5.02.00','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2901,'2015','3.5.2.1.5.03.00','IPI-EXPORTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2902,'2015','3.5.2.1.5.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2903,'2015','3.5.2.1.5.05.00','TRANSFERÊNCIA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2904,'2015','3.5.2.1.5.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE – REPASSE FUNDO A FUNDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2905,'2015','3.5.2.2.0.00.00','TRANSFERÊNCIAS AO FUNDEB','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2906,'2015','3.5.2.2.4.00.00','TRANSFERÊNCIAS AO FUNDEB - INTER-OFSS – ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2907,'2015','3.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2908,'2015','3.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2909,'2015','3.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2910,'2015','3.5.2.3.3.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2911,'2015','3.5.2.3.3.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2912,'2015','3.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2913,'2015','3.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2914,'2015','3.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2915,'2015','3.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2916,'2015','3.5.2.3.4.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2917,'2015','3.5.2.3.4.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2918,'2015','3.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2919,'2015','3.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2920,'2015','3.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2921,'2015','3.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2922,'2015','3.5.2.3.5.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2923,'2015','3.5.2.3.5.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2924,'2015','3.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2925,'2015','3.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2926,'2015','3.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2927,'2015','3.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2928,'2015','3.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2929,'2015','3.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2930,'2015','3.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2931,'2015','3.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2932,'2015','3.5.3.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2933,'2015','3.5.3.1.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2934,'2015','3.5.3.1.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2935,'2015','3.5.3.1.1.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2936,'2015','3.5.3.1.1.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2937,'2015','3.5.3.1.1.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2938,'2015','3.5.3.2.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2939,'2015','3.5.3.2.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2940,'2015','3.5.3.2.1.01.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2941,'2015','3.5.4.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2942,'2015','3.5.4.0.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2943,'2015','3.5.5.0.0.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2944,'2015','3.5.5.0.1.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2945,'2015','3.5.6.0.0.00.00','TRANSFERÊNCIAS AO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2946,'2015','3.5.6.0.1.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2947,'2015','3.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2948,'2015','3.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2949,'2015','3.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2950,'2015','3.5.7.1.3.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2951,'2015','3.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2952,'2015','3.5.7.1.3.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2953,'2015','3.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2954,'2015','3.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2955,'2015','3.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2956,'2015','3.5.7.1.3.07.00','DEMAIS VPD COM DELEGAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2957,'2015','3.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2958,'2015','3.5.7.1.4.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2959,'2015','3.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2960,'2015','3.5.7.1.4.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2961,'2015','3.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2962,'2015','3.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2963,'2015','3.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2964,'2015','3.5.7.1.4.07.00','DEMAIS VPD COM DELEGAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2965,'2015','3.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2966,'2015','3.5.7.1.5.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2967,'2015','3.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2968,'2015','3.5.7.1.5.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2969,'2015','3.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2970,'2015','3.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2971,'2015','3.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2972,'2015','3.5.7.1.5.07.00','DEMAIS VPD COM DELEGAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2973,'2015','3.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2974,'2015','3.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2975,'2015','3.5.7.2.1.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2976,'2015','3.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2977,'2015','3.5.7.2.1.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2978,'2015','3.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2979,'2015','3.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2980,'2015','3.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2981,'2015','3.5.7.2.1.07.00','DEMAIS VPD COM DELEGAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2982,'2015','3.5.9.0.0.00.00','OUTRAS TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2983,'2015','3.5.9.0.1.00.00','OUTRAS TRANSFERÊNCIAS CONCEDIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2984,'2015','3.5.9.0.1.01.00','DOAÇÕES CONCEDIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2985,'2015','3.6.0.0.0.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS E INCORPORAÇÃO DE PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2986,'2015','3.6.1.0.0.00.00','REAVALIAÇÃO, REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2987,'2015','3.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2988,'2015','3.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2989,'2015','3.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2990,'2015','3.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2991,'2015','3.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2992,'2015','3.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2993,'2015','3.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2994,'2015','3.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2995,'2015','3.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2996,'2015','3.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2997,'2015','3.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2998,'2015','3.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (2999,'2015','3.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3000,'2015','3.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3001,'2015','3.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3002,'2015','3.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3003,'2015','3.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3004,'2015','3.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3005,'2015','3.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3006,'2015','3.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3007,'2015','3.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3008,'2015','3.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3009,'2015','3.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3010,'2015','3.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3011,'2015','3.6.1.3.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3012,'2015','3.6.1.3.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3013,'2015','3.6.1.4.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3014,'2015','3.6.1.4.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3015,'2015','3.6.1.4.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3016,'2015','3.6.1.4.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3017,'2015','3.6.1.4.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3018,'2015','3.6.1.4.1.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3019,'2015','3.6.1.4.2.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3020,'2015','3.6.1.4.2.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3021,'2015','3.6.1.4.2.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3022,'2015','3.6.1.4.2.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3023,'2015','3.6.1.4.2.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3024,'2015','3.6.1.4.3.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3025,'2015','3.6.1.4.3.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3026,'2015','3.6.1.4.3.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3027,'2015','3.6.1.4.3.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3028,'2015','3.6.1.4.3.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3029,'2015','3.6.1.4.4.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3030,'2015','3.6.1.4.4.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3031,'2015','3.6.1.4.4.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3032,'2015','3.6.1.4.4.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3033,'2015','3.6.1.4.4.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3034,'2015','3.6.1.4.5.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3035,'2015','3.6.1.4.5.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3036,'2015','3.6.1.4.5.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3037,'2015','3.6.1.4.5.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3038,'2015','3.6.1.4.5.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3039,'2015','3.6.1.5.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3040,'2015','3.6.1.5.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3041,'2015','3.6.1.5.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3042,'2015','3.6.1.5.1.01.01','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3043,'2015','3.6.1.5.1.01.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3044,'2015','3.6.1.5.1.01.03','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3045,'2015','3.6.1.5.1.01.04','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3046,'2015','3.6.1.5.1.01.05','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3047,'2015','3.6.1.5.1.01.06','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3048,'2015','3.6.1.5.1.01.07','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3049,'2015','3.6.1.5.1.01.08','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3050,'2015','3.6.1.5.1.01.09','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3051,'2015','3.6.1.5.1.01.10','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3052,'2015','3.6.1.5.1.01.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3053,'2015','3.6.1.5.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3054,'2015','3.6.1.5.1.02.01','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3055,'2015','3.6.1.5.1.02.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3056,'2015','3.6.1.5.1.02.03','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3057,'2015','3.6.1.5.1.02.04','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3058,'2015','3.6.1.5.1.02.05','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3059,'2015','3.6.1.5.1.02.06','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3060,'2015','3.6.1.5.1.02.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3061,'2015','3.6.1.6.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3062,'2015','3.6.1.6.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3063,'2015','3.6.1.6.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3064,'2015','3.6.1.6.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATÉNTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3065,'2015','3.6.1.6.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3066,'2015','3.6.1.7.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3067,'2015','3.6.1.7.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS  E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3068,'2015','3.6.1.7.1.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3069,'2015','3.6.1.7.1.02.00','AJUSTE PARA PERDAS EM CLIENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3070,'2015','3.6.1.7.1.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3071,'2015','3.6.1.7.1.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3072,'2015','3.6.1.7.1.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3073,'2015','3.6.1.7.1.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3074,'2015','3.6.1.7.1.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3075,'2015','3.6.1.7.1.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3076,'2015','3.6.1.7.1.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3077,'2015','3.6.1.7.1.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3078,'2015','3.6.1.7.1.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3079,'2015','3.6.1.7.1.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3080,'2015','3.6.1.7.1.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3081,'2015','3.6.1.7.1.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3082,'2015','3.6.1.7.1.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3083,'2015','3.6.1.7.1.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3084,'2015','3.6.1.7.1.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3085,'2015','3.6.1.7.1.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3086,'2015','3.6.1.7.1.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3087,'2015','3.6.1.7.1.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3088,'2015','3.6.1.7.1.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3089,'2015','3.6.1.7.1.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3090,'2015','3.6.1.7.1.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3091,'2015','3.6.1.7.1.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3092,'2015','3.6.1.7.1.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3093,'2015','3.6.1.7.1.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3094,'2015','3.6.1.7.1.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3095,'2015','3.6.1.7.1.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3096,'2015','3.6.1.7.1.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3097,'2015','3.6.1.7.1.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3098,'2015','3.6.1.7.1.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3099,'2015','3.6.1.7.1.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3100,'2015','3.6.1.7.1.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3101,'2015','3.6.1.7.1.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3102,'2015','3.6.1.7.1.07.00','AJUSTE PARA PERDAS EM INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3103,'2015','3.6.1.7.1.07.01','AJUSTE PARA PERDAS EM TÍTULOS E VALORES MOBILIÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3104,'2015','3.6.1.7.1.07.02','AJUSTE PARA PERDAS EM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3105,'2015','3.6.1.7.1.07.03','AJUSTE PARA PERDAS EM APLICAÇÕES TEMPORÁRIAS EM SEGMENTO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3106,'2015','3.6.1.7.1.98.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3107,'2015','3.6.1.7.1.99.00','AJUSTE PARA PERDAS DE DEMAIS INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3108,'2015','3.6.1.7.2.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3109,'2015','3.6.1.7.2.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3110,'2015','3.6.1.7.2.02.00','AJUSTE PARA PERDAS EM CLIENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3111,'2015','3.6.1.7.2.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3112,'2015','3.6.1.7.2.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3113,'2015','3.6.1.7.2.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3114,'2015','3.6.1.7.2.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3115,'2015','3.6.1.7.2.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3116,'2015','3.6.1.7.2.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3117,'2015','3.6.1.7.2.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3118,'2015','3.6.1.7.2.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3119,'2015','3.6.1.7.2.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3120,'2015','3.6.1.7.2.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3121,'2015','3.6.1.7.2.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3122,'2015','3.6.1.7.2.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3123,'2015','3.6.1.7.2.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3124,'2015','3.6.1.7.2.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3125,'2015','3.6.1.7.2.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3126,'2015','3.6.1.7.2.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3127,'2015','3.6.1.7.2.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3128,'2015','3.6.1.7.2.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3129,'2015','3.6.1.7.2.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3130,'2015','3.6.1.7.2.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3131,'2015','3.6.1.7.2.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3132,'2015','3.6.1.7.2.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3133,'2015','3.6.1.7.2.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3134,'2015','3.6.1.7.2.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3135,'2015','3.6.1.7.2.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3136,'2015','3.6.1.7.2.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3137,'2015','3.6.1.7.2.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3138,'2015','3.6.1.7.2.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3139,'2015','3.6.1.7.2.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3140,'2015','3.6.1.7.2.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3141,'2015','3.6.1.7.2.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3142,'2015','3.6.1.7.2.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3143,'2015','3.6.1.7.2.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3144,'2015','3.6.1.7.3.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3145,'2015','3.6.1.7.3.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3146,'2015','3.6.1.7.3.02.00','AJUSTE PARA PERDAS EM CLIENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3147,'2015','3.6.1.7.3.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3148,'2015','3.6.1.7.3.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3149,'2015','3.6.1.7.3.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3150,'2015','3.6.1.7.3.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3151,'2015','3.6.1.7.3.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3152,'2015','3.6.1.7.3.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3153,'2015','3.6.1.7.3.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3154,'2015','3.6.1.7.3.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3155,'2015','3.6.1.7.3.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3156,'2015','3.6.1.7.3.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3157,'2015','3.6.1.7.3.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3158,'2015','3.6.1.7.3.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3159,'2015','3.6.1.7.3.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3160,'2015','3.6.1.7.3.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3161,'2015','3.6.1.7.3.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3162,'2015','3.6.1.7.3.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3163,'2015','3.6.1.7.3.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3164,'2015','3.6.1.7.3.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3165,'2015','3.6.1.7.3.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3166,'2015','3.6.1.7.3.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3167,'2015','3.6.1.7.3.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3168,'2015','3.6.1.7.3.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3169,'2015','3.6.1.7.3.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3170,'2015','3.6.1.7.3.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3171,'2015','3.6.1.7.3.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3172,'2015','3.6.1.7.3.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3173,'2015','3.6.1.7.3.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3174,'2015','3.6.1.7.3.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3175,'2015','3.6.1.7.3.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3176,'2015','3.6.1.7.3.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3177,'2015','3.6.1.7.3.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3178,'2015','3.6.1.7.3.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3179,'2015','3.6.1.7.3.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3180,'2015','3.6.1.7.4.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3181,'2015','3.6.1.7.4.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3182,'2015','3.6.1.7.4.02.00','AJUSTE PARA PERDAS EM CLIENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3183,'2015','3.6.1.7.4.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3184,'2015','3.6.1.7.4.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3185,'2015','3.6.1.7.4.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3186,'2015','3.6.1.7.4.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3187,'2015','3.6.1.7.4.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3188,'2015','3.6.1.7.4.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3189,'2015','3.6.1.7.4.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3190,'2015','3.6.1.7.4.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3191,'2015','3.6.1.7.4.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3192,'2015','3.6.1.7.4.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3193,'2015','3.6.1.7.4.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3194,'2015','3.6.1.7.4.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3195,'2015','3.6.1.7.4.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3196,'2015','3.6.1.7.4.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3197,'2015','3.6.1.7.4.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3198,'2015','3.6.1.7.4.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3199,'2015','3.6.1.7.4.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3200,'2015','3.6.1.7.4.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3201,'2015','3.6.1.7.4.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3202,'2015','3.6.1.7.4.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3203,'2015','3.6.1.7.4.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3204,'2015','3.6.1.7.4.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3205,'2015','3.6.1.7.4.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3206,'2015','3.6.1.7.4.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3207,'2015','3.6.1.7.4.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3208,'2015','3.6.1.7.4.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3209,'2015','3.6.1.7.4.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3210,'2015','3.6.1.7.4.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3211,'2015','3.6.1.7.4.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3212,'2015','3.6.1.7.4.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3213,'2015','3.6.1.7.4.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3214,'2015','3.6.1.7.4.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3215,'2015','3.6.1.7.4.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3216,'2015','3.6.1.7.5.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3217,'2015','3.6.1.7.5.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3218,'2015','3.6.1.7.5.02.00','AJUSTE PARA PERDAS EM CLIENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3219,'2015','3.6.1.7.5.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3220,'2015','3.6.1.7.5.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3221,'2015','3.6.1.7.5.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3222,'2015','3.6.1.7.5.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3223,'2015','3.6.1.7.5.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3224,'2015','3.6.1.7.5.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3225,'2015','3.6.1.7.5.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3226,'2015','3.6.1.7.5.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3227,'2015','3.6.1.7.5.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3228,'2015','3.6.1.7.5.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3229,'2015','3.6.1.7.5.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3230,'2015','3.6.1.7.5.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3231,'2015','3.6.1.7.5.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3232,'2015','3.6.1.7.5.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3233,'2015','3.6.1.7.5.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3234,'2015','3.6.1.7.5.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3235,'2015','3.6.1.7.5.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3236,'2015','3.6.1.7.5.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3237,'2015','3.6.1.7.5.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULACAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3238,'2015','3.6.1.7.5.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3239,'2015','3.6.1.7.5.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3240,'2015','3.6.1.7.5.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3241,'2015','3.6.1.7.5.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3242,'2015','3.6.1.7.5.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3243,'2015','3.6.1.7.5.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3244,'2015','3.6.1.7.5.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3245,'2015','3.6.1.7.5.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINCAO - ATUALIZACAO MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3246,'2015','3.6.1.7.5.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3247,'2015','3.6.1.7.5.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3248,'2015','3.6.1.7.5.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3249,'2015','3.6.1.7.5.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3250,'2015','3.6.1.7.5.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3251,'2015','3.6.1.7.5.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3252,'2015','3.6.1.8.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3253,'2015','3.6.1.8.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3254,'2015','3.6.1.8.1.01.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MERCADORIAS PARA REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3255,'2015','3.6.1.8.1.02.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS ACABADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3256,'2015','3.6.1.8.1.03.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3257,'2015','3.6.1.8.1.04.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATÉRIAS-PRIMAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3258,'2015','3.6.1.8.1.05.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATERIAIS EM TRÂNSITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3259,'2015','3.6.1.8.1.06.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3260,'2015','3.6.1.8.1.07.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ADIANTAMENTOS A FORNECEDORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3261,'2015','3.6.1.8.1.08.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS ESTOQUES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3262,'2015','3.6.2.0.0.00.00','PERDAS COM ALIENAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3263,'2015','3.6.2.1.0.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3264,'2015','3.6.2.1.1.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3265,'2015','3.6.2.1.1.01.00','PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3266,'2015','3.6.2.1.1.02.00','PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3267,'2015','3.6.2.1.1.03.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3268,'2015','3.6.2.1.1.04.00','PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3269,'2015','3.6.2.2.0.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3270,'2015','3.6.2.2.1.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3271,'2015','3.6.2.2.1.01.00','PERDAS COM ALIENAÇÃO DE BENS MOVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3272,'2015','3.6.2.2.1.01.01','PERDAS COM ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3273,'2015','3.6.2.2.1.01.02','PERDAS COM ALIENAÇÃO DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3274,'2015','3.6.2.2.1.01.03','PERDAS COM ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3275,'2015','3.6.2.2.1.01.04','PERDAS COM ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3276,'2015','3.6.2.2.1.01.05','PERDAS COM ALIENAÇÃO DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3277,'2015','3.6.2.2.1.01.06','PERDAS COM ALIENAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3278,'2015','3.6.2.2.1.01.07','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3279,'2015','3.6.2.2.1.01.08','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3280,'2015','3.6.2.2.1.01.09','PERDAS COM ALIENAÇÃO DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3281,'2015','3.6.2.2.1.01.10','PERDAS COM ALIENAÇÃO DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3282,'2015','3.6.2.2.1.01.99','PERDAS COM ALIENAÇÃO DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3283,'2015','3.6.2.2.1.02.00','PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3284,'2015','3.6.2.3.0.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3285,'2015','3.6.2.3.1.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3286,'2015','3.6.2.3.1.01.00','PERDAS COM ALIENAÇÃO DE SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3287,'2015','3.6.2.3.1.02.00','PERDAS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3288,'2015','3.6.2.3.1.03.00','PERDAS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3289,'2015','3.6.2.9.0.00.00','PERDAS COM ALIENAÇÃO DE DEMAIS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3290,'2015','3.6.2.9.1.00.00','PERDAS COM ALIENAÇÃO DE DEMAIS ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3291,'2015','3.6.3.0.0.00.00','PERDAS INVOLUNTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3292,'2015','3.6.3.1.0.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3293,'2015','3.6.3.1.1.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3294,'2015','3.6.3.1.1.01.00','PERDAS INVOLUNTÁRIAS DE BENS MOVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3295,'2015','3.6.3.1.1.01.01','PERDAS INVOLUNTÁRIAS DE  MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3296,'2015','3.6.3.1.1.01.02','PERDAS INVOLUNTÁRIAS DE  BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3297,'2015','3.6.3.1.1.01.03','PERDAS INVOLUNTÁRIAS DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3298,'2015','3.6.3.1.1.01.04','PERDAS INVOLUNTÁRIAS DE  MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3299,'2015','3.6.3.1.1.01.05','PERDAS INVOLUNTÁRIAS DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3300,'2015','3.6.3.1.1.01.06','PERDAS INVOLUNTÁRIAS DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3301,'2015','3.6.3.1.1.01.07','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3302,'2015','3.6.3.1.1.01.08','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3303,'2015','3.6.3.1.1.01.09','PERDAS INVOLUNTÁRIAS DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3304,'2015','3.6.3.1.1.01.10','PERDAS INVOLUNTÁRIAS DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3305,'2015','3.6.3.1.1.01.99','PERDAS INVOLUNTÁRIAS DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3306,'2015','3.6.3.1.1.02.00','PERDAS INVOLUNTÁRIAS DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3307,'2015','3.6.3.2.0.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3308,'2015','3.6.3.2.1.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3309,'2015','3.6.3.2.1.01.00','PERDAS  INVOLUNTÁRIAS COM SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3310,'2015','3.6.3.2.1.02.00','PERDAS  INVOLUNTÁRIAS COM MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3311,'2015','3.6.3.2.1.03.00','PERDAS  INVOLUNTÁRIAS COM DIREITO DE USO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3312,'2015','3.6.3.3.0.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3313,'2015','3.6.3.3.1.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3314,'2015','3.6.3.3.1.01.00','PERDAS INVOLUNTÁRIAS COM  MERCADORIAS PARA REVENDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3315,'2015','3.6.3.3.1.02.00','PERDAS INVOLUNTÁRIAS COM  PRODUTOS E SERVIÇOS ACABADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3316,'2015','3.6.3.3.1.03.00','PERDAS INVOLUNTÁRIAS COM  PRODUTOS E SERVIÇOS EM ELABORAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3317,'2015','3.6.3.3.1.04.00','PERDAS INVOLUNTÁRIAS COM  MATÉRIAS-PRIMAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3318,'2015','3.6.3.3.1.05.00','PERDAS INVOLUNTÁRIAS COM  MATERIAIS EM TRÂNSITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3319,'2015','3.6.3.3.1.06.00','PERDAS INVOLUNTÁRIAS COM  ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3320,'2015','3.6.3.3.1.07.00','PERDAS INVOLUNTÁRIAS COM  ADIANTAMENTOS A FORNECEDORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3321,'2015','3.6.3.3.1.99.00','PERDAS INVOLUNTÁRIAS COM  OUTROS ESTOQUES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3322,'2015','3.6.3.9.0.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3323,'2015','3.6.3.9.1.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3324,'2015','3.6.4.0.0.00.00','INCORPORAÇÃO DE PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3325,'2015','3.6.4.0.1.00.00','INCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3326,'2015','3.6.5.0.0.00.00','DESINCORPORAÇÃO DE ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3327,'2015','3.6.5.0.1.00.00','DESINCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3328,'2015','3.7.0.0.0.00.00','TRIBUTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3329,'2015','3.7.1.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3330,'2015','3.7.1.1.0.00.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3331,'2015','3.7.1.1.1.00.00','IMPOSTOS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3332,'2015','3.7.1.1.1.01.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3333,'2015','3.7.1.1.1.02.00','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3334,'2015','3.7.1.1.1.03.00','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3335,'2015','3.7.1.1.1.04.00','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3336,'2015','3.7.1.1.1.05.00','IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3337,'2015','3.7.1.1.1.06.00','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3338,'2015','3.7.1.1.1.07.00','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3339,'2015','3.7.1.1.1.08.00','ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3340,'2015','3.7.1.1.1.09.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS - IPI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3341,'2015','3.7.1.1.1.10.00','IMPOSTO S/ OPERACOES FINANCEIRAS - IOF','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3342,'2015','3.7.1.1.1.11.00','IMPOSTO S/ IMPORTACAO - II','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3343,'2015','3.7.1.1.1.99.00','OUTROS IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3344,'2015','3.7.1.2.0.00.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3345,'2015','3.7.1.2.1.00.00','TAXAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3346,'2015','3.7.1.2.1.01.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3347,'2015','3.7.1.2.1.02.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3348,'2015','3.7.1.3.0.00.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3349,'2015','3.7.1.3.1.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3350,'2015','3.7.1.3.1.01.00','CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3351,'2015','3.7.2.0.0.00.00','CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3352,'2015','3.7.2.1.0.00.00','CONTRIBUIÇÕES SOCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3353,'2015','3.7.2.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3354,'2015','3.7.2.1.1.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS -','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3355,'2015','3.7.2.1.1.02.00','PIS/PASEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3356,'2015','3.7.2.1.1.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL -','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3357,'2015','3.7.2.1.1.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3358,'2015','3.7.2.1.1.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA -','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3359,'2015','3.7.2.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3360,'2015','3.7.2.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3361,'2015','3.7.2.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3362,'2015','3.7.2.1.3.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS -','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3363,'2015','3.7.2.1.3.02.00','PIS/PASEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3364,'2015','3.7.2.1.3.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL -','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3365,'2015','3.7.2.1.3.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3366,'2015','3.7.2.1.3.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA -','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3367,'2015','3.7.2.1.3.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3368,'2015','3.7.2.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3369,'2015','3.7.2.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3370,'2015','3.7.2.2.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3371,'2015','3.7.2.2.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3372,'2015','3.7.2.3.0.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3373,'2015','3.7.2.3.1.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3374,'2015','3.7.2.9.0.00.00','OUTRAS CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3375,'2015','3.7.2.9.1.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3376,'2015','3.7.2.9.1.01.00','CONTRIBUIÇÃO SINDICAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3377,'2015','3.7.2.9.1.99.00','DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3378,'2015','3.8.0.0.0.00.00','CUSTO DAS MERCADORIAS VENDIDAS, DOS PRODUTOS VENDIDOS E DOS SERVIÇOS PRESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3379,'2015','3.8.1.0.0.00.00','CUSTO DE MERCADORIAS VENDIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3380,'2015','3.8.1.0.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3381,'2015','3.8.1.0.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3382,'2015','3.8.1.0.3.00.00','CUSTO DE MERCADORIAS VENDIDAS -  INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3383,'2015','3.8.1.0.4.00.00','CUSTO DE MERCADORIAS VENDIDAS -  INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3384,'2015','3.8.1.0.5.00.00','CUSTO DE MERCADORIAS VENDIDAS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3385,'2015','3.8.2.0.0.00.00','CUSTO DE PRODUTOS VENDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3386,'2015','3.8.2.0.1.00.00','CUSTO DOS PRODUTOS VENDIDOS-CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3387,'2015','3.8.2.0.2.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3388,'2015','3.8.2.0.3.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTER OFSS UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3389,'2015','3.8.2.0.4.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTER OFSS ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3390,'2015','3.8.2.0.5.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTER OFSS MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3391,'2015','3.8.3.0.0.00.00','CUSTO DE SERVIÇOS PRESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3392,'2015','3.8.3.0.1.00.00','CUSTO DE SERVIÇOS PRESTADOS-CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3393,'2015','3.8.3.0.2.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3394,'2015','3.8.3.0.3.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTER OFSS UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3395,'2015','3.8.3.0.4.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTER OFSS ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3396,'2015','3.8.3.0.5.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTER OFSS MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3397,'2015','3.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3398,'2015','3.9.1.0.0.00.00','PREMIAÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3399,'2015','3.9.1.1.0.00.00','PREMIAÇÕES CULTURAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3400,'2015','3.9.1.1.1.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3401,'2015','3.9.1.2.0.00.00','PREMIAÇÕES ARTÍSTICAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3402,'2015','3.9.1.2.1.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3403,'2015','3.9.1.3.0.00.00','PREMIAÇÕES CIENTIFICAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3404,'2015','3.9.1.3.1.00.00','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3405,'2015','3.9.1.4.0.00.00','PREMIAÇÕES DESPORTIVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3406,'2015','3.9.1.4.1.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3407,'2015','3.9.1.5.0.00.00','ORDENS HONORIFICAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3408,'2015','3.9.1.5.1.00.00','ORDENS HONORIFICAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3409,'2015','3.9.1.9.0.00.00','OUTRAS PREMIAÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3410,'2015','3.9.1.9.1.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3411,'2015','3.9.2.0.0.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3412,'2015','3.9.2.1.0.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3413,'2015','3.9.2.1.1.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3414,'2015','3.9.2.1.2.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3415,'2015','3.9.2.1.3.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3416,'2015','3.9.2.1.4.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3417,'2015','3.9.2.1.5.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3418,'2015','3.9.4.0.0.00.00','INCENTIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3419,'2015','3.9.4.1.0.00.00','INCENTIVOS A EDUCAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3420,'2015','3.9.4.1.1.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3421,'2015','3.9.4.1.1.01.00','BOLSA DE ESTUDOS NO PAÍS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3422,'2015','3.9.4.1.1.02.00','BOLSA DE ESTUDOS NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3423,'2015','3.9.4.1.1.03.00','AUXÍLIOS PARA DESENV. DE ESTUDOS E PESQUISAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3424,'2015','3.9.4.1.1.99.00','OUTROS INCENTIVOS A EDUCAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3425,'2015','3.9.4.2.0.00.00','INCENTIVOS A CIÊNCIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3426,'2015','3.9.4.2.1.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3427,'2015','3.9.4.2.1.01.00','AUXÍLIO A PESQUISADORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3428,'2015','3.9.4.2.1.02.00','AUXÍLIO AS ATIVIDADES AUXILIARES DE PESQUISA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3429,'2015','3.9.4.2.1.99.00','OUTROS INCENTIVOS A CIÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3430,'2015','3.9.4.3.0.00.00','INCENTIVOS A CULTURA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3431,'2015','3.9.4.3.1.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3432,'2015','3.9.4.3.1.01.00','INCENTIVOS A CULTURA - PESSOAS FÍSICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3433,'2015','3.9.4.3.1.99.00','OUTROS INCENTIVOS A CULTURA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3434,'2015','3.9.4.4.0.00.00','INCENTIVOS AO ESPORTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3435,'2015','3.9.4.4.1.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3436,'2015','3.9.4.4.1.01.00','INCENTIVOS AO ESPORTE - PESSOAS FÍSICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3437,'2015','3.9.4.4.1.99.00','OUTROS INCENTIVOS AO ESPORTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3438,'2015','3.9.4.9.0.00.00','OUTROS INCENTIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3439,'2015','3.9.4.9.1.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3440,'2015','3.9.5.0.0.00.00','SUBVENÇÕES ECONÔMICAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3441,'2015','3.9.5.0.1.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3442,'2015','3.9.5.0.1.01.00','CORREÇÃO MONETÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3443,'2015','3.9.5.0.1.02.00','DIFERENCIAL DE JUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3444,'2015','3.9.5.0.1.03.00','PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3445,'2015','3.9.5.0.1.04.00','GARANTIA E SUSTENTAÇÃO DE PREÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3446,'2015','3.9.5.0.1.05.00','CUSTOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3447,'2015','3.9.5.0.1.06.00','CUSTEIO AGROPECUÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3448,'2015','3.9.5.0.1.07.00','SUBVENÇÃO ECONOMICA AO PREMIO DE SEGURO GARANTIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3449,'2015','3.9.5.0.1.08.00','AQUISIÇÃO E PRODUÇÃO DE BENS DE CAPITAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3450,'2015','3.9.5.0.1.99.00','OUTRAS SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3451,'2015','3.9.6.0.0.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3452,'2015','3.9.6.1.0.00.00','PARTICIPAÇÕES DE DEBÊNTURES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3453,'2015','3.9.6.1.1.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3454,'2015','3.9.6.2.0.00.00','PARTICIPAÇÕES DE EMPREGADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3455,'2015','3.9.6.2.1.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3456,'2015','3.9.6.3.0.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3457,'2015','3.9.6.3.1.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3458,'2015','3.9.6.4.0.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3459,'2015','3.9.6.4.1.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3460,'2015','3.9.6.5.0.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3461,'2015','3.9.6.5.1.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3462,'2015','3.9.7.0.0.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3463,'2015','3.9.7.1.0.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3464,'2015','3.9.7.1.1.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3465,'2015','3.9.7.2.0.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3466,'2015','3.9.7.2.1.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3467,'2015','3.9.7.3.0.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3468,'2015','3.9.7.3.1.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS – CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3469,'2015','3.9.7.4.0.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3470,'2015','3.9.7.4.1.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS – CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3471,'2015','3.9.7.5.0.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3472,'2015','3.9.7.5.5.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3473,'2015','3.9.7.6.0.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3474,'2015','3.9.7.6.1.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3475,'2015','3.9.7.9.0.00.00','VPD DE OUTRAS PROVISÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3476,'2015','3.9.7.9.1.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3477,'2015','3.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3478,'2015','3.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3479,'2015','3.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3480,'2015','3.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3481,'2015','3.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3482,'2015','3.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3483,'2015','3.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3484,'2015','3.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3485,'2015','3.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3486,'2015','3.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3487,'2015','3.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3488,'2015','3.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3489,'2015','3.9.9.4.0.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3490,'2015','3.9.9.4.1.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3491,'2015','3.9.9.4.2.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3492,'2015','3.9.9.4.3.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3493,'2015','3.9.9.4.4.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3494,'2015','3.9.9.4.5.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3495,'2015','3.9.9.6.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3496,'2015','3.9.9.6.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3497,'2015','3.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3498,'2015','3.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3499,'2015','3.9.9.9.1.01.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3500,'2015','3.9.9.9.1.02.00','HONRA DE AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3501,'2015','4.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3502,'2015','4.1.0.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3503,'2015','4.1.1.0.0.00.00','IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3504,'2015','4.1.1.1.0.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3505,'2015','4.1.1.1.1.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3506,'2015','4.1.1.2.0.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3507,'2015','4.1.1.2.1.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3508,'2015','4.1.1.2.1.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3509,'2015','4.1.1.2.1.02.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3510,'2015','4.1.1.2.1.03.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3511,'2015','4.1.1.2.1.03.01','IR - PESSOAS FISICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3512,'2015','4.1.1.2.1.03.02','IR - PESSOAS JURIDICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3513,'2015','4.1.1.2.1.04.00','ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3514,'2015','4.1.1.2.1.05.00','ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3515,'2015','4.1.1.2.1.06.00','IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3516,'2015','4.1.1.2.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3517,'2015','4.1.1.3.0.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3518,'2015','4.1.1.3.1.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3519,'2015','4.1.1.3.1.01.00','ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3520,'2015','4.1.1.3.1.02.00','ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3521,'2015','4.1.1.3.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3522,'2015','4.1.1.4.0.00.00','IMPOSTOS EXTRAORDINÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3523,'2015','4.1.1.4.1.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3524,'2015','4.1.1.9.0.00.00','OUTROS IMPOSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3525,'2015','4.1.1.9.1.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3526,'2015','4.1.2.0.0.00.00','TAXAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3527,'2015','4.1.2.1.0.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3528,'2015','4.1.2.1.1.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3529,'2015','4.1.2.1.1.11.00','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3530,'2015','4.1.2.1.1.11.01','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - SAÚDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3531,'2015','4.1.2.1.1.11.02','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - ANIMAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3532,'2015','4.1.2.1.1.14.00','TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3533,'2015','4.1.2.1.1.15.00','TAXA DE SERVIÇOS ADMINISTRATIVO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3534,'2015','4.1.2.1.1.15.01','ATOS DA ADMINISTRAÇÃO EM GERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3535,'2015','4.1.2.1.1.15.02','ATOS DA SAÚDE PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3536,'2015','4.1.2.1.1.70.00','TAXA DE PREVENÇÃO CONTRA SINISTRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3537,'2015','4.1.2.1.1.71.00','TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3538,'2015','4.1.2.1.1.72.00','TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3539,'2015','4.1.2.1.1.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3540,'2015','4.1.2.1.1.97.11','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3541,'2015','4.1.2.1.1.97.14','(-) DEDUÇÃO DA TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3542,'2015','4.1.2.1.1.97.15','(-) DEDUÇÃO TAXA DE SERVIÇOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3543,'2015','4.1.2.1.1.97.70','(-) DEDUÇÃO TAXA DE PREVENÇÃO CONTRA SINISTRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3544,'2015','4.1.2.1.1.97.71','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3545,'2015','4.1.2.1.1.97.72','(-) DEDUÇÃO TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3546,'2015','4.1.2.1.1.97.98','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3547,'2015','4.1.2.2.0.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3548,'2015','4.1.2.2.1.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3549,'2015','4.1.2.2.1.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3550,'2015','4.1.2.2.1.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3551,'2015','4.1.2.2.1.70.00','TAXA JUDICIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3552,'2015','4.1.2.2.1.71.00','TAXA DE SEGURANÇA CONTRA INCÊNDIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3553,'2015','4.1.2.2.1.72.00','TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3554,'2015','4.1.2.2.1.73.00','TAXA DE SEGURANÇA PREVENTIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3555,'2015','4.1.2.2.1.74.00','TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3556,'2015','4.1.2.2.1.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3557,'2015','4.1.2.2.1.97.07','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3558,'2015','4.1.2.2.1.97.09','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3559,'2015','4.1.2.2.1.97.70','(-) DEDUÇÃO TAXA JUDICIÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3560,'2015','4.1.2.2.1.97.71','(-) DEDUÇÃO TAXA DE SEGURANÇA CONTRA INCÊNDIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3561,'2015','4.1.2.2.1.97.72','(-) DEDUÇÃO TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3562,'2015','4.1.2.2.1.97.73','(-) DEDUÇÃO TAXA DE SEGURANÇA PREVENTIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3563,'2015','4.1.2.2.1.97.74','(-) DEDUÇÃO TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3564,'2015','4.1.2.2.1.97.98','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3565,'2015','4.1.2.2.1.99.00','OUTRAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3566,'2015','4.1.3.0.0.00.00','CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3567,'2015','4.1.3.1.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3568,'2015','4.1.3.1.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3569,'2015','4.1.3.1.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3570,'2015','4.1.3.1.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3571,'2015','4.1.3.2.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3572,'2015','4.1.3.2.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3573,'2015','4.1.3.2.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3574,'2015','4.1.3.2.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3575,'2015','4.1.3.3.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3576,'2015','4.1.3.3.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3577,'2015','4.1.3.3.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3578,'2015','4.1.3.3.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3579,'2015','4.1.3.4.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3580,'2015','4.1.3.4.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3581,'2015','4.1.3.4.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3582,'2015','4.1.3.4.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3583,'2015','4.1.3.9.0.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3584,'2015','4.1.3.9.1.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3585,'2015','4.1.3.9.1.01.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3586,'2015','4.1.3.9.1.97.00','(-) DEDUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3587,'2015','4.2.0.0.0.00.00','CONTRIBUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3588,'2015','4.2.1.0.0.00.00','CONTRIBUIÇÕES SOCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3589,'2015','4.2.1.1.0.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3590,'2015','4.2.1.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3591,'2015','4.2.1.1.1.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3592,'2015','4.2.1.1.1.01.01','CONTRIB. PATRONAL DE SERVIDOR CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3593,'2015','4.2.1.1.1.01.02','CONTR.PATRONAL - PAGAMENTO DE SENTENCAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3594,'2015','4.2.1.1.1.02.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3595,'2015','4.2.1.1.1.02.01','CONTRIBUICAO DO SERVIDOR CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3596,'2015','4.2.1.1.1.02.02','CONTRIBUICAO DO  APOSENTADO CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3597,'2015','4.2.1.1.1.02.03','CONTRIBUICAO DE PENSIONISTA CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3598,'2015','4.2.1.1.1.02.04','CONTR.SERV. CIVIL-PAGTO SENT. JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3599,'2015','4.2.1.1.1.02.05','CONTR. APOSENTADO CIVIL - PAGTO SENT. JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3600,'2015','4.2.1.1.1.02.06','CONTR.PENSIONISTA CIVIL-PAGTO SENT. JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3601,'2015','4.2.1.1.1.03.00','CONTRIBUIÇÃO PREVIDENCIÁRIA PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3602,'2015','4.2.1.1.1.04.00','CONTRIBUIÇÕES PARA CUSTEIO DAS PENSÕES MILITARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3603,'2015','4.2.1.1.1.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3604,'2015','4.2.1.1.1.97.01','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3605,'2015','4.2.1.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3606,'2015','4.2.1.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3607,'2015','4.2.1.1.2.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3608,'2015','4.2.1.1.2.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3609,'2015','4.2.1.1.2.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3610,'2015','4.2.1.1.2.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3611,'2015','4.2.1.1.2.97.01','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3612,'2015','4.2.1.1.2.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3613,'2015','4.2.1.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS – UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3614,'2015','4.2.1.1.3.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3615,'2015','4.2.1.1.3.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3616,'2015','4.2.1.1.3.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3617,'2015','4.2.1.1.3.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3618,'2015','4.2.1.1.3.97.01','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3619,'2015','4.2.1.1.3.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3620,'2015','4.2.1.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3621,'2015','4.2.1.1.4.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3622,'2015','4.2.1.1.4.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3623,'2015','4.2.1.1.4.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3624,'2015','4.2.1.1.4.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3625,'2015','4.2.1.1.4.97.01','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3626,'2015','4.2.1.1.4.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3627,'2015','4.2.1.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3628,'2015','4.2.1.1.5.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3629,'2015','4.2.1.1.5.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3630,'2015','4.2.1.1.5.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3631,'2015','4.2.1.1.5.97.00','(-) DEDUÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3632,'2015','4.2.1.1.5.97.01','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3633,'2015','4.2.1.1.5.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3634,'2015','4.2.1.2.0.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3635,'2015','4.2.1.2.1.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3636,'2015','4.2.1.2.2.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3637,'2015','4.2.1.2.3.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3638,'2015','4.2.1.2.4.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3639,'2015','4.2.1.2.5.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3640,'2015','4.2.1.3.0.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3641,'2015','4.2.1.3.1.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3642,'2015','4.2.1.4.0.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3643,'2015','4.2.1.4.1.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3644,'2015','4.2.1.5.0.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3645,'2015','4.2.1.5.1.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3646,'2015','4.2.1.6.0.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3647,'2015','4.2.1.6.1.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3648,'2015','4.2.1.9.0.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3649,'2015','4.2.1.9.1.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3650,'2015','4.2.2.0.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3651,'2015','4.2.2.0.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3652,'2015','4.2.3.0.0.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3653,'2015','4.2.3.0.1.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3654,'2015','4.2.3.0.1.01.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3655,'2015','4.2.4.0.0.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3656,'2015','4.2.4.0.1.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3657,'2015','4.3.0.0.0.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3658,'2015','4.3.1.0.0.00.00','VENDA DE MERCADORIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3659,'2015','4.3.1.1.0.00.00','VENDA BRUTA DE MERCADORIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3660,'2015','4.3.1.1.1.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3661,'2015','4.3.1.1.1.01.00','VENDA DE ESTOQUE PRÓPRIO - PAÍS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3662,'2015','4.3.1.1.1.11.00','VENDA DE ESTOQUE DE PRODUÇÃO VEGETAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3663,'2015','4.3.1.1.1.11.01','AGRICULTURA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3664,'2015','4.3.1.1.1.11.02','HORTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3665,'2015','4.3.1.1.1.11.03','POMAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3666,'2015','4.3.1.1.1.11.99','OUTRAS VPAS DE PRODUÇÃO VEGETAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3667,'2015','4.3.1.1.1.12.00','VENDA DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3668,'2015','4.3.1.1.1.12.01','GRANJA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3669,'2015','4.3.1.1.1.12.02','PISCICULTURA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3670,'2015','4.3.1.1.1.12.03','PECUÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3671,'2015','4.3.1.1.1.12.04','APICULTURA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3672,'2015','4.3.1.1.1.12.05','SUINOCULTURA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3673,'2015','4.3.1.1.1.12.06','OVINOCULTURA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3674,'2015','4.3.1.1.1.12.07','COELHOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3675,'2015','4.3.1.1.1.12.08','GADO LEITEIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3676,'2015','4.3.1.1.1.12.09','EQÜINOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3677,'2015','4.3.1.1.1.12.10','AVÍCOLA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3678,'2015','4.3.1.1.1.12.99','OUTRAS VPAS DE PRODUÇÃO ANIMAL E DERIVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3679,'2015','4.3.1.1.1.13.00','VENDA DE MEDICAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3680,'2015','4.3.1.1.1.14.00','VENDA DE LIVROS PERIOD. MAT. ESC. E PUBLICID.','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3681,'2015','4.3.1.1.1.14.01','VENDA DE LIVROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3682,'2015','4.3.1.1.1.14.02','PUBLICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3683,'2015','4.3.1.1.1.14.03','VENDAS REVISTA RAC','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3684,'2015','4.3.1.1.1.14.04','PUBLICAÇÕES TÉCNICAS EPAGRI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3685,'2015','4.3.1.1.1.14.05','DIVULGAÇÃO E PUBLICIDADE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3686,'2015','4.3.1.1.1.15.00','VENDA DE PRODUTOS AGROPECUÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3687,'2015','4.3.1.1.1.15.99','OUTRAS VPAS AGROPECUÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3688,'2015','4.3.1.1.1.16.00','VENDA DE FARDAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3689,'2015','4.3.1.9.0.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3690,'2015','4.3.1.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3691,'2015','4.3.1.9.1.97.00','(-) DEDUÇÕES DE VENDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3692,'2015','4.3.1.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3693,'2015','4.3.1.9.1.97.02','(-) ABATIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3694,'2015','4.3.1.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3695,'2015','4.3.1.9.1.97.05','(-) ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3696,'2015','4.3.1.9.1.97.06','(-) PIS/PASEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3697,'2015','4.3.1.9.1.97.07','(-) COFINS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3698,'2015','4.3.1.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3699,'2015','4.3.1.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3700,'2015','4.3.2.0.0.00.00','VENDA DE PRODUTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3701,'2015','4.3.2.1.0.00.00','VENDA BRUTA DE PRODUTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3702,'2015','4.3.2.1.1.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3703,'2015','4.3.2.9.0.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3704,'2015','4.3.2.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3705,'2015','4.3.2.9.1.97.00','(-) DEDUÇÕES DE VENDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3706,'2015','4.3.2.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3707,'2015','4.3.2.9.1.97.02','(-) ABATIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3708,'2015','4.3.2.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3709,'2015','4.3.2.9.1.97.04','(-)IPI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3710,'2015','4.3.2.9.1.97.05','(-) ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3711,'2015','4.3.2.9.1.97.06','(-) PIS/PASEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3712,'2015','4.3.2.9.1.97.07','(-) COFINS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3713,'2015','4.3.2.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3714,'2015','4.3.2.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3715,'2015','4.3.3.0.0.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3716,'2015','4.3.3.1.0.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3717,'2015','4.3.3.1.1.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3718,'2015','4.3.3.1.1.01.00','PRESTACAO DE SERVICOS DE TREINAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3719,'2015','4.3.3.1.1.02.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3720,'2015','4.3.3.1.1.03.00','PRESTACAO DE SERVICOS DE LOCACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3721,'2015','4.3.3.1.1.04.00','PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3722,'2015','4.3.3.1.1.05.00','SERVICOS DE ESTUDOS E PESQUISAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3723,'2015','4.3.3.1.1.06.00','PRESTACAO DE SERVICOS DE CONSULTORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3724,'2015','4.3.3.1.1.07.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3725,'2015','4.3.3.1.1.08.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3726,'2015','4.3.3.1.1.09.00','PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3727,'2015','4.3.3.1.1.10.00','SERVICOS DE PROCESSAMENTO DE DADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3728,'2015','4.3.3.1.1.11.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3729,'2015','4.3.3.1.1.12.00','PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3730,'2015','4.3.3.1.1.13.00','SERVICOS DE TECNOLOGIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3731,'2015','4.3.3.1.1.14.00','SERVICOS DE COMUNICACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3732,'2015','4.3.3.1.1.15.00','PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3733,'2015','4.3.3.1.1.16.00','PRESTACAO DE SERVICOS COMPLEMENTARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3734,'2015','4.3.3.1.1.17.00','PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3735,'2015','4.3.3.1.1.18.00','PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3736,'2015','4.3.3.1.1.19.00','PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3737,'2015','4.3.3.1.1.20.00','FORNECIMENTO DE MAO-DE-OBRA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3738,'2015','4.3.3.1.1.21.00','PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3739,'2015','4.3.3.1.1.22.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3740,'2015','4.3.3.1.1.23.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3741,'2015','4.3.3.1.1.24.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3742,'2015','4.3.3.1.1.25.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3743,'2015','4.3.3.1.1.26.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3744,'2015','4.3.3.1.1.27.00','CONCESSAO FLORESTAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3745,'2015','4.3.3.1.1.28.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3746,'2015','4.3.3.1.1.29.00','COMPENSACOES FINANCEIRAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3747,'2015','4.3.3.1.1.30.00','SERVICOS DE TRANSPORTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3748,'2015','4.3.3.1.1.31.00','SERVICOS PORTUARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3749,'2015','4.3.3.1.1.32.00','SERVICOS DE SOCORRO MARITIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3750,'2015','4.3.3.1.1.33.00','SERVICOS DE SAUDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3751,'2015','4.3.3.1.1.34.00','CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3752,'2015','4.3.3.1.1.35.00','SERVICOS DE METROLOGIA E CERTIFICACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3753,'2015','4.3.3.1.1.36.00','SERVICOS DE INSPECAO E FISCALIZACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3754,'2015','4.3.3.1.1.37.00','SERVICOS ADMINISTRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3755,'2015','4.3.3.1.1.38.00','SERVICOS DE METEOROLOGIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3756,'2015','4.3.3.1.1.39.00','SERVICOS EDUCACIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3757,'2015','4.3.3.1.1.40.00','SERVICOS AGROPECUARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3758,'2015','4.3.3.1.1.41.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3759,'2015','4.3.3.1.1.42.00','SERVICOS RECREATIVOS E CULTURAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3760,'2015','4.3.3.1.1.43.00','SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3761,'2015','4.3.3.1.1.44.00','SERVICOS DE REGISTRO DO COMERCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3762,'2015','4.3.3.1.1.45.00','SERVICOS DE FORNECIMENTO DE AGUA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3763,'2015','4.3.3.1.1.46.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3764,'2015','4.3.3.1.1.47.00','SERVICOS DE GEOPROCESSAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3765,'2015','4.3.3.1.1.48.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3766,'2015','4.3.3.1.1.49.00','TARIFA DE UTILIZACAO DE FAROIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3767,'2015','4.3.3.1.1.50.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3768,'2015','4.3.3.1.1.51.00','SERVICOS DE CADASTRO DA ATIVIDADE MINERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3769,'2015','4.3.3.1.1.52.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3770,'2015','4.3.3.1.1.53.00','SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3771,'2015','4.3.3.1.1.54.00','GARANTIAS E AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3772,'2015','4.3.3.1.1.55.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3773,'2015','4.3.3.1.1.56.00','SERVICOS VETERINARIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3774,'2015','4.3.3.1.1.57.00','CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3775,'2015','4.3.3.1.1.58.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3776,'2015','4.3.3.1.1.59.00','SERVICOS FINANCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3777,'2015','4.3.3.1.1.60.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3778,'2015','4.3.3.1.1.61.00','SERVIÇOS DE TURISMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3779,'2015','4.3.3.1.1.99.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3780,'2015','4.3.3.9.0.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3781,'2015','4.3.3.9.1.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3782,'2015','4.3.3.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3783,'2015','4.3.3.9.1.02.00','(-) ABATIMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3784,'2015','4.3.3.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3785,'2015','4.3.3.9.1.05.00','(-) ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3786,'2015','4.3.3.9.1.06.00','(-) ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3787,'2015','4.3.3.9.1.07.00','(-) PIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3788,'2015','4.3.3.9.1.08.00','(-) PASEP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3789,'2015','4.3.3.9.1.09.00','(-) COFINS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3790,'2015','4.3.3.9.1.10.00','(-) CONTRIBUIÇÕES PREVIDENCIARIAS - INSS PATRONAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3791,'2015','4.3.3.9.1.99.00','(-) OUTRAS DEDUCOES DE VENDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3792,'2015','4.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3793,'2015','4.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3794,'2015','4.4.1.1.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3795,'2015','4.4.1.1.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3796,'2015','4.4.1.1.3.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3797,'2015','4.4.1.1.4.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3798,'2015','4.4.1.1.5.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3799,'2015','4.4.1.2.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3800,'2015','4.4.1.2.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3801,'2015','4.4.1.3.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3802,'2015','4.4.1.3.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3803,'2015','4.4.1.3.3.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3804,'2015','4.4.1.3.4.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3805,'2015','4.4.1.3.5.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3806,'2015','4.4.1.4.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3807,'2015','4.4.1.4.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3808,'2015','4.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3809,'2015','4.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3810,'2015','4.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3811,'2015','4.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3812,'2015','4.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3813,'2015','4.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3814,'2015','4.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3815,'2015','4.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3816,'2015','4.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3817,'2015','4.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3818,'2015','4.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3819,'2015','4.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3820,'2015','4.4.2.4.1.01.00','MULTAS E JUROS SOBRE IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3821,'2015','4.4.2.4.1.02.00','MULTAS E JUROS SOBRE IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3822,'2015','4.4.2.4.1.03.00','MULTAS E JUROS SOBRE ITCMD','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3823,'2015','4.4.2.4.1.04.00','MULTAS E JUROS SOBRE ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3824,'2015','4.4.2.4.1.05.00','MULTAS E JUROS SOBRE IPTU','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3825,'2015','4.4.2.4.1.06.00','MULTAS E JUROS SOBRE ITBI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3826,'2015','4.4.2.4.1.07.00','MULTAS E JUROS SOBRE ISS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3827,'2015','4.4.2.4.1.08.00','MULTAS E JUROS SOBRE ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3828,'2015','4.4.2.4.1.09.00','MULTAS E JUROSTAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3829,'2015','4.4.2.4.1.10.00','MULTAS E JUROS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3830,'2015','4.4.2.4.1.11.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3831,'2015','4.4.2.4.1.12.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3832,'2015','4.4.2.4.1.13.00','MULTAS E JUROS DEMAIS CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3833,'2015','4.4.2.4.1.14.00','MULTAS E JUROS CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3834,'2015','4.4.2.4.1.15.00','MULTAS E JUROS CRÉDITOS TRIBUTARIOS PARCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3835,'2015','4.4.2.4.1.16.00','MULTAS E JUROS DE DÍVIDA ATIVA TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3836,'2015','4.4.2.4.1.97.00','(-) DEDUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3837,'2015','4.4.2.4.1.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CRÉDITOS TRIBUTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3838,'2015','4.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3839,'2015','4.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3840,'2015','4.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3841,'2015','4.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3842,'2015','4.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3843,'2015','4.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3844,'2015','4.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3845,'2015','4.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3846,'2015','4.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3847,'2015','4.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3848,'2015','4.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3849,'2015','4.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3850,'2015','4.4.3.3.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3851,'2015','4.4.3.3.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3852,'2015','4.4.3.3.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3853,'2015','4.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3854,'2015','4.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3855,'2015','4.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3856,'2015','4.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3857,'2015','4.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3858,'2015','4.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3859,'2015','4.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3860,'2015','4.4.4.0.0.00.00','DESCONTOS FINANCEIROS OBTIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3861,'2015','4.4.4.0.1.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3862,'2015','4.4.5.0.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3863,'2015','4.4.5.1.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3864,'2015','4.4.5.1.1.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3865,'2015','4.4.5.2.0.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3866,'2015','4.4.5.2.1.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3867,'2015','4.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3868,'2015','4.4.9.0.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3869,'2015','4.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3870,'2015','4.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3871,'2015','4.5.1.1.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3872,'2015','4.5.1.1.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3873,'2015','4.5.1.1.2.01.00','COTA RECEBIDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3874,'2015','4.5.1.1.2.02.00','REPASSE RECEBIDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3875,'2015','4.5.1.1.2.04.00','RECURSOS ARRECADADOS - RECEBIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3876,'2015','4.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3877,'2015','4.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3878,'2015','4.5.1.1.2.09.00','DEVOLUÇÃO DE TRANSFERÊNCIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3879,'2015','4.5.1.2.0.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3880,'2015','4.5.1.2.2.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3881,'2015','4.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3882,'2015','4.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS RECEBIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3883,'2015','4.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITO - SALDOS NAO FINANCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3884,'2015','4.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITOS - SALDOS FINANCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3885,'2015','4.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3886,'2015','4.5.1.2.2.02.00','TRANSFERÊNCIAS  NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3887,'2015','4.5.1.2.2.02.01','TRANSFERÊNCIAS RECEBIDAS DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3888,'2015','4.5.1.2.2.02.02','DOAÇÕES RECEBIDAS DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3889,'2015','4.5.1.2.2.02.03','TRANFERÊNCIAS RECEBIDAS DE BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3890,'2015','4.5.1.2.2.02.04','DOAÇÕES RECEBIDAS DE BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3891,'2015','4.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3892,'2015','4.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3893,'2015','4.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS  NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3894,'2015','4.5.1.2.2.09.00','DEVOLUÇÃO DE TRANSFERÊNCIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3895,'2015','4.5.1.3.0.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3896,'2015','4.5.1.3.2.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3897,'2015','4.5.1.3.2.01.00','PLANO FINANCEIRO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3898,'2015','4.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3899,'2015','4.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3900,'2015','4.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3901,'2015','4.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3902,'2015','4.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3903,'2015','4.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3904,'2015','4.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3905,'2015','4.5.1.4.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3906,'2015','4.5.1.4.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS  – INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3907,'2015','4.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3908,'2015','4.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3909,'2015','4.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3910,'2015','4.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3911,'2015','4.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3912,'2015','4.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3913,'2015','4.5.2.1.0.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3914,'2015','4.5.2.1.1.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS  DE RECEITAS- CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3915,'2015','4.5.2.1.3.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS – UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3916,'2015','4.5.2.1.3.01.00','COTA-PARTE FPE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3917,'2015','4.5.2.1.3.02.00','COTA-PARTE FPM','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3918,'2015','4.5.2.1.3.03.00','COTA-PARTE ITR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3919,'2015','4.5.2.1.3.04.00','COTA-PARTE IPI','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3920,'2015','4.5.2.1.3.05.00','COTA-PARTE IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, OU RELATIVA A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZAÇÃO DO OURO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3921,'2015','4.5.2.1.3.06.00','TRANSFERENCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3922,'2015','4.5.2.1.3.07.00','TRANSFERÊNCIAS DE RECURSOS DO SUS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3923,'2015','4.5.2.1.3.08.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSITENCIA SOCIAL - FNAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3924,'2015','4.5.2.1.3.09.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3925,'2015','4.5.2.1.3.10.00','TRANSFERENCIA FINANCEIRA DO ICMS DESONERAÇÃO - LC 87/96 (LEI KANDIR)','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3926,'2015','4.5.2.1.3.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DA UNIÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3927,'2015','4.5.2.1.4.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3928,'2015','4.5.2.1.4.01.00','COTA-PARTE ICMS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3929,'2015','4.5.2.1.4.02.00','COTA-PARTE IPVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3930,'2015','4.5.2.1.4.03.00','COTA-PARTE IPI-EXPORTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3931,'2015','4.5.2.1.4.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3932,'2015','4.5.2.1.4.05.00','TRANSFERÊNCIA DA  COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3933,'2015','4.5.2.1.4.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE – REPASSE FUNDO A FUNDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3934,'2015','4.5.2.1.4.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DOS ESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3935,'2015','4.5.2.2.0.00.00','TRANSFERÊNCIAS DO FUNDEB','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3936,'2015','4.5.2.2.3.00.00','TRANSFERÊNCIAS DO FUNDEB  - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3937,'2015','4.5.2.2.4.00.00','TRANSFERÊNCIAS DO FUNDEB  - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3938,'2015','4.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3939,'2015','4.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3940,'2015','4.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3941,'2015','4.5.2.3.3.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3942,'2015','4.5.2.3.3.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3943,'2015','4.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3944,'2015','4.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3945,'2015','4.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3946,'2015','4.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3947,'2015','4.5.2.3.4.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3948,'2015','4.5.2.3.4.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3949,'2015','4.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3950,'2015','4.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3951,'2015','4.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3952,'2015','4.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3953,'2015','4.5.2.3.5.01.00','CONTRIBUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3954,'2015','4.5.2.3.5.02.00','AUXÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3955,'2015','4.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3956,'2015','4.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3957,'2015','4.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3958,'2015','4.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3959,'2015','4.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3960,'2015','4.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3961,'2015','4.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3962,'2015','4.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3963,'2015','4.5.3.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3964,'2015','4.5.3.1.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3965,'2015','4.5.3.1.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3966,'2015','4.5.3.1.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3967,'2015','4.5.3.1.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3968,'2015','4.5.3.1.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3969,'2015','4.5.3.2.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3970,'2015','4.5.3.2.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3971,'2015','4.5.3.2.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3972,'2015','4.5.3.2.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3973,'2015','4.5.3.2.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3974,'2015','4.5.4.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3975,'2015','4.5.4.0.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3976,'2015','4.5.4.0.1.01.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3977,'2015','4.5.4.0.1.02.00','TRANSFERÊNCIAS DE RECURSOS DA COMPLEMENTAÇÃO DO FUNDEB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3978,'2015','4.5.4.0.1.99.00','OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3979,'2015','4.5.5.0.0.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3980,'2015','4.5.5.0.1.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3981,'2015','4.5.6.0.0.00.00','TRANSFERÊNCIAS DO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3982,'2015','4.5.6.0.1.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3983,'2015','4.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3984,'2015','4.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3985,'2015','4.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3986,'2015','4.5.7.1.3.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3987,'2015','4.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3988,'2015','4.5.7.1.3.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3989,'2015','4.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3990,'2015','4.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3991,'2015','4.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3992,'2015','4.5.7.1.3.99.00','DEMAIS VPAS COM DELEGAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3993,'2015','4.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3994,'2015','4.5.7.1.4.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3995,'2015','4.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3996,'2015','4.5.7.1.4.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3997,'2015','4.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3998,'2015','4.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (3999,'2015','4.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4000,'2015','4.5.7.1.4.99.00','DEMAIS VPAS COM DELEGAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4001,'2015','4.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4002,'2015','4.5.7.1.5.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4003,'2015','4.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4004,'2015','4.5.7.1.5.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4005,'2015','4.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4006,'2015','4.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4007,'2015','4.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4008,'2015','4.5.7.1.5.99.00','DEMAIS VPAS COM DELEGAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4009,'2015','4.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4010,'2015','4.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4011,'2015','4.5.7.2.1.01.00','DIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4012,'2015','4.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4013,'2015','4.5.7.2.1.03.00','MATERIAL DE CONSUMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4014,'2015','4.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4015,'2015','4.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4016,'2015','4.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4017,'2015','4.5.7.2.1.99.00','DEMAIS VPAS COM DELEGAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4018,'2015','4.5.8.0.0.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4019,'2015','4.5.8.0.1.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4020,'2015','4.5.9.0.0.00.00','OUTRAS TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4021,'2015','4.5.9.0.1.00.00','OUTRAS TRANSFERÊNCIAS RECEBIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4022,'2015','4.5.9.0.1.01.00','DOAÇÕES RECEBIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4023,'2015','4.6.0.0.0.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS E DESINCORPORAÇÃO DE PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4024,'2015','4.6.1.0.0.00.00','REAVALIAÇÃO DE ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4025,'2015','4.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4026,'2015','4.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4027,'2015','4.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4028,'2015','4.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4029,'2015','4.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4030,'2015','4.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4031,'2015','4.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4032,'2015','4.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4033,'2015','4.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4034,'2015','4.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4035,'2015','4.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4036,'2015','4.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4037,'2015','4.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4038,'2015','4.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4039,'2015','4.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4040,'2015','4.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4041,'2015','4.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4042,'2015','4.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4043,'2015','4.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4044,'2015','4.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4045,'2015','4.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4046,'2015','4.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4047,'2015','4.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4048,'2015','4.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4049,'2015','4.6.1.9.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4050,'2015','4.6.1.9.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4051,'2015','4.6.2.0.0.00.00','GANHOS COM ALIENAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4052,'2015','4.6.2.1.0.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4053,'2015','4.6.2.1.1.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4054,'2015','4.6.2.1.1.01.00','GANHOS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4055,'2015','4.6.2.1.1.02.00','GANHOS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4056,'2015','4.6.2.1.1.03.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4057,'2015','4.6.2.1.1.99.00','GANHOS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4058,'2015','4.6.2.2.0.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4059,'2015','4.6.2.2.1.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4060,'2015','4.6.2.2.1.01.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4061,'2015','4.6.2.2.1.01.01','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4062,'2015','4.6.2.2.1.01.02','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4063,'2015','4.6.2.2.1.01.03','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4064,'2015','4.6.2.2.1.01.04','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4065,'2015','4.6.2.2.1.01.05','GANHO LÍQUIDO COM A ALIENAÇÃO DE  VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4066,'2015','4.6.2.2.1.01.07','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4067,'2015','4.6.2.2.1.01.08','GANHO LÍQUIDO COM A ALIENAÇÃO DE  BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4068,'2015','4.6.2.2.1.01.09','GANHO LÍQUIDO COM A ALIENAÇÃO DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4069,'2015','4.6.2.2.1.01.10','GANHO LÍQUIDO COM A ALIENAÇÃO DE  SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4070,'2015','4.6.2.2.1.01.99','GANHO LÍQUIDO COM A ALIENAÇÃO DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4071,'2015','4.6.2.2.1.02.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4072,'2015','4.6.2.2.1.02.01','PRODUTO DE ALIENAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4073,'2015','4.6.2.2.1.02.02','ALIENAÇÃO DE IMÓVEIS RURAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4074,'2015','4.6.2.2.1.02.03','ALIENAÇÃO DE IMÓVEIS URBANOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4075,'2015','4.6.2.2.1.02.99','ALIENAÇÃO DE OUTROS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4076,'2015','4.6.2.2.1.97.00','(-) DEDUÇÃO DOS GANHOS COM ALIENAÇÃO DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4077,'2015','4.6.2.2.1.97.01','(-) DEDUÇÃO ALIENAÇÃO DE BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4078,'2015','4.6.2.2.1.97.02','(-) DEDUÇÃO ALIENAÇÃO DE BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4079,'2015','4.6.2.3.0.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4080,'2015','4.6.2.3.1.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4081,'2015','4.6.2.3.1.01.00','GANHOS COM ALIENAÇÃO DE SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4082,'2015','4.6.2.3.1.02.00','GANHOS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4083,'2015','4.6.2.3.1.03.00','GANHOS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4084,'2015','4.6.2.9.0.00.00','GANHOS COM ALIENAÇÃO DE DEMAIS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4085,'2015','4.6.2.9.1.00.00','GANHOS COM ALIENAÇÃO DE DEMAIS ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4086,'2015','4.6.3.0.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4087,'2015','4.6.3.1.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4088,'2015','4.6.3.1.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4089,'2015','4.6.3.2.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4090,'2015','4.6.3.2.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4091,'2015','4.6.3.3.0.00.00','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4092,'2015','4.6.3.3.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4093,'2015','4.6.3.9.0.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4094,'2015','4.6.3.9.1.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4095,'2015','4.6.4.0.0.00.00','DESINCORPORAÇÃO DE PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4096,'2015','4.6.4.0.1.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4097,'2015','4.6.5.0.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4098,'2015','4.6.5.1.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4099,'2015','4.6.5.1.1.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4100,'2015','4.6.5.1.1.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4101,'2015','4.6.5.1.1.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4102,'2015','4.6.5.1.1.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4103,'2015','4.6.5.1.1.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4104,'2015','4.6.5.1.2.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4105,'2015','4.6.5.1.2.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4106,'2015','4.6.5.1.2.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4107,'2015','4.6.5.1.2.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4108,'2015','4.6.5.1.2.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4109,'2015','4.6.5.1.3.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4110,'2015','4.6.5.1.3.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4111,'2015','4.6.5.1.3.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4112,'2015','4.6.5.1.3.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4113,'2015','4.6.5.1.3.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4114,'2015','4.6.5.1.4.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4115,'2015','4.6.5.1.4.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4116,'2015','4.6.5.1.4.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4117,'2015','4.6.5.1.4.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4118,'2015','4.6.5.1.4.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4119,'2015','4.6.5.1.5.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4120,'2015','4.6.5.1.5.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4121,'2015','4.6.5.1.5.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4122,'2015','4.6.5.1.5.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4123,'2015','4.6.5.1.5.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4124,'2015','4.6.5.2.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4125,'2015','4.6.5.2.1.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4126,'2015','4.6.5.2.1.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4127,'2015','4.6.5.2.1.01.01','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4128,'2015','4.6.5.2.1.01.02','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4129,'2015','4.6.5.2.1.01.03','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4130,'2015','4.6.5.2.1.01.04','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4131,'2015','4.6.5.2.1.01.05','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4132,'2015','4.6.5.2.1.01.06','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4133,'2015','4.6.5.2.1.01.07','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4134,'2015','4.6.5.2.1.01.08','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4135,'2015','4.6.5.2.1.01.09','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4136,'2015','4.6.5.2.1.01.10','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4137,'2015','4.6.5.2.1.01.99','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4138,'2015','4.6.5.2.1.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4139,'2015','4.6.5.2.1.02.01','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4140,'2015','4.6.5.2.1.02.02','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4141,'2015','4.6.5.2.1.02.03','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4142,'2015','4.6.5.2.1.02.04','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4143,'2015','4.6.5.2.1.02.05','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4144,'2015','4.6.5.2.1.02.06','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4145,'2015','4.6.5.2.1.02.99','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4146,'2015','4.6.5.3.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4147,'2015','4.6.5.3.1.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4148,'2015','4.6.5.3.1.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4149,'2015','4.6.5.3.1.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATÉNTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4150,'2015','4.6.5.3.1.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4151,'2015','4.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4152,'2015','4.9.1.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4153,'2015','4.9.1.0.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4154,'2015','4.9.1.0.1.01.00','VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4155,'2015','4.9.1.0.1.99.00','(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4156,'2015','4.9.2.0.0.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4157,'2015','4.9.2.1.0.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4158,'2015','4.9.2.1.1.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4159,'2015','4.9.2.1.2.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4160,'2015','4.9.2.1.3.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4161,'2015','4.9.2.1.4.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4162,'2015','4.9.2.1.5.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4163,'2015','4.9.2.2.0.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4164,'2015','4.9.2.2.1.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4165,'2015','4.9.7.0.0.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4166,'2015','4.9.7.1.0.00.00','REVERSÃO DE PROVISÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4167,'2015','4.9.7.1.1.00.00','REVERSÃO DE PROVISÕES – CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4168,'2015','4.9.7.1.1.01.00','REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4169,'2015','4.9.7.1.1.02.00','REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4170,'2015','4.9.7.1.1.03.00','REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4171,'2015','4.9.7.1.1.04.00','REVERSÃO DE PROVISÕES PARA RISCOS CÍVEIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4172,'2015','4.9.7.1.1.05.00','REVERSÃO DE PROVISÕES REPARTIÇÃO DE CRÉDITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4173,'2015','4.9.7.1.1.06.00','REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4174,'2015','4.9.7.1.1.99.00','REVERSÃO DE OUTRAS PROVISÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4175,'2015','4.9.7.1.3.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4176,'2015','4.9.7.1.4.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - ESTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4177,'2015','4.9.7.1.5.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - MUNICÍPIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4178,'2015','4.9.7.2.0.00.00','REVERSÃO DE AJUSTES DE PERDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4179,'2015','4.9.7.2.1.00.00','REVERSÃO DE AJUSTES DE PERDAS – CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4180,'2015','4.9.7.2.1.01.00','REVERSÃO DE AJUSTES DE PERDAS DE CRÉDITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4181,'2015','4.9.7.2.1.02.00','REVERSÃO DE AJUSTES DE PERDAS DE ESTOQUES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4182,'2015','4.9.7.2.1.03.00','REVERSÃO DE AJUSTES DE INVESTIMENTOS E APLICAÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4183,'2015','4.9.7.2.2.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4184,'2015','4.9.7.2.3.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4185,'2015','4.9.7.2.4.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4186,'2015','4.9.7.2.5.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4187,'2015','4.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4188,'2015','4.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4189,'2015','4.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4190,'2015','4.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4191,'2015','4.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4192,'2015','4.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4193,'2015','4.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4194,'2015','4.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4195,'2015','4.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4196,'2015','4.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4197,'2015','4.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4198,'2015','4.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4199,'2015','4.9.9.4.0.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4200,'2015','4.9.9.4.1.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4201,'2015','4.9.9.4.2.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4202,'2015','4.9.9.4.3.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4203,'2015','4.9.9.4.4.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4204,'2015','4.9.9.4.5.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4205,'2015','4.9.9.5.0.00.00','MULTAS ADMINISTRATIVAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4206,'2015','4.9.9.5.1.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4207,'2015','4.9.9.6.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4208,'2015','4.9.9.6.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4209,'2015','4.9.9.6.1.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4210,'2015','4.9.9.6.1.02.00','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4211,'2015','4.9.9.6.1.03.00','INDENIZ. POSSE OU OCUPACAO ILIC. BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4212,'2015','4.9.9.6.1.04.00','REPOSIÇÃO/INDENIZAÇÃO DE SERVIDORES/AGENTES PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4213,'2015','4.9.9.6.1.99.00','OUTRAS INDENIZACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4214,'2015','4.9.9.7.0.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4215,'2015','4.9.9.7.1.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4216,'2015','4.9.9.7.1.01.00','VPA DE LEILOES DE MERCADORIAS APREENDIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4217,'2015','4.9.9.7.1.02.00','VPA DE ALIENACAO DE BENS APREENDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4218,'2015','4.9.9.7.1.03.00','VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4219,'2015','4.9.9.7.1.70.00','RECEITA DE ALIENAÇÃO DE BENS CAUCIONADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4220,'2015','4.9.9.7.1.99.00','OUTRAS VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4221,'2015','4.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4222,'2015','4.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4223,'2015','5.0.0.0.0.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4224,'2015','5.1.0.0.0.00.00','PLANEJAMENTO APROVADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4225,'2015','5.1.1.0.0.00.00','PPA - APROVADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4226,'2015','5.1.1.1.0.00.00','APROVAÇÃO INICIAL DO PPA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4227,'2015','5.1.1.2.0.00.00','REVISAO DO PPA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4228,'2015','5.1.2.0.0.00.00','PLOA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4229,'2015','5.1.2.1.0.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4230,'2015','5.1.2.1.1.00.00','PLOA INICIAL DA RECEITA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4231,'2015','5.1.2.1.2.00.00','ALTERACOES  DO PROJETO INICIAL DA LOA - RECEITA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4232,'2015','5.1.2.2.0.00.00','PROJETO INICIAL DA LOA - DESPESA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4233,'2015','5.1.2.2.1.00.00','PLOA INICIAL DA DESPESA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4234,'2015','5.1.2.2.2.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4235,'2015','5.2.0.0.0.00.00','ORÇAMENTO APROVADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4236,'2015','5.2.1.0.0.00.00','PREVISÃO DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4237,'2015','5.2.1.1.0.00.00','PREVISÃO INICIAL DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4238,'2015','5.2.1.1.1.00.00','PREVISAO INICIAL DA RECEITA  BRUTA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4239,'2015','5.2.1.1.2.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4240,'2015','5.2.1.1.2.01.00','(-) DEDUÇÕES  POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4241,'2015','5.2.1.1.2.01.01','(-) FUNDEB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4242,'2015','5.2.1.1.2.01.02','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4243,'2015','5.2.1.1.2.02.00','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4244,'2015','5.2.1.1.2.99.00','(-) OUTRAS DEDUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4245,'2015','5.2.1.2.0.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4246,'2015','5.2.1.2.1.00.00','PREVISÃO ADICIONAL DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4247,'2015','5.2.1.2.1.01.00','REESTIMATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4248,'2015','5.2.1.2.1.02.00','CORREÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4249,'2015','5.2.1.2.9.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4250,'2015','5.2.2.0.0.00.00','FIXAÇÃO DA DESPESA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4251,'2015','5.2.2.1.0.00.00','DOTAÇÃO ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4252,'2015','5.2.2.1.1.00.00','DOTAÇÃO INICIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4253,'2015','5.2.2.1.1.01.00','CREDITO INICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4254,'2015','5.2.2.1.1.02.00','CREDITOS ANTECIPADOS - LDO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4255,'2015','5.2.2.1.1.02.01','ANTECIPACAO - LDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4256,'2015','5.2.2.1.1.02.09','(-) ANULACAO DA ANTECIPACAO - LDO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4257,'2015','5.2.2.1.2.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CREDITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4258,'2015','5.2.2.1.2.01.00','CREDITO ADICIONAL – SUPLEMENTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4259,'2015','5.2.2.1.2.02.00','CREDITO ADICIONAL - ESPECIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4260,'2015','5.2.2.1.2.02.01','CRÉDITOS ESPECIAIS ABERTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4261,'2015','5.2.2.1.2.02.02','CRÉDITOS ESPECIAIS REABERTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4262,'2015','5.2.2.1.2.02.03','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4263,'2015','5.2.2.1.2.03.00','CREDITO ADICIONAL – EXTRAORDINÁRIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4264,'2015','5.2.2.1.2.03.01','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4265,'2015','5.2.2.1.2.03.02','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4266,'2015','5.2.2.1.2.03.03','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4267,'2015','5.2.2.1.3.00.00','DOTAÇÃO ADICIONAL POR FONTE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4268,'2015','5.2.2.1.3.01.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4269,'2015','5.2.2.1.3.02.00','EXCESSO DE ARRECADACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4270,'2015','5.2.2.1.3.03.00','ANULACAO DE DOTACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4271,'2015','5.2.2.1.3.04.00','OPERACOES DE CREDITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4272,'2015','5.2.2.1.3.05.00','RESERVA DE CONTINGENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4273,'2015','5.2.2.1.3.06.00','DOTACAO TRANSFERIDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4274,'2015','5.2.2.1.3.07.00','RECURSOS SEM DESPESAS CORRESPONDENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4275,'2015','5.2.2.1.3.09.00','(-) CANCELAMENTO DE DOTACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4276,'2015','5.2.2.1.3.99.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4277,'2015','5.2.2.1.9.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4278,'2015','5.2.2.1.9.01.00','ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4279,'2015','5.2.2.1.9.01.01','ACRESCIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4280,'2015','5.2.2.1.9.01.09','(-)REDUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4281,'2015','5.2.2.1.9.02.00','ALTERACAO DA LEI ORCAMENTARIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4282,'2015','5.2.2.1.9.02.01','ACRESCIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4283,'2015','5.2.2.1.9.02.09','(-)REDUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4284,'2015','5.2.2.1.9.04.00','(-)CANCELAMENTO DE DOTACOES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4285,'2015','5.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4286,'2015','5.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4287,'2015','5.2.2.2.1.01.00','PROVISAO RECEBIDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4288,'2015','5.2.2.2.1.02.00','PROVISAO RECEBIDA - BLOQUEADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4289,'2015','5.2.2.2.1.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4290,'2015','5.2.2.2.1.09.01','ACRESCIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4291,'2015','5.2.2.2.1.09.09','(-) REDUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4292,'2015','5.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4293,'2015','5.2.2.2.2.01.00','ADMINISTRACAO DIRETA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4294,'2015','5.2.2.2.2.01.01','CREDITOS RECEBIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4295,'2015','5.2.2.2.2.01.09','(-) CREDITOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4296,'2015','5.2.2.2.2.02.00','ADMINISTRACAO INDIRETA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4297,'2015','5.2.2.2.2.02.01','CREDITOS RECEBIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4298,'2015','5.2.2.2.2.02.09','(-) CREDITOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4299,'2015','5.2.2.2.2.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4300,'2015','5.2.2.2.2.09.01','ACRESCIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4301,'2015','5.2.2.2.2.09.09','(-) REDUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4302,'2015','5.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4303,'2015','5.2.2.2.9.01.00','CREDITOS EXT. RECEB. POR FUSAO/CISAO/EXTINCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4304,'2015','5.2.2.2.9.02.00','CREDITOS INT. RECEB. POR FUSAO/CISAO/EXTINCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4305,'2015','5.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4306,'2015','5.2.2.3.1.00.00','CREDITOS A DETALHAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4307,'2015','5.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4308,'2015','5.2.2.9.1.00.00','PRÉ-EMPENHOS DA DESPESA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4309,'2015','5.2.2.9.1.01.00','PRÉ-EMPENHOS EMITIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4310,'2015','5.2.2.9.1.02.00','REFORÇO DE PRÉ-EMPENHO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4311,'2015','5.2.2.9.1.03.00','ANULAÇÃO DE PRÉ-EMPENHO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4312,'2015','5.2.2.9.2.00.00','EMPENHOS POR EMISSÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4313,'2015','5.2.2.9.2.01.00','EXECUÇÃO DA DESPESA POR NOTA DE EMPENHO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4314,'2015','5.2.2.9.2.01.01','EMISSAO DE EMPENHOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4315,'2015','5.2.2.9.2.01.02','REFORCO DE EMPENHOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4316,'2015','5.2.2.9.2.01.03','(-)ANULACAO DE EMPENHOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4317,'2015','5.2.2.9.2.01.04','(-)CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4318,'2015','5.3.0.0.0.00.00','INSCRIÇÃO DE RESTOS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4319,'2015','5.3.1.0.0.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4320,'2015','5.3.1.1.0.00.00','RP NÃO PROCESSADOS INSCRITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4321,'2015','5.3.1.2.0.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4322,'2015','5.3.1.3.0.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4323,'2015','5.3.1.6.0.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4324,'2015','5.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4325,'2015','5.3.2.0.0.00.00','INSCRIÇÃO DE RP PROCESSADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4326,'2015','5.3.2.1.0.00.00','RP PROCESSADOS - INSCRITOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4327,'2015','5.3.2.2.0.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4328,'2015','5.3.2.6.0.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4329,'2015','5.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4330,'2015','6.0.0.0.0.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4331,'2015','6.1.0.0.0.00.00','EXECUÇÃO DO PLANEJAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4332,'2015','6.1.1.0.0.00.00','EXECUÇÃO DO PPA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4333,'2015','6.1.1.1.0.00.00','PPA A ALOCAR EM LEIS ORÇAMENTÁRIAS ANUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4334,'2015','6.1.1.2.0.00.00','PPA ALOCADO  EM LEIS ORÇAMENTÁRIAS ANUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4335,'2015','6.1.1.3.0.00.00','PPA EXECUTADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4336,'2015','6.1.2.0.0.00.00','EXECUÇÃO DO PLOA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4337,'2015','6.1.2.1.0.00.00','PROCESSAMENTO DO PLOA -RECEITA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4338,'2015','6.1.2.2.0.00.00','PROCESSAMENTO DO PLOA -DESPESA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4339,'2015','6.2.0.0.0.00.00','EXECUÇÃO DO ORÇAMENTO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4340,'2015','6.2.1.0.0.00.00','EXECUÇÃO DA RECEITA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4341,'2015','6.2.1.1.0.00.00','RECEITA A REALIZAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4342,'2015','6.2.1.2.0.00.00','RECEITA REALIZADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4343,'2015','6.2.1.3.0.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4344,'2015','6.2.1.3.1.00.00','(-) DEDUÇÕES  POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4345,'2015','6.2.1.3.1.01.00','(-) FUNDEB','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4346,'2015','6.2.1.3.1.02.00','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4347,'2015','6.2.1.3.2.00.00','(-) RENÚNCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4348,'2015','6.2.1.3.9.00.00','(-) OUTRAS DEDUCOES DA RECEITA REALIZADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4349,'2015','6.2.1.8.0.00.00','CORREÇÃO DE DIFERENÇAS RESULTANTES DE VARIAÇÃO CAMBIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4350,'2015','6.2.2.0.0.00.00','EXECUÇÃO DA DESPESA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4351,'2015','6.2.2.1.0.00.00','DISPONIBILIDADES DE CREDITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4352,'2015','6.2.2.1.1.00.00','CREDITO DISPONÍVEL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4353,'2015','6.2.2.1.2.00.00','CREDITO INDISPONÍVEL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4354,'2015','6.2.2.1.2.01.00','BLOQUEIO DE CREDITO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4355,'2015','6.2.2.1.2.02.00','CREDITO PRE-EMPENHADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4356,'2015','6.2.2.1.2.99.00','OUTRAS INDISPONIBILIDADES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4357,'2015','6.2.2.1.3.00.00','CREDITO UTILIZADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4358,'2015','6.2.2.1.3.01.00','CREDITO EMPENHADO A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4359,'2015','6.2.2.1.3.02.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4360,'2015','6.2.2.1.3.03.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4361,'2015','6.2.2.1.3.04.00','CREDITO EMPENHADO LIQUIDADO PAGO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4362,'2015','6.2.2.1.3.05.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4363,'2015','6.2.2.1.3.06.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4364,'2015','6.2.2.1.3.07.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4365,'2015','6.2.2.1.3.99.00','(-) OUTROS CRÉDITOS UTILIZADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4366,'2015','6.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4367,'2015','6.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4368,'2015','6.2.2.2.1.01.00','PROVISAO CONCEDIDA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4369,'2015','6.2.2.2.1.02.00','PROVISAO CONCEDIDA - BLOQUEADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4370,'2015','6.2.2.2.1.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4371,'2015','6.2.2.2.1.09.01','ACRESCIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4372,'2015','6.2.2.2.1.09.09','(-) REDUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4373,'2015','6.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4374,'2015','6.2.2.2.2.01.00','ADMINISTRACAO DIRETA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4375,'2015','6.2.2.2.2.01.01','CREDITOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4376,'2015','6.2.2.2.2.02.00','ADMINISTRACAO INDIRETA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4377,'2015','6.2.2.2.2.02.01','CREDITOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4378,'2015','6.2.2.2.2.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4379,'2015','6.2.2.2.2.09.01','ACRESCIMO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4380,'2015','6.2.2.2.2.09.09','(-) REDUCAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4381,'2015','6.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4382,'2015','6.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4383,'2015','6.2.2.3.1.00.00','CREDITOS DETALHADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4384,'2015','6.2.2.8.0.00.00','CORREÇÃO DE DIFERENÇAS RESULTANTES DE VARIAÇÃO CAMBIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4385,'2015','6.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4386,'2015','6.2.2.9.1.00.00','DESPESA PRE-EMPENHADA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4387,'2015','6.2.2.9.1.01.00','PRE-EMPENHOS A EMPENHAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4388,'2015','6.2.2.9.1.02.00','PRE-EMPENHOS EMPENHADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4389,'2015','6.2.2.9.2.00.00','EMISSAO DE EMPENHO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4390,'2015','6.2.2.9.2.01.00','EMPENHOS POR NOTA DE EMPENHO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4391,'2015','6.2.2.9.2.01.01','EMPENHOS A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4392,'2015','6.2.2.9.2.01.02','EMPENHOS EM LIQUIDACAO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4393,'2015','6.2.2.9.2.01.03','EMPENHOS LIQUIDADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4394,'2015','6.2.2.9.2.01.04','EMPENHOS LIQUIDADOS PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4395,'2015','6.3.0.0.0.00.00','EXECUÇÃO DE RESTOS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4396,'2015','6.3.1.0.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4397,'2015','6.3.1.1.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4398,'2015','6.3.1.2.0.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4399,'2015','6.3.1.3.0.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4400,'2015','6.3.1.4.0.00.00','RP NÃO PROCESSADOS PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4401,'2015','6.3.1.5.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4402,'2015','6.3.1.6.0.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4403,'2015','6.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4404,'2015','6.3.1.7.1.00.00','RP NAO PROCESSADOS A LIQUIDAR-  INSCRICAO NO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4405,'2015','6.3.1.7.2.00.00','RP NAO PROCESSADOS EM LIQUIDACAO -  INSCRICAO NO EXERCICIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4406,'2015','6.3.1.9.0.00.00','RP NÃO PROCESSADOS CANCELADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4407,'2015','6.3.1.9.1.00.00','CANCELAMENTOS POR INSUFICIENCIA DE RECURSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4408,'2015','6.3.1.9.9.00.00','OUTROS CANCELAMENTOS DE RP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4409,'2015','6.3.2.0.0.00.00','EXECUÇÃO DE RP PROCESSADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4410,'2015','6.3.2.1.0.00.00','RP PROCESSADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4411,'2015','6.3.2.2.0.00.00','RP PROCESSADOS PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4412,'2015','6.3.2.6.0.00.00','RP PROCESSADOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4413,'2015','6.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4414,'2015','6.3.2.9.0.00.00','RP PROCESSADOS CANCELADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4415,'2015','6.3.2.9.1.00.00','POR VALORES E/OU INSCRICOES INDEVIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4416,'2015','6.3.2.9.9.00.00','OUTROS CANCELAMENTOS DE RP','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4417,'2015','6.3.8.0.0.00.00','CORREÇÃO DE DIFERENÇAS RESULTANTES DE VARIAÇÃO CAMBIAL','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4418,'2015','7.0.0.0.0.00.00','CONTROLES DEVEDORES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4419,'2015','7.1.0.0.0.00.00','ATOS POTENCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4420,'2015','7.1.1.0.0.00.00','ATOS POTENCIAIS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4421,'2015','7.1.1.1.0.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4422,'2015','7.1.1.1.1.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4423,'2015','7.1.1.1.1.01.00','GARANTIAS RECEBIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4424,'2015','7.1.1.1.1.01.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4425,'2015','7.1.1.1.1.01.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4426,'2015','7.1.1.1.1.01.03','HIPOTECAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4427,'2015','7.1.1.1.1.01.04','SEGUROS-GARANTIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4428,'2015','7.1.1.1.1.01.05','CAUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4429,'2015','7.1.1.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4430,'2015','7.1.1.1.1.01.07','GARANTIAS DA DÍVIDA PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4431,'2015','7.1.1.1.1.01.08','APÓLICES DE SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4432,'2015','7.1.1.1.1.01.99','OUTRAS GARANTIAS  RECEBIDAS NO PAÍS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4433,'2015','7.1.1.1.1.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4434,'2015','7.1.1.1.1.02.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4435,'2015','7.1.1.1.1.02.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4436,'2015','7.1.1.1.1.02.03','HIPOTECAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4437,'2015','7.1.1.1.1.02.04','SEGUROS-GARANTIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4438,'2015','7.1.1.1.1.02.05','CAUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4439,'2015','7.1.1.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4440,'2015','7.1.1.1.1.02.07','GARANTIAS DA DÍVIDA PÚBLICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4441,'2015','7.1.1.1.1.02.08','APÓLICES DE SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4442,'2015','7.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4443,'2015','7.1.1.1.1.03.00','CONTRAGARANTIAS RECEBIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4444,'2015','7.1.1.1.1.03.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4445,'2015','7.1.1.1.1.03.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4446,'2015','7.1.1.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4447,'2015','7.1.1.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4448,'2015','7.1.1.1.1.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4449,'2015','7.1.1.1.1.04.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4450,'2015','7.1.1.1.1.04.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4451,'2015','7.1.1.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4452,'2015','7.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4453,'2015','7.1.1.2.0.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4454,'2015','7.1.1.2.1.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4455,'2015','7.1.1.2.1.01.00','DIREITOS CONVENIADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4456,'2015','7.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4457,'2015','7.1.1.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4458,'2015','7.1.1.3.0.00.00','DIREITOS CONTRATUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4459,'2015','7.1.1.3.1.00.00','DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4460,'2015','7.1.1.3.1.01.00','CONTRATOS DE SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4461,'2015','7.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4462,'2015','7.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4463,'2015','7.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4464,'2015','7.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4465,'2015','7.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4466,'2015','7.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4467,'2015','7.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4468,'2015','7.1.1.9.0.00.00','OUTROS ATOS POTENCIAIS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4469,'2015','7.1.2.0.0.00.00','ATOS POTENCIAIS PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4470,'2015','7.1.2.1.0.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4471,'2015','7.1.2.1.1.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4472,'2015','7.1.2.1.1.01.00','GARANTIAS CONCEDIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4473,'2015','7.1.2.1.1.01.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4474,'2015','7.1.2.1.1.01.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4475,'2015','7.1.2.1.1.01.03','HIPOTECAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4476,'2015','7.1.2.1.1.01.04','SEGUROS-GARANTIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4477,'2015','7.1.2.1.1.01.05','CAUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4478,'2015','7.1.2.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4479,'2015','7.1.2.1.1.01.99','OUTRAS GARANTIAS E CONTRAGARANTIAS RECEBIDAS NO PAÍS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4480,'2015','7.1.2.1.1.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4481,'2015','7.1.2.1.1.02.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4482,'2015','7.1.2.1.1.02.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4483,'2015','7.1.2.1.1.02.03','HIPOTECAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4484,'2015','7.1.2.1.1.02.04','SEGUROS-GARANTIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4485,'2015','7.1.2.1.1.02.05','CAUÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4486,'2015','7.1.2.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4487,'2015','7.1.2.1.1.02.99','OUTRAS GARANTIAS E CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4488,'2015','7.1.2.1.1.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4489,'2015','7.1.2.1.1.03.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4490,'2015','7.1.2.1.1.03.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4491,'2015','7.1.2.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4492,'2015','7.1.2.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4493,'2015','7.1.2.1.1.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4494,'2015','7.1.2.1.1.04.01','AVAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4495,'2015','7.1.2.1.1.04.02','FIANÇAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4496,'2015','7.1.2.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4497,'2015','7.1.2.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4498,'2015','7.1.2.2.0.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4499,'2015','7.1.2.2.1.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4500,'2015','7.1.2.2.1.01.00','OBRIGAÇÕES CONVENIADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4501,'2015','7.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4502,'2015','7.1.2.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4503,'2015','7.1.2.3.0.00.00','OBRIGAÇÕES CONTRATUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4504,'2015','7.1.2.3.1.00.00','OBRIGAÇÕES CONTRATUAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4505,'2015','7.1.2.3.1.01.00','CONTRATOS DE SEGUROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4506,'2015','7.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4507,'2015','7.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4508,'2015','7.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4509,'2015','7.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4510,'2015','7.1.2.3.1.06.00','CONTRATO DE GESTÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4511,'2015','7.1.2.3.1.07.00','TERMO DE PARCERIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4512,'2015','7.1.2.3.1.08.00','CONTRATOS DE PPP','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4513,'2015','7.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4514,'2015','7.1.2.3.1.08.02','RISCOS NÃO PROVISIONADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4515,'2015','7.1.2.3.1.08.03','OUTROS PASSIVOS CONTINGENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4516,'2015','7.1.2.3.1.99.00','OUTROS OBRIGAÇÕES CONTRATUAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4517,'2015','7.1.2.9.0.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4518,'2015','7.2.0.0.0.00.00','ADMINISTRAÇÃO FINANCEIRA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4519,'2015','7.2.1.0.0.00.00','DISPONIBILIDADES POR DESTINAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4520,'2015','7.2.1.1.0.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4521,'2015','7.2.1.1.1.00.00','RECURSOS ORDINÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4522,'2015','7.2.1.1.2.00.00','RECURSOS VINCULADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4523,'2015','7.2.1.1.3.00.00','RECURSOS EXTRAORÇAMENTÁRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4524,'2015','7.2.1.2.0.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4525,'2015','7.2.1.3.0.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4526,'2015','7.2.2.0.0.00.00','PROGRAMAÇÃO FINANCEIRA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4527,'2015','7.2.3.0.0.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4528,'2015','7.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4529,'2015','7.3.0.0.0.00.00','DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4530,'2015','7.3.1.0.0.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4531,'2015','7.3.1.1.0.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4532,'2015','7.3.1.1.1.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4533,'2015','7.3.1.1.1.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4534,'2015','7.3.1.1.1.02.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4535,'2015','7.3.1.1.1.03.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4536,'2015','7.3.1.1.2.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4537,'2015','7.3.1.1.2.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  NÃO-TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4538,'2015','7.3.2.0.0.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4539,'2015','7.3.2.1.0.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4540,'2015','7.3.2.1.1.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4541,'2015','7.3.2.1.2.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4542,'2015','7.4.0.0.0.00.00','RISCOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4543,'2015','7.4.1.0.0.00.00','CONTROLE DE PASSIVOS CONTINGENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4544,'2015','7.4.1.1.0.00.00','PASSIVOS CONTINGENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4545,'2015','7.4.1.1.1.00.00','DEMANDAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4546,'2015','7.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4547,'2015','7.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4548,'2015','7.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4549,'2015','7.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4550,'2015','7.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4551,'2015','7.4.2.0.0.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4552,'2015','7.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4553,'2015','7.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4554,'2015','7.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4555,'2015','7.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4556,'2015','7.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4557,'2015','7.5.0.0.0.00.00','CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4558,'2015','7.5.1.0.0.00.00','CONTRATO DE RATEIO DE CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4559,'2015','7.5.2.0.0.00.00','PRESTAÇÃO DE CONTAS DE CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4560,'2015','7.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO  DO CONSÓRCIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4561,'2015','7.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4562,'2015','7.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4563,'2015','7.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4564,'2015','7.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4565,'2015','7.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4566,'2015','7.8.0.0.0.00.00','CUSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4567,'2015','7.9.0.0.0.00.00','OUTROS CONTROLES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4568,'2015','7.9.1.0.0.00.00','RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4569,'2015','7.9.1.1.0.00.00','RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4570,'2015','7.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4571,'2015','7.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4572,'2015','7.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4573,'2015','7.9.1.2.0.00.00','RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4574,'2015','7.9.1.2.1.00.00','CONTROLE DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4575,'2015','7.9.1.2.2.00.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4576,'2015','7.9.1.2.9.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4577,'2015','7.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4578,'2015','8.0.0.0.0.00.00','CONTROLES CREDORES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4579,'2015','8.1.0.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4580,'2015','8.1.1.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4581,'2015','8.1.1.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4582,'2015','8.1.1.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4583,'2015','8.1.1.1.1.01.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4584,'2015','8.1.1.1.1.01.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4585,'2015','8.1.1.1.1.01.02','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4586,'2015','8.1.1.1.1.01.03','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4587,'2015','8.1.1.1.1.01.04','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4588,'2015','8.1.1.1.1.01.05','HIPOTECAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4589,'2015','8.1.1.1.1.01.06','HIPOTECAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4590,'2015','8.1.1.1.1.01.07','SEGUROS-GARANTIA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4591,'2015','8.1.1.1.1.01.08','SEGUROS-GARANTIA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4592,'2015','8.1.1.1.1.01.09','CAUÇÕES A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4593,'2015','8.1.1.1.1.01.10','CAUÇÕES EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4594,'2015','8.1.1.1.1.01.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4595,'2015','8.1.1.1.1.01.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4596,'2015','8.1.1.1.1.01.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4597,'2015','8.1.1.1.1.01.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4598,'2015','8.1.1.1.1.01.15','APÓLICES DE SEGUROS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4599,'2015','8.1.1.1.1.01.16','APÓLICES DE SEGUROS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4600,'2015','8.1.1.1.1.01.98','OUTRAS GARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4601,'2015','8.1.1.1.1.01.99','OUTRAS GARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4602,'2015','8.1.1.1.1.02.00','EXECUÇÃO DE GARANTIAS   RECEBIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4603,'2015','8.1.1.1.1.02.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4604,'2015','8.1.1.1.1.02.02','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4605,'2015','8.1.1.1.1.02.03','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4606,'2015','8.1.1.1.1.02.04','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4607,'2015','8.1.1.1.1.02.05','HIPOTECAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4608,'2015','8.1.1.1.1.02.06','HIPOTECAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4609,'2015','8.1.1.1.1.02.07','SEGUROS-GARANTIA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4610,'2015','8.1.1.1.1.02.08','SEGUROS-GARANTIA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4611,'2015','8.1.1.1.1.02.09','CAUÇÕES A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4612,'2015','8.1.1.1.1.02.10','CAUÇÕES EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4613,'2015','8.1.1.1.1.02.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4614,'2015','8.1.1.1.1.02.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4615,'2015','8.1.1.1.1.02.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4616,'2015','8.1.1.1.1.02.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4617,'2015','8.1.1.1.1.02.15','APÓLICES DE SEGUROS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4618,'2015','8.1.1.1.1.02.16','APÓLICES DE SEGUROS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4619,'2015','8.1.1.1.1.02.98','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4620,'2015','8.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4621,'2015','8.1.1.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4622,'2015','8.1.1.1.1.03.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4623,'2015','8.1.1.1.1.03.02','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4624,'2015','8.1.1.1.1.03.03','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4625,'2015','8.1.1.1.1.03.04','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4626,'2015','8.1.1.1.1.03.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4627,'2015','8.1.1.1.1.03.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4628,'2015','8.1.1.1.1.03.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4629,'2015','8.1.1.1.1.03.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4630,'2015','8.1.1.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4631,'2015','8.1.1.1.1.04.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4632,'2015','8.1.1.1.1.04.02','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4633,'2015','8.1.1.1.1.04.03','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4634,'2015','8.1.1.1.1.04.04','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4635,'2015','8.1.1.1.1.04.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4636,'2015','8.1.1.1.1.04.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4637,'2015','8.1.1.1.1.04.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4638,'2015','8.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4639,'2015','8.1.1.2.0.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4640,'2015','8.1.1.2.1.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4641,'2015','8.1.1.2.1.01.00','EXECUÇÃO DE CONVÊNIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4642,'2015','8.1.1.2.1.01.01','CONVÊNIOS A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4643,'2015','8.1.1.2.1.01.02','CONVÊNIOS A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4644,'2015','8.1.1.2.1.01.03','CONVÊNIOS A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4645,'2015','8.1.1.2.1.01.04','CONVÊNIOS APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4646,'2015','8.1.1.2.1.01.05','CONVÊNIOS IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4647,'2015','8.1.1.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4648,'2015','8.1.1.2.1.01.07','CONVÊNIO EM INADIMPLÊNCIA SUSPENSA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4649,'2015','8.1.1.2.1.01.08','CONVÊNIOS HOMOLOGADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4650,'2015','8.1.1.2.1.01.09','CONVÊNIOS CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4651,'2015','8.1.1.2.1.01.10','CONVÊNIOS NÃO RECEBIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4652,'2015','8.1.1.2.1.01.11','CONVÊNIOS ARQUIVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4653,'2015','8.1.1.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4654,'2015','8.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4655,'2015','8.1.1.2.1.02.01','TERMO DE COOPERAÇÃO A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4656,'2015','8.1.1.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4657,'2015','8.1.1.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4658,'2015','8.1.1.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4659,'2015','8.1.1.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4660,'2015','8.1.1.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4661,'2015','8.1.1.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4662,'2015','8.1.1.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4663,'2015','8.1.1.2.1.02.09','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4664,'2015','8.1.1.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4665,'2015','8.1.1.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4666,'2015','8.1.1.2.1.99.01','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4667,'2015','8.1.1.2.1.99.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4668,'2015','8.1.1.2.1.99.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4669,'2015','8.1.1.2.1.99.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4670,'2015','8.1.1.2.1.99.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4671,'2015','8.1.1.2.1.99.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4672,'2015','8.1.1.2.1.99.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4673,'2015','8.1.1.2.1.99.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4674,'2015','8.1.1.2.1.99.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4675,'2015','8.1.1.2.1.99.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4676,'2015','8.1.1.3.0.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4677,'2015','8.1.1.3.1.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4678,'2015','8.1.1.3.1.01.00','CONTRATOS DE SEGUROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4679,'2015','8.1.1.3.1.01.01','EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4680,'2015','8.1.1.3.1.01.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4681,'2015','8.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4682,'2015','8.1.1.3.1.02.01','EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4683,'2015','8.1.1.3.1.02.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4684,'2015','8.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4685,'2015','8.1.1.3.1.03.01','EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4686,'2015','8.1.1.3.1.03.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4687,'2015','8.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4688,'2015','8.1.1.3.1.04.01','EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4689,'2015','8.1.1.3.1.04.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4690,'2015','8.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4691,'2015','8.1.1.3.1.05.01','EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4692,'2015','8.1.1.3.1.05.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4693,'2015','8.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4694,'2015','8.1.1.3.1.06.01','CONTRATOS DE PPP - DO ENTE FEDERADO - EC','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4695,'2015','8.1.1.3.1.06.02','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 1','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4696,'2015','8.1.1.3.1.06.03','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 2','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4697,'2015','8.1.1.3.1.06.04','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 3','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4698,'2015','8.1.1.3.1.06.05','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 4','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4699,'2015','8.1.1.3.1.06.06','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 5','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4700,'2015','8.1.1.3.1.06.07','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 6','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4701,'2015','8.1.1.3.1.06.08','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 7','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4702,'2015','8.1.1.3.1.06.09','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 8','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4703,'2015','8.1.1.3.1.06.10','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 9','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4704,'2015','8.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4705,'2015','8.1.1.3.1.07.01','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4706,'2015','8.1.1.3.1.07.02','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 1','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4707,'2015','8.1.1.3.1.07.03','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 2','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4708,'2015','8.1.1.3.1.07.04','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 3','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4709,'2015','8.1.1.3.1.07.05','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 4','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4710,'2015','8.1.1.3.1.07.06','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 5','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4711,'2015','8.1.1.3.1.07.07','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 6','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4712,'2015','8.1.1.3.1.07.08','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 7','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4713,'2015','8.1.1.3.1.07.09','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 8','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4714,'2015','8.1.1.3.1.07.10','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 9','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4715,'2015','8.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4716,'2015','8.1.1.3.1.99.01','EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4717,'2015','8.1.1.3.1.99.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4718,'2015','8.1.1.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4719,'2015','8.1.1.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4720,'2015','8.1.2.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4721,'2015','8.1.2.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4722,'2015','8.1.2.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4723,'2015','8.1.2.1.1.01.00','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4724,'2015','8.1.2.1.1.01.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4725,'2015','8.1.2.1.1.01.03','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4726,'2015','8.1.2.1.1.01.04','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4727,'2015','8.1.2.1.1.01.06','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4728,'2015','8.1.2.1.1.01.07','HIPOTECAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4729,'2015','8.1.2.1.1.01.09','HIPOTECAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4730,'2015','8.1.2.1.1.01.10','SEGUROS-GARANTIA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4731,'2015','8.1.2.1.1.01.12','SEGUROS-GARANTIA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4732,'2015','8.1.2.1.1.01.13','CAUÇÕES A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4733,'2015','8.1.2.1.1.01.15','CAUÇÕES EXECUTADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4734,'2015','8.1.2.1.1.01.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4735,'2015','8.1.2.1.1.01.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4736,'2015','8.1.2.1.1.01.19','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4737,'2015','8.1.2.1.1.01.21','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4738,'2015','8.1.2.1.1.02.00','EXECUÇÃO DE GARANTIAS E  CONCEDIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4739,'2015','8.1.2.1.1.02.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4740,'2015','8.1.2.1.1.02.03','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4741,'2015','8.1.2.1.1.02.04','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4742,'2015','8.1.2.1.1.02.06','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4743,'2015','8.1.2.1.1.02.07','HIPOTECAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4744,'2015','8.1.2.1.1.02.09','HIPOTECAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4745,'2015','8.1.2.1.1.02.10','SEGUROS-GARANTIA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4746,'2015','8.1.2.1.1.02.12','SEGUROS-GARANTIA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4747,'2015','8.1.2.1.1.02.13','CAUÇÕES A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4748,'2015','8.1.2.1.1.02.15','CAUÇÕES EXECUTADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4749,'2015','8.1.2.1.1.02.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4750,'2015','8.1.2.1.1.02.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4751,'2015','8.1.2.1.1.02.19','OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4752,'2015','8.1.2.1.1.02.21','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4753,'2015','8.1.2.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO PAÍS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4754,'2015','8.1.2.1.1.03.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4755,'2015','8.1.2.1.1.03.03','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4756,'2015','8.1.2.1.1.03.04','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4757,'2015','8.1.2.1.1.03.06','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4758,'2015','8.1.2.1.1.03.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4759,'2015','8.1.2.1.1.03.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4760,'2015','8.1.2.1.1.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4761,'2015','8.1.2.1.1.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4762,'2015','8.1.2.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4763,'2015','8.1.2.1.1.04.01','AVAIS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4764,'2015','8.1.2.1.1.04.03','AVAIS EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4765,'2015','8.1.2.1.1.04.04','FIANÇAS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4766,'2015','8.1.2.1.1.04.06','FIANÇAS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4767,'2015','8.1.2.1.1.04.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4768,'2015','8.1.2.1.1.04.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4769,'2015','8.1.2.1.1.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4770,'2015','8.1.2.1.1.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4771,'2015','8.1.2.2.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4772,'2015','8.1.2.2.1.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4773,'2015','8.1.2.2.1.01.00','EXECUÇÃO DE CONVÊNIOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4774,'2015','8.1.2.2.1.01.01','CONVÊNIOS A LIBERAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4775,'2015','8.1.2.2.1.01.02','CONVÊNIOS A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4776,'2015','8.1.2.2.1.01.03','CONVÊNIOS A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4777,'2015','8.1.2.2.1.01.04','CONVÊNIOS APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4778,'2015','8.1.2.2.1.01.05','CONVÊNIOS IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4779,'2015','8.1.2.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4780,'2015','8.1.2.2.1.01.07','CONVÊNIOSEM INADIMPLÊNCIA SUSPENSA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4781,'2015','8.1.2.2.1.01.08','CONVÊNIOS HOMOLOGADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4782,'2015','8.1.2.2.1.01.09','CONVÊNIOS CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4783,'2015','8.1.2.2.1.01.10','CONVÊNIOS NÃO LIBERADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4784,'2015','8.1.2.2.1.01.11','CONVÊNIOS ARQUIVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4785,'2015','8.1.2.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4786,'2015','8.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4787,'2015','8.1.2.2.1.02.01','TERMO DE COOPERAÇÃO A LIBERAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4788,'2015','8.1.2.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4789,'2015','8.1.2.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4790,'2015','8.1.2.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4791,'2015','8.1.2.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4792,'2015','8.1.2.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4793,'2015','8.1.2.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4794,'2015','8.1.2.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4795,'2015','8.1.2.2.1.02.09','TERMO DE COOPERAÇÃO NÃO LIBERADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4796,'2015','8.1.2.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4797,'2015','8.1.2.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4798,'2015','8.1.2.2.1.99.01','OUTROS INSTRUMENTOS CONGÊNERES A LIBERAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4799,'2015','8.1.2.2.1.99.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4800,'2015','8.1.2.2.1.99.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4801,'2015','8.1.2.2.1.99.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4802,'2015','8.1.2.2.1.99.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4803,'2015','8.1.2.2.1.99.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4804,'2015','8.1.2.2.1.99.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4805,'2015','8.1.2.2.1.99.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4806,'2015','8.1.2.2.1.99.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO LIBERADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4807,'2015','8.1.2.2.1.99.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4808,'2015','8.1.2.3.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4809,'2015','8.1.2.3.1.00.00','EXECUÇÃO DE OBRIGAÇÕES -CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4810,'2015','8.1.2.3.1.01.00','CONTRATOS DE SEGUROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4811,'2015','8.1.2.3.1.01.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4812,'2015','8.1.2.3.1.01.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4813,'2015','8.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4814,'2015','8.1.2.3.1.02.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4815,'2015','8.1.2.3.1.02.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4816,'2015','8.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4817,'2015','8.1.2.3.1.03.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4818,'2015','8.1.2.3.1.03.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4819,'2015','8.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4820,'2015','8.1.2.3.1.04.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4821,'2015','8.1.2.3.1.04.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4822,'2015','8.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4823,'2015','8.1.2.3.1.05.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4824,'2015','8.1.2.3.1.05.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4825,'2015','8.1.2.3.1.06.00','CONTRATO DE GESTÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4826,'2015','8.1.2.3.1.06.01','A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4827,'2015','8.1.2.3.1.06.02','LIQUIDADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4828,'2015','8.1.2.3.1.07.00','TERMO DE PARCERIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4829,'2015','8.1.2.3.1.07.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4830,'2015','8.1.2.3.1.07.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4831,'2015','8.1.2.3.1.08.00','CONTRATOS DE PPP','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4832,'2015','8.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS - A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4833,'2015','8.1.2.3.1.08.02','CONTRAPRESTAÇÕES FUTURAS - EXECUTADAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4834,'2015','8.1.2.3.1.08.03','RISCOS NÃO PROVISIONADOS - A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4835,'2015','8.1.2.3.1.08.04','RISCOS NÃO PROVISIONADOS - EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4836,'2015','8.1.2.3.1.08.05','OUTROS PASSIVOS CONTINGENTES - A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4837,'2015','8.1.2.3.1.08.06','OUTROS PASSIVOS CONTIGENTES - EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4838,'2015','8.1.2.3.1.99.00','OUTRAS OBRIGAÇÕES CONTRATUAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4839,'2015','8.1.2.3.1.99.01','A EXECUTAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4840,'2015','8.1.2.3.1.99.02','EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4841,'2015','8.1.2.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4842,'2015','8.1.2.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4843,'2015','8.2.0.0.0.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4844,'2015','8.2.1.0.0.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4845,'2015','8.2.1.1.0.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4846,'2015','8.2.1.1.1.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4847,'2015','8.2.1.1.2.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4848,'2015','8.2.1.1.3.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4849,'2015','8.2.1.1.3.01.00','COMPROMETIDA POR LIQUIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4850,'2015','8.2.1.1.3.02.00','COMPROMETIDA POR CONSIGNAÇÕES/RETENÇÕES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4851,'2015','8.2.1.1.3.03.00','COMPROMETIDA POR ENTRADAS COMPENSATÓRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4852,'2015','8.2.1.1.4.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4853,'2015','8.2.1.1.5.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA OU ARRECADAÇÃO PRÓPRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4854,'2015','8.2.1.2.0.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4855,'2015','8.2.1.3.0.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4856,'2015','8.2.2.0.0.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4857,'2015','8.2.3.0.0.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4858,'2015','8.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4859,'2015','8.3.0.0.0.00.00','EXECUÇÃO DA DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4860,'2015','8.3.1.0.0.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4861,'2015','8.3.1.1.0.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4862,'2015','8.3.1.1.1.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4863,'2015','8.3.1.1.1.01.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4864,'2015','8.3.1.1.1.02.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4865,'2015','8.3.1.1.1.03.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4866,'2015','8.3.1.1.2.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4867,'2015','8.3.1.1.2.01.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4868,'2015','8.3.1.2.0.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4869,'2015','8.3.1.2.1.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4870,'2015','8.3.1.2.1.01.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4871,'2015','8.3.1.2.1.02.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4872,'2015','8.3.1.2.1.03.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4873,'2015','8.3.1.2.2.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4874,'2015','8.3.1.2.2.01.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4875,'2015','8.3.1.3.0.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4876,'2015','8.3.1.3.1.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4877,'2015','8.3.1.3.1.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4878,'2015','8.3.1.3.1.02.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4879,'2015','8.3.1.3.1.03.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4880,'2015','8.3.1.3.2.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4881,'2015','8.3.1.3.2.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4882,'2015','8.3.1.4.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4883,'2015','8.3.1.4.1.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4884,'2015','8.3.1.4.1.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4885,'2015','8.3.1.4.1.02.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4886,'2015','8.3.1.4.1.03.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4887,'2015','8.3.1.4.2.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4888,'2015','8.3.1.4.2.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4889,'2015','8.3.2.0.0.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4890,'2015','8.3.2.1.0.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4891,'2015','8.3.2.1.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4892,'2015','8.3.2.1.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4893,'2015','8.3.2.2.0.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA DEVOLVIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4894,'2015','8.3.2.2.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA DEVOLVIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4895,'2015','8.3.2.2.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO TRIBUTÁRIA DEVOLVIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4896,'2015','8.3.2.3.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4897,'2015','8.3.2.3.1.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4898,'2015','8.3.2.3.1.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4899,'2015','8.3.2.3.1.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4900,'2015','8.3.2.3.2.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4901,'2015','8.3.2.3.2.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4902,'2015','8.3.2.3.2.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4903,'2015','8.3.2.4.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA RECEBIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4904,'2015','8.3.2.4.1.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4905,'2015','8.3.2.4.1.01.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4906,'2015','8.3.2.4.1.02.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4907,'2015','8.3.2.4.2.00.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4908,'2015','8.3.2.4.2.01.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4909,'2015','8.3.2.4.2.02.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4910,'2015','8.3.2.5.0.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4911,'2015','8.3.2.5.1.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4912,'2015','8.3.2.5.1.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA ADMINISTRATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4913,'2015','8.3.2.5.1.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4914,'2015','8.3.2.5.2.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4915,'2015','8.3.2.5.2.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMNISTRATIVA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4916,'2015','8.3.2.5.2.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4917,'2015','8.4.0.0.0.00.00','EXECUÇÃO DOS RISCOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4918,'2015','8.4.1.0.0.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4919,'2015','8.4.1.1.0.00.00','PASSIVOS CONTINGENTES PREVISTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4920,'2015','8.4.1.1.1.00.00','DEMANDAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4921,'2015','8.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4922,'2015','8.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4923,'2015','8.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4924,'2015','8.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4925,'2015','8.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4926,'2015','8.4.1.2.0.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4927,'2015','8.4.1.2.1.00.00','DEMANDAS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4928,'2015','8.4.1.2.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4929,'2015','8.4.1.2.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4930,'2015','8.4.1.2.4.00.00','ASSUNÇÃO DE PASSIVOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4931,'2015','8.4.1.2.5.00.00','ASSISTÊNCIAS DIVERSAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4932,'2015','8.4.1.2.9.00.00','OUTROS PASSIVOS CONTINGENTES','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4933,'2015','8.4.2.0.0.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4934,'2015','8.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS PREVISTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4935,'2015','8.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4936,'2015','8.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4937,'2015','8.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4938,'2015','8.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4939,'2015','8.4.2.2.0.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4940,'2015','8.5.0.0.0.00.00','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4941,'2015','8.5.1.0.0.00.00','EXECUÇÃO DO CONTRATO DE RATEIO DE CONSÓRCIO PÚBLICO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4942,'2015','8.5.1.1.0.00.00','CONTRATO DE RATEIO - EM EXECUÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4943,'2015','8.5.1.2.0.00.00','CONTRATO DE RATEIO -  EXECUTADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4944,'2015','8.5.2.0.0.00.00','EXECUÇÃO DA PRESTAÇÃO DE CONTAS DE CONSÓRCIO PÚBLICO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4945,'2015','8.5.2.1.0.00.00','A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4946,'2015','8.5.2.2.0.00.00','EM INADIMPLENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4947,'2015','8.5.2.3.0.00.00','A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4948,'2015','8.5.2.4.0.00.00','APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4949,'2015','8.5.2.5.0.00.00','IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4950,'2015','8.5.2.6.0.00.00','CONCLUÍDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4951,'2015','8.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4952,'2015','8.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4953,'2015','8.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4954,'2015','8.5.3.2.1.00.00','CREDITO EMPENHADO A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4955,'2015','8.5.3.2.2.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4956,'2015','8.5.3.2.3.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4957,'2015','8.5.3.2.4.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4958,'2015','8.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4959,'2015','8.5.3.3.1.00.00','RP NÃO PROCESSADOS A LIQUIDAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4960,'2015','8.5.3.3.2.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4961,'2015','8.5.3.3.3.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4962,'2015','8.5.3.3.4.00.00','RP NÃO PROCESSADOS PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4963,'2015','8.5.3.3.5.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4964,'2015','8.5.3.3.6.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4965,'2015','8.5.3.3.7.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4966,'2015','8.5.3.3.8.00.00','RP NÃO PROCESSADOS CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4967,'2015','8.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4968,'2015','8.5.3.4.1.00.00','RP PROCESSADOS A PAGAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4969,'2015','8.5.3.4.2.00.00','RP PROCESSADOS PAGOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4970,'2015','8.5.3.4.3.00.00','RP PROCESSADOS TRANSFERIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4971,'2015','8.5.3.4.4.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4972,'2015','8.5.3.4.5.00.00','RP PROCESSADOS CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4973,'2015','8.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4974,'2015','8.8.0.0.0.00.00','APURAÇÃO DE CUSTOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4975,'2015','8.9.0.0.0.00.00','OUTROS CONTROLES','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4976,'2015','8.9.1.0.0.00.00','EXECUÇÃO DE RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4977,'2015','8.9.1.1.0.00.00','EXECUÇÃO DE RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4978,'2015','8.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4979,'2015','8.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4980,'2015','8.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4981,'2015','8.9.1.2.0.00.00','EXECUÇÃO DE RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4982,'2015','8.9.1.2.1.00.00','EXECUÇÃO DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4983,'2015','8.9.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A COMPROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4984,'2015','8.9.1.2.1.02.00','ADIANTAMENTOS A APROVAR','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4985,'2015','8.9.1.2.1.03.00','ADIANTAMENTOS APROVADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4986,'2015','8.9.1.2.1.04.00','ADIANTAMENTOS IMPUGNADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4987,'2015','8.9.1.2.1.05.00','ADIANTAMENTOS EM INDADIMPLENCIA','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4988,'2015','8.9.1.2.1.06.00','ADIANTAMENTOS CANCELADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4989,'2015','8.9.1.2.2.00.00','EXECUÇÃO DE ATIVOS DE PPP CONTABILIZADOS NA SPE','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4990,'2015','8.9.1.2.2.01.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4991,'2015','8.9.1.2.2.02.00','ATIVOS DE PPP CONTABILIZADOS NA SPE BAIXADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4992,'2015','8.9.1.2.9.00.00','EXECUÇÃO DE OUTRAS RESPONSABILIDADES DE TERCEIROS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4993,'2015','8.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4994,'2015','8.9.2.1.0.00.00','PAGAMENTOS INDEVIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4995,'2015','8.9.2.2.0.00.00','SALDOS NÃO RECOLHIDOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4996,'2015','8.9.2.3.0.00.00','DESFALQUES OU DESVIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4997,'2015','8.9.2.4.0.00.00','DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4998,'2015','8.9.2.5.0.00.00','RESPONSÁVEIS POR DANOS OU PERDAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (4999,'2015','8.9.2.6.0.00.00','PAGAMENTOS SEM RESPALDO ORÇAMENTÁRIO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5000,'2015','8.9.2.7.0.00.00','CRÉDITOS ANTECIPADOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5001,'2015','8.9.2.8.0.00.00','FALTA OU IRREGULARIDADE DE COMPROVAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5002,'2015','8.9.2.9.0.00.00','OUTRAS RESPONSABILIDADES EM APURAÇÃO','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5003,'2015','8.9.2.9.1.00.00','MULTAS E JUROS','S');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5004,'2015','8.9.2.9.1.01.00','FALTA DE LICITAÇÃO','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5005,'2015','8.9.2.9.1.02.00','FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIÁRIAS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5006,'2015','8.9.2.9.1.04.00','DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMOVEL','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5007,'2015','8.9.2.9.1.05.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5008,'2015','8.9.2.9.1.06.00','FRAUDES EM BENEFÍCIOS','A');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano, exercicio, estrutural, titulo, natureza) VALUES (5009,'2015','8.9.2.9.1.99.00','DEMAIS RESPONSABILIDADES EM APURAÇÃO','A');

        stSQL := '
                   SELECT *
                     FROM tcmgo.plano_contas_tcmgo
                    WHERE exercicio = ''2015''
                        ;
                 ';
        FOR reRecord IN EXECUTE stSQL LOOP
        RAISE NOTICE 'estrutural: %', reRecord.estrutural;
            PERFORM 1
               FROM contabilidade.plano_conta
              WHERE cod_estrutural = reRecord.estrutural || '.00.00.00'
                AND exercicio      = reRecord.exercicio
                  ;
            IF FOUND THEN
                SELECT cod_conta
                     , exercicio
                  INTO inCodConta
                     , stExercicio
                  FROM contabilidade.plano_conta
                 WHERE cod_estrutural = reRecord.estrutural || '.00.00.00'
                   AND exercicio      = reRecord.exercicio
                     ;
                INSERT
                  INTO tcmgo.vinculo_plano_contas_tcmgo
                     ( exercicio       -- character(4) | not null
                     , cod_plano_tcmgo -- integer      | not null
                     , exercicio_tcmgo -- character(4) | not null
                     , cod_conta       -- integer      | not null
                     )
                VALUES
                     ( stExercicio
                     , reRecord.cod_plano
                     , reRecord.exercicio
                     , inCodConta
                     );
            END IF;
        END LOOP;
    END IF;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();

CREATE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN
    PERFORM 1
       FROM administracao.configuracao
      WHERE cod_modulo = 2
        AND exercicio  = '2015'
        AND parametro  = 'cnpj'
        AND valor      = '24854234000164'
          ;
    IF FOUND THEN
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.1.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.5.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.5.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.5.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.2.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.4.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.7.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.5.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.7.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.1.9.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.1.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.2.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.3.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.4.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.1.5.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.98.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.2.1.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.3.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.3.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.3.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.3.1.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.07.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.98.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.4.1.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.07.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.1.9.1.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.2.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.2.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.3.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.3.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.4.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.4.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.5.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.1.5.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.7.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.8.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.2.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.2.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.3.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.3.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.4.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.4.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.5.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.2.9.5.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.8.1.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.9.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.3.9.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.8.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.8.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.8.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.9.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.9.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '1.2.4.9.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.1.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.5.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.5.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.8.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.8.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.8.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.4.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.5.0.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.5.0.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.5.0.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.5.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.5.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.7.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.1.8.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.1.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.5.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.5.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.8.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.8.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.8.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.4.3.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.2.1.07.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.5.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.5.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.7.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.8.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.9.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.2.9.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.1.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.2.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.2.0.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.2.0.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.2.0.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.2.0.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.3.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.3.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.3.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.5.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.5.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.5.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.6.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.6.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.6.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.6.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.7.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.7.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.7.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.7.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.7.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.5.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.6.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.2.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.2.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.2.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.2.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.3.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.3.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.3.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.3.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.4.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.4.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.4.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.4.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.5.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.5.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.5.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.1.5.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.1.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.2.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.3.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.4.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.05.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.7.2.5.06.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '2.3.9.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.9.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.2.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.1.9.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.4.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.5.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.2.9.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.3.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.8.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.8.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.8.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.3.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.4.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.4.9.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.1.3.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.2.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.4.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.5.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.6.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.6.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.5.7.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.7.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.7.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.7.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.7.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.7.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.8.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.1.8.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.6.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.7.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.4.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.5.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.6.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.5.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.7.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '3.9.9.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.1.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.97.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.1.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.2.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.3.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.2.4.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.3.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.1.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.2.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.9.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.9.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.3.9.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.4.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.5.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.5.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.5.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.5.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.4.9.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.1.3.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.3.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.3.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.3.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.2.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.4.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.5.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.5.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.6.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.6.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.7.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.8.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.5.8.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.1.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.2.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.3.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.4.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.6.4.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.1.0.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.7.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.1.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.2.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.2.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.2.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.3.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.4.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.4.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.4.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.4.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.4.5.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.5.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.6.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.7.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '4.9.9.9.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.1.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.1.2.9.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.02.01.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.02.02.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.02.03.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.03.01.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.03.02.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.2.03.03.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.1.9.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.2.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.2.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.2.2.2.9.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.1.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.1.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '5.3.2.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.3.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.3.01.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.3.02.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.3.03.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.3.04.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.2.2.1.3.99.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.7.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.2.6.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '6.3.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.1.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '7.5.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.0.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.1.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.1.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.1.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.1.2.9.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.2.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.2.1.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.2.1.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.2.1.1.1.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.2.1.1.2.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.2.1.1.4.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.0.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.2.0.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.2.1.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.2.2.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.2.3.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.2.4.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.3.2.5.0.00.00.00.00.00';
        UPDATE contabilidade.plano_conta SET obrigatorio_tcmgo = TRUE WHERE exercicio = '2015' AND cod_estrutural = '8.5.0.0.0.00.00.00.00.00';
    END IF;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();

